#version 430

layout(binding = 0, std140) uniform UBO
{
    mat4 MVP;
    vec4 SourceSize;
    vec4 OriginalSize;
    vec4 CorePassSize;
    vec4 CorePassFeedbackSize;
    vec4 OutputSize;
    vec4 FinalViewportSize;
    vec4 NegativeCropAddedPassSize;
    vec4 DerezedPassSize;
    int FrameDirection;
    uint FrameCount;
    float HSM_RESOLUTION_DEBUG_ON;
    float HSM_CACHE_GRAPHICS_ON;
    float HSM_CACHE_UPDATE_INDICATOR_MODE;
    float HSM_GLOBAL_GRAPHICS_BRIGHTNESS;
    float HSM_STATIC_LAYERS_GAMMA;
    float HSM_AMBIENT_LIGHTING_OPACITY;
    float HSM_AMBIENT2_LIGHTING_OPACITY;
    float HSM_AMBIENT_LIGHTING_SWAP_IMAGES;
    float HSM_AMBIENT_LIGHTING_HUE;
    float HSM_AMBIENT_LIGHTING_SATURATION;
    float HSM_AMBIENT_LIGHTING_VALUE;
    float HSM_AMBIENT_LIGHTING_CONTRAST;
    float HSM_AMBIENT_LIGHTING_SCALE_KEEP_ASPECT;
    float HSM_AMBIENT_LIGHTING_SCALE_WITH_ZOOM;
    float HSM_AMBIENT_LIGHTING_SCALE;
    float HSM_AMBIENT_LIGHTING_SCALE_X;
    float HSM_AMBIENT_LIGHTING_ROTATE;
    float HSM_AMBIENT_LIGHTING_MIRROR_HORZ;
    float HSM_AMBIENT_LIGHTING_POSITION_X;
    float HSM_AMBIENT_LIGHTING_POSITION_Y;
    float HSM_AMBIENT_LIGHTING_DITHERING_SAMPLES;
    float HSM_AMBIENT2_LIGHTING_HUE;
    float HSM_AMBIENT2_LIGHTING_SATURATION;
    float HSM_AMBIENT2_LIGHTING_VALUE;
    float HSM_AMBIENT2_LIGHTING_CONTRAST;
    float HSM_AMBIENT2_LIGHTING_SCALE_KEEP_ASPECT;
    float HSM_AMBIENT2_LIGHTING_SCALE_WITH_ZOOM;
    float HSM_AMBIENT2_LIGHTING_SCALE;
    float HSM_AMBIENT2_LIGHTING_SCALE_X;
    float HSM_AMBIENT2_LIGHTING_ROTATE;
    float HSM_AMBIENT2_LIGHTING_MIRROR_HORZ;
    float HSM_AMBIENT2_LIGHTING_POSITION_X;
    float HSM_AMBIENT2_LIGHTING_POSITION_Y;
    float HSM_VIEWPORT_ZOOM;
    float HSM_VIEWPORT_POSITION_X;
    float HSM_VIEWPORT_POSITION_Y;
    float HSM_VIEWPORT_ZOOM_MASK;
    float HSM_FLIP_VIEWPORT_VERTICAL;
    float HSM_FLIP_VIEWPORT_HORIZONTAL;
    float HSM_FLIP_CORE_VERTICAL;
    float HSM_FLIP_CORE_HORIZONTAL;
    float HSM_ROTATE_CORE_IMAGE;
    float HSM_ASPECT_RATIO_ORIENTATION;
    float HSM_ASPECT_RATIO_MODE;
    float HSM_ASPECT_RATIO_EXPLICIT;
    float HSM_INT_SCALE_MODE;
    float HSM_INT_SCALE_MULTIPLE_OFFSET;
    float HSM_INT_SCALE_MULTIPLE_OFFSET_LONG;
    float HSM_INT_SCALE_MAX_HEIGHT;
    float HSM_VERTICAL_PRESET;
    float HSM_NON_INTEGER_SCALE;
    float HSM_USE_PHYSICAL_SIZE_FOR_NON_INTEGER;
    float HSM_PHYSICAL_MONITOR_ASPECT_RATIO;
    float HSM_PHYSICAL_MONITOR_DIAGONAL_SIZE;
    float HSM_PHYSICAL_SIM_TUBE_DIAGONAL_SIZE;
    float HSM_USE_IMAGE_FOR_PLACEMENT;
    float HSM_PLACEMENT_IMAGE_USE_HORIZONTAL;
    float HSM_PLACEMENT_IMAGE_MODE;
    float HSM_NON_INTEGER_SCALE_OFFSET;
    float HSM_USE_SNAP_TO_CLOSEST_INT_SCALE;
    float HSM_SNAP_TO_CLOSEST_INT_SCALE_TOLERANCE;
    float HSM_SCREEN_POSITION_X;
    float HSM_SCREEN_POSITION_Y;
    float HSM_CROP_MODE;
    float HSM_CROP_PERCENT_ZOOM;
    float HSM_CROP_PERCENT_TOP;
    float HSM_CROP_PERCENT_BOTTOM;
    float HSM_CROP_PERCENT_LEFT;
    float HSM_CROP_PERCENT_RIGHT;
    float HSM_CROP_BLACK_THRESHOLD;
    float HSM_SCANLINE_DIRECTION;
    float HSM_CORE_RES_SAMPLING_MULT_SCANLINE_DIR;
    float HSM_DOWNSAMPLE_BLUR_SCANLINE_DIR;
    float HSM_CORE_RES_SAMPLING_MULT_OPPOSITE_DIR;
    float HSM_DOWNSAMPLE_BLUR_OPPOSITE_DIR;
    float HSM_CORE_RES_SAMPLING_SHIFT_OPPOSITE_DIR;
    float HSM_INTERLACE_TRIGGER_RES;
    float HSM_INTERLACE_MODE;
    float HSM_INTERLACE_EFFECT_SMOOTHNESS_INTERS;
    float HSM_INTERLACE_SCANLINE_EFFECT;
    float iscans;
    float HSM_FAKE_SCANLINE_MODE;
    float HSM_FAKE_SCANLINE_OPACITY;
    float HSM_FAKE_SCANLINE_RES_MODE;
    float HSM_FAKE_SCANLINE_RES;
    float HSM_FAKE_SCANLINE_INT_SCALE;
    float HSM_FAKE_SCANLINE_ROLL;
    float HSM_FAKE_SCANLINE_CURVATURE;
    float HSM_FAKE_SCANLINE_BRIGHTNESS_CUTOFF;
    float HSM_DUALSCREEN_MODE;
    float HSM_DUALSCREEN_CORE_IMAGE_SPLIT_MODE;
    float HSM_DUALSCREEN_CORE_IMAGE_SWAP_SCREENS;
    float HSM_DUALSCREEN_CORE_IMAGE_SPLIT_OFFSET;
    float HSM_DUALSCREEN_VIEWPORT_SPLIT_LOCATION;
    float HSM_DUALSCREEN_SHIFT_POSITION_WITH_SCALE;
    float HSM_DUALSCREEN_POSITION_OFFSET_BETWEEN_SCREENS;
    float HSM_2ND_SCREEN_ASPECT_RATIO_MODE;
    float HSM_2ND_SCREEN_INDEPENDENT_SCALE;
    float HSM_2ND_SCREEN_SCALE_OFFSET;
    float HSM_2ND_SCREEN_POS_X;
    float HSM_2ND_SCREEN_POS_Y;
    float HSM_2ND_SCREEN_CROP_PERCENT_ZOOM;
    float HSM_2ND_SCREEN_CROP_PERCENT_TOP;
    float HSM_2ND_SCREEN_CROP_PERCENT_BOTTOM;
    float HSM_2ND_SCREEN_CROP_PERCENT_LEFT;
    float HSM_2ND_SCREEN_CROP_PERCENT_RIGHT;
    float HSM_CURVATURE_MODE;
    float HSM_CURVATURE_2D_SCALE_LONG_AXIS;
    float HSM_CURVATURE_2D_SCALE_SHORT_AXIS;
    float HSM_CURVATURE_3D_RADIUS;
    float HSM_CURVATURE_3D_VIEW_DIST;
    float HSM_CURVATURE_3D_TILT_ANGLE_X;
    float HSM_CURVATURE_3D_TILT_ANGLE_Y;
    float HSM_CRT_CURVATURE_SCALE;
    float HSM_ANTI_FLICKER_ON;
    float HSM_ANTI_FLICKER_THRESHOLD;
    float HSM_AB_COMPARE_SHOW_MODE;
    float HSM_AB_COMPARE_AREA;
    float HSM_AB_COMPARE_FREEZE_CRT_TUBE;
    float HSM_AB_COMPARE_FREEZE_GRAPHICS;
    float HSM_AB_COMPARE_SPLIT_AREA;
    float HSM_AB_COMPARE_SPLIT_POSITION;
    float HSM_CRT_BLEND_MODE;
    float HSM_CRT_BLEND_AMOUNT;
    float HSM_CRT_SCREEN_BLEND_MODE;
    float HSM_SCREEN_VIGNETTE_ON;
    float HSM_SCREEN_VIGNETTE_DUALSCREEN_VIS_MODE;
    float HSM_SCREEN_VIGNETTE_STRENGTH;
    float HSM_SCREEN_VIGNETTE_POWER;
    float HSM_SCREEN_VIGNETTE_IN_REFLECTION;
    float HSM_MONOCHROME_MODE;
    float HSM_MONOCHROME_BRIGHTNESS;
    float HSM_MONOCHROME_GAMMA;
    float HSM_MONOCHROME_HUE_OFFSET;
    float HSM_MONOCHROME_SATURATION;
    float HSM_MONOCHROME_DUALSCREEN_VIS_MODE;
    float HSM_SCREEN_REFLECTION_SCALE;
    float HSM_SCREEN_REFLECTION_POS_X;
    float HSM_SCREEN_REFLECTION_POS_Y;
    float HSM_TUBE_DIFFUSE_MODE;
    float HSM_TUBE_DIFFUSE_IMAGE_DUALSCREEN_VIS_MODE;
    float HSM_TUBE_DIFFUSE_OPACITY;
    float HSM_TUBE_DIFFUSE_IMAGE_HUE;
    float HSM_TUBE_DIFFUSE_IMAGE_COLORIZE_ON;
    float HSM_TUBE_DIFFUSE_IMAGE_SATURATION;
    float HSM_TUBE_DIFFUSE_IMAGE_BRIGHTNESS;
    float HSM_TUBE_DIFFUSE_IMAGE_GAMMA;
    float HSM_TUBE_DIFFUSE_IMAGE_AMBIENT_LIGHTING;
    float HSM_TUBE_DIFFUSE_IMAGE_AMBIENT2_LIGHTING;
    float HSM_TUBE_DIFFUSE_IMAGE_SCALE;
    float HSM_TUBE_DIFFUSE_IMAGE_SCALE_X;
    float HSM_TUBE_EMPTY_THICKNESS;
    float HSM_TUBE_EMPTY_THICKNESS_X_SCALE;
    float HSM_TUBE_DIFFUSE_FORCE_ASPECT;
    float HSM_TUBE_EXPLICIT_ASPECT;
    float HSM_SCREEN_CORNER_RADIUS_SCALE;
    float HSM_TUBE_COLORED_GEL_IMAGE_ON;
    float HSM_TUBE_COLORED_GEL_IMAGE_DUALSCREEN_VIS_MODE;
    float HSM_TUBE_COLORED_GEL_IMAGE_MULTIPLY_AMOUNT;
    float HSM_TUBE_COLORED_GEL_IMAGE_NORMAL_AMOUNT;
    float HSM_TUBE_COLORED_GEL_IMAGE_NORMAL_BRIGHTNESS;
    float HSM_TUBE_COLORED_GEL_IMAGE_NORMAL_VIGNETTE;
    float HSM_TUBE_COLORED_GEL_IMAGE_TRANSPARENCY_THRESHOLD;
    float HSM_TUBE_COLORED_GEL_IMAGE_ADDITIVE_AMOUNT;
    float HSM_SHOW_CRT_ON_TOP_OF_COLORED_GEL;
    float HSM_TUBE_SHADOW_IMAGE_ON;
    float HSM_TUBE_SHADOW_IMAGE_OPACITY;
    float HSM_TUBE_SHADOW_IMAGE_SCALE_X;
    float HSM_TUBE_SHADOW_IMAGE_SCALE_Y;
    float HSM_TUBE_SHADOW_IMAGE_POS_X;
    float HSM_TUBE_SHADOW_IMAGE_POS_Y;
    float HSM_TUBE_SHADOW_CURVATURE_SCALE;
    float HSM_TUBE_COLORED_GEL_IMAGE_AMBIENT_LIGHTING;
    float HSM_TUBE_COLORED_GEL_IMAGE_AMBIENT2_LIGHTING;
    float HSM_TUBE_COLORED_GEL_IMAGE_FAKE_SCANLINE_AMOUNT;
    float HSM_TUBE_COLORED_GEL_IMAGE_SCALE;
    float HSM_TUBE_COLORED_GEL_IMAGE_FLIP_HORIZONTAL;
    float HSM_TUBE_COLORED_GEL_IMAGE_FLIP_VERTICAL;
    float HSM_TUBE_STATIC_REFLECTION_IMAGE_ON;
    float HSM_TUBE_STATIC_REFLECTION_IMAGE_DUALSCREEN_VIS_MODE;
    float HSM_TUBE_STATIC_REFLECTION_IMAGE_OPACITY;
    float HSM_TUBE_STATIC_REFLECTION_IMAGE_AMBIENT_LIGHTING;
    float HSM_TUBE_STATIC_REFLECTION_IMAGE_AMBIENT2_LIGHTING;
    float HSM_TUBE_STATIC_REFLECTION_IMAGE_SCALE;
    float HSM_TUBE_STATIC_REFLECTION_IMAGE_SHADOW_OPACITY;
    float HSM_TUBE_STATIC_REFLECTION_IMAGE_DITHERING_SAMPLES;
    float HSM_GLOBAL_CORNER_RADIUS;
    float HSM_TUBE_BLACK_EDGE_CORNER_RADIUS_SCALE;
    float HSM_TUBE_BLACK_EDGE_SHARPNESS;
    float HSM_TUBE_BLACK_EDGE_CURVATURE_SCALE;
    float HSM_TUBE_BLACK_EDGE_THICKNESS;
    float HSM_TUBE_BLACK_EDGE_THICKNESS_X_SCALE;
    float HSM_BZL_USE_INDEPENDENT_SCALE;
    float HSM_BZL_INDEPENDENT_SCALE;
    float HSM_BZL_USE_INDEPENDENT_CURVATURE;
    float HSM_BZL_INDEPENDENT_CURVATURE_SCALE_LONG_AXIS;
    float HSM_BZL_INDEPENDENT_CURVATURE_SCALE_SHORT_AXIS;
    float HSM_BZL_OPACITY;
    float HSM_BZL_BLEND_MODE;
    float HSM_BZL_WIDTH;
    float HSM_BZL_HEIGHT;
    float HSM_BZL_SCALE_OFFSET;
    float HSM_BZL_INNER_CURVATURE_SCALE;
    float HSM_BZL_INNER_CORNER_RADIUS_SCALE;
    float HSM_BZL_OUTER_CURVATURE_SCALE;
    float HSM_BZL_INNER_EDGE_THICKNESS;
    float HSM_BZL_INNER_EDGE_SHARPNESS;
    float HSM_BZL_OUTER_CORNER_RADIUS_SCALE;
    float HSM_BZL_INNER_EDGE_SHADOW;
    float HSM_BZL_COLOR_HUE;
    float HSM_BZL_COLOR_SATURATION;
    float HSM_BZL_COLOR_VALUE;
    float HSM_BZL_NOISE;
    float HSM_BZL_BRIGHTNESS;
    float HSM_BZL_HIGHLIGHT;
    float HSM_BZL_AMBIENT_LIGHTING_MULTIPLIER;
    float HSM_BZL_AMBIENT2_LIGHTING_MULTIPLIER;
    float HSM_FRM_USE_INDEPENDENT_COLOR;
    float HSM_FRM_COLOR_HUE;
    float HSM_FRM_COLOR_SATURATION;
    float HSM_FRM_COLOR_VALUE;
    float HSM_FRM_NOISE;
    float HSM_FRM_OUTER_CURVATURE_SCALE;
    float HSM_FRM_THICKNESS;
    float HSM_FRM_THICKNESS_SCALE_X;
    float HSM_FRM_OUTER_POS_Y;
    float HSM_FRM_INNER_EDGE_THICKNESS;
    float HSM_FRM_OUTER_EDGE_THICKNESS;
    float HSM_FRM_OUTER_EDGE_SHADING;
    float HSM_FRM_OUTER_CORNER_RADIUS;
    float HSM_BZL_OUTER_POSITION_Y;
    float HSM_FRM_SHADOW_OPACITY;
    float HSM_FRM_SHADOW_WIDTH;
    float HSM_REFLECT_CORNER_FADE;
    float HSM_REFLECT_CORNER_INNER_SPREAD;
    float HSM_REFLECT_CORNER_OUTER_SPREAD;
    float HSM_REFLECT_CORNER_ROTATION_OFFSET_TOP;
    float HSM_REFLECT_CORNER_ROTATION_OFFSET_BOTTOM;
    float HSM_REFLECT_CORNER_SPREAD_FALLOFF;
    float HSM_REFLECT_CORNER_FADE_DISTANCE;
    float HSM_REFLECT_GLOBAL_AMOUNT;
    float HSM_REFLECT_GLOBAL_GAMMA_ADJUST;
    float HSM_REFLECT_BEZEL_INNER_EDGE_AMOUNT;
    float HSM_REFLECT_BEZEL_INNER_EDGE_FULLSCREEN_GLOW;
    float HSM_REFLECT_FRAME_INNER_EDGE_AMOUNT;
    float HSM_REFLECT_FRAME_INNER_EDGE_SHARPNESS;
    float HSM_REFLECT_DIRECT_AMOUNT;
    float HSM_REFLECT_DIFFUSED_AMOUNT;
    float HSM_REFLECT_FULLSCREEN_GLOW;
    float HSM_REFLECT_FULLSCREEN_GLOW_GAMMA;
    float HSM_REFLECT_FADE_AMOUNT;
    float HSM_REFLECT_RADIAL_FADE_WIDTH;
    float HSM_REFLECT_RADIAL_FADE_HEIGHT;
    float HSM_REFLECT_LATERAL_OUTER_FADE_POSITION;
    float HSM_REFLECT_LATERAL_OUTER_FADE_DISTANCE;
    float HSM_REFLECT_VIGNETTE_AMOUNT;
    float HSM_REFLECT_VIGNETTE_SIZE;
    float HSM_REFLECT_NOISE_AMOUNT;
    float HSM_REFLECT_NOISE_SAMPLES;
    float HSM_REFLECT_NOISE_SAMPLE_DISTANCE;
    float HSM_REFLECT_BLUR_NUM_SAMPLES;
    float HSM_REFLECT_BLUR_FALLOFF_DISTANCE;
    float HSM_REFLECT_BLUR_MIN;
    float HSM_REFLECT_BLUR_MAX;
    float HSM_REFLECT_MASK_IMG_AMOUNT;
    float HSM_REFLECT_IS_LAST_PASS;
    float HSM_GLASS_BORDER_ON;
    float HSM_POTATO_SHOW_BG_OVER_SCREEN;
    float HSM_STANDARD_DECAL_SCALE_WITH_FRAME;
    float HSM_STANDARD_TOP_SCALE_WITH_FRAME;
    float HSM_BG_LAYER_ORDER;
    float HSM_VIEWPORT_VIGNETTE_LAYER_ORDER;
    float HSM_CRT_LAYER_ORDER;
    float HSM_DEVICE_LAYER_ORDER;
    float HSM_CAB_GLASS_LAYER_ORDER;
    float HSM_DECAL_LAYER_ORDER;
    float HSM_LED_LAYER_ORDER;
    float HSM_TOP_LAYER_ORDER;
    float HSM_CUTOUT_ASPECT_MODE;
    float HSM_CUTOUT_EXPLICIT_ASPECT;
    float HSM_CUTOUT_SCALE_MODE;
    float HSM_CUTOUT_SCALE_FULL_WITH_ZOOM;
    float HSM_CUTOUT_KEEP_ASPECT;
    float HSM_CUTOUT_SCALE;
    float HSM_CUTOUT_SCALE_X;
    float HSM_CUTOUT_CORNER_RADIUS;
    float HSM_CUTOUT_POS_X;
    float HSM_CUTOUT_POS_Y;
    float HSM_BG_OPACITY;
    float HSM_BG_HUE;
    float HSM_BG_COLORIZE_ON;
    float HSM_BG_SATURATION;
    float HSM_BG_BRIGHTNESS;
    float HSM_BG_GAMMA;
    float HSM_BG_AMBIENT_LIGHTING_MULTIPLIER;
    float HSM_BG_AMBIENT2_LIGHTING_MULTIPLIER;
    float HSM_BG_APPLY_AMBIENT_IN_ADD_MODE;
    float HSM_BG_BLEND_MODE;
    float HSM_BG_SOURCE_MATTE_TYPE;
    float HSM_BG_MASK_MODE;
    float HSM_BG_CUTOUT_MODE;
    float HSM_BG_DUALSCREEN_VIS_MODE;
    float HSM_BG_SCALE_MODE;
    float HSM_BG_SCALE_FULL_WITH_ZOOM;
    float HSM_BG_FILL_MODE;
    float HSM_BG_SCALE_KEEP_ASPECT;
    float HSM_BG_SCALE;
    float HSM_BG_SCALE_X;
    float HSM_BG_POS_X;
    float HSM_BG_POS_Y;
    float HSM_BG_MIRROR_WRAP;
    float HSM_BG_MIPMAPPING_BLEND_BIAS;
    float HSM_VIEWPORT_VIGNETTE_OPACITY;
    float HSM_VIEWPORT_VIGNETTE_MASK_MODE;
    float HSM_VIEWPORT_VIGNETTE_CUTOUT_MODE;
    float HSM_VIEWPORT_VIGNETTE_SCALE_MODE;
    float HSM_VIEWPORT_VIGNETTE_SCALE;
    float HSM_VIEWPORT_VIGNETTE_SCALE_X;
    float HSM_VIEWPORT_VIGNETTE_POS_X;
    float HSM_VIEWPORT_VIGNETTE_POS_Y;
    float HSM_LED_OPACITY;
    float HSM_LED_HUE;
    float HSM_LED_COLORIZE_ON;
    float HSM_LED_SATURATION;
    float HSM_LED_BRIGHTNESS;
    float HSM_LED_GAMMA;
    float HSM_LED_AMBIENT_LIGHTING_MULTIPLIER;
    float HSM_LED_AMBIENT2_LIGHTING_MULTIPLIER;
    float HSM_LED_APPLY_AMBIENT_IN_ADD_MODE;
    float HSM_LED_BLEND_MODE;
    float HSM_LED_SOURCE_MATTE_TYPE;
    float HSM_LED_MASK_MODE;
    float HSM_LED_CUTOUT_MODE;
    float HSM_LED_DUALSCREEN_VIS_MODE;
    float HSM_LED_SCALE_MODE;
    float HSM_LED_SCALE_FULL_WITH_ZOOM;
    float HSM_LED_SCALE_KEEP_ASPECT;
    float HSM_LED_FILL_MODE;
    float HSM_LED_SCALE;
    float HSM_LED_SCALE_X;
    float HSM_LED_POS_X;
    float HSM_LED_POS_Y;
    float HSM_LED_MIPMAPPING_BLEND_BIAS;
    float HSM_DEVICE_OPACITY;
    float HSM_DEVICE_HUE;
    float HSM_DEVICE_COLORIZE_ON;
    float HSM_DEVICE_SATURATION;
    float HSM_DEVICE_BRIGHTNESS;
    float HSM_DEVICE_GAMMA;
    float HSM_DEVICE_AMBIENT_LIGHTING_MULTIPLIER;
    float HSM_DEVICE_AMBIENT2_LIGHTING_MULTIPLIER;
    float HSM_DEVICE_APPLY_AMBIENT_IN_ADD_MODE;
    float HSM_DEVICE_BLEND_MODE;
    float HSM_DEVICE_SOURCE_MATTE_TYPE;
    float HSM_DEVICE_MASK_MODE;
    float HSM_DEVICE_CUTOUT_MODE;
    float HSM_DEVICE_DUALSCREEN_VIS_MODE;
    float HSM_DEVICE_SCALE_MODE;
    float HSM_DEVICE_SCALE_FULL_WITH_ZOOM;
    float HSM_DEVICE_SCALE_KEEP_ASPECT;
    float HSM_DEVICE_FILL_MODE;
    float HSM_DEVICE_SCALE;
    float HSM_DEVICE_SCALE_X;
    float HSM_DEVICE_POS_X;
    float HSM_DEVICE_POS_Y;
    float HSM_DEVICE_COPY_INHERITED_COORD;
    float HSM_REFLECT_MASK_SCALE_MODE;
    float HSM_DEVICE_MIPMAPPING_BLEND_BIAS;
    float HSM_FRM_OPACITY;
    float HSM_FRM_BLEND_MODE;
    float HSM_FRM_TEXTURE_OPACITY;
    float HSM_FRM_TEXTURE_BLEND_MODE;
    float HSM_DECAL_OPACITY;
    float HSM_DECAL_HUE;
    float HSM_DECAL_COLORIZE_ON;
    float HSM_DECAL_SATURATION;
    float HSM_DECAL_BRIGHTNESS;
    float HSM_DECAL_GAMMA;
    float HSM_DECAL_AMBIENT_LIGHTING_MULTIPLIER;
    float HSM_DECAL_AMBIENT2_LIGHTING_MULTIPLIER;
    float HSM_DECAL_APPLY_AMBIENT_IN_ADD_MODE;
    float HSM_DECAL_BLEND_MODE;
    float HSM_DECAL_SOURCE_MATTE_TYPE;
    float HSM_DECAL_MASK_MODE;
    float HSM_DECAL_CUTOUT_MODE;
    float HSM_DECAL_DUALSCREEN_VIS_MODE;
    float HSM_DECAL_SCALE_MODE;
    float HSM_DECAL_SCALE_FULL_WITH_ZOOM;
    float HSM_DECAL_SCALE_KEEP_ASPECT;
    float HSM_DECAL_FILL_MODE;
    float HSM_DECAL_SCALE;
    float HSM_DECAL_SCALE_X;
    float HSM_DECAL_POS_X;
    float HSM_DECAL_POS_Y;
    float HSM_DECAL_MIPMAPPING_BLEND_BIAS;
    float HSM_CAB_GLASS_OPACITY;
    float HSM_CAB_GLASS_HUE;
    float HSM_CAB_GLASS_COLORIZE_ON;
    float HSM_CAB_GLASS_SATURATION;
    float HSM_CAB_GLASS_BRIGHTNESS;
    float HSM_CAB_GLASS_GAMMA;
    float HSM_CAB_GLASS_AMBIENT_LIGHTING_MULTIPLIER;
    float HSM_CAB_GLASS_AMBIENT2_LIGHTING_MULTIPLIER;
    float HSM_CAB_GLASS_APPLY_AMBIENT_IN_ADD_MODE;
    float HSM_CAB_GLASS_BLEND_MODE;
    float HSM_CAB_GLASS_SOURCE_MATTE_TYPE;
    float HSM_CAB_GLASS_MASK_MODE;
    float HSM_CAB_GLASS_CUTOUT_MODE;
    float HSM_CAB_GLASS_DUALSCREEN_VIS_MODE;
    float HSM_CAB_GLASS_SCALE_MODE;
    float HSM_CAB_GLASS_SCALE_FULL_WITH_ZOOM;
    float HSM_CAB_GLASS_SCALE_KEEP_ASPECT;
    float HSM_CAB_GLASS_FILL_MODE;
    float HSM_CAB_GLASS_SCALE;
    float HSM_CAB_GLASS_SCALE_X;
    float HSM_CAB_GLASS_POS_X;
    float HSM_CAB_GLASS_POS_Y;
    float HSM_CAB_GLASS_MIPMAPPING_BLEND_BIAS;
    float HSM_TOP_OPACITY;
    float HSM_TOP_HUE;
    float HSM_TOP_COLORIZE_ON;
    float HSM_TOP_SATURATION;
    float HSM_TOP_BRIGHTNESS;
    float HSM_TOP_GAMMA;
    float HSM_TOP_AMBIENT_LIGHTING_MULTIPLIER;
    float HSM_TOP_AMBIENT2_LIGHTING_MULTIPLIER;
    float HSM_TOP_APPLY_AMBIENT_IN_ADD_MODE;
    float HSM_TOP_BLEND_MODE;
    float HSM_TOP_SOURCE_MATTE_TYPE;
    float HSM_TOP_MASK_MODE;
    float HSM_TOP_CUTOUT_MODE;
    float HSM_TOP_DUALSCREEN_VIS_MODE;
    float HSM_TOP_SCALE_MODE;
    float HSM_TOP_SCALE_FULL_WITH_ZOOM;
    float HSM_TOP_SCALE_KEEP_ASPECT;
    float HSM_TOP_FILL_MODE;
    float HSM_TOP_SCALE;
    float HSM_TOP_SCALE_X;
    float HSM_TOP_POS_X;
    float HSM_TOP_POS_Y;
    float HSM_TOP_MIRROR_WRAP;
    float HSM_TOP_MIPMAPPING_BLEND_BIAS;
    float HSM_RENDER_SIMPLE_MODE;
    float HSM_RENDER_SIMPLE_MASK_TYPE;
    float HSM_LAYERING_DEBUG_MASK_MODE;
    float HSM_INTRO_LOGO_BLEND_MODE;
    float HSM_INTRO_LOGO_FLIP_VERTICAL;
    float HSM_INTRO_NOISE_BLEND_MODE;
    float HSM_INTRO_NOISE_HOLD;
    float HSM_INTRO_NOISE_FADE_OUT;
    float HSM_INTRO_SOLID_BLACK_HOLD;
    float HSM_INTRO_SOLID_BLACK_FADE_OUT;
    float HSM_INTRO_SOLID_COLOR_BLEND_MODE;
    float HSM_INTRO_LOGO_OVER_SOLID_COLOR;
    float HSM_INTRO_LOGO_PLACEMENT;
    float HSM_INTRO_LOGO_HEIGHT;
    float HSM_INTRO_LOGO_POS_X;
    float HSM_INTRO_LOGO_POS_Y;
    float HSM_INTRO_WHEN_TO_SHOW;
    float HSM_INTRO_SPEED;
    float HSM_INTRO_LOGO_WAIT;
    float HSM_INTRO_LOGO_FADE_IN;
    float HSM_INTRO_LOGO_HOLD;
    float HSM_INTRO_LOGO_FADE_OUT;
    float HSM_INTRO_SOLID_COLOR_HUE;
    float HSM_INTRO_SOLID_COLOR_SAT;
    float HSM_INTRO_SOLID_COLOR_VALUE;
    float HSM_INTRO_SOLID_COLOR_HOLD;
    float HSM_INTRO_SOLID_COLOR_FADE_OUT;
    float GAMMA_INPUT;
    float gamma_out;
    float post_br;
    float post_br_affect_black_level;
    float glow;
    float bloom;
    float mask_bloom;
    float bloom_dist;
    float halation;
    float TATE;
    float IOS;
    float OS;
    float BLOOM;
    float overscanX;
    float overscanY;
    float intres;
    float prescalex;
    float c_shape;
    float sborder;
    float csize;
    float bsize1;
    float warpX;
    float warpY;
    float gamma_c;
    float brightboost;
    float brightboost1;
    float blendMode;
    float gsl;
    float scanline1;
    float scanline2;
    float beam_min;
    float beam_max;
    float beam_size;
    float vertmask;
    float scans;
    float scan_falloff;
    float spike;
    float ring;
    float scangamma;
    float rolling_scan;
    float h_sharp;
    float s_sharp;
    float smart_ei;
    float ei_limit;
    float sth;
    float barspeed;
    float barintensity;
    float bardir;
    float shadowMask;
    float maskstr;
    float mcut;
    float masksize;
    float maskDark;
    float maskLight;
    float mask_gamma;
    float slotmask;
    float slotmask1;
    float slotwidth;
    float double_slot;
    float slotms;
    float mclip;
    float mshift;
    float mask_layout;
    float GDV_DECONVERGENCE_ON;
    float decons;
    float GDV_NOISE_ON;
    float addnoised;
    float noisetype;
    float noiseresd;
    float deconrr;
    float deconrg;
    float deconrb;
    float deconrry;
    float deconrgy;
    float deconrby;
    float deconsmooth;
    float dctypex;
    float dctypey;
    float g_grade_on;
    float wp_temperature;
    float g_satr;
    float g_satg;
    float g_satb;
    float AS;
    float asat;
    float hcrt_h_size;
    float hcrt_v_size;
    float hcrt_h_cent;
    float hcrt_v_cent;
    float hcrt_pin_phase;
    float hcrt_pin_amp;
} global;

layout(binding = 2) uniform sampler2D InfoCachePassFeedback;
layout(binding = 1) uniform sampler2D Source;
layout(binding = 3) uniform sampler2D ScreenPlacementImage;

layout(location = 0) out vec4 FragColor;
layout(location = 0) in vec2 vTexCoord;
float NEGATIVE_CROP_EXPAND_MULTIPLIER;
float MAX_NEGATIVE_CROP;
float DEFAULT_SCREEN_ASPECT;
float DEFAULT_BEZEL_ASPECT;
vec2 DEFAULT_SCREEN_SCALE;
vec2 DEFAULT_BEZEL_SCALE;
int INFOCACHE_MAX_INDEX;
float BLEND_MODE_OFF;
float BLEND_MODE_NORMAL;
float BLEND_MODE_ADD;
float BLEND_MODE_MULTIPLY;
float SOURCE_MATTE_PREMULTIPLIED;
float SOURCE_MATTE_WHITE;
float SOURCE_MATTE_NONE;
float IMAGE_ASPECT_MODE_INHERIT_ASPECT_SCALE;
float IMAGE_ASPECT_MODE_KEEP_ASPECT;
float FILL_MODE_STRETCH;
float FILL_MODE_SPLIT_FILL_HORIZONTAL;
float FILL_MODE_SPLIT_FILL_VERTICAL;
bool CACHE_INFO_PARAM_SUM_CHANGED;
float CURRENT_FRAME_FROM_CACHE_INFO;
float TUBE_DIFFUSE_MASK;
float TUBE_MASK;
float BEZEL_MASK;
float INSIDE_BEZEL_MASK;
float OUTSIDE_TUBE_MASK_FOR_IMAGE;
float FRAME_MASK;
float FRAME_MASK_FOR_IMAGE;
float OUTSIDE_BEZEL_MASK;
float OUTSIDE_FRAME_MASK_FOR_IMAGE;
float OUTSIDE_FRAME_MASK;
float CUTOUT_MASK;
float SCREEN_INDEX;
float SCREEN_ASPECT;
vec2 SCREEN_SCALE;
vec2 SCREEN_POS_OFFSET;
vec2 SCREEN_SCALE_2ND_SCREEN;
vec2 SCREEN_POS_OFFSET_2ND_SCREEN;
vec2 VIEWPORT_SCALE;
vec2 VIEWPORT_POS;
vec2 TUBE_SCALE;
vec2 TUBE_DIFFUSE_SCALE;
float TUBE_DIFFUSE_ASPECT;
vec2 FRAME_SCALE;
vec2 BEZEL_OUTSIDE_SCALE;
vec2 BACKGROUND_SCALE;
vec2 LED_SCALE;
vec2 DEVICE_SCALE;
vec2 DECAL_SCALE;
vec2 CAB_GLASS_SCALE;
vec2 TOP_IMAGE_SCALE;
float AVERAGE_LUMA;
float USE_VERTICAL_SCANLINES;
vec2 CORE_SIZE;
vec2 ROTATED_CORE_ORIGINAL_SIZE;
vec2 ROTATED_CORE_PREPPED_SIZE;
vec2 ROTATED_DEREZED_SIZE;
vec2 CROPPED_ROTATED_SIZE_WITH_RES_MULT;
vec2 CROPPED_ROTATED_SIZE_WITH_RES_MULT_FEEDBACK;
vec2 CROPPED_ROTATED_SIZE;
vec2 SAMPLE_AREA_START_PIXEL_COORD;
vec2 VIEWPORT_UNSCALED_COORD;
vec2 SCREEN_COORD;
vec2 TUBE_COORD;
vec2 TUBE_DIFFUSE_COORD;
vec2 BEZEL_OUTSIDE_COORD;
vec2 BACKGROUND_COORD;
vec2 DEVICE_COORD;
vec2 LED_COORD;
vec2 DECAL_COORD;
vec2 CAB_GLASS_COORD;
vec2 TOP_IMAGE_COORD;
vec2 SCREEN_CURVED_COORD;
vec2 TUBE_CURVED_COORD;
vec2 TUBE_DIFFUSE_CURVED_COORD;
vec2 BEZEL_OUTSIDE_CURVED_COORD;
vec2 FRAME_OUTSIDE_CURVED_COORD;
vec2 BACKGROUND_CURVED_COORD;
vec2 LED_CURVED_COORD;
vec2 DEVICE_CURVED_COORD;
vec2 DECAL_CURVED_COORD;
vec2 CAB_GLASS_CURVED_COORD;
vec2 TOP_IMAGE_CURVED_COORD;
float HSM_RESOLUTION_DEBUG_ON;
float HSM_CACHE_GRAPHICS_ON;
float HSM_CACHE_UPDATE_INDICATOR_MODE;
float HSM_GLOBAL_GRAPHICS_BRIGHTNESS;
float HSM_STATIC_LAYERS_GAMMA;
float HSM_AMBIENT_LIGHTING_OPACITY;
float HSM_AMBIENT2_LIGHTING_OPACITY;
float HSM_AMBIENT_LIGHTING_SWAP_IMAGES;
float HSM_VIEWPORT_ZOOM;
float HSM_VIEWPORT_ZOOM_MASK;
float HSM_VIEWPORT_POSITION_X;
float HSM_VIEWPORT_POSITION_Y;
float HSM_FLIP_VIEWPORT_VERTICAL;
float HSM_FLIP_VIEWPORT_HORIZONTAL;
float HSM_FLIP_CORE_VERTICAL;
float HSM_FLIP_CORE_HORIZONTAL;
float HSM_ROTATE_CORE_IMAGE;
float HSM_ASPECT_RATIO_ORIENTATION;
float HSM_ASPECT_RATIO_MODE;
float HSM_ASPECT_RATIO_EXPLICIT;
float HSM_VERTICAL_PRESET;
float HSM_INT_SCALE_MAX_HEIGHT;
float HSM_NON_INTEGER_SCALE;
float HSM_USE_PHYSICAL_SIZE_FOR_NON_INTEGER;
float HSM_PHYSICAL_MONITOR_ASPECT_RATIO;
float HSM_PHYSICAL_MONITOR_DIAGONAL_SIZE;
float HSM_PHYSICAL_SIM_TUBE_DIAGONAL_SIZE;
float HSM_USE_IMAGE_FOR_PLACEMENT;
float HSM_PLACEMENT_IMAGE_USE_HORIZONTAL;
float HSM_PLACEMENT_IMAGE_MODE;
float HSM_NON_INTEGER_SCALE_OFFSET;
float HSM_USE_SNAP_TO_CLOSEST_INT_SCALE;
float HSM_SNAP_TO_CLOSEST_INT_SCALE_TOLERANCE;
float HSM_SCREEN_POSITION_X;
float HSM_SCREEN_POSITION_Y;
float HSM_CROP_MODE;
float HSM_CROP_PERCENT_ZOOM;
float HSM_CROP_PERCENT_TOP;
float HSM_CROP_PERCENT_BOTTOM;
float HSM_CROP_PERCENT_LEFT;
float HSM_CROP_PERCENT_RIGHT;
float HSM_CROP_BLACK_THRESHOLD;
float HSM_SCANLINE_DIRECTION;
float HSM_CORE_RES_SAMPLING_MULT_SCANLINE_DIR;
float HSM_DOWNSAMPLE_BLUR_SCANLINE_DIR;
float HSM_CORE_RES_SAMPLING_MULT_OPPOSITE_DIR;
float HSM_DOWNSAMPLE_BLUR_OPPOSITE_DIR;
float HSM_CORE_RES_SAMPLING_SHIFT_OPPOSITE_DIR;
float HSM_USE_GEOM;
float HSM_CURVATURE_MODE;
float HSM_CURVATURE_3D_RADIUS;
float HSM_CURVATURE_3D_VIEW_DIST;
float HSM_CURVATURE_3D_TILT_ANGLE_X;
float HSM_CURVATURE_3D_TILT_ANGLE_Y;
float HSM_CRT_CURVATURE_SCALE;
float HSM_AB_COMPARE_SHOW_MODE;
float HSM_AB_COMPARE_AREA;
float HSM_AB_COMPARE_SPLIT_POSITION;
float HSM_AB_COMPARE_FREEZE_CRT_TUBE;
float HSM_AB_COMPARE_FREEZE_GRAPHICS;
float HSM_SCREEN_VIGNETTE_DUALSCREEN_VIS_MODE;
float HSM_MONOCHROME_DUALSCREEN_VIS_MODE;
float HSM_TUBE_DIFFUSE_MODE;
float HSM_TUBE_DIFFUSE_OPACITY;
float HSM_TUBE_DIFFUSE_IMAGE_DUALSCREEN_VIS_MODE;
float HSM_TUBE_DIFFUSE_IMAGE_COLORIZE_ON;
float HSM_TUBE_DIFFUSE_IMAGE_HUE;
float HSM_TUBE_DIFFUSE_IMAGE_SATURATION;
float HSM_TUBE_DIFFUSE_IMAGE_BRIGHTNESS;
float HSM_TUBE_DIFFUSE_IMAGE_GAMMA;
float HSM_TUBE_DIFFUSE_IMAGE_AMBIENT_LIGHTING;
float HSM_TUBE_DIFFUSE_IMAGE_AMBIENT2_LIGHTING;
float HSM_TUBE_DIFFUSE_IMAGE_SCALE;
float HSM_TUBE_DIFFUSE_IMAGE_SCALE_X;
float HSM_TUBE_SHADOW_IMAGE_ON;
float HSM_TUBE_SHADOW_IMAGE_OPACITY;
float HSM_TUBE_SHADOW_IMAGE_POS_X;
float HSM_TUBE_SHADOW_IMAGE_POS_Y;
float HSM_TUBE_SHADOW_IMAGE_SCALE_X;
float HSM_TUBE_SHADOW_IMAGE_SCALE_Y;
float HSM_TUBE_SHADOW_CURVATURE_SCALE;
float HSM_TUBE_COLORED_GEL_IMAGE_ON;
float HSM_TUBE_COLORED_GEL_IMAGE_SCALE;
float HSM_TUBE_COLORED_GEL_IMAGE_FLIP_HORIZONTAL;
float HSM_TUBE_COLORED_GEL_IMAGE_FLIP_VERTICAL;
float HSM_TUBE_COLORED_GEL_IMAGE_DUALSCREEN_VIS_MODE;
float HSM_TUBE_COLORED_GEL_IMAGE_MULTIPLY_AMOUNT;
float HSM_TUBE_COLORED_GEL_IMAGE_ADDITIVE_AMOUNT;
float HSM_TUBE_COLORED_GEL_IMAGE_NORMAL_AMOUNT;
float HSM_TUBE_COLORED_GEL_IMAGE_TRANSPARENCY_THRESHOLD;
float HSM_TUBE_COLORED_GEL_IMAGE_NORMAL_BRIGHTNESS;
float HSM_TUBE_COLORED_GEL_IMAGE_NORMAL_VIGNETTE;
float HSM_TUBE_COLORED_GEL_IMAGE_FAKE_SCANLINE_AMOUNT;
float HSM_TUBE_COLORED_GEL_IMAGE_AMBIENT_LIGHTING;
float HSM_TUBE_COLORED_GEL_IMAGE_AMBIENT2_LIGHTING;
float HSM_SHOW_CRT_ON_TOP_OF_COLORED_GEL;
float HSM_TUBE_STATIC_REFLECTION_IMAGE_ON;
float HSM_TUBE_STATIC_REFLECTION_IMAGE_DUALSCREEN_VIS_MODE;
float HSM_TUBE_STATIC_REFLECTION_IMAGE_OPACITY;
float HSM_TUBE_STATIC_REFLECTION_IMAGE_AMBIENT_LIGHTING;
float HSM_TUBE_STATIC_REFLECTION_IMAGE_AMBIENT2_LIGHTING;
float HSM_TUBE_STATIC_REFLECTION_IMAGE_SCALE;
float HSM_TUBE_STATIC_REFLECTION_IMAGE_SHADOW_OPACITY;
float HSM_DUALSCREEN_MODE;
float HSM_DUALSCREEN_CORE_IMAGE_SPLIT_MODE;
float HSM_DUALSCREEN_CORE_IMAGE_SWAP_SCREENS;
float HSM_DUALSCREEN_CORE_IMAGE_SPLIT_OFFSET;
float HSM_DUALSCREEN_VIEWPORT_SPLIT_LOCATION;
float HSM_DUALSCREEN_SHIFT_POSITION_WITH_SCALE;
float HSM_DUALSCREEN_POSITION_OFFSET_BETWEEN_SCREENS;
float HSM_2ND_SCREEN_ASPECT_RATIO_MODE;
float HSM_2ND_SCREEN_INDEPENDENT_SCALE;
float HSM_2ND_SCREEN_SCALE_OFFSET;
float HSM_2ND_SCREEN_POS_X;
float HSM_2ND_SCREEN_POS_Y;
float HSM_2ND_SCREEN_CROP_PERCENT_ZOOM;
float HSM_2ND_SCREEN_CROP_PERCENT_TOP;
float HSM_2ND_SCREEN_CROP_PERCENT_BOTTOM;
float HSM_2ND_SCREEN_CROP_PERCENT_LEFT;
float HSM_2ND_SCREEN_CROP_PERCENT_RIGHT;
float HSM_SCREEN_REFLECTION_SCALE;
float HSM_SCREEN_REFLECTION_POS_X;
float HSM_SCREEN_REFLECTION_POS_Y;
float HSM_AMBIENT_LIGHTING_HUE;
float HSM_AMBIENT_LIGHTING_SATURATION;
float HSM_AMBIENT_LIGHTING_VALUE;
float HSM_AMBIENT_LIGHTING_CONTRAST;
float HSM_AMBIENT_LIGHTING_SCALE_KEEP_ASPECT;
float HSM_AMBIENT_LIGHTING_SCALE_WITH_ZOOM;
float HSM_AMBIENT_LIGHTING_SCALE;
float HSM_AMBIENT_LIGHTING_SCALE_X;
float HSM_AMBIENT_LIGHTING_ROTATE;
float HSM_AMBIENT_LIGHTING_MIRROR_HORZ;
float HSM_AMBIENT_LIGHTING_POSITION_X;
float HSM_AMBIENT_LIGHTING_POSITION_Y;
float HSM_AMBIENT_LIGHTING_DITHERING_SAMPLES;
float HSM_AMBIENT2_LIGHTING_HUE;
float HSM_AMBIENT2_LIGHTING_SATURATION;
float HSM_AMBIENT2_LIGHTING_VALUE;
float HSM_AMBIENT2_LIGHTING_CONTRAST;
float HSM_AMBIENT2_LIGHTING_SCALE_KEEP_ASPECT;
float HSM_AMBIENT2_LIGHTING_SCALE_WITH_ZOOM;
float HSM_AMBIENT2_LIGHTING_SCALE;
float HSM_AMBIENT2_LIGHTING_SCALE_X;
float HSM_AMBIENT2_LIGHTING_ROTATE;
float HSM_AMBIENT2_LIGHTING_MIRROR_HORZ;
float HSM_AMBIENT2_LIGHTING_POSITION_X;
float HSM_AMBIENT2_LIGHTING_POSITION_Y;
float HSM_BZL_OPACITY;
float HSM_BZL_BLEND_MODE;
float HSM_BZL_WIDTH;
float HSM_BZL_HEIGHT;
float HSM_BZL_INNER_CORNER_RADIUS_SCALE;
float HSM_BZL_INNER_EDGE_THICKNESS;
float HSM_BZL_INNER_EDGE_SHARPNESS;
float HSM_BZL_OUTER_POSITION_Y;
float HSM_BZL_OUTER_CURVATURE_SCALE;
float HSM_BZL_OUTER_CORNER_RADIUS_SCALE;
float HSM_BZL_BRIGHTNESS;
float HSM_BZL_HIGHLIGHT;
float HSM_BZL_NOISE;
float HSM_BZL_INNER_EDGE_SHADOW;
float HSM_BZL_COLOR_HUE;
float HSM_BZL_COLOR_SATURATION;
float HSM_BZL_COLOR_VALUE;
float HSM_BZL_AMBIENT_LIGHTING_MULTIPLIER;
float HSM_BZL_AMBIENT2_LIGHTING_MULTIPLIER;
float HSM_FRM_USE_INDEPENDENT_COLOR;
float HSM_FRM_COLOR_HUE;
float HSM_FRM_COLOR_SATURATION;
float HSM_FRM_COLOR_VALUE;
float HSM_FRM_OPACITY;
float HSM_FRM_BLEND_MODE;
float HSM_FRM_TEXTURE_OPACITY;
float HSM_FRM_TEXTURE_BLEND_MODE;
float HSM_FRM_NOISE;
float HSM_FRM_INNER_EDGE_THICKNESS;
float HSM_FRM_THICKNESS;
float HSM_FRM_THICKNESS_SCALE_X;
float HSM_FRM_OUTER_POS_Y;
float HSM_FRM_OUTER_CURVATURE_SCALE;
float HSM_FRM_OUTER_CORNER_RADIUS;
float HSM_FRM_OUTER_EDGE_THICKNESS;
float HSM_FRM_OUTER_EDGE_SHADING;
float HSM_FRM_SHADOW_OPACITY;
float HSM_FRM_SHADOW_WIDTH;
float HSM_REFLECT_CORNER_FADE;
float HSM_REFLECT_CORNER_FADE_DISTANCE;
float HSM_REFLECT_CORNER_INNER_SPREAD;
float HSM_REFLECT_CORNER_OUTER_SPREAD;
float HSM_REFLECT_CORNER_ROTATION_OFFSET_TOP;
float HSM_REFLECT_CORNER_ROTATION_OFFSET_BOTTOM;
float HSM_REFLECT_CORNER_SPREAD_FALLOFF;
float HSM_REFLECT_GLOBAL_AMOUNT;
float HSM_REFLECT_GLOBAL_GAMMA_ADJUST;
float HSM_REFLECT_DIRECT_AMOUNT;
float HSM_REFLECT_DIFFUSED_AMOUNT;
float HSM_REFLECT_FULLSCREEN_GLOW;
float HSM_REFLECT_FULLSCREEN_GLOW_GAMMA;
float HSM_REFLECT_BEZEL_INNER_EDGE_AMOUNT;
float HSM_REFLECT_BEZEL_INNER_EDGE_FULLSCREEN_GLOW;
float HSM_REFLECT_FRAME_INNER_EDGE_AMOUNT;
float HSM_REFLECT_FRAME_INNER_EDGE_SHARPNESS;
float HSM_REFLECT_FADE_AMOUNT;
float HSM_REFLECT_RADIAL_FADE_WIDTH;
float HSM_REFLECT_RADIAL_FADE_HEIGHT;
float HSM_REFLECT_LATERAL_OUTER_FADE_POSITION;
float HSM_REFLECT_LATERAL_OUTER_FADE_DISTANCE;
float HSM_REFLECT_BLUR_NUM_SAMPLES;
float HSM_REFLECT_BLUR_MIN;
float HSM_REFLECT_BLUR_MAX;
float HSM_REFLECT_BLUR_FALLOFF_DISTANCE;
float HSM_REFLECT_NOISE_AMOUNT;
float HSM_REFLECT_NOISE_SAMPLES;
float HSM_REFLECT_NOISE_SAMPLE_DISTANCE;
float HSM_GLASS_BORDER_ON;
float HSM_REFLECT_VIGNETTE_AMOUNT;
float HSM_REFLECT_VIGNETTE_SIZE;
float HSM_BG_LAYER_ORDER;
float HSM_VIEWPORT_VIGNETTE_LAYER_ORDER;
float HSM_LED_LAYER_ORDER;
float HSM_DEVICE_LAYER_ORDER;
float HSM_CRT_LAYER_ORDER;
float HSM_DECAL_LAYER_ORDER;
float HSM_CAB_GLASS_LAYER_ORDER;
float HSM_TOP_LAYER_ORDER;
float HSM_CUTOUT_ASPECT_MODE;
float HSM_CUTOUT_EXPLICIT_ASPECT;
float HSM_CUTOUT_SCALE_MODE;
float HSM_CUTOUT_SCALE_FULL_WITH_ZOOM;
float HSM_CUTOUT_KEEP_ASPECT;
float HSM_CUTOUT_SCALE;
float HSM_CUTOUT_SCALE_X;
float HSM_CUTOUT_POS_X;
float HSM_CUTOUT_POS_Y;
float HSM_CUTOUT_CORNER_RADIUS;
float HSM_LAYERING_DEBUG_MASK_MODE;
float HSM_BG_OPACITY;
float HSM_BG_COLORIZE_ON;
float HSM_BG_HUE;
float HSM_BG_SATURATION;
float HSM_BG_BRIGHTNESS;
float HSM_BG_GAMMA;
float HSM_BG_AMBIENT_LIGHTING_MULTIPLIER;
float HSM_BG_AMBIENT2_LIGHTING_MULTIPLIER;
float HSM_BG_APPLY_AMBIENT_IN_ADD_MODE;
float HSM_BG_BLEND_MODE;
float HSM_BG_SOURCE_MATTE_TYPE;
float HSM_BG_MASK_MODE;
float HSM_BG_CUTOUT_MODE;
float HSM_BG_DUALSCREEN_VIS_MODE;
float HSM_BG_SCALE_MODE;
float HSM_BG_SCALE_FULL_WITH_ZOOM;
float HSM_BG_SCALE_KEEP_ASPECT;
float HSM_BG_FILL_MODE;
float HSM_BG_SCALE;
float HSM_BG_SCALE_X;
float HSM_BG_POS_X;
float HSM_BG_POS_Y;
float HSM_BG_MIRROR_WRAP;
float HSM_BG_MIPMAPPING_BLEND_BIAS;
float HSM_VIEWPORT_VIGNETTE_OPACITY;
float HSM_VIEWPORT_VIGNETTE_MASK_MODE;
float HSM_VIEWPORT_VIGNETTE_CUTOUT_MODE;
float HSM_VIEWPORT_VIGNETTE_SCALE_MODE;
float HSM_VIEWPORT_VIGNETTE_SCALE;
float HSM_VIEWPORT_VIGNETTE_SCALE_X;
float HSM_VIEWPORT_VIGNETTE_POS_X;
float HSM_VIEWPORT_VIGNETTE_POS_Y;
float HSM_LED_OPACITY;
float HSM_LED_COLORIZE_ON;
float HSM_LED_HUE;
float HSM_LED_SATURATION;
float HSM_LED_BRIGHTNESS;
float HSM_LED_GAMMA;
float HSM_LED_AMBIENT_LIGHTING_MULTIPLIER;
float HSM_LED_AMBIENT2_LIGHTING_MULTIPLIER;
float HSM_LED_APPLY_AMBIENT_IN_ADD_MODE;
float HSM_LED_BLEND_MODE;
float HSM_LED_SOURCE_MATTE_TYPE;
float HSM_LED_MASK_MODE;
float HSM_LED_CUTOUT_MODE;
float HSM_LED_DUALSCREEN_VIS_MODE;
float HSM_LED_SCALE_MODE;
float HSM_LED_SCALE_FULL_WITH_ZOOM;
float HSM_LED_SCALE_KEEP_ASPECT;
float HSM_LED_FILL_MODE;
float HSM_LED_SCALE;
float HSM_LED_SCALE_X;
float HSM_LED_POS_X;
float HSM_LED_POS_Y;
float HSM_LED_MIPMAPPING_BLEND_BIAS;
float HSM_DEVICE_OPACITY;
float HSM_DEVICE_COLORIZE_ON;
float HSM_DEVICE_HUE;
float HSM_DEVICE_SATURATION;
float HSM_DEVICE_BRIGHTNESS;
float HSM_DEVICE_GAMMA;
float HSM_DEVICE_AMBIENT_LIGHTING_MULTIPLIER;
float HSM_DEVICE_AMBIENT2_LIGHTING_MULTIPLIER;
float HSM_DEVICE_APPLY_AMBIENT_IN_ADD_MODE;
float HSM_DEVICE_BLEND_MODE;
float HSM_DEVICE_SOURCE_MATTE_TYPE;
float HSM_DEVICE_MASK_MODE;
float HSM_DEVICE_CUTOUT_MODE;
float HSM_DEVICE_DUALSCREEN_VIS_MODE;
float HSM_DEVICE_SCALE_MODE;
float HSM_DEVICE_SCALE_FULL_WITH_ZOOM;
float HSM_DEVICE_COPY_INHERITED_COORD;
float HSM_DEVICE_SCALE_KEEP_ASPECT;
float HSM_DEVICE_FILL_MODE;
float HSM_DEVICE_SCALE;
float HSM_DEVICE_SCALE_X;
float HSM_DEVICE_POS_X;
float HSM_DEVICE_POS_Y;
float HSM_DEVICE_MIPMAPPING_BLEND_BIAS;
float HSM_DECAL_OPACITY;
float HSM_DECAL_COLORIZE_ON;
float HSM_DECAL_HUE;
float HSM_DECAL_SATURATION;
float HSM_DECAL_BRIGHTNESS;
float HSM_DECAL_GAMMA;
float HSM_DECAL_AMBIENT_LIGHTING_MULTIPLIER;
float HSM_DECAL_AMBIENT2_LIGHTING_MULTIPLIER;
float HSM_DECAL_APPLY_AMBIENT_IN_ADD_MODE;
float HSM_DECAL_BLEND_MODE;
float HSM_DECAL_SOURCE_MATTE_TYPE;
float HSM_DECAL_MASK_MODE;
float HSM_DECAL_CUTOUT_MODE;
float HSM_DECAL_DUALSCREEN_VIS_MODE;
float HSM_DECAL_SCALE_MODE;
float HSM_DECAL_SCALE_FULL_WITH_ZOOM;
float HSM_DECAL_SCALE_KEEP_ASPECT;
float HSM_DECAL_FILL_MODE;
float HSM_DECAL_SCALE;
float HSM_DECAL_SCALE_X;
float HSM_DECAL_POS_X;
float HSM_DECAL_POS_Y;
float HSM_DECAL_MIPMAPPING_BLEND_BIAS;
float HSM_CAB_GLASS_OPACITY;
float HSM_CAB_GLASS_COLORIZE_ON;
float HSM_CAB_GLASS_HUE;
float HSM_CAB_GLASS_SATURATION;
float HSM_CAB_GLASS_BRIGHTNESS;
float HSM_CAB_GLASS_GAMMA;
float HSM_CAB_GLASS_AMBIENT_LIGHTING_MULTIPLIER;
float HSM_CAB_GLASS_AMBIENT2_LIGHTING_MULTIPLIER;
float HSM_CAB_GLASS_APPLY_AMBIENT_IN_ADD_MODE;
float HSM_CAB_GLASS_BLEND_MODE;
float HSM_CAB_GLASS_SOURCE_MATTE_TYPE;
float HSM_CAB_GLASS_MASK_MODE;
float HSM_CAB_GLASS_CUTOUT_MODE;
float HSM_CAB_GLASS_DUALSCREEN_VIS_MODE;
float HSM_CAB_GLASS_SCALE_MODE;
float HSM_CAB_GLASS_SCALE_FULL_WITH_ZOOM;
float HSM_CAB_GLASS_SCALE_KEEP_ASPECT;
float HSM_CAB_GLASS_FILL_MODE;
float HSM_CAB_GLASS_SCALE;
float HSM_CAB_GLASS_SCALE_X;
float HSM_CAB_GLASS_POS_X;
float HSM_CAB_GLASS_POS_Y;
float HSM_CAB_GLASS_MIPMAPPING_BLEND_BIAS;
float HSM_TOP_OPACITY;
float HSM_TOP_COLORIZE_ON;
float HSM_TOP_HUE;
float HSM_TOP_SATURATION;
float HSM_TOP_BRIGHTNESS;
float HSM_TOP_GAMMA;
float HSM_TOP_AMBIENT_LIGHTING_MULTIPLIER;
float HSM_TOP_AMBIENT2_LIGHTING_MULTIPLIER;
float HSM_TOP_APPLY_AMBIENT_IN_ADD_MODE;
float HSM_TOP_BLEND_MODE;
float HSM_TOP_SOURCE_MATTE_TYPE;
float HSM_TOP_MASK_MODE;
float HSM_TOP_CUTOUT_MODE;
float HSM_TOP_DUALSCREEN_VIS_MODE;
float HSM_TOP_SCALE_MODE;
float HSM_TOP_SCALE_FULL_WITH_ZOOM;
float HSM_TOP_SCALE_KEEP_ASPECT;
float HSM_TOP_FILL_MODE;
float HSM_TOP_SCALE;
float HSM_TOP_SCALE_X;
float HSM_TOP_POS_X;
float HSM_TOP_POS_Y;
float HSM_TOP_MIRROR_WRAP;
float HSM_TOP_MIPMAPPING_BLEND_BIAS;
float HSM_RENDER_SIMPLE_MODE;
float HSM_RENDER_SIMPLE_MASK_TYPE;
float CURVATURE_MODE_OFF;
float CURVATURE_MODE_2D;
float CURVATURE_MODE_2D_CYLINDER;
float CURVATURE_MODE_3D_1;
float CURVATURE_MODE_3D_2;
float CURVATURE_MODE_3D_CYLINDER;

float HSM_GetCoreImageSplitDirection()
{
    float core_image_split_direction = 1.0;
    if (HSM_DUALSCREEN_CORE_IMAGE_SPLIT_MODE == 0.0)
    {
        if (HSM_DUALSCREEN_MODE == 1.0)
        {
            core_image_split_direction = 1.0;
        }
        if (HSM_DUALSCREEN_MODE == 2.0)
        {
            core_image_split_direction = 2.0;
        }
    }
    else
    {
        core_image_split_direction = HSM_DUALSCREEN_CORE_IMAGE_SPLIT_MODE;
    }
    return core_image_split_direction;
}

vec2 HSM_GetScreenDerezedSize()
{
    vec2 pass_size = global.DerezedPassSize.xy;
    if (HSM_DUALSCREEN_MODE > 0.0)
    {
        if (HSM_GetCoreImageSplitDirection() == 1.0)
        {
            pass_size.y *= 0.5;
        }
        else
        {
            pass_size.x *= 0.5;
        }
    }
    return pass_size;
}

vec2 HSM_GetRotatedScreenDerezedSize()
{
    vec2 pass_size = HSM_GetScreenDerezedSize();
    return (pass_size.yx * HSM_ROTATE_CORE_IMAGE) + (pass_size * (1.0 - HSM_ROTATE_CORE_IMAGE));
}

float HSM_GetSwappedScreenIndex(float screen_index)
{
    float out_index = screen_index;
    if (HSM_DUALSCREEN_CORE_IMAGE_SWAP_SCREENS == 1.0)
    {
        if (screen_index == 1.0)
        {
            out_index = 2.0;
        }
        else
        {
            out_index = 1.0;
        }
    }
    return out_index;
}

vec2 HSM_GetRotatedNegativeCropAddedSize()
{
    return (global.NegativeCropAddedPassSize.yx * HSM_ROTATE_CORE_IMAGE) + (global.NegativeCropAddedPassSize.xy * (1.0 - HSM_ROTATE_CORE_IMAGE));
}

vec2 HSM_RotateCoordinate(vec2 in_coord, float rotation_on)
{
    vec2 ctr_coord = in_coord - vec2(0.5);
    ctr_coord = (ctr_coord * (1.0 - rotation_on)) + (vec2(-ctr_coord.y, ctr_coord.x) * rotation_on);
    return ctr_coord + vec2(0.5);
}

vec4 HSM_GetTexSampleFromSampleStartAndSize(sampler2D in_sampler, inout vec2 in_screen_coord, vec2 sample_start_pixel_coord, vec2 window_size)
{
    vec2 core_prepped_size = HSM_GetRotatedNegativeCropAddedSize();
    if (HSM_DUALSCREEN_MODE > 0.0)
    {
        if (HSM_FLIP_CORE_VERTICAL == (-1.0))
        {
            in_screen_coord.y = 1.0 - in_screen_coord.y;
        }
    }
    vec2 px_coord = SAMPLE_AREA_START_PIXEL_COORD + (in_screen_coord * window_size);
    vec2 sample_coord = px_coord / core_prepped_size;
    vec2 param = sample_coord;
    float param_1 = HSM_ROTATE_CORE_IMAGE;
    sample_coord = HSM_RotateCoordinate(param, param_1);
    vec4 out_color = texture(in_sampler, sample_coord);
    return out_color;
}

vec4 HSM_GetBlackOnlyCropInPixels(sampler2D in_sampler_2D, vec2 sample_start_pixel_coord, vec2 window_size, float num_samples, vec4 max_crop)
{
    vec4 tex_sample = vec4(0.0);
    float brightness = 0.0;
    float test_crop = 0.0;
    float crop_left_px = max_crop.x;
    float crop_top_px = max_crop.y;
    float crop_right_px = max_crop.z;
    float crop_bottom_px = max_crop.w;
    float final_crop_left_px = crop_left_px;
    test_crop = crop_left_px;
    for (int i = 0; float(i) < crop_left_px; i++)
    {
        vec2 param = vec2((test_crop - 0.5) / window_size.x, 0.5);
        vec2 param_1 = sample_start_pixel_coord;
        vec2 param_2 = window_size;
        vec4 _2200 = HSM_GetTexSampleFromSampleStartAndSize(in_sampler_2D, param, param_1, param_2);
        tex_sample = _2200;
        brightness = (tex_sample.x + tex_sample.y) + tex_sample.z;
        if (brightness > HSM_CROP_BLACK_THRESHOLD)
        {
            final_crop_left_px = min(final_crop_left_px, test_crop);
        }
        test_crop -= 1.0;
    }
    final_crop_left_px -= 1.0;
    float final_crop_top_px = crop_top_px;
    test_crop = crop_top_px;
    for (int i_1 = 0; float(i_1) < crop_top_px; i_1++)
    {
        vec2 param_3 = vec2(0.5, (test_crop - 0.5) / window_size.y);
        vec2 param_4 = sample_start_pixel_coord;
        vec2 param_5 = window_size;
        vec4 _2247 = HSM_GetTexSampleFromSampleStartAndSize(in_sampler_2D, param_3, param_4, param_5);
        tex_sample = _2247;
        brightness = (tex_sample.x + tex_sample.y) + tex_sample.z;
        if (brightness > HSM_CROP_BLACK_THRESHOLD)
        {
            final_crop_top_px = test_crop;
        }
        test_crop -= 1.0;
    }
    final_crop_top_px -= 1.0;
    float final_crop_right_px = crop_right_px;
    test_crop = crop_right_px;
    for (int i_2 = 0; float(i_2) < crop_right_px; i_2++)
    {
        vec2 param_6 = vec2(((window_size.x - test_crop) + 0.5) / window_size.x, 0.5);
        vec2 param_7 = sample_start_pixel_coord;
        vec2 param_8 = window_size;
        vec4 _2295 = HSM_GetTexSampleFromSampleStartAndSize(in_sampler_2D, param_6, param_7, param_8);
        tex_sample = _2295;
        brightness = (tex_sample.x + tex_sample.y) + tex_sample.z;
        if (brightness > HSM_CROP_BLACK_THRESHOLD)
        {
            final_crop_right_px = test_crop;
        }
        test_crop -= 1.0;
    }
    final_crop_right_px -= 2.0;
    float final_crop_bottom_px = crop_bottom_px;
    test_crop = crop_bottom_px;
    for (int i_3 = 0; float(i_3) < crop_bottom_px; i_3++)
    {
        vec2 param_9 = vec2(0.5, ((window_size.y - test_crop) + 0.5) / window_size.y);
        vec2 param_10 = sample_start_pixel_coord;
        vec2 param_11 = window_size;
        vec4 _2343 = HSM_GetTexSampleFromSampleStartAndSize(in_sampler_2D, param_9, param_10, param_11);
        tex_sample = _2343;
        brightness = (tex_sample.x + tex_sample.y) + tex_sample.z;
        if (brightness > 0.0)
        {
            final_crop_bottom_px = test_crop;
        }
        test_crop -= 1.0;
    }
    final_crop_bottom_px -= 2.0;
    return clamp(vec4(final_crop_left_px, final_crop_top_px, final_crop_right_px, final_crop_bottom_px), vec4(0.0), vec4(512.0));
}

float HSM_GetUseVerticalScanlines(float screen_aspect)
{
    float auto_use_vert_scanlines = float(int(screen_aspect < 1.0));
    float scanline_direction = float((HSM_SCANLINE_DIRECTION < 2.0) ? 0 : 1);
    if (HSM_SCANLINE_DIRECTION < 1.0)
    {
        if (HSM_DUALSCREEN_MODE < 1.0)
        {
            scanline_direction = auto_use_vert_scanlines;
        }
    }
    return scanline_direction;
}

vec2 HSM_GetResMult()
{
    vec2 original_size = HSM_GetRotatedNegativeCropAddedSize();
    float param = original_size.x / original_size.y;
    float use_vert_scanlines = HSM_GetUseVerticalScanlines(param);
    vec2 sampling_mult = vec2(HSM_CORE_RES_SAMPLING_MULT_SCANLINE_DIR, HSM_CORE_RES_SAMPLING_MULT_OPPOSITE_DIR);
    bool _968 = (use_vert_scanlines == 1.0) && (HSM_ROTATE_CORE_IMAGE == 0.0);
    bool _977;
    if (!_968)
    {
        _977 = (use_vert_scanlines == 0.0) && (HSM_ROTATE_CORE_IMAGE == 1.0);
    }
    else
    {
        _977 = _968;
    }
    if (_977)
    {
        sampling_mult = sampling_mult.yx;
    }
    return sampling_mult;
}

void HSM_GetCroppedRotatedSizeAndPixelSampleAreaStart(inout float screen_index, sampler2D original_pass, inout vec2 cropped_rotated_size, out vec2 cropped_rotated_size_with_res_mult, out vec2 cropped_sample_area_start)
{
    float param = screen_index;
    screen_index = HSM_GetSwappedScreenIndex(param);
    vec2 rotated_negative_crop_added_size = HSM_GetRotatedNegativeCropAddedSize();
    float default_crop_left_px = floor(MAX_NEGATIVE_CROP * rotated_negative_crop_added_size.x);
    float default_crop_top_px = floor(MAX_NEGATIVE_CROP * rotated_negative_crop_added_size.y);
    float default_crop_right_px = floor(MAX_NEGATIVE_CROP * rotated_negative_crop_added_size.x);
    float default_crop_bottom_px = floor(MAX_NEGATIVE_CROP * rotated_negative_crop_added_size.y);
    float zoom_crop_left_px = floor(HSM_CROP_PERCENT_ZOOM * rotated_negative_crop_added_size.x);
    float zoom_crop_top_px = floor(HSM_CROP_PERCENT_ZOOM * rotated_negative_crop_added_size.y);
    float zoom_crop_right_px = floor(HSM_CROP_PERCENT_ZOOM * rotated_negative_crop_added_size.x);
    float zoom_crop_bottom_px = floor(HSM_CROP_PERCENT_ZOOM * rotated_negative_crop_added_size.y);
    float crop_left_px = floor(HSM_CROP_PERCENT_LEFT * rotated_negative_crop_added_size.x);
    float crop_top_px = floor(HSM_CROP_PERCENT_TOP * rotated_negative_crop_added_size.y);
    float crop_right_px = floor(HSM_CROP_PERCENT_RIGHT * rotated_negative_crop_added_size.x);
    float crop_bottom_px = floor(HSM_CROP_PERCENT_BOTTOM * rotated_negative_crop_added_size.y);
    float final_crop_left_px = 0.0;
    float final_crop_top_px = 0.0;
    float final_crop_right_px = 0.0;
    float final_crop_bottom_px = 0.0;
    cropped_rotated_size = vec2(100.0);
    cropped_sample_area_start = vec2(100.0);
    if (HSM_DUALSCREEN_MODE > 0.0)
    {
        float zoom_crop = 0.0;
        if (screen_index == 2.0)
        {
            crop_left_px = floor(HSM_2ND_SCREEN_CROP_PERCENT_LEFT * rotated_negative_crop_added_size.x);
            crop_top_px = floor(HSM_2ND_SCREEN_CROP_PERCENT_TOP * rotated_negative_crop_added_size.y);
            crop_right_px = floor(HSM_2ND_SCREEN_CROP_PERCENT_RIGHT * rotated_negative_crop_added_size.x);
            crop_bottom_px = floor(HSM_2ND_SCREEN_CROP_PERCENT_BOTTOM * rotated_negative_crop_added_size.y);
            zoom_crop = HSM_2ND_SCREEN_CROP_PERCENT_ZOOM;
            if (HSM_GetCoreImageSplitDirection() == 1.0)
            {
                default_crop_top_px = floor(rotated_negative_crop_added_size.y * (0.5 - HSM_DUALSCREEN_CORE_IMAGE_SPLIT_OFFSET));
                crop_top_px = floor(crop_top_px / 2.0);
                crop_bottom_px = floor(crop_bottom_px / 2.0);
            }
            else
            {
                default_crop_left_px = floor(rotated_negative_crop_added_size.x * (0.5 - HSM_DUALSCREEN_CORE_IMAGE_SPLIT_OFFSET));
                crop_left_px = floor(crop_left_px / 2.0);
                crop_right_px = floor(crop_right_px / 2.0);
            }
        }
        else
        {
            zoom_crop = HSM_CROP_PERCENT_ZOOM;
            if (HSM_GetCoreImageSplitDirection() == 1.0)
            {
                default_crop_bottom_px = floor(rotated_negative_crop_added_size.y * (0.5 + HSM_DUALSCREEN_CORE_IMAGE_SPLIT_OFFSET));
                crop_top_px = floor(crop_top_px / 2.0);
                crop_bottom_px = floor(crop_bottom_px / 2.0);
            }
            else
            {
                default_crop_right_px = floor(rotated_negative_crop_added_size.x * (0.5 + HSM_DUALSCREEN_CORE_IMAGE_SPLIT_OFFSET));
                crop_left_px = floor(crop_left_px / 2.0);
                crop_right_px = floor(crop_right_px / 2.0);
            }
        }
        vec2 base_cropped_size = rotated_negative_crop_added_size - vec2(final_crop_left_px + final_crop_right_px, final_crop_top_px + final_crop_bottom_px);
        if (HSM_GetCoreImageSplitDirection() == 1.0)
        {
            zoom_crop_top_px = floor((base_cropped_size.x * zoom_crop) / 2.0);
        }
        else
        {
            zoom_crop_left_px = floor((base_cropped_size.y * zoom_crop) / 2.0);
        }
        zoom_crop_right_px = zoom_crop_left_px;
        zoom_crop_bottom_px = zoom_crop_top_px;
        final_crop_top_px += ((default_crop_top_px + crop_top_px) + zoom_crop_top_px);
        final_crop_left_px += ((default_crop_left_px + crop_left_px) + zoom_crop_left_px);
        final_crop_right_px += ((default_crop_right_px + crop_right_px) + zoom_crop_right_px);
        final_crop_bottom_px += ((default_crop_bottom_px + crop_bottom_px) + zoom_crop_bottom_px);
    }
    else
    {
        if (HSM_CROP_MODE == 0.0)
        {
            final_crop_left_px = default_crop_left_px;
            final_crop_top_px = default_crop_top_px;
            final_crop_right_px = default_crop_right_px;
            final_crop_bottom_px = default_crop_bottom_px;
        }
        else
        {
            if (HSM_CROP_MODE == 1.0)
            {
                vec4 max_crop = vec4((default_crop_left_px + crop_left_px) + zoom_crop_left_px, (default_crop_top_px + crop_top_px) + zoom_crop_top_px, (default_crop_right_px + crop_right_px) + zoom_crop_right_px, (default_crop_bottom_px + crop_bottom_px) + zoom_crop_bottom_px);
                vec2 black_sample_start_coord_px = vec2(0.0);
                vec2 black_sample_window = rotated_negative_crop_added_size;
                vec2 param_1 = black_sample_start_coord_px;
                vec2 param_2 = black_sample_window;
                float param_3 = 100.0;
                vec4 param_4 = max_crop;
                vec4 cropping = HSM_GetBlackOnlyCropInPixels(original_pass, param_1, param_2, param_3, param_4);
                final_crop_left_px = cropping.x;
                final_crop_top_px = cropping.y;
                final_crop_right_px = cropping.z;
                final_crop_bottom_px = cropping.w;
            }
            else
            {
                final_crop_top_px = (default_crop_top_px + crop_top_px) + zoom_crop_top_px;
                final_crop_left_px = (default_crop_left_px + crop_left_px) + zoom_crop_left_px;
                final_crop_bottom_px = (default_crop_bottom_px + crop_bottom_px) + zoom_crop_bottom_px;
                final_crop_right_px = (default_crop_right_px + crop_right_px) + zoom_crop_right_px;
            }
        }
    }
    final_crop_top_px = clamp(final_crop_top_px, 0.0, 20000.0);
    final_crop_bottom_px = clamp(final_crop_bottom_px, 0.0, 20000.0);
    final_crop_left_px = clamp(final_crop_left_px, 0.0, 20000.0);
    final_crop_right_px = clamp(final_crop_right_px, 0.0, 20000.0);
    cropped_rotated_size = rotated_negative_crop_added_size - vec2(final_crop_left_px + final_crop_right_px, final_crop_top_px + final_crop_bottom_px);
    cropped_sample_area_start = vec2(final_crop_left_px, final_crop_top_px);
    vec2 sampling_mult = HSM_GetResMult();
    vec2 _2704;
    if (HSM_ROTATE_CORE_IMAGE == 1.0)
    {
        _2704 = sampling_mult.yx;
    }
    else
    {
        _2704 = sampling_mult;
    }
    sampling_mult = _2704;
    cropped_rotated_size_with_res_mult = ceil(cropped_rotated_size * sampling_mult);
}

vec3 HSM_GetScreenPlacementAndHeight(sampler2D in_sampler_2D, float num_samples)
{
    if (HSM_USE_IMAGE_FOR_PLACEMENT == 1.0)
    {
        float screen_top_y_pos = 1.0;
        float screen_bottom_y_pos = 0.0;
        for (int i = 0; float(i) < num_samples; i++)
        {
            float y_pos = float(i * 1) / num_samples;
            vec4 sample_color = texture(in_sampler_2D, vec2(0.5, y_pos));
            float test_value = 0.0;
            if (HSM_PLACEMENT_IMAGE_MODE > 0.0)
            {
                test_value = ((sample_color.x + sample_color.z) + sample_color.y) / 3.0;
            }
            else
            {
                test_value = 1.0 - sample_color.w;
            }
            if (test_value > 0.5)
            {
                screen_top_y_pos = min(screen_top_y_pos, y_pos);
                screen_bottom_y_pos = max(screen_bottom_y_pos, y_pos);
            }
        }
        float screen_left_x_pos = 0.75;
        float screen_right_x_pos = 0.25;
        if (HSM_PLACEMENT_IMAGE_USE_HORIZONTAL == 1.0)
        {
            for (int i_1 = 0; float(i_1) < num_samples; i_1++)
            {
                float x_pos = 0.25 + ((float(i_1) * 0.5) / num_samples);
                vec4 sample_color_1 = texture(in_sampler_2D, vec2(x_pos, 0.5));
                float test_value_1 = 0.0;
                if (HSM_PLACEMENT_IMAGE_MODE == 1.0)
                {
                    test_value_1 = ((sample_color_1.x + sample_color_1.z) + sample_color_1.y) / 3.0;
                }
                else
                {
                    test_value_1 = 1.0 - sample_color_1.w;
                }
                if (test_value_1 > 0.5)
                {
                    screen_left_x_pos = min(screen_left_x_pos, x_pos);
                    screen_right_x_pos = max(screen_right_x_pos, x_pos);
                }
            }
        }
        return vec3((screen_left_x_pos + screen_right_x_pos) / 2.0, (screen_top_y_pos + screen_bottom_y_pos) / 2.0, screen_bottom_y_pos - screen_top_y_pos);
    }
    else
    {
        return vec3(0.5, 0.5, 1.0);
    }
}

vec2 HSM_GetRotatedCoreOriginalSize()
{
    return (global.OriginalSize.yx * HSM_ROTATE_CORE_IMAGE) + (global.OriginalSize.xy * (1.0 - HSM_ROTATE_CORE_IMAGE));
}

bool HSM_ResolutionIsEqual(vec2 in_res, vec2 match_res)
{
    return all(equal(in_res, match_res));
}

vec2 HSM_GetScreenCorePreppedSize(float screen_index)
{
    vec2 core_prepped_size = global.NegativeCropAddedPassSize.xy;
    if (HSM_DUALSCREEN_MODE > 0.0)
    {
        if (HSM_GetCoreImageSplitDirection() == 1.0)
        {
            core_prepped_size.y *= 0.5;
        }
        else
        {
            core_prepped_size.x *= 0.5;
        }
    }
    return core_prepped_size;
}

vec2 HSM_GetRotatedScreenCorePreppedSize(float screen_index)
{
    float param = screen_index;
    vec2 original_size = HSM_GetScreenCorePreppedSize(param);
    return (original_size.yx * HSM_ROTATE_CORE_IMAGE) + (original_size * (1.0 - HSM_ROTATE_CORE_IMAGE));
}

float HSM_GetIsCorePreppedSizeVertical(float screen_index)
{
    float param = screen_index;
    vec2 rotated_original_size = HSM_GetRotatedScreenCorePreppedSize(param);
    float aspect_ratio = rotated_original_size.x / rotated_original_size.y;
    return float(int(aspect_ratio < 1.0));
}

float HSM_GetScreenAspect(float screen_index, vec2 cropped_size)
{
    vec2 original_size = HSM_GetRotatedCoreOriginalSize();
    vec2 rotated_original_size = HSM_GetRotatedCoreOriginalSize();
    float core_aspect_ratio = rotated_original_size.x / rotated_original_size.y;
    float _1798;
    if (core_aspect_ratio < 1.0)
    {
        _1798 = 1.0 / core_aspect_ratio;
    }
    else
    {
        _1798 = core_aspect_ratio;
    }
    float core_aspect_horizontal = _1798;
    float horizontal_aspect = 0.0;
    vec2 atari_lynx_res = vec2(160.0, 102.0);
    vec2 atari_2600_res = vec2(160.0, 228.0);
    vec2 atari_2600_crop_res = vec2(152.0, 228.0);
    vec2 nintendo_gameboy_advance_res = vec2(240.0, 160.0);
    vec2 nintendo_gameboy_res = vec2(160.0, 144.0);
    vec2 nintendo_ds_res = vec2(256.0, 192.0);
    vec2 nintendo_ds_top_bottom_res = vec2(256.0, 384.0);
    vec2 nintendo_ds_side_by_side_res = vec2(512.0, 192.0);
    vec2 nintendo_3ds_top_res = vec2(400.0, 240.0);
    vec2 nintendo_3ds_bottom_res = vec2(320.0, 240.0);
    vec2 nintendo_3ds_top_bottom_res = vec2(400.0, 480.0);
    vec2 nintendo_3ds_side_by_side_res = vec2(720.0, 240.0);
    vec2 sega_saturn_fmv_res = vec2(352.0, 480.0);
    vec2 sony_psp = vec2(480.0, 272.0);
    vec2 sony_ps_fmv_res = vec2(320.0, 480.0);
    vec2 sony_ps_fmv_res_2 = vec2(512.0, 480.0);
    float sony_ps_height = 448.0;
    if (HSM_ASPECT_RATIO_MODE == 0.0)
    {
        if (original_size.y > 580.0)
        {
            horizontal_aspect = core_aspect_horizontal;
        }
        else
        {
            vec2 param = sony_psp;
            vec2 param_1 = original_size;
            if (HSM_ResolutionIsEqual(param, param_1))
            {
                horizontal_aspect = core_aspect_horizontal;
            }
            else
            {
                vec2 param_2 = nintendo_gameboy_advance_res;
                vec2 param_3 = original_size;
                if (HSM_ResolutionIsEqual(param_2, param_3))
                {
                    horizontal_aspect = core_aspect_horizontal;
                }
                else
                {
                    vec2 param_4 = nintendo_gameboy_res;
                    vec2 param_5 = original_size;
                    if (HSM_ResolutionIsEqual(param_4, param_5))
                    {
                        horizontal_aspect = core_aspect_horizontal;
                    }
                    else
                    {
                        vec2 param_6 = nintendo_ds_res;
                        vec2 param_7 = original_size;
                        if (HSM_ResolutionIsEqual(param_6, param_7))
                        {
                            horizontal_aspect = core_aspect_horizontal;
                        }
                        else
                        {
                            vec2 param_8 = nintendo_ds_top_bottom_res;
                            vec2 param_9 = original_size;
                            if (HSM_ResolutionIsEqual(param_8, param_9))
                            {
                                horizontal_aspect = core_aspect_horizontal;
                            }
                            else
                            {
                                vec2 param_10 = nintendo_ds_side_by_side_res;
                                vec2 param_11 = original_size;
                                if (HSM_ResolutionIsEqual(param_10, param_11))
                                {
                                    horizontal_aspect = core_aspect_horizontal;
                                }
                                else
                                {
                                    vec2 param_12 = nintendo_3ds_top_res;
                                    vec2 param_13 = original_size;
                                    if (HSM_ResolutionIsEqual(param_12, param_13))
                                    {
                                        horizontal_aspect = core_aspect_horizontal;
                                    }
                                    else
                                    {
                                        vec2 param_14 = nintendo_3ds_bottom_res;
                                        vec2 param_15 = original_size;
                                        if (HSM_ResolutionIsEqual(param_14, param_15))
                                        {
                                            horizontal_aspect = core_aspect_horizontal;
                                        }
                                        else
                                        {
                                            vec2 param_16 = nintendo_3ds_top_bottom_res;
                                            vec2 param_17 = original_size;
                                            if (HSM_ResolutionIsEqual(param_16, param_17))
                                            {
                                                horizontal_aspect = core_aspect_horizontal;
                                            }
                                            else
                                            {
                                                vec2 param_18 = nintendo_3ds_side_by_side_res;
                                                vec2 param_19 = original_size;
                                                if (HSM_ResolutionIsEqual(param_18, param_19))
                                                {
                                                    horizontal_aspect = core_aspect_horizontal;
                                                }
                                                else
                                                {
                                                    vec2 param_20 = atari_lynx_res;
                                                    vec2 param_21 = original_size;
                                                    if (HSM_ResolutionIsEqual(param_20, param_21))
                                                    {
                                                        horizontal_aspect = core_aspect_horizontal;
                                                    }
                                                    else
                                                    {
                                                        vec2 param_22 = atari_2600_res;
                                                        vec2 param_23 = original_size;
                                                        if (HSM_ResolutionIsEqual(param_22, param_23))
                                                        {
                                                            horizontal_aspect = 1.3329999446868896484375;
                                                        }
                                                        else
                                                        {
                                                            vec2 param_24 = atari_2600_crop_res;
                                                            vec2 param_25 = original_size;
                                                            if (HSM_ResolutionIsEqual(param_24, param_25))
                                                            {
                                                                horizontal_aspect = 1.3329999446868896484375;
                                                            }
                                                            else
                                                            {
                                                                vec2 param_26 = sony_ps_fmv_res;
                                                                vec2 param_27 = original_size;
                                                                if (HSM_ResolutionIsEqual(param_26, param_27))
                                                                {
                                                                    horizontal_aspect = 1.3329999446868896484375;
                                                                }
                                                                else
                                                                {
                                                                    vec2 param_28 = sony_ps_fmv_res_2;
                                                                    vec2 param_29 = original_size;
                                                                    if (HSM_ResolutionIsEqual(param_28, param_29))
                                                                    {
                                                                        horizontal_aspect = 1.3329999446868896484375;
                                                                    }
                                                                    else
                                                                    {
                                                                        if (original_size.y == sony_ps_height)
                                                                        {
                                                                            horizontal_aspect = 1.3329999446868896484375;
                                                                        }
                                                                        else
                                                                        {
                                                                            horizontal_aspect = HSM_ASPECT_RATIO_EXPLICIT;
                                                                        }
                                                                    }
                                                                }
                                                            }
                                                        }
                                                    }
                                                }
                                            }
                                        }
                                    }
                                }
                            }
                        }
                    }
                }
            }
        }
    }
    else
    {
        if (HSM_ASPECT_RATIO_MODE == 1.0)
        {
            horizontal_aspect = HSM_ASPECT_RATIO_EXPLICIT;
        }
        else
        {
            if (HSM_ASPECT_RATIO_MODE == 2.0)
            {
                horizontal_aspect = 1.33329999446868896484375;
            }
            else
            {
                if (HSM_ASPECT_RATIO_MODE == 3.0)
                {
                    horizontal_aspect = 1.5;
                }
                else
                {
                    if (HSM_ASPECT_RATIO_MODE == 4.0)
                    {
                        horizontal_aspect = 1.777699947357177734375;
                    }
                    else
                    {
                        if (HSM_ASPECT_RATIO_MODE == 5.0)
                        {
                            horizontal_aspect = cropped_size.x / cropped_size.y;
                        }
                        else
                        {
                            if (HSM_ASPECT_RATIO_MODE == 6.0)
                            {
                                horizontal_aspect = global.FinalViewportSize.x / global.FinalViewportSize.y;
                            }
                            else
                            {
                                horizontal_aspect = 1.3329999446868896484375;
                            }
                        }
                    }
                }
            }
        }
    }
    float vertical_aspect = 1.0 / horizontal_aspect;
    float final_orientation = HSM_ASPECT_RATIO_ORIENTATION;
    if (HSM_ASPECT_RATIO_ORIENTATION < 0.5)
    {
        vec2 param_30 = atari_2600_res;
        vec2 param_31 = original_size;
        bool _2066 = HSM_ResolutionIsEqual(param_30, param_31);
        bool _2075;
        if (!_2066)
        {
            vec2 param_32 = atari_2600_crop_res;
            vec2 param_33 = original_size;
            _2075 = HSM_ResolutionIsEqual(param_32, param_33);
        }
        else
        {
            _2075 = _2066;
        }
        bool _2084;
        if (!_2075)
        {
            vec2 param_34 = sega_saturn_fmv_res;
            vec2 param_35 = original_size;
            _2084 = HSM_ResolutionIsEqual(param_34, param_35);
        }
        else
        {
            _2084 = _2075;
        }
        bool _2093;
        if (!_2084)
        {
            vec2 param_36 = sony_ps_fmv_res;
            vec2 param_37 = original_size;
            _2093 = HSM_ResolutionIsEqual(param_36, param_37);
        }
        else
        {
            _2093 = _2084;
        }
        bool _2102;
        if (!_2093)
        {
            vec2 param_38 = sony_ps_fmv_res_2;
            vec2 param_39 = original_size;
            _2102 = HSM_ResolutionIsEqual(param_38, param_39);
        }
        else
        {
            _2102 = _2093;
        }
        bool _2110;
        if (!_2102)
        {
            _2110 = original_size.y == sony_ps_height;
        }
        else
        {
            _2110 = _2102;
        }
        if (_2110)
        {
            final_orientation = 1.0;
        }
        else
        {
            float param_40 = screen_index;
            final_orientation = float((HSM_GetIsCorePreppedSizeVertical(param_40) > 0.5) ? 2 : 1);
        }
    }
    float final_aspect_ratio = (final_orientation < 1.5) ? horizontal_aspect : vertical_aspect;
    return final_aspect_ratio;
}

vec2 HSM_GetScreenScale(float screen_aspect, float screen_height_from_image, vec2 cropped_size)
{
    if (HSM_ASPECT_RATIO_MODE > 5.5)
    {
        return vec2(1.0);
    }
    else
    {
        float output_aspect_ratio = global.FinalViewportSize.x / global.FinalViewportSize.y;
        bool viewport_is_vertical = global.FinalViewportSize.x < global.FinalViewportSize.y;
        float vertical_preset_scale_mult = ((HSM_VERTICAL_PRESET > 0.5) || viewport_is_vertical) ? 0.42244184017181396484375 : 1.0;
        float screen_height = HSM_NON_INTEGER_SCALE * vertical_preset_scale_mult;
        if (HSM_DUALSCREEN_MODE > 0.0)
        {
            screen_height *= 0.5;
        }
        if (true)
        {
            if (HSM_USE_PHYSICAL_SIZE_FOR_NON_INTEGER == 1.0)
            {
                float _1477;
                if ((HSM_VERTICAL_PRESET > 0.5) || viewport_is_vertical)
                {
                    _1477 = 1.0 / HSM_PHYSICAL_MONITOR_ASPECT_RATIO;
                }
                else
                {
                    _1477 = HSM_PHYSICAL_MONITOR_ASPECT_RATIO;
                }
                float monitor_aspect_with_rotation = _1477;
                float monitor_height = HSM_PHYSICAL_MONITOR_DIAGONAL_SIZE / sqrt((monitor_aspect_with_rotation * monitor_aspect_with_rotation) + 1.0);
                float sim_screen_height = HSM_PHYSICAL_SIM_TUBE_DIAGONAL_SIZE / sqrt((screen_aspect * screen_aspect) + 1.0);
                screen_height = 0.01200000010430812835693359375 + (sim_screen_height / monitor_height);
            }
            if (HSM_USE_IMAGE_FOR_PLACEMENT == 1.0)
            {
                screen_height = screen_height_from_image;
            }
            screen_height *= HSM_NON_INTEGER_SCALE_OFFSET;
            if (HSM_SNAP_TO_CLOSEST_INT_SCALE_TOLERANCE > 0.0)
            {
                float integer_scale_multiple_vert = (screen_height * global.FinalViewportSize.y) / cropped_size.y;
                float int_scale_remainder = fract(integer_scale_multiple_vert);
                float _1532;
                if (int_scale_remainder < (1.0 - int_scale_remainder))
                {
                    _1532 = int_scale_remainder;
                }
                else
                {
                    _1532 = 1.0 - int_scale_remainder;
                }
                int_scale_remainder = _1532;
                float remainder_percent_of_screen_height = (int_scale_remainder * cropped_size.y) / (screen_height * global.FinalViewportSize.y);
                if (remainder_percent_of_screen_height < HSM_SNAP_TO_CLOSEST_INT_SCALE_TOLERANCE)
                {
                    integer_scale_multiple_vert = round(integer_scale_multiple_vert);
                    screen_height = (integer_scale_multiple_vert * cropped_size.y) / global.FinalViewportSize.y;
                }
            }
            return vec2(screen_aspect / output_aspect_ratio, 1.0) * screen_height;
        }
        float viewport_res_y_without_border = global.FinalViewportSize.y - ((1.0 - HSM_INT_SCALE_MAX_HEIGHT) * global.FinalViewportSize.y);
        float viewport_res_x_without_border = global.FinalViewportSize.x - ((1.0 - HSM_INT_SCALE_MAX_HEIGHT) * global.FinalViewportSize.x);
        if (HSM_DUALSCREEN_MODE == 1.0)
        {
            viewport_res_y_without_border = (global.FinalViewportSize.y / 2.0) - ((0.5 * (1.0 - HSM_INT_SCALE_MAX_HEIGHT)) * global.FinalViewportSize.y);
        }
        if (HSM_DUALSCREEN_MODE == 2.0)
        {
            viewport_res_x_without_border *= ((global.FinalViewportSize.x / 2.0) - ((0.5 * (1.0 - HSM_INT_SCALE_MAX_HEIGHT)) * global.FinalViewportSize.x));
        }
        if (viewport_is_vertical)
        {
            viewport_res_y_without_border = viewport_res_x_without_border / screen_aspect;
        }
        if ((viewport_res_y_without_border * screen_aspect) > global.FinalViewportSize.x)
        {
            viewport_res_y_without_border = ((1.0 - (2.0 * (1.0 - HSM_INT_SCALE_MAX_HEIGHT))) * global.FinalViewportSize.x) / screen_aspect;
        }
        float integer_scale_multiple_vert_1 = clamp(floor(viewport_res_y_without_border / cropped_size.y) + 0.0, 1.0, 100.0);
        float integer_scale_vert = (integer_scale_multiple_vert_1 * cropped_size.y) / global.FinalViewportSize.y;
        float integer_scale_horz_from_aspect = (screen_aspect / output_aspect_ratio) * integer_scale_vert;
        float integer_scale_multiple_horz = (integer_scale_horz_from_aspect * global.FinalViewportSize.x) / cropped_size.x;
        float final_int_scale_mode = 0.0;
        if (false)
        {
            float param = screen_aspect;
            if ((HSM_GetUseVerticalScanlines(param) == 1.0) || false)
            {
                integer_scale_multiple_horz = round(integer_scale_multiple_horz);
                final_int_scale_mode = 2.0;
            }
        }
        float both_axes = clamp((final_int_scale_mode - 1.0) * 10000.0, 0.0, 1.0);
        integer_scale_multiple_vert_1 += ((both_axes * abs(clamp((screen_aspect - 1.0) * 10000.0, -1.0, 0.0))) * 0.0);
        integer_scale_multiple_horz += ((both_axes * abs(clamp((screen_aspect - 1.0) * 10000.0, 0.0, 1.0))) * 0.0);
        integer_scale_vert = (integer_scale_multiple_vert_1 * cropped_size.y) / global.FinalViewportSize.y;
        float integer_scale_horz = (integer_scale_multiple_horz * cropped_size.x) / global.FinalViewportSize.x;
        return vec2(integer_scale_horz, integer_scale_vert);
    }
}

vec2 HSM_GetScreenScaleWithEdgeHeight(vec2 edge_thickness, vec2 screen_scale)
{
    float output_aspect_ratio = global.FinalViewportSize.x / global.FinalViewportSize.y;
    float aspect_ratio = screen_scale.x / screen_scale.y;
    vec2 edge_width_height_as_scale = vec2(0.0);
    edge_width_height_as_scale.x = 1.0 + (((edge_thickness.x / screen_scale.y) / aspect_ratio) / output_aspect_ratio);
    edge_width_height_as_scale.y = 1.0 + (edge_thickness.y / screen_scale.y);
    return screen_scale * edge_width_height_as_scale;
}

vec2 HSM_GetTubeScale(inout vec2 screen_scale, float image_placement_screen_height, vec2 edge_thickness)
{
    if (false)
    {
        if (HSM_USE_IMAGE_FOR_PLACEMENT == 0.0)
        {
            screen_scale = ((screen_scale / vec2(screen_scale.y)) * 82.970001220703125) / vec2(100.0);
        }
        else
        {
            screen_scale = (screen_scale / vec2(screen_scale.y)) * image_placement_screen_height;
        }
    }
    float normalized_screen_height = screen_scale.y / 0.82959997653961181640625;
    vec2 param = edge_thickness * vec2(0.01200000010430812835693359375 * normalized_screen_height);
    vec2 param_1 = (screen_scale * 100.0) / vec2(100.0);
    return HSM_GetScreenScaleWithEdgeHeight(param, param_1);
}

vec2 HSM_GetScreenPositionOffset(inout vec2 placement_image_pos, vec2 screen_scale, float screen_index)
{
    float output_aspect = global.FinalViewportSize.x / global.FinalViewportSize.y;
    placement_image_pos = ((HSM_USE_IMAGE_FOR_PLACEMENT == 1.0) && (screen_index == 1.0)) ? placement_image_pos : vec2(0.5);
    vec2 _1039;
    if (screen_index == 1.0)
    {
        _1039 = vec2(HSM_SCREEN_POSITION_X / output_aspect, HSM_SCREEN_POSITION_Y) + (placement_image_pos - vec2(0.5));
    }
    else
    {
        _1039 = vec2(HSM_2ND_SCREEN_POS_X / output_aspect, HSM_2ND_SCREEN_POS_Y);
    }
    vec2 pos_offset = _1039;
    float split_offset_multiplier = float((screen_index == 1.0) ? (-1) : 1);
    if (HSM_DUALSCREEN_MODE == 1.0)
    {
        if (HSM_DUALSCREEN_SHIFT_POSITION_WITH_SCALE == 1.0)
        {
            pos_offset.y += (HSM_DUALSCREEN_VIEWPORT_SPLIT_LOCATION + (((split_offset_multiplier * screen_scale.y) * 1.16999995708465576171875) / 2.0));
        }
        else
        {
            pos_offset.y += (split_offset_multiplier * 0.25);
        }
        pos_offset.y += (split_offset_multiplier * HSM_DUALSCREEN_POSITION_OFFSET_BETWEEN_SCREENS);
    }
    if (HSM_DUALSCREEN_MODE == 2.0)
    {
        if (HSM_DUALSCREEN_SHIFT_POSITION_WITH_SCALE == 1.0)
        {
            pos_offset.x += ((HSM_DUALSCREEN_VIEWPORT_SPLIT_LOCATION / output_aspect) + (((split_offset_multiplier * screen_scale.x) * 1.16999995708465576171875) / 2.0));
        }
        else
        {
            pos_offset.x += ((split_offset_multiplier * 0.25) / output_aspect);
        }
        pos_offset.x += ((split_offset_multiplier * HSM_DUALSCREEN_POSITION_OFFSET_BETWEEN_SCREENS) / output_aspect);
    }
    return pos_offset;
}

vec2 HSM_GetScreenScaleFor2ndScreen(vec2 screen_scale, float screen_aspect)
{
    vec2 out_screen_scale = screen_scale;
    float output_aspect = global.FinalViewportSize.x / global.FinalViewportSize.y;
    if (HSM_2ND_SCREEN_INDEPENDENT_SCALE == 1.0)
    {
        out_screen_scale = vec2(screen_aspect / output_aspect, 1.0) * 0.414799988269805908203125;
    }
    else
    {
        out_screen_scale = vec2(screen_aspect / output_aspect, 1.0) * screen_scale.y;
    }
    out_screen_scale *= HSM_2ND_SCREEN_SCALE_OFFSET;
    return out_screen_scale;
}

vec4 HSM_GetCacheSampleRange(float column_index, float row_index)
{
    float num_rows = 8.0;
    float num_columns = 8.0;
    float range_width = 1.0 / num_columns;
    float range_height = 1.0 / num_rows;
    float zero_based_row_index = row_index - 1.0;
    float zero_based_column_index = column_index - 1.0;
    vec4 out_sample_range = vec4(0.0);
    out_sample_range.x = zero_based_column_index * range_width;
    out_sample_range.y = zero_based_row_index * range_height;
    out_sample_range.z = out_sample_range.x + range_width;
    out_sample_range.w = out_sample_range.y + range_height;
    return out_sample_range;
}

int HSM_IsCoordIn2DRange(vec2 in_coord, vec4 in_2d_range)
{
    bool _2133 = in_coord.x > in_2d_range.x;
    bool _2141;
    if (_2133)
    {
        _2141 = in_coord.y > in_2d_range.y;
    }
    else
    {
        _2141 = _2133;
    }
    bool _2149;
    if (_2141)
    {
        _2149 = in_coord.x < in_2d_range.z;
    }
    else
    {
        _2149 = _2141;
    }
    bool _2157;
    if (_2149)
    {
        _2157 = in_coord.y < in_2d_range.w;
    }
    else
    {
        _2157 = _2149;
    }
    return int(_2157);
}

float HSM_GetAverageLuma(sampler2D Source_1, vec2 SourceSize)
{
    float m = max(log2(global.SourceSize.x), log2(global.SourceSize.y));
    m = max(m - 1.0, 1.0);
    float luma_total = 0.0;
    float num_samples = 5.0;
    float sample_dist = 1.0 / (num_samples - 1.0);
    vec4 tex_sample = vec4(0.0);
    for (float i = 0.0; i <= num_samples; i += 1.0)
    {
        for (float j = 0.0; j <= num_samples; j += 1.0)
        {
            tex_sample = textureLod(Source_1, vec2(sample_dist * i, sample_dist * j), m);
            luma_total += max(0.0, ((tex_sample.x + tex_sample.y) + tex_sample.y) / 3.0);
        }
    }
    luma_total = pow((0.57735025882720947265625 * luma_total) / (num_samples * num_samples), 0.60000002384185791015625);
    return luma_total;
}

float HSM_GetParameterSum()
{
    float _2785 = ((((((((((((((((((((((((((((((0.0 + (HSM_GLOBAL_GRAPHICS_BRIGHTNESS * 100.0)) + HSM_STATIC_LAYERS_GAMMA) + (HSM_AMBIENT_LIGHTING_OPACITY * 100.0)) + (HSM_AMBIENT2_LIGHTING_OPACITY * 100.0)) + HSM_AMBIENT_LIGHTING_SWAP_IMAGES) + (HSM_VIEWPORT_ZOOM * 100.0)) + (HSM_VIEWPORT_POSITION_X * 1000.0)) + (HSM_VIEWPORT_POSITION_Y * 1000.0)) + HSM_FLIP_VIEWPORT_VERTICAL) + HSM_FLIP_VIEWPORT_HORIZONTAL) + HSM_ASPECT_RATIO_ORIENTATION) + HSM_ASPECT_RATIO_MODE) + HSM_ASPECT_RATIO_EXPLICIT) + 0.0) + HSM_VERTICAL_PRESET) + HSM_INT_SCALE_MAX_HEIGHT) + 0.0) + 0.0) + HSM_NON_INTEGER_SCALE) + HSM_USE_PHYSICAL_SIZE_FOR_NON_INTEGER) + HSM_PHYSICAL_MONITOR_ASPECT_RATIO) + HSM_PHYSICAL_MONITOR_DIAGONAL_SIZE) + HSM_PHYSICAL_SIM_TUBE_DIAGONAL_SIZE) + HSM_USE_IMAGE_FOR_PLACEMENT) + HSM_PLACEMENT_IMAGE_USE_HORIZONTAL) + HSM_PLACEMENT_IMAGE_MODE) + (HSM_NON_INTEGER_SCALE_OFFSET * 100.0)) + HSM_USE_SNAP_TO_CLOSEST_INT_SCALE) + HSM_SNAP_TO_CLOSEST_INT_SCALE_TOLERANCE) + (HSM_SCREEN_POSITION_X * 1000.0)) + (HSM_SCREEN_POSITION_Y * 1000.0);
    float _2853 = ((((((((((((((((((((((((((((((((_2785 + HSM_CROP_MODE) + (HSM_CROP_PERCENT_ZOOM * 100.0)) + (HSM_CROP_PERCENT_TOP * 100.0)) + (HSM_CROP_PERCENT_BOTTOM * 100.0)) + (HSM_CROP_PERCENT_LEFT * 100.0)) + (HSM_CROP_PERCENT_RIGHT * 100.0)) + (HSM_CROP_BLACK_THRESHOLD * 100.0)) + HSM_CURVATURE_MODE) + 100.0) + 100.0) + (HSM_CURVATURE_3D_RADIUS * 100.0)) + (HSM_CURVATURE_3D_VIEW_DIST * 100.0)) + (HSM_CURVATURE_3D_TILT_ANGLE_X * 100.0)) + (HSM_CURVATURE_3D_TILT_ANGLE_Y * 100.0)) + HSM_AB_COMPARE_AREA) + HSM_AB_COMPARE_SPLIT_POSITION) + HSM_AB_COMPARE_FREEZE_GRAPHICS) + 0.0) + 1.0) + 1.0) + 1.33329999446868896484375) + 10.0) + 100.0) + 70.0) + 100.0) + 70.0) + 100.0) + HSM_DUALSCREEN_MODE) + HSM_DUALSCREEN_CORE_IMAGE_SPLIT_MODE) + HSM_DUALSCREEN_CORE_IMAGE_SWAP_SCREENS) + (HSM_DUALSCREEN_CORE_IMAGE_SPLIT_OFFSET * 1000.0)) + (HSM_DUALSCREEN_VIEWPORT_SPLIT_LOCATION * 1000.0)) + HSM_DUALSCREEN_SHIFT_POSITION_WITH_SCALE;
    float _2921 = ((((((((((((((((((((((((_2853 + (HSM_DUALSCREEN_POSITION_OFFSET_BETWEEN_SCREENS * 1000.0)) + HSM_2ND_SCREEN_ASPECT_RATIO_MODE) + HSM_2ND_SCREEN_INDEPENDENT_SCALE) + (HSM_2ND_SCREEN_SCALE_OFFSET * 100.0)) + (HSM_2ND_SCREEN_POS_X * 1000.0)) + (HSM_2ND_SCREEN_POS_Y * 1000.0)) + (HSM_2ND_SCREEN_CROP_PERCENT_ZOOM * 100.0)) + (HSM_2ND_SCREEN_CROP_PERCENT_TOP * 100.0)) + (HSM_2ND_SCREEN_CROP_PERCENT_BOTTOM * 100.0)) + (HSM_2ND_SCREEN_CROP_PERCENT_LEFT * 100.0)) + (HSM_2ND_SCREEN_CROP_PERCENT_RIGHT * 100.0)) + (HSM_AMBIENT_LIGHTING_HUE * 360.0)) + (HSM_AMBIENT_LIGHTING_SATURATION * 100.0)) + (HSM_AMBIENT_LIGHTING_VALUE * 100.0)) + HSM_AMBIENT_LIGHTING_CONTRAST) + HSM_AMBIENT_LIGHTING_SCALE_KEEP_ASPECT) + HSM_AMBIENT_LIGHTING_SCALE_WITH_ZOOM) + (HSM_AMBIENT_LIGHTING_SCALE * 100.0)) + (HSM_AMBIENT_LIGHTING_SCALE_X * 100.0)) + HSM_AMBIENT_LIGHTING_ROTATE) + HSM_AMBIENT_LIGHTING_MIRROR_HORZ) + (HSM_AMBIENT_LIGHTING_POSITION_X * 1000.0)) + (HSM_AMBIENT_LIGHTING_POSITION_Y * 1000.0)) + HSM_AMBIENT_LIGHTING_DITHERING_SAMPLES) + (HSM_AMBIENT2_LIGHTING_HUE * 360.0);
    float _2992 = ((((((((((((((((((((((((((((_2921 + (HSM_AMBIENT2_LIGHTING_SATURATION * 100.0)) + (HSM_AMBIENT2_LIGHTING_VALUE * 100.0)) + HSM_AMBIENT2_LIGHTING_CONTRAST) + HSM_AMBIENT2_LIGHTING_SCALE_KEEP_ASPECT) + HSM_AMBIENT2_LIGHTING_SCALE_WITH_ZOOM) + (HSM_AMBIENT2_LIGHTING_SCALE * 100.0)) + (HSM_AMBIENT2_LIGHTING_SCALE_X * 100.0)) + HSM_AMBIENT2_LIGHTING_ROTATE) + HSM_AMBIENT2_LIGHTING_MIRROR_HORZ) + (HSM_AMBIENT2_LIGHTING_POSITION_X * 1000.0)) + (HSM_AMBIENT2_LIGHTING_POSITION_Y * 1000.0)) + 0.0) + 82.970001220703125) + 0.0) + 100.0) + 100.0) + (HSM_BZL_OPACITY * 100.0)) + HSM_BZL_BLEND_MODE) + (HSM_BZL_WIDTH / 0.0008623999892733991146087646484375)) + (HSM_BZL_HEIGHT / 0.000873200013302266597747802734375)) + 100.0) + 100.0) + (HSM_BZL_INNER_CORNER_RADIUS_SCALE * 100.0)) + (HSM_BZL_INNER_EDGE_THICKNESS / 7.0000001869630068540573120117188e-05)) + (HSM_BZL_INNER_EDGE_SHARPNESS * 100.0)) + (HSM_BZL_OUTER_POSITION_Y * 2000.0)) + (HSM_BZL_OUTER_CURVATURE_SCALE * 100.0)) + (HSM_BZL_OUTER_CORNER_RADIUS_SCALE * 100.0)) + (HSM_BZL_BRIGHTNESS * 100.0);
    float _3063 = (((((((((((((((((((((((_2992 + (HSM_BZL_HIGHLIGHT * 100.0)) + (HSM_BZL_NOISE * 100.0)) + (HSM_BZL_INNER_EDGE_SHADOW * 100.0)) + (HSM_BZL_COLOR_HUE * 360.0)) + (HSM_BZL_COLOR_SATURATION * 100.0)) + (HSM_BZL_COLOR_VALUE * 100.0)) + (HSM_BZL_AMBIENT_LIGHTING_MULTIPLIER * 100.0)) + (HSM_BZL_AMBIENT2_LIGHTING_MULTIPLIER * 100.0)) + HSM_FRM_USE_INDEPENDENT_COLOR) + (HSM_FRM_COLOR_HUE * 360.0)) + (HSM_FRM_COLOR_SATURATION * 100.0)) + (HSM_FRM_COLOR_VALUE * 100.0)) + (HSM_FRM_OPACITY * 100.0)) + HSM_FRM_BLEND_MODE) + (HSM_FRM_TEXTURE_OPACITY * 100.0)) + HSM_FRM_TEXTURE_BLEND_MODE) + (HSM_FRM_NOISE * 100.0)) + (HSM_FRM_INNER_EDGE_THICKNESS / 2.9999999242136254906654357910156e-05)) + (HSM_FRM_THICKNESS / 0.00069999997504055500030517578125)) + (HSM_FRM_THICKNESS_SCALE_X * 100.0)) + (HSM_FRM_OUTER_POS_Y * 100.0)) + (HSM_FRM_OUTER_CURVATURE_SCALE * 100.0)) + HSM_FRM_OUTER_CORNER_RADIUS) + (HSM_FRM_OUTER_EDGE_THICKNESS / 5.9999998484272509813308715820312e-05);
    float _3129 = ((((((((((((((((((((((((((((_3063 + (HSM_FRM_OUTER_EDGE_SHADING * 100.0)) + (HSM_FRM_SHADOW_OPACITY * 100.0)) + (HSM_FRM_SHADOW_WIDTH * 1000.0)) + HSM_BG_LAYER_ORDER) + HSM_VIEWPORT_VIGNETTE_LAYER_ORDER) + HSM_CRT_LAYER_ORDER) + HSM_DEVICE_LAYER_ORDER) + HSM_CAB_GLASS_LAYER_ORDER) + HSM_DECAL_LAYER_ORDER) + HSM_LED_LAYER_ORDER) + HSM_TOP_LAYER_ORDER) + HSM_BG_OPACITY) + HSM_BG_COLORIZE_ON) + (HSM_BG_HUE * 360.0)) + (HSM_BG_SATURATION * 100.0)) + (HSM_BG_BRIGHTNESS * 100.0)) + HSM_BG_GAMMA) + (HSM_BG_AMBIENT_LIGHTING_MULTIPLIER * 100.0)) + (HSM_BG_AMBIENT2_LIGHTING_MULTIPLIER * 100.0)) + HSM_BG_APPLY_AMBIENT_IN_ADD_MODE) + HSM_BG_BLEND_MODE) + HSM_BG_SOURCE_MATTE_TYPE) + HSM_BG_MASK_MODE) + HSM_BG_CUTOUT_MODE) + HSM_BG_DUALSCREEN_VIS_MODE) + HSM_BG_SCALE_MODE) + HSM_BG_SCALE_FULL_WITH_ZOOM) + HSM_BG_FILL_MODE) + HSM_BG_SCALE_KEEP_ASPECT;
    float _3195 = (((((((((((((((((((((((((_3129 + (HSM_BG_SCALE * 100.0)) + (HSM_BG_SCALE_X * 100.0)) + (HSM_BG_POS_X * 100.0)) + (HSM_BG_POS_Y * 100.0)) + HSM_BG_MIRROR_WRAP) + HSM_BG_MIPMAPPING_BLEND_BIAS) + (HSM_VIEWPORT_VIGNETTE_OPACITY * 100.0)) + HSM_VIEWPORT_VIGNETTE_MASK_MODE) + HSM_VIEWPORT_VIGNETTE_CUTOUT_MODE) + HSM_VIEWPORT_VIGNETTE_SCALE_MODE) + (HSM_VIEWPORT_VIGNETTE_SCALE * 100.0)) + (HSM_VIEWPORT_VIGNETTE_SCALE_X * 100.0)) + (HSM_VIEWPORT_VIGNETTE_POS_X * 100.0)) + (HSM_VIEWPORT_VIGNETTE_POS_Y * 100.0)) + HSM_CUTOUT_ASPECT_MODE) + HSM_CUTOUT_EXPLICIT_ASPECT) + HSM_CUTOUT_SCALE_MODE) + HSM_CUTOUT_SCALE_FULL_WITH_ZOOM) + HSM_CUTOUT_KEEP_ASPECT) + (HSM_CUTOUT_SCALE * 100.0)) + (HSM_CUTOUT_SCALE_X * 100.0)) + (HSM_CUTOUT_POS_X * 400.0)) + (HSM_CUTOUT_POS_Y * 400.0)) + HSM_CUTOUT_CORNER_RADIUS) + (HSM_LED_OPACITY * 100.0)) + HSM_LED_COLORIZE_ON;
    float _3262 = ((((((((((((((((((((((((((_3195 + (HSM_LED_HUE * 360.0)) + (HSM_LED_SATURATION * 100.0)) + (HSM_LED_BRIGHTNESS * 100.0)) + HSM_LED_GAMMA) + (HSM_LED_AMBIENT_LIGHTING_MULTIPLIER * 100.0)) + (HSM_LED_AMBIENT2_LIGHTING_MULTIPLIER * 100.0)) + HSM_LED_APPLY_AMBIENT_IN_ADD_MODE) + HSM_LED_BLEND_MODE) + HSM_LED_SOURCE_MATTE_TYPE) + HSM_LED_MASK_MODE) + HSM_LED_CUTOUT_MODE) + HSM_LED_DUALSCREEN_VIS_MODE) + HSM_LED_SCALE_MODE) + HSM_LED_SCALE_FULL_WITH_ZOOM) + HSM_LED_SCALE_KEEP_ASPECT) + HSM_LED_FILL_MODE) + (HSM_LED_SCALE * 100.0)) + (HSM_LED_SCALE_X * 100.0)) + (HSM_LED_POS_X * 100.0)) + (HSM_LED_POS_Y * 100.0)) + HSM_LED_MIPMAPPING_BLEND_BIAS) + (HSM_DEVICE_OPACITY * 100.0)) + HSM_DEVICE_COLORIZE_ON) + (HSM_DEVICE_HUE * 360.0)) + (HSM_DEVICE_SATURATION * 100.0)) + (HSM_DEVICE_BRIGHTNESS * 100.0)) + HSM_DEVICE_GAMMA;
    float _3328 = ((((((((((((((((((((((((((_3262 + (HSM_DEVICE_AMBIENT_LIGHTING_MULTIPLIER * 100.0)) + (HSM_DEVICE_AMBIENT2_LIGHTING_MULTIPLIER * 100.0)) + HSM_DEVICE_APPLY_AMBIENT_IN_ADD_MODE) + HSM_DEVICE_BLEND_MODE) + HSM_DEVICE_SOURCE_MATTE_TYPE) + HSM_DEVICE_MASK_MODE) + HSM_DEVICE_CUTOUT_MODE) + HSM_DEVICE_DUALSCREEN_VIS_MODE) + HSM_DEVICE_SCALE_MODE) + HSM_DEVICE_SCALE_FULL_WITH_ZOOM) + HSM_DEVICE_SCALE_KEEP_ASPECT) + HSM_DEVICE_FILL_MODE) + (HSM_DEVICE_SCALE * 100.0)) + (HSM_DEVICE_SCALE_X * 100.0)) + (HSM_DEVICE_POS_X * 100.0)) + (HSM_DEVICE_POS_Y * 100.0)) + HSM_DEVICE_COPY_INHERITED_COORD) + HSM_DEVICE_MIPMAPPING_BLEND_BIAS) + (HSM_DECAL_OPACITY * 100.0)) + HSM_DECAL_COLORIZE_ON) + (HSM_DECAL_HUE * 360.0)) + (HSM_DECAL_SATURATION * 100.0)) + (HSM_DECAL_BRIGHTNESS * 100.0)) + HSM_DECAL_GAMMA) + (HSM_DECAL_AMBIENT_LIGHTING_MULTIPLIER * 100.0)) + (HSM_DECAL_AMBIENT2_LIGHTING_MULTIPLIER * 100.0)) + HSM_DECAL_APPLY_AMBIENT_IN_ADD_MODE;
    float _3394 = (((((((((((((((((((((((((((_3328 + HSM_DECAL_BLEND_MODE) + HSM_DECAL_SOURCE_MATTE_TYPE) + HSM_DECAL_MASK_MODE) + HSM_DECAL_CUTOUT_MODE) + HSM_DECAL_DUALSCREEN_VIS_MODE) + HSM_DECAL_SCALE_MODE) + HSM_DECAL_SCALE_FULL_WITH_ZOOM) + HSM_DECAL_SCALE_KEEP_ASPECT) + HSM_DECAL_FILL_MODE) + (HSM_DECAL_SCALE * 100.0)) + (HSM_DECAL_SCALE_X * 100.0)) + (HSM_DECAL_POS_X * 100.0)) + (HSM_DECAL_POS_Y * 100.0)) + HSM_DECAL_MIPMAPPING_BLEND_BIAS) + (HSM_CAB_GLASS_OPACITY * 100.0)) + HSM_CAB_GLASS_COLORIZE_ON) + (HSM_CAB_GLASS_HUE * 360.0)) + (HSM_CAB_GLASS_SATURATION * 100.0)) + (HSM_CAB_GLASS_BRIGHTNESS * 100.0)) + HSM_CAB_GLASS_GAMMA) + (HSM_CAB_GLASS_AMBIENT_LIGHTING_MULTIPLIER * 100.0)) + (HSM_CAB_GLASS_AMBIENT2_LIGHTING_MULTIPLIER * 100.0)) + HSM_CAB_GLASS_APPLY_AMBIENT_IN_ADD_MODE) + HSM_CAB_GLASS_BLEND_MODE) + HSM_CAB_GLASS_SOURCE_MATTE_TYPE) + HSM_CAB_GLASS_MASK_MODE) + HSM_CAB_GLASS_CUTOUT_MODE) + HSM_CAB_GLASS_DUALSCREEN_VIS_MODE;
    float _3461 = (((((((((((((((((((((((((((_3394 + HSM_CAB_GLASS_SCALE_MODE) + HSM_CAB_GLASS_SCALE_FULL_WITH_ZOOM) + HSM_CAB_GLASS_SCALE_KEEP_ASPECT) + HSM_CAB_GLASS_FILL_MODE) + (HSM_CAB_GLASS_SCALE * 100.0)) + (HSM_CAB_GLASS_SCALE_X * 100.0)) + (HSM_CAB_GLASS_POS_X * 100.0)) + (HSM_CAB_GLASS_POS_Y * 100.0)) + HSM_CAB_GLASS_MIPMAPPING_BLEND_BIAS) + (HSM_TOP_OPACITY * 100.0)) + HSM_TOP_COLORIZE_ON) + (HSM_TOP_HUE * 360.0)) + (HSM_TOP_SATURATION * 100.0)) + (HSM_TOP_BRIGHTNESS * 100.0)) + HSM_TOP_GAMMA) + (HSM_TOP_AMBIENT_LIGHTING_MULTIPLIER * 100.0)) + (HSM_TOP_AMBIENT2_LIGHTING_MULTIPLIER * 100.0)) + HSM_TOP_APPLY_AMBIENT_IN_ADD_MODE) + HSM_TOP_BLEND_MODE) + HSM_TOP_SOURCE_MATTE_TYPE) + HSM_TOP_MASK_MODE) + HSM_TOP_CUTOUT_MODE) + HSM_TOP_DUALSCREEN_VIS_MODE) + HSM_TOP_SCALE_MODE) + HSM_TOP_SCALE_FULL_WITH_ZOOM) + HSM_TOP_SCALE_KEEP_ASPECT) + HSM_TOP_FILL_MODE) + (HSM_TOP_SCALE * 100.0);
    float out_sum = ((((((_3461 + (HSM_TOP_SCALE_X * 100.0)) + (HSM_TOP_POS_X * 100.0)) + (HSM_TOP_POS_Y * 100.0)) + HSM_TOP_MIRROR_WRAP) + HSM_TOP_MIPMAPPING_BLEND_BIAS) + HSM_RENDER_SIMPLE_MODE) + HSM_LAYERING_DEBUG_MASK_MODE;
    return out_sum;
}

vec2 HSM_GetCacheSampleCoord(float column_index, float row_index)
{
    float num_rows = 8.0;
    float num_columns = 8.0;
    float range_width = 1.0 / num_columns;
    float range_height = 1.0 / num_rows;
    float param = column_index;
    float param_1 = row_index;
    vec4 sample_range = HSM_GetCacheSampleRange(param, param_1);
    return vec2(sample_range.x + (range_width / 2.0), sample_range.y + (range_height / 2.0));
}

vec4 HSM_GetColorForScreenInfoCache(vec2 viewport_coord, sampler2D feedback_pass, sampler2D original_pass, sampler2D screen_placement_image)
{
    NEGATIVE_CROP_EXPAND_MULTIPLIER = global.NegativeCropAddedPassSize.y / global.DerezedPassSize.y;
    MAX_NEGATIVE_CROP = (1.0 - (1.0 / NEGATIVE_CROP_EXPAND_MULTIPLIER)) / 2.0;
    vec4 out_color = vec4(0.0);
    float output_aspect = global.FinalViewportSize.x / global.FinalViewportSize.y;
    vec2 rotated_derezed_size = HSM_GetRotatedScreenDerezedSize();
    vec2 cropped_rotated_size_with_res_mult = vec2(100.0);
    vec2 cropped_rotated_size = vec2(100.0);
    vec2 cropped_sample_area_start_pixel_coord = vec2(100.0);
    float param = 1.0;
    vec2 param_1 = cropped_rotated_size;
    vec2 param_2 = cropped_rotated_size_with_res_mult;
    vec2 param_3 = cropped_sample_area_start_pixel_coord;
    HSM_GetCroppedRotatedSizeAndPixelSampleAreaStart(param, original_pass, param_1, param_2, param_3);
    cropped_rotated_size = param_1;
    cropped_rotated_size_with_res_mult = param_2;
    cropped_sample_area_start_pixel_coord = param_3;
    float param_4 = 60.0;
    vec3 screen_pos_and_height = HSM_GetScreenPlacementAndHeight(screen_placement_image, param_4);
    float param_5 = 1.0;
    vec2 param_6 = cropped_rotated_size;
    float screen_aspect = HSM_GetScreenAspect(param_5, param_6);
    float param_7 = screen_aspect;
    float param_8 = screen_pos_and_height.z;
    vec2 param_9 = cropped_rotated_size;
    vec2 screen_scale = HSM_GetScreenScale(param_7, param_8, param_9);
    vec2 param_10 = screen_scale;
    float param_11 = screen_pos_and_height.z;
    vec2 param_12 = vec2(0.0);
    vec2 _3540 = HSM_GetTubeScale(param_10, param_11, param_12);
    vec2 tube_diffuse_scale = _3540;
    float tube_diffuse_aspect = (tube_diffuse_scale.x / tube_diffuse_scale.y) * output_aspect;
    if (true)
    {
        if (true)
        {
            tube_diffuse_aspect = screen_aspect;
        }
        if (false)
        {
            tube_diffuse_aspect = (screen_aspect > 1.0) ? 1.33329999446868896484375 : 0.750018775463104248046875;
        }
        tube_diffuse_scale = vec2((tube_diffuse_scale.y * tube_diffuse_aspect) / output_aspect, tube_diffuse_scale.y);
    }
    vec2 param_13 = tube_diffuse_scale;
    float param_14 = screen_pos_and_height.z;
    vec2 param_15 = vec2(0.699999988079071044921875);
    vec2 _3577 = HSM_GetTubeScale(param_13, param_14, param_15);
    vec2 tube_scale = _3577;
    vec2 param_16 = screen_pos_and_height.xy;
    vec2 param_17 = screen_scale;
    float param_18 = 1.0;
    vec2 _3585 = HSM_GetScreenPositionOffset(param_16, param_17, param_18);
    vec2 pos_offset = _3585;
    float param_19 = 1.0;
    vec2 rotated_core_preppezd_size = HSM_GetRotatedScreenCorePreppedSize(param_19);
    vec2 cropped_size_with_res_mult_2nd_screen = vec2(100.0);
    vec2 cropped_size_2nd_screen = vec2(100.0);
    vec2 sample_area_start_pixel_coord_2nd_screen = vec2(100.0);
    float param_20 = 2.0;
    vec2 param_21 = cropped_size_2nd_screen;
    vec2 param_22 = cropped_size_with_res_mult_2nd_screen;
    vec2 param_23 = sample_area_start_pixel_coord_2nd_screen;
    HSM_GetCroppedRotatedSizeAndPixelSampleAreaStart(param_20, original_pass, param_21, param_22, param_23);
    cropped_size_2nd_screen = param_21;
    cropped_size_with_res_mult_2nd_screen = param_22;
    sample_area_start_pixel_coord_2nd_screen = param_23;
    float _3606;
    if (HSM_2ND_SCREEN_ASPECT_RATIO_MODE == 1.0)
    {
        _3606 = cropped_size_2nd_screen.x / cropped_size_2nd_screen.y;
    }
    else
    {
        _3606 = screen_aspect;
    }
    float screen_aspect_2nd_screen = _3606;
    vec2 param_24 = screen_scale;
    float param_25 = screen_aspect_2nd_screen;
    vec2 screen_scale_2nd_screen = HSM_GetScreenScaleFor2ndScreen(param_24, param_25);
    vec2 param_26 = screen_scale_2nd_screen;
    float param_27 = 0.82959997653961181640625;
    vec2 param_28 = vec2(0.0);
    vec2 _3628 = HSM_GetTubeScale(param_26, param_27, param_28);
    vec2 tube_diffuse_scale_2nd_screen = _3628;
    vec2 param_29 = tube_diffuse_scale_2nd_screen;
    float param_30 = 0.82959997653961181640625;
    vec2 param_31 = vec2(0.699999988079071044921875);
    vec2 _3634 = HSM_GetTubeScale(param_29, param_30, param_31);
    vec2 tube_scale_2nd_screen = _3634;
    float tube_aspect_2nd_screen = (tube_scale_2nd_screen.x / tube_scale_2nd_screen.y) * output_aspect;
    vec2 param_32 = vec2(0.5);
    vec2 param_33 = screen_scale_2nd_screen;
    float param_34 = 2.0;
    vec2 _3648 = HSM_GetScreenPositionOffset(param_32, param_33, param_34);
    vec2 pos_offset_2nd_screen = _3648;
    vec4 sample_2d_range = vec4(0.0);
    float param_35 = 1.0;
    float param_36 = 1.0;
    sample_2d_range = HSM_GetCacheSampleRange(param_35, param_36);
    vec2 param_37 = viewport_coord;
    vec4 param_38 = sample_2d_range;
    if (HSM_IsCoordIn2DRange(param_37, param_38) == 1)
    {
        vec2 param_39 = global.NegativeCropAddedPassSize.xy;
        out_color.x = HSM_GetAverageLuma(original_pass, param_39);
    }
    float param_40 = 2.0;
    float param_41 = 1.0;
    sample_2d_range = HSM_GetCacheSampleRange(param_40, param_41);
    vec2 param_42 = viewport_coord;
    vec4 param_43 = sample_2d_range;
    if (HSM_IsCoordIn2DRange(param_42, param_43) == 1)
    {
        out_color.x = screen_aspect;
        out_color.z = screen_scale.x;
        out_color.w = screen_scale.y;
    }
    float param_44 = 3.0;
    float param_45 = 1.0;
    sample_2d_range = HSM_GetCacheSampleRange(param_44, param_45);
    vec2 param_46 = viewport_coord;
    vec4 param_47 = sample_2d_range;
    if (HSM_IsCoordIn2DRange(param_46, param_47) == 1)
    {
        out_color.x = tube_scale.x;
        out_color.y = tube_scale.y;
        out_color.z = pos_offset.x;
        out_color.w = pos_offset.y;
    }
    float param_48 = 4.0;
    float param_49 = 1.0;
    sample_2d_range = HSM_GetCacheSampleRange(param_48, param_49);
    vec2 param_50 = viewport_coord;
    vec4 param_51 = sample_2d_range;
    if (HSM_IsCoordIn2DRange(param_50, param_51) == 1)
    {
        out_color.x = cropped_rotated_size_with_res_mult.x;
        out_color.y = cropped_rotated_size_with_res_mult.y;
    }
    float param_52 = 1.0;
    float param_53 = 2.0;
    sample_2d_range = HSM_GetCacheSampleRange(param_52, param_53);
    vec2 param_54 = viewport_coord;
    vec4 param_55 = sample_2d_range;
    if (HSM_IsCoordIn2DRange(param_54, param_55) == 1)
    {
        out_color.x = cropped_rotated_size.x;
        out_color.y = cropped_rotated_size.y;
        out_color.z = cropped_sample_area_start_pixel_coord.x;
        out_color.w = cropped_sample_area_start_pixel_coord.y;
    }
    float param_56 = 2.0;
    float param_57 = 2.0;
    sample_2d_range = HSM_GetCacheSampleRange(param_56, param_57);
    vec2 param_58 = viewport_coord;
    vec4 param_59 = sample_2d_range;
    if (HSM_IsCoordIn2DRange(param_58, param_59) == 1)
    {
        out_color.x = screen_aspect_2nd_screen;
        out_color.y = screen_scale_2nd_screen.x;
        out_color.z = screen_scale_2nd_screen.y;
    }
    float param_60 = 3.0;
    float param_61 = 2.0;
    sample_2d_range = HSM_GetCacheSampleRange(param_60, param_61);
    vec2 param_62 = viewport_coord;
    vec4 param_63 = sample_2d_range;
    if (HSM_IsCoordIn2DRange(param_62, param_63) == 1)
    {
        out_color.x = tube_scale_2nd_screen.x;
        out_color.y = tube_scale_2nd_screen.y;
        out_color.z = pos_offset_2nd_screen.x;
        out_color.w = pos_offset_2nd_screen.y;
    }
    float param_64 = 4.0;
    float param_65 = 2.0;
    sample_2d_range = HSM_GetCacheSampleRange(param_64, param_65);
    vec2 param_66 = viewport_coord;
    vec4 param_67 = sample_2d_range;
    if (HSM_IsCoordIn2DRange(param_66, param_67) == 1)
    {
        out_color.x = cropped_size_with_res_mult_2nd_screen.x;
        out_color.y = cropped_size_with_res_mult_2nd_screen.y;
    }
    float param_68 = 1.0;
    float param_69 = 3.0;
    sample_2d_range = HSM_GetCacheSampleRange(param_68, param_69);
    vec2 param_70 = viewport_coord;
    vec4 param_71 = sample_2d_range;
    if (HSM_IsCoordIn2DRange(param_70, param_71) == 1)
    {
        out_color.x = cropped_size_2nd_screen.x;
        out_color.y = cropped_size_2nd_screen.y;
        out_color.z = sample_area_start_pixel_coord_2nd_screen.x;
        out_color.w = sample_area_start_pixel_coord_2nd_screen.y;
    }
    float param_72 = 2.0;
    float param_73 = 3.0;
    sample_2d_range = HSM_GetCacheSampleRange(param_72, param_73);
    vec2 param_74 = viewport_coord;
    vec4 param_75 = sample_2d_range;
    if (HSM_IsCoordIn2DRange(param_74, param_75) == 1)
    {
        out_color.x = global.CorePassSize.xy.x;
        out_color.y = global.CorePassSize.xy.y;
    }
    float param_76 = 3.0;
    float param_77 = 3.0;
    sample_2d_range = HSM_GetCacheSampleRange(param_76, param_77);
    vec2 param_78 = viewport_coord;
    vec4 param_79 = sample_2d_range;
    if (HSM_IsCoordIn2DRange(param_78, param_79) == 1)
    {
        vec2 _3851 = vec2(HSM_VIEWPORT_ZOOM, HSM_VIEWPORT_ZOOM);
        out_color.x = _3851.x;
        out_color.y = _3851.y;
        vec2 _3858 = vec2(HSM_VIEWPORT_POSITION_X, HSM_VIEWPORT_POSITION_Y);
        out_color.z = _3858.x;
        out_color.w = _3858.y;
    }
    float param_80 = 4.0;
    float param_81 = 3.0;
    sample_2d_range = HSM_GetCacheSampleRange(param_80, param_81);
    vec2 param_82 = viewport_coord;
    vec4 param_83 = sample_2d_range;
    if (HSM_IsCoordIn2DRange(param_82, param_83) == 1)
    {
        out_color.x = screen_scale_2nd_screen.x;
        out_color.y = screen_scale_2nd_screen.y;
        out_color.z = pos_offset_2nd_screen.x;
        out_color.w = pos_offset_2nd_screen.y;
    }
    float param_84 = 1.0;
    float param_85 = 4.0;
    sample_2d_range = HSM_GetCacheSampleRange(param_84, param_85);
    vec2 param_86 = viewport_coord;
    vec4 param_87 = sample_2d_range;
    if (HSM_IsCoordIn2DRange(param_86, param_87) == 1)
    {
        out_color.x = HSM_GetParameterSum();
        float param_88 = 1.0;
        float param_89 = 4.0;
        vec2 sample_coord = HSM_GetCacheSampleCoord(param_88, param_89);
        vec4 texture_sample = texture(feedback_pass, sample_coord);
        float last_frame = floor(texture_sample.y);
        out_color.y = last_frame + float(global.FrameDirection * 1);
        out_color.z = rotated_derezed_size.x;
        out_color.w = rotated_derezed_size.y;
    }
    float param_90 = 2.0;
    float param_91 = 4.0;
    sample_2d_range = HSM_GetCacheSampleRange(param_90, param_91);
    vec2 param_92 = viewport_coord;
    vec4 param_93 = sample_2d_range;
    if (HSM_IsCoordIn2DRange(param_92, param_93) == 1)
    {
        out_color.x = NEGATIVE_CROP_EXPAND_MULTIPLIER;
        out_color.y = MAX_NEGATIVE_CROP;
    }
    float param_94 = 3.0;
    float param_95 = 4.0;
    sample_2d_range = HSM_GetCacheSampleRange(param_94, param_95);
    vec2 param_96 = viewport_coord;
    vec4 param_97 = sample_2d_range;
    if (HSM_IsCoordIn2DRange(param_96, param_97) == 1)
    {
        out_color.x = tube_diffuse_scale.x;
        out_color.y = tube_diffuse_scale.y;
        out_color.z = tube_diffuse_scale_2nd_screen.x;
        out_color.w = tube_diffuse_scale_2nd_screen.y;
    }
    return out_color;
}

void main()
{
    NEGATIVE_CROP_EXPAND_MULTIPLIER = 0.5;
    MAX_NEGATIVE_CROP = 0.5;
    DEFAULT_SCREEN_ASPECT = 1.3329918384552001953125;
    DEFAULT_BEZEL_ASPECT = 1.32272231578826904296875;
    DEFAULT_SCREEN_SCALE = vec2(0.0);
    DEFAULT_BEZEL_SCALE = vec2(0.0);
    INFOCACHE_MAX_INDEX = 4;
    BLEND_MODE_OFF = 0.0;
    BLEND_MODE_NORMAL = 1.0;
    BLEND_MODE_ADD = 2.0;
    BLEND_MODE_MULTIPLY = 3.0;
    SOURCE_MATTE_PREMULTIPLIED = 0.0;
    SOURCE_MATTE_WHITE = 1.0;
    SOURCE_MATTE_NONE = 2.0;
    IMAGE_ASPECT_MODE_INHERIT_ASPECT_SCALE = 0.0;
    IMAGE_ASPECT_MODE_KEEP_ASPECT = 1.0;
    FILL_MODE_STRETCH = 0.0;
    FILL_MODE_SPLIT_FILL_HORIZONTAL = 1.0;
    FILL_MODE_SPLIT_FILL_VERTICAL = 2.0;
    CACHE_INFO_PARAM_SUM_CHANGED = false;
    CURRENT_FRAME_FROM_CACHE_INFO = 0.0;
    TUBE_DIFFUSE_MASK = 0.0;
    TUBE_MASK = 0.0;
    BEZEL_MASK = 0.0;
    INSIDE_BEZEL_MASK = 0.0;
    OUTSIDE_TUBE_MASK_FOR_IMAGE = 0.0;
    FRAME_MASK = 0.0;
    FRAME_MASK_FOR_IMAGE = 0.0;
    OUTSIDE_BEZEL_MASK = 0.0;
    OUTSIDE_FRAME_MASK_FOR_IMAGE = 0.0;
    OUTSIDE_FRAME_MASK = 0.0;
    CUTOUT_MASK = 0.0;
    SCREEN_INDEX = 1.0;
    SCREEN_ASPECT = 1.0;
    SCREEN_SCALE = vec2(1.0);
    SCREEN_POS_OFFSET = vec2(0.1500000059604644775390625);
    SCREEN_SCALE_2ND_SCREEN = vec2(1.0);
    SCREEN_POS_OFFSET_2ND_SCREEN = vec2(0.1500000059604644775390625);
    VIEWPORT_SCALE = vec2(1.0);
    VIEWPORT_POS = vec2(1.0);
    TUBE_SCALE = vec2(1.0);
    TUBE_DIFFUSE_SCALE = vec2(1.0);
    TUBE_DIFFUSE_ASPECT = 1.0;
    FRAME_SCALE = vec2(1.0);
    BEZEL_OUTSIDE_SCALE = vec2(0.5);
    BACKGROUND_SCALE = vec2(0.5);
    LED_SCALE = vec2(0.5);
    DEVICE_SCALE = vec2(0.5);
    DECAL_SCALE = vec2(0.5);
    CAB_GLASS_SCALE = vec2(0.5);
    TOP_IMAGE_SCALE = vec2(0.5);
    AVERAGE_LUMA = 0.0;
    USE_VERTICAL_SCANLINES = 0.0;
    CORE_SIZE = vec2(1.0);
    ROTATED_CORE_ORIGINAL_SIZE = vec2(1.0);
    ROTATED_CORE_PREPPED_SIZE = vec2(1.0);
    ROTATED_DEREZED_SIZE = vec2(1.0);
    CROPPED_ROTATED_SIZE_WITH_RES_MULT = vec2(1.0);
    CROPPED_ROTATED_SIZE_WITH_RES_MULT_FEEDBACK = vec2(1.0);
    CROPPED_ROTATED_SIZE = vec2(1.0);
    SAMPLE_AREA_START_PIXEL_COORD = vec2(1.0);
    VIEWPORT_UNSCALED_COORD = vec2(0.5);
    SCREEN_COORD = vec2(0.5);
    TUBE_COORD = vec2(0.5);
    TUBE_DIFFUSE_COORD = vec2(0.5);
    BEZEL_OUTSIDE_COORD = vec2(0.5);
    BACKGROUND_COORD = vec2(0.5);
    DEVICE_COORD = vec2(0.5);
    LED_COORD = vec2(0.5);
    DECAL_COORD = vec2(0.5);
    CAB_GLASS_COORD = vec2(0.5);
    TOP_IMAGE_COORD = vec2(0.5);
    SCREEN_CURVED_COORD = vec2(0.5);
    TUBE_CURVED_COORD = vec2(0.5);
    TUBE_DIFFUSE_CURVED_COORD = vec2(0.5);
    BEZEL_OUTSIDE_CURVED_COORD = vec2(0.5);
    FRAME_OUTSIDE_CURVED_COORD = vec2(0.5);
    BACKGROUND_CURVED_COORD = vec2(0.5);
    LED_CURVED_COORD = vec2(0.5);
    DEVICE_CURVED_COORD = vec2(0.5);
    DECAL_CURVED_COORD = vec2(0.5);
    CAB_GLASS_CURVED_COORD = vec2(0.5);
    TOP_IMAGE_CURVED_COORD = vec2(0.5);
    HSM_RESOLUTION_DEBUG_ON = 0.0;
    HSM_CACHE_GRAPHICS_ON = 1.0;
    HSM_CACHE_UPDATE_INDICATOR_MODE = 2.0;
    HSM_GLOBAL_GRAPHICS_BRIGHTNESS = 1.0;
    HSM_STATIC_LAYERS_GAMMA = 1.0;
    HSM_AMBIENT_LIGHTING_OPACITY = 0.0;
    HSM_AMBIENT2_LIGHTING_OPACITY = 0.0;
    HSM_AMBIENT_LIGHTING_SWAP_IMAGES = 0.0;
    HSM_VIEWPORT_ZOOM = 1.0;
    HSM_VIEWPORT_ZOOM_MASK = 0.0;
    HSM_VIEWPORT_POSITION_X = -0.0;
    HSM_VIEWPORT_POSITION_Y = -0.0;
    HSM_FLIP_VIEWPORT_VERTICAL = 1.0;
    HSM_FLIP_VIEWPORT_HORIZONTAL = 1.0;
    HSM_FLIP_CORE_VERTICAL = 1.0;
    HSM_FLIP_CORE_HORIZONTAL = 1.0;
    HSM_ROTATE_CORE_IMAGE = 0.0;
    HSM_ASPECT_RATIO_ORIENTATION = 0.0;
    HSM_ASPECT_RATIO_MODE = 0.0;
    HSM_ASPECT_RATIO_EXPLICIT = 1.33329999446868896484375;
    HSM_VERTICAL_PRESET = 0.0;
    HSM_INT_SCALE_MAX_HEIGHT = 0.88999998569488525390625;
    HSM_NON_INTEGER_SCALE = 0.829699993133544921875;
    HSM_USE_PHYSICAL_SIZE_FOR_NON_INTEGER = 0.0;
    HSM_PHYSICAL_MONITOR_ASPECT_RATIO = 1.769999980926513671875;
    HSM_PHYSICAL_MONITOR_DIAGONAL_SIZE = 27.0;
    HSM_PHYSICAL_SIM_TUBE_DIAGONAL_SIZE = 18.1000003814697265625;
    HSM_USE_IMAGE_FOR_PLACEMENT = 0.0;
    HSM_PLACEMENT_IMAGE_USE_HORIZONTAL = 0.0;
    HSM_PLACEMENT_IMAGE_MODE = 0.0;
    HSM_NON_INTEGER_SCALE_OFFSET = 1.0;
    HSM_USE_SNAP_TO_CLOSEST_INT_SCALE = 0.0;
    HSM_SNAP_TO_CLOSEST_INT_SCALE_TOLERANCE = (HSM_USE_SNAP_TO_CLOSEST_INT_SCALE > 0.5) ? 0.20000000298023223876953125 : 0.0;
    HSM_SCREEN_POSITION_X = 0.0;
    HSM_SCREEN_POSITION_Y = -0.0;
    HSM_CROP_MODE = 2.0;
    HSM_CROP_PERCENT_ZOOM = 0.0;
    HSM_CROP_PERCENT_TOP = 0.0;
    HSM_CROP_PERCENT_BOTTOM = 0.0;
    HSM_CROP_PERCENT_LEFT = 0.0;
    HSM_CROP_PERCENT_RIGHT = 0.0;
    HSM_CROP_BLACK_THRESHOLD = 0.0;
    HSM_SCANLINE_DIRECTION = 0.0;
    HSM_CORE_RES_SAMPLING_MULT_SCANLINE_DIR = 1.0;
    HSM_DOWNSAMPLE_BLUR_SCANLINE_DIR = 0.0;
    HSM_CORE_RES_SAMPLING_MULT_OPPOSITE_DIR = 1.0;
    HSM_DOWNSAMPLE_BLUR_OPPOSITE_DIR = 0.0;
    HSM_CORE_RES_SAMPLING_SHIFT_OPPOSITE_DIR = 0.0;
    HSM_USE_GEOM = 0.0;
    HSM_CURVATURE_MODE = 1.0;
    HSM_CURVATURE_3D_RADIUS = 2.0;
    HSM_CURVATURE_3D_VIEW_DIST = 1.5;
    HSM_CURVATURE_3D_TILT_ANGLE_X = 0.0;
    HSM_CURVATURE_3D_TILT_ANGLE_Y = 0.0;
    HSM_CRT_CURVATURE_SCALE = 1.0;
    HSM_AB_COMPARE_SHOW_MODE = 0.0;
    HSM_AB_COMPARE_AREA = 0.0;
    HSM_AB_COMPARE_SPLIT_POSITION = 0.5;
    HSM_AB_COMPARE_FREEZE_CRT_TUBE = 0.0;
    HSM_AB_COMPARE_FREEZE_GRAPHICS = 0.0;
    HSM_SCREEN_VIGNETTE_DUALSCREEN_VIS_MODE = 0.0;
    HSM_MONOCHROME_DUALSCREEN_VIS_MODE = 0.0;
    HSM_TUBE_DIFFUSE_MODE = 0.0;
    HSM_TUBE_DIFFUSE_OPACITY = 1.0;
    HSM_TUBE_DIFFUSE_IMAGE_DUALSCREEN_VIS_MODE = 0.0;
    HSM_TUBE_DIFFUSE_IMAGE_COLORIZE_ON = 0.0;
    HSM_TUBE_DIFFUSE_IMAGE_HUE = 0.0;
    HSM_TUBE_DIFFUSE_IMAGE_SATURATION = 1.0;
    HSM_TUBE_DIFFUSE_IMAGE_BRIGHTNESS = 0.20000000298023223876953125;
    HSM_TUBE_DIFFUSE_IMAGE_GAMMA = 1.0;
    HSM_TUBE_DIFFUSE_IMAGE_AMBIENT_LIGHTING = 1.0;
    HSM_TUBE_DIFFUSE_IMAGE_AMBIENT2_LIGHTING = 0.0;
    HSM_TUBE_DIFFUSE_IMAGE_SCALE = 1.2000000476837158203125;
    HSM_TUBE_DIFFUSE_IMAGE_SCALE_X = 1.0;
    HSM_TUBE_SHADOW_IMAGE_ON = 1.0;
    HSM_TUBE_SHADOW_IMAGE_OPACITY = 0.60000002384185791015625;
    HSM_TUBE_SHADOW_IMAGE_POS_X = 0.0;
    HSM_TUBE_SHADOW_IMAGE_POS_Y = 0.0900000035762786865234375;
    HSM_TUBE_SHADOW_IMAGE_SCALE_X = 1.2200000286102294921875;
    HSM_TUBE_SHADOW_IMAGE_SCALE_Y = 1.2999999523162841796875;
    HSM_TUBE_SHADOW_CURVATURE_SCALE = 3.0;
    HSM_TUBE_COLORED_GEL_IMAGE_ON = 0.0;
    HSM_TUBE_COLORED_GEL_IMAGE_SCALE = 1.0;
    HSM_TUBE_COLORED_GEL_IMAGE_FLIP_HORIZONTAL = 1.0;
    HSM_TUBE_COLORED_GEL_IMAGE_FLIP_VERTICAL = 1.0;
    HSM_TUBE_COLORED_GEL_IMAGE_DUALSCREEN_VIS_MODE = 0.0;
    HSM_TUBE_COLORED_GEL_IMAGE_MULTIPLY_AMOUNT = 0.89999997615814208984375;
    HSM_TUBE_COLORED_GEL_IMAGE_ADDITIVE_AMOUNT = 0.0;
    HSM_TUBE_COLORED_GEL_IMAGE_NORMAL_AMOUNT = 0.1500000059604644775390625;
    HSM_TUBE_COLORED_GEL_IMAGE_TRANSPARENCY_THRESHOLD = 0.23000000417232513427734375;
    HSM_TUBE_COLORED_GEL_IMAGE_NORMAL_BRIGHTNESS = 1.0;
    HSM_TUBE_COLORED_GEL_IMAGE_NORMAL_VIGNETTE = 0.0;
    HSM_TUBE_COLORED_GEL_IMAGE_FAKE_SCANLINE_AMOUNT = 0.0;
    HSM_TUBE_COLORED_GEL_IMAGE_AMBIENT_LIGHTING = 1.0;
    HSM_TUBE_COLORED_GEL_IMAGE_AMBIENT2_LIGHTING = 0.0;
    HSM_SHOW_CRT_ON_TOP_OF_COLORED_GEL = 0.0;
    HSM_TUBE_STATIC_REFLECTION_IMAGE_ON = 0.0;
    HSM_TUBE_STATIC_REFLECTION_IMAGE_DUALSCREEN_VIS_MODE = 0.0;
    HSM_TUBE_STATIC_REFLECTION_IMAGE_OPACITY = 0.100000001490116119384765625;
    HSM_TUBE_STATIC_REFLECTION_IMAGE_AMBIENT_LIGHTING = 1.0;
    HSM_TUBE_STATIC_REFLECTION_IMAGE_AMBIENT2_LIGHTING = 0.0;
    HSM_TUBE_STATIC_REFLECTION_IMAGE_SCALE = 1.10000002384185791015625;
    HSM_TUBE_STATIC_REFLECTION_IMAGE_SHADOW_OPACITY = 0.4000000059604644775390625;
    HSM_DUALSCREEN_MODE = 0.0;
    HSM_DUALSCREEN_CORE_IMAGE_SPLIT_MODE = 1.0;
    HSM_DUALSCREEN_CORE_IMAGE_SWAP_SCREENS = 0.0;
    HSM_DUALSCREEN_CORE_IMAGE_SPLIT_OFFSET = 0.0;
    HSM_DUALSCREEN_VIEWPORT_SPLIT_LOCATION = 0.0;
    HSM_DUALSCREEN_SHIFT_POSITION_WITH_SCALE = 1.0;
    HSM_DUALSCREEN_POSITION_OFFSET_BETWEEN_SCREENS = 0.0;
    HSM_2ND_SCREEN_ASPECT_RATIO_MODE = 0.0;
    HSM_2ND_SCREEN_INDEPENDENT_SCALE = 0.0;
    HSM_2ND_SCREEN_SCALE_OFFSET = 1.0;
    HSM_2ND_SCREEN_POS_X = 0.0;
    HSM_2ND_SCREEN_POS_Y = 0.0;
    HSM_2ND_SCREEN_CROP_PERCENT_ZOOM = 0.0;
    HSM_2ND_SCREEN_CROP_PERCENT_TOP = 0.0;
    HSM_2ND_SCREEN_CROP_PERCENT_BOTTOM = 0.0;
    HSM_2ND_SCREEN_CROP_PERCENT_LEFT = 0.0;
    HSM_2ND_SCREEN_CROP_PERCENT_RIGHT = 0.0;
    HSM_SCREEN_REFLECTION_SCALE = 1.0;
    HSM_SCREEN_REFLECTION_POS_X = 0.0;
    HSM_SCREEN_REFLECTION_POS_Y = 0.0;
    HSM_AMBIENT_LIGHTING_HUE = 0.0;
    HSM_AMBIENT_LIGHTING_SATURATION = 1.0;
    HSM_AMBIENT_LIGHTING_VALUE = 1.0;
    HSM_AMBIENT_LIGHTING_CONTRAST = 1.0;
    HSM_AMBIENT_LIGHTING_SCALE_KEEP_ASPECT = 0.0;
    HSM_AMBIENT_LIGHTING_SCALE_WITH_ZOOM = 1.0;
    HSM_AMBIENT_LIGHTING_SCALE = 1.0;
    HSM_AMBIENT_LIGHTING_SCALE_X = 1.0;
    HSM_AMBIENT_LIGHTING_ROTATE = 0.0;
    HSM_AMBIENT_LIGHTING_MIRROR_HORZ = 0.0;
    HSM_AMBIENT_LIGHTING_POSITION_X = 0.0;
    HSM_AMBIENT_LIGHTING_POSITION_Y = -0.0;
    HSM_AMBIENT_LIGHTING_DITHERING_SAMPLES = 0.0;
    HSM_AMBIENT2_LIGHTING_HUE = 0.0;
    HSM_AMBIENT2_LIGHTING_SATURATION = 1.0;
    HSM_AMBIENT2_LIGHTING_VALUE = 2.0;
    HSM_AMBIENT2_LIGHTING_CONTRAST = 1.0;
    HSM_AMBIENT2_LIGHTING_SCALE_KEEP_ASPECT = 1.0;
    HSM_AMBIENT2_LIGHTING_SCALE_WITH_ZOOM = 1.0;
    HSM_AMBIENT2_LIGHTING_SCALE = 1.0;
    HSM_AMBIENT2_LIGHTING_SCALE_X = 1.0;
    HSM_AMBIENT2_LIGHTING_ROTATE = 0.0;
    HSM_AMBIENT2_LIGHTING_MIRROR_HORZ = 0.0;
    HSM_AMBIENT2_LIGHTING_POSITION_X = 0.0;
    HSM_AMBIENT2_LIGHTING_POSITION_Y = -0.0;
    HSM_BZL_OPACITY = 1.0;
    HSM_BZL_BLEND_MODE = 1.0;
    HSM_BZL_WIDTH = 0.107799999415874481201171875;
    HSM_BZL_HEIGHT = 0.0873199999332427978515625;
    HSM_BZL_INNER_CORNER_RADIUS_SCALE = 0.800000011920928955078125;
    HSM_BZL_INNER_EDGE_THICKNESS = 0.0076999999582767486572265625;
    HSM_BZL_INNER_EDGE_SHARPNESS = 0.949999988079071044921875;
    HSM_BZL_OUTER_POSITION_Y = 0.0;
    HSM_BZL_OUTER_CURVATURE_SCALE = 0.0;
    HSM_BZL_OUTER_CORNER_RADIUS_SCALE = 0.540000021457672119140625;
    HSM_BZL_BRIGHTNESS = 0.300000011920928955078125;
    HSM_BZL_HIGHLIGHT = 0.00999999977648258209228515625;
    HSM_BZL_NOISE = 0.300000011920928955078125;
    HSM_BZL_INNER_EDGE_SHADOW = 0.699999988079071044921875;
    HSM_BZL_COLOR_HUE = 0.0;
    HSM_BZL_COLOR_SATURATION = 0.0;
    HSM_BZL_COLOR_VALUE = 0.100000001490116119384765625;
    HSM_BZL_AMBIENT_LIGHTING_MULTIPLIER = 1.0;
    HSM_BZL_AMBIENT2_LIGHTING_MULTIPLIER = 0.0;
    HSM_FRM_USE_INDEPENDENT_COLOR = 0.0;
    HSM_FRM_COLOR_HUE = 0.0;
    HSM_FRM_COLOR_SATURATION = 0.0;
    HSM_FRM_COLOR_VALUE = 0.100000001490116119384765625;
    HSM_FRM_OPACITY = 1.0;
    HSM_FRM_BLEND_MODE = 1.0;
    HSM_FRM_TEXTURE_OPACITY = 0.014999999664723873138427734375;
    HSM_FRM_TEXTURE_BLEND_MODE = 2.0;
    HSM_FRM_NOISE = 0.300000011920928955078125;
    HSM_FRM_INNER_EDGE_THICKNESS = 0.0030000000260770320892333984375;
    HSM_FRM_THICKNESS = 0.070000000298023223876953125;
    HSM_FRM_THICKNESS_SCALE_X = 1.0;
    HSM_FRM_OUTER_POS_Y = 0.0;
    HSM_FRM_OUTER_CURVATURE_SCALE = 0.0;
    HSM_FRM_OUTER_CORNER_RADIUS = 5.0;
    HSM_FRM_OUTER_EDGE_THICKNESS = 0.006000000052154064178466796875;
    HSM_FRM_OUTER_EDGE_SHADING = 0.5;
    HSM_FRM_SHADOW_OPACITY = 1.0;
    HSM_FRM_SHADOW_WIDTH = 0.100000001490116119384765625;
    HSM_REFLECT_CORNER_FADE = 0.100000001490116119384765625;
    HSM_REFLECT_CORNER_FADE_DISTANCE = 1.0;
    HSM_REFLECT_CORNER_INNER_SPREAD = 5.0;
    HSM_REFLECT_CORNER_OUTER_SPREAD = 1.60000002384185791015625;
    HSM_REFLECT_CORNER_ROTATION_OFFSET_TOP = 0.0;
    HSM_REFLECT_CORNER_ROTATION_OFFSET_BOTTOM = 0.0;
    HSM_REFLECT_CORNER_SPREAD_FALLOFF = 100.0;
    HSM_REFLECT_GLOBAL_AMOUNT = 0.4000000059604644775390625;
    HSM_REFLECT_GLOBAL_GAMMA_ADJUST = 1.2000000476837158203125;
    HSM_REFLECT_DIRECT_AMOUNT = 1.5;
    HSM_REFLECT_DIFFUSED_AMOUNT = 0.5;
    HSM_REFLECT_FULLSCREEN_GLOW = 0.75;
    HSM_REFLECT_FULLSCREEN_GLOW_GAMMA = 3.0;
    HSM_REFLECT_BEZEL_INNER_EDGE_AMOUNT = 1.2999999523162841796875;
    HSM_REFLECT_BEZEL_INNER_EDGE_FULLSCREEN_GLOW = 0.4000000059604644775390625;
    HSM_REFLECT_FRAME_INNER_EDGE_AMOUNT = 0.5;
    HSM_REFLECT_FRAME_INNER_EDGE_SHARPNESS = 0.89999997615814208984375;
    HSM_REFLECT_FADE_AMOUNT = 1.0;
    HSM_REFLECT_RADIAL_FADE_WIDTH = 0.2857142984867095947265625;
    HSM_REFLECT_RADIAL_FADE_HEIGHT = 0.2857142984867095947265625;
    HSM_REFLECT_LATERAL_OUTER_FADE_POSITION = 0.017999999225139617919921875;
    HSM_REFLECT_LATERAL_OUTER_FADE_DISTANCE = 0.20000000298023223876953125;
    HSM_REFLECT_BLUR_NUM_SAMPLES = 12.0;
    HSM_REFLECT_BLUR_MIN = 0.0;
    HSM_REFLECT_BLUR_MAX = 0.949999988079071044921875;
    HSM_REFLECT_BLUR_FALLOFF_DISTANCE = 1.0;
    HSM_REFLECT_NOISE_AMOUNT = 0.5;
    HSM_REFLECT_NOISE_SAMPLES = 1.0;
    HSM_REFLECT_NOISE_SAMPLE_DISTANCE = 0.20000000298023223876953125;
    HSM_GLASS_BORDER_ON = 0.0;
    HSM_REFLECT_VIGNETTE_AMOUNT = 0.0;
    HSM_REFLECT_VIGNETTE_SIZE = 1.0;
    HSM_BG_LAYER_ORDER = 0.0;
    HSM_VIEWPORT_VIGNETTE_LAYER_ORDER = 1.0;
    HSM_LED_LAYER_ORDER = 2.0;
    HSM_DEVICE_LAYER_ORDER = 3.0;
    HSM_CRT_LAYER_ORDER = 5.0;
    HSM_DECAL_LAYER_ORDER = 7.0;
    HSM_CAB_GLASS_LAYER_ORDER = 9.0;
    HSM_TOP_LAYER_ORDER = 12.0;
    HSM_CUTOUT_ASPECT_MODE = 4.0;
    HSM_CUTOUT_EXPLICIT_ASPECT = 1.33333003520965576171875;
    HSM_CUTOUT_SCALE_MODE = 0.0;
    HSM_CUTOUT_SCALE_FULL_WITH_ZOOM = 1.0;
    HSM_CUTOUT_KEEP_ASPECT = 1.0;
    HSM_CUTOUT_SCALE = 1.0;
    HSM_CUTOUT_SCALE_X = 1.0;
    HSM_CUTOUT_POS_X = -0.0;
    HSM_CUTOUT_POS_Y = 0.0;
    HSM_CUTOUT_CORNER_RADIUS = 0.0;
    HSM_LAYERING_DEBUG_MASK_MODE = -1.0;
    HSM_BG_OPACITY = 1.0;
    HSM_BG_COLORIZE_ON = 0.0;
    HSM_BG_HUE = 0.0;
    HSM_BG_SATURATION = 1.0;
    HSM_BG_BRIGHTNESS = 1.0;
    HSM_BG_GAMMA = 1.0;
    HSM_BG_AMBIENT_LIGHTING_MULTIPLIER = 1.0;
    HSM_BG_AMBIENT2_LIGHTING_MULTIPLIER = 0.0;
    HSM_BG_APPLY_AMBIENT_IN_ADD_MODE = 0.0;
    HSM_BG_BLEND_MODE = 1.0;
    HSM_BG_SOURCE_MATTE_TYPE = 0.0;
    HSM_BG_MASK_MODE = 0.0;
    HSM_BG_CUTOUT_MODE = 0.0;
    HSM_BG_DUALSCREEN_VIS_MODE = 0.0;
    HSM_BG_SCALE_MODE = 0.0;
    HSM_BG_SCALE_FULL_WITH_ZOOM = 1.0;
    HSM_BG_SCALE_KEEP_ASPECT = 1.0;
    HSM_BG_FILL_MODE = 0.0;
    HSM_BG_SCALE = 1.0;
    HSM_BG_SCALE_X = 1.0;
    HSM_BG_POS_X = -0.0;
    HSM_BG_POS_Y = 0.0;
    HSM_BG_MIRROR_WRAP = 1.0;
    HSM_BG_MIPMAPPING_BLEND_BIAS = 0.0;
    HSM_VIEWPORT_VIGNETTE_OPACITY = 0.0;
    HSM_VIEWPORT_VIGNETTE_MASK_MODE = 5.0;
    HSM_VIEWPORT_VIGNETTE_CUTOUT_MODE = 0.0;
    HSM_VIEWPORT_VIGNETTE_SCALE_MODE = 0.0;
    HSM_VIEWPORT_VIGNETTE_SCALE = 1.0;
    HSM_VIEWPORT_VIGNETTE_SCALE_X = 1.0;
    HSM_VIEWPORT_VIGNETTE_POS_X = -0.0;
    HSM_VIEWPORT_VIGNETTE_POS_Y = 0.0;
    HSM_LED_OPACITY = 1.0;
    HSM_LED_COLORIZE_ON = 0.0;
    HSM_LED_HUE = 0.0;
    HSM_LED_SATURATION = 1.0;
    HSM_LED_BRIGHTNESS = 1.0;
    HSM_LED_GAMMA = 1.0;
    HSM_LED_AMBIENT_LIGHTING_MULTIPLIER = 1.0;
    HSM_LED_AMBIENT2_LIGHTING_MULTIPLIER = 0.0;
    HSM_LED_APPLY_AMBIENT_IN_ADD_MODE = 0.0;
    HSM_LED_BLEND_MODE = 2.0;
    HSM_LED_SOURCE_MATTE_TYPE = 0.0;
    HSM_LED_MASK_MODE = 0.0;
    HSM_LED_CUTOUT_MODE = 0.0;
    HSM_LED_DUALSCREEN_VIS_MODE = 0.0;
    HSM_LED_SCALE_MODE = 3.0;
    HSM_LED_SCALE_FULL_WITH_ZOOM = 1.0;
    HSM_LED_SCALE_KEEP_ASPECT = 1.0;
    HSM_LED_FILL_MODE = 0.0;
    HSM_LED_SCALE = 1.0;
    HSM_LED_SCALE_X = 1.0;
    HSM_LED_POS_X = -0.0;
    HSM_LED_POS_Y = 0.0;
    HSM_LED_MIPMAPPING_BLEND_BIAS = 0.0;
    HSM_DEVICE_OPACITY = 1.0;
    HSM_DEVICE_COLORIZE_ON = 0.0;
    HSM_DEVICE_HUE = 0.0;
    HSM_DEVICE_SATURATION = 1.0;
    HSM_DEVICE_BRIGHTNESS = 1.0;
    HSM_DEVICE_GAMMA = 1.0;
    HSM_DEVICE_AMBIENT_LIGHTING_MULTIPLIER = 1.0;
    HSM_DEVICE_AMBIENT2_LIGHTING_MULTIPLIER = 0.0;
    HSM_DEVICE_APPLY_AMBIENT_IN_ADD_MODE = 0.0;
    HSM_DEVICE_BLEND_MODE = 1.0;
    HSM_DEVICE_SOURCE_MATTE_TYPE = 0.0;
    HSM_DEVICE_MASK_MODE = 0.0;
    HSM_DEVICE_CUTOUT_MODE = 0.0;
    HSM_DEVICE_DUALSCREEN_VIS_MODE = 0.0;
    HSM_DEVICE_SCALE_MODE = 1.0;
    HSM_DEVICE_SCALE_FULL_WITH_ZOOM = 1.0;
    HSM_DEVICE_COPY_INHERITED_COORD = 0.0;
    HSM_DEVICE_SCALE_KEEP_ASPECT = 1.0;
    HSM_DEVICE_FILL_MODE = 0.0;
    HSM_DEVICE_SCALE = 1.0;
    HSM_DEVICE_SCALE_X = 1.0;
    HSM_DEVICE_POS_X = -0.0;
    HSM_DEVICE_POS_Y = 0.0;
    HSM_DEVICE_MIPMAPPING_BLEND_BIAS = 0.0;
    HSM_DECAL_OPACITY = 1.0;
    HSM_DECAL_COLORIZE_ON = 0.0;
    HSM_DECAL_HUE = 0.0;
    HSM_DECAL_SATURATION = 1.0;
    HSM_DECAL_BRIGHTNESS = 1.0;
    HSM_DECAL_GAMMA = 1.0;
    HSM_DECAL_AMBIENT_LIGHTING_MULTIPLIER = 1.0;
    HSM_DECAL_AMBIENT2_LIGHTING_MULTIPLIER = 0.0;
    HSM_DECAL_APPLY_AMBIENT_IN_ADD_MODE = 0.0;
    HSM_DECAL_BLEND_MODE = 1.0;
    HSM_DECAL_SOURCE_MATTE_TYPE = 0.0;
    HSM_DECAL_MASK_MODE = 0.0;
    HSM_DECAL_CUTOUT_MODE = 0.0;
    HSM_DECAL_DUALSCREEN_VIS_MODE = 0.0;
    HSM_DECAL_SCALE_MODE = 0.0;
    HSM_DECAL_SCALE_FULL_WITH_ZOOM = 1.0;
    HSM_DECAL_SCALE_KEEP_ASPECT = 1.0;
    HSM_DECAL_FILL_MODE = 0.0;
    HSM_DECAL_SCALE = 1.0;
    HSM_DECAL_SCALE_X = 1.0;
    HSM_DECAL_POS_X = -0.0;
    HSM_DECAL_POS_Y = 0.0;
    HSM_DECAL_MIPMAPPING_BLEND_BIAS = 0.0;
    HSM_CAB_GLASS_OPACITY = 1.0;
    HSM_CAB_GLASS_COLORIZE_ON = 0.0;
    HSM_CAB_GLASS_HUE = 0.0;
    HSM_CAB_GLASS_SATURATION = 1.0;
    HSM_CAB_GLASS_BRIGHTNESS = 1.0;
    HSM_CAB_GLASS_GAMMA = 1.0;
    HSM_CAB_GLASS_AMBIENT_LIGHTING_MULTIPLIER = 1.0;
    HSM_CAB_GLASS_AMBIENT2_LIGHTING_MULTIPLIER = 0.0;
    HSM_CAB_GLASS_APPLY_AMBIENT_IN_ADD_MODE = 0.0;
    HSM_CAB_GLASS_BLEND_MODE = 1.0;
    HSM_CAB_GLASS_SOURCE_MATTE_TYPE = 0.0;
    HSM_CAB_GLASS_MASK_MODE = 0.0;
    HSM_CAB_GLASS_CUTOUT_MODE = 0.0;
    HSM_CAB_GLASS_DUALSCREEN_VIS_MODE = 0.0;
    HSM_CAB_GLASS_SCALE_MODE = 0.0;
    HSM_CAB_GLASS_SCALE_FULL_WITH_ZOOM = 1.0;
    HSM_CAB_GLASS_SCALE_KEEP_ASPECT = 1.0;
    HSM_CAB_GLASS_FILL_MODE = 0.0;
    HSM_CAB_GLASS_SCALE = 1.0;
    HSM_CAB_GLASS_SCALE_X = 1.0;
    HSM_CAB_GLASS_POS_X = -0.0;
    HSM_CAB_GLASS_POS_Y = 0.0;
    HSM_CAB_GLASS_MIPMAPPING_BLEND_BIAS = 0.0;
    HSM_TOP_OPACITY = 1.0;
    HSM_TOP_COLORIZE_ON = 0.0;
    HSM_TOP_HUE = 0.0;
    HSM_TOP_SATURATION = 1.0;
    HSM_TOP_BRIGHTNESS = 1.0;
    HSM_TOP_GAMMA = 1.0;
    HSM_TOP_AMBIENT_LIGHTING_MULTIPLIER = 1.0;
    HSM_TOP_AMBIENT2_LIGHTING_MULTIPLIER = 0.0;
    HSM_TOP_APPLY_AMBIENT_IN_ADD_MODE = 0.0;
    HSM_TOP_BLEND_MODE = 1.0;
    HSM_TOP_SOURCE_MATTE_TYPE = 0.0;
    HSM_TOP_MASK_MODE = 0.0;
    HSM_TOP_CUTOUT_MODE = 0.0;
    HSM_TOP_DUALSCREEN_VIS_MODE = 0.0;
    HSM_TOP_SCALE_MODE = 0.0;
    HSM_TOP_SCALE_FULL_WITH_ZOOM = 1.0;
    HSM_TOP_SCALE_KEEP_ASPECT = 1.0;
    HSM_TOP_FILL_MODE = 0.0;
    HSM_TOP_SCALE = 1.0;
    HSM_TOP_SCALE_X = 1.0;
    HSM_TOP_POS_X = -0.0;
    HSM_TOP_POS_Y = 0.0;
    HSM_TOP_MIRROR_WRAP = 1.0;
    HSM_TOP_MIPMAPPING_BLEND_BIAS = 0.0;
    HSM_RENDER_SIMPLE_MODE = 0.0;
    HSM_RENDER_SIMPLE_MASK_TYPE = 0.0;
    CURVATURE_MODE_OFF = 0.0;
    CURVATURE_MODE_2D = 1.0;
    CURVATURE_MODE_2D_CYLINDER = 2.0;
    CURVATURE_MODE_3D_1 = 3.0;
    CURVATURE_MODE_3D_2 = 4.0;
    CURVATURE_MODE_3D_CYLINDER = 5.0;
    vec2 param = vTexCoord;
    vec4 _3971 = HSM_GetColorForScreenInfoCache(param, InfoCachePassFeedback, Source, ScreenPlacementImage);
    FragColor = _3971;
}

