#version 430

layout(binding = 0, std140) uniform UBO
{
    mat4 MVP;
    vec4 SourceSize;
    vec4 OriginalSize;
    vec4 CorePassSize;
    vec4 CorePassFeedbackSize;
    vec4 OutputSize;
    vec4 FinalViewportSize;
    vec4 NegativeCropAddedPassSize;
    vec4 DerezedPassSize;
    int FrameDirection;
    uint FrameCount;
    float HSM_RESOLUTION_DEBUG_ON;
    float HSM_CACHE_GRAPHICS_ON;
    float HSM_CACHE_UPDATE_INDICATOR_MODE;
    float HSM_GLOBAL_GRAPHICS_BRIGHTNESS;
    float HSM_STATIC_LAYERS_GAMMA;
    float HSM_AMBIENT_LIGHTING_OPACITY;
    float HSM_AMBIENT2_LIGHTING_OPACITY;
    float HSM_AMBIENT_LIGHTING_SWAP_IMAGES;
    float HSM_AMBIENT_LIGHTING_HUE;
    float HSM_AMBIENT_LIGHTING_SATURATION;
    float HSM_AMBIENT_LIGHTING_VALUE;
    float HSM_AMBIENT_LIGHTING_CONTRAST;
    float HSM_AMBIENT_LIGHTING_SCALE_KEEP_ASPECT;
    float HSM_AMBIENT_LIGHTING_SCALE_WITH_ZOOM;
    float HSM_AMBIENT_LIGHTING_SCALE;
    float HSM_AMBIENT_LIGHTING_SCALE_X;
    float HSM_AMBIENT_LIGHTING_ROTATE;
    float HSM_AMBIENT_LIGHTING_MIRROR_HORZ;
    float HSM_AMBIENT_LIGHTING_POSITION_X;
    float HSM_AMBIENT_LIGHTING_POSITION_Y;
    float HSM_AMBIENT_LIGHTING_DITHERING_SAMPLES;
    float HSM_AMBIENT2_LIGHTING_HUE;
    float HSM_AMBIENT2_LIGHTING_SATURATION;
    float HSM_AMBIENT2_LIGHTING_VALUE;
    float HSM_AMBIENT2_LIGHTING_CONTRAST;
    float HSM_AMBIENT2_LIGHTING_SCALE_KEEP_ASPECT;
    float HSM_AMBIENT2_LIGHTING_SCALE_WITH_ZOOM;
    float HSM_AMBIENT2_LIGHTING_SCALE;
    float HSM_AMBIENT2_LIGHTING_SCALE_X;
    float HSM_AMBIENT2_LIGHTING_ROTATE;
    float HSM_AMBIENT2_LIGHTING_MIRROR_HORZ;
    float HSM_AMBIENT2_LIGHTING_POSITION_X;
    float HSM_AMBIENT2_LIGHTING_POSITION_Y;
    float HSM_VIEWPORT_ZOOM;
    float HSM_VIEWPORT_POSITION_X;
    float HSM_VIEWPORT_POSITION_Y;
    float HSM_VIEWPORT_ZOOM_MASK;
    float HSM_FLIP_VIEWPORT_VERTICAL;
    float HSM_FLIP_VIEWPORT_HORIZONTAL;
    float HSM_FLIP_CORE_VERTICAL;
    float HSM_FLIP_CORE_HORIZONTAL;
    float HSM_ROTATE_CORE_IMAGE;
    float HSM_ASPECT_RATIO_ORIENTATION;
    float HSM_ASPECT_RATIO_MODE;
    float HSM_ASPECT_RATIO_EXPLICIT;
    float HSM_INT_SCALE_MODE;
    float HSM_INT_SCALE_MULTIPLE_OFFSET;
    float HSM_INT_SCALE_MULTIPLE_OFFSET_LONG;
    float HSM_INT_SCALE_MAX_HEIGHT;
    float HSM_VERTICAL_PRESET;
    float HSM_NON_INTEGER_SCALE;
    float HSM_USE_PHYSICAL_SIZE_FOR_NON_INTEGER;
    float HSM_PHYSICAL_MONITOR_ASPECT_RATIO;
    float HSM_PHYSICAL_MONITOR_DIAGONAL_SIZE;
    float HSM_PHYSICAL_SIM_TUBE_DIAGONAL_SIZE;
    float HSM_USE_IMAGE_FOR_PLACEMENT;
    float HSM_PLACEMENT_IMAGE_USE_HORIZONTAL;
    float HSM_PLACEMENT_IMAGE_MODE;
    float HSM_NON_INTEGER_SCALE_OFFSET;
    float HSM_USE_SNAP_TO_CLOSEST_INT_SCALE;
    float HSM_SNAP_TO_CLOSEST_INT_SCALE_TOLERANCE;
    float HSM_SCREEN_POSITION_X;
    float HSM_SCREEN_POSITION_Y;
    float HSM_CROP_MODE;
    float HSM_CROP_PERCENT_ZOOM;
    float HSM_CROP_PERCENT_TOP;
    float HSM_CROP_PERCENT_BOTTOM;
    float HSM_CROP_PERCENT_LEFT;
    float HSM_CROP_PERCENT_RIGHT;
    float HSM_CROP_BLACK_THRESHOLD;
    float HSM_SCANLINE_DIRECTION;
    float HSM_CORE_RES_SAMPLING_MULT_SCANLINE_DIR;
    float HSM_DOWNSAMPLE_BLUR_SCANLINE_DIR;
    float HSM_CORE_RES_SAMPLING_MULT_OPPOSITE_DIR;
    float HSM_DOWNSAMPLE_BLUR_OPPOSITE_DIR;
    float HSM_CORE_RES_SAMPLING_SHIFT_OPPOSITE_DIR;
    float HSM_INTERLACE_TRIGGER_RES;
    float HSM_INTERLACE_MODE;
    float HSM_INTERLACE_EFFECT_SMOOTHNESS_INTERS;
    float HSM_INTERLACE_SCANLINE_EFFECT;
    float iscans;
    float HSM_FAKE_SCANLINE_MODE;
    float HSM_FAKE_SCANLINE_OPACITY;
    float HSM_FAKE_SCANLINE_RES_MODE;
    float HSM_FAKE_SCANLINE_RES;
    float HSM_FAKE_SCANLINE_INT_SCALE;
    float HSM_FAKE_SCANLINE_ROLL;
    float HSM_FAKE_SCANLINE_CURVATURE;
    float HSM_FAKE_SCANLINE_BRIGHTNESS_CUTOFF;
    float HSM_DUALSCREEN_MODE;
    float HSM_DUALSCREEN_CORE_IMAGE_SPLIT_MODE;
    float HSM_DUALSCREEN_CORE_IMAGE_SWAP_SCREENS;
    float HSM_DUALSCREEN_CORE_IMAGE_SPLIT_OFFSET;
    float HSM_DUALSCREEN_VIEWPORT_SPLIT_LOCATION;
    float HSM_DUALSCREEN_SHIFT_POSITION_WITH_SCALE;
    float HSM_DUALSCREEN_POSITION_OFFSET_BETWEEN_SCREENS;
    float HSM_2ND_SCREEN_ASPECT_RATIO_MODE;
    float HSM_2ND_SCREEN_INDEPENDENT_SCALE;
    float HSM_2ND_SCREEN_SCALE_OFFSET;
    float HSM_2ND_SCREEN_POS_X;
    float HSM_2ND_SCREEN_POS_Y;
    float HSM_2ND_SCREEN_CROP_PERCENT_ZOOM;
    float HSM_2ND_SCREEN_CROP_PERCENT_TOP;
    float HSM_2ND_SCREEN_CROP_PERCENT_BOTTOM;
    float HSM_2ND_SCREEN_CROP_PERCENT_LEFT;
    float HSM_2ND_SCREEN_CROP_PERCENT_RIGHT;
    float HSM_CURVATURE_MODE;
    float HSM_CURVATURE_2D_SCALE_LONG_AXIS;
    float HSM_CURVATURE_2D_SCALE_SHORT_AXIS;
    float HSM_CURVATURE_3D_RADIUS;
    float HSM_CURVATURE_3D_VIEW_DIST;
    float HSM_CURVATURE_3D_TILT_ANGLE_X;
    float HSM_CURVATURE_3D_TILT_ANGLE_Y;
    float HSM_CRT_CURVATURE_SCALE;
    float HSM_ANTI_FLICKER_ON;
    float HSM_ANTI_FLICKER_THRESHOLD;
    float HSM_AB_COMPARE_SHOW_MODE;
    float HSM_AB_COMPARE_AREA;
    float HSM_AB_COMPARE_FREEZE_CRT_TUBE;
    float HSM_AB_COMPARE_FREEZE_GRAPHICS;
    float HSM_AB_COMPARE_SPLIT_AREA;
    float HSM_AB_COMPARE_SPLIT_POSITION;
    float HSM_CRT_BLEND_MODE;
    float HSM_CRT_BLEND_AMOUNT;
    float HSM_CRT_SCREEN_BLEND_MODE;
    float HSM_SCREEN_VIGNETTE_ON;
    float HSM_SCREEN_VIGNETTE_DUALSCREEN_VIS_MODE;
    float HSM_SCREEN_VIGNETTE_STRENGTH;
    float HSM_SCREEN_VIGNETTE_POWER;
    float HSM_SCREEN_VIGNETTE_IN_REFLECTION;
    float HSM_MONOCHROME_MODE;
    float HSM_MONOCHROME_BRIGHTNESS;
    float HSM_MONOCHROME_GAMMA;
    float HSM_MONOCHROME_HUE_OFFSET;
    float HSM_MONOCHROME_SATURATION;
    float HSM_MONOCHROME_DUALSCREEN_VIS_MODE;
    float HSM_SCREEN_REFLECTION_SCALE;
    float HSM_SCREEN_REFLECTION_POS_X;
    float HSM_SCREEN_REFLECTION_POS_Y;
    float HSM_TUBE_DIFFUSE_MODE;
    float HSM_TUBE_DIFFUSE_IMAGE_DUALSCREEN_VIS_MODE;
    float HSM_TUBE_DIFFUSE_OPACITY;
    float HSM_TUBE_DIFFUSE_IMAGE_HUE;
    float HSM_TUBE_DIFFUSE_IMAGE_COLORIZE_ON;
    float HSM_TUBE_DIFFUSE_IMAGE_SATURATION;
    float HSM_TUBE_DIFFUSE_IMAGE_BRIGHTNESS;
    float HSM_TUBE_DIFFUSE_IMAGE_GAMMA;
    float HSM_TUBE_DIFFUSE_IMAGE_AMBIENT_LIGHTING;
    float HSM_TUBE_DIFFUSE_IMAGE_AMBIENT2_LIGHTING;
    float HSM_TUBE_DIFFUSE_IMAGE_SCALE;
    float HSM_TUBE_DIFFUSE_IMAGE_SCALE_X;
    float HSM_TUBE_EMPTY_THICKNESS;
    float HSM_TUBE_EMPTY_THICKNESS_X_SCALE;
    float HSM_TUBE_DIFFUSE_FORCE_ASPECT;
    float HSM_TUBE_EXPLICIT_ASPECT;
    float HSM_SCREEN_CORNER_RADIUS_SCALE;
    float HSM_TUBE_COLORED_GEL_IMAGE_ON;
    float HSM_TUBE_COLORED_GEL_IMAGE_DUALSCREEN_VIS_MODE;
    float HSM_TUBE_COLORED_GEL_IMAGE_MULTIPLY_AMOUNT;
    float HSM_TUBE_COLORED_GEL_IMAGE_NORMAL_AMOUNT;
    float HSM_TUBE_COLORED_GEL_IMAGE_NORMAL_BRIGHTNESS;
    float HSM_TUBE_COLORED_GEL_IMAGE_NORMAL_VIGNETTE;
    float HSM_TUBE_COLORED_GEL_IMAGE_TRANSPARENCY_THRESHOLD;
    float HSM_TUBE_COLORED_GEL_IMAGE_ADDITIVE_AMOUNT;
    float HSM_SHOW_CRT_ON_TOP_OF_COLORED_GEL;
    float HSM_TUBE_SHADOW_IMAGE_ON;
    float HSM_TUBE_SHADOW_IMAGE_OPACITY;
    float HSM_TUBE_SHADOW_IMAGE_SCALE_X;
    float HSM_TUBE_SHADOW_IMAGE_SCALE_Y;
    float HSM_TUBE_SHADOW_IMAGE_POS_X;
    float HSM_TUBE_SHADOW_IMAGE_POS_Y;
    float HSM_TUBE_SHADOW_CURVATURE_SCALE;
    float HSM_TUBE_COLORED_GEL_IMAGE_AMBIENT_LIGHTING;
    float HSM_TUBE_COLORED_GEL_IMAGE_AMBIENT2_LIGHTING;
    float HSM_TUBE_COLORED_GEL_IMAGE_FAKE_SCANLINE_AMOUNT;
    float HSM_TUBE_COLORED_GEL_IMAGE_SCALE;
    float HSM_TUBE_COLORED_GEL_IMAGE_FLIP_HORIZONTAL;
    float HSM_TUBE_COLORED_GEL_IMAGE_FLIP_VERTICAL;
    float HSM_TUBE_STATIC_REFLECTION_IMAGE_ON;
    float HSM_TUBE_STATIC_REFLECTION_IMAGE_DUALSCREEN_VIS_MODE;
    float HSM_TUBE_STATIC_REFLECTION_IMAGE_OPACITY;
    float HSM_TUBE_STATIC_REFLECTION_IMAGE_AMBIENT_LIGHTING;
    float HSM_TUBE_STATIC_REFLECTION_IMAGE_AMBIENT2_LIGHTING;
    float HSM_TUBE_STATIC_REFLECTION_IMAGE_SCALE;
    float HSM_TUBE_STATIC_REFLECTION_IMAGE_SHADOW_OPACITY;
    float HSM_TUBE_STATIC_REFLECTION_IMAGE_DITHERING_SAMPLES;
    float HSM_GLOBAL_CORNER_RADIUS;
    float HSM_TUBE_BLACK_EDGE_CORNER_RADIUS_SCALE;
    float HSM_TUBE_BLACK_EDGE_SHARPNESS;
    float HSM_TUBE_BLACK_EDGE_CURVATURE_SCALE;
    float HSM_TUBE_BLACK_EDGE_THICKNESS;
    float HSM_TUBE_BLACK_EDGE_THICKNESS_X_SCALE;
    float HSM_BZL_USE_INDEPENDENT_SCALE;
    float HSM_BZL_INDEPENDENT_SCALE;
    float HSM_BZL_USE_INDEPENDENT_CURVATURE;
    float HSM_BZL_INDEPENDENT_CURVATURE_SCALE_LONG_AXIS;
    float HSM_BZL_INDEPENDENT_CURVATURE_SCALE_SHORT_AXIS;
    float HSM_BZL_OPACITY;
    float HSM_BZL_BLEND_MODE;
    float HSM_BZL_WIDTH;
    float HSM_BZL_HEIGHT;
    float HSM_BZL_SCALE_OFFSET;
    float HSM_BZL_INNER_CURVATURE_SCALE;
    float HSM_BZL_INNER_CORNER_RADIUS_SCALE;
    float HSM_BZL_OUTER_CURVATURE_SCALE;
    float HSM_BZL_INNER_EDGE_THICKNESS;
    float HSM_BZL_INNER_EDGE_SHARPNESS;
    float HSM_BZL_OUTER_CORNER_RADIUS_SCALE;
    float HSM_BZL_INNER_EDGE_SHADOW;
    float HSM_BZL_COLOR_HUE;
    float HSM_BZL_COLOR_SATURATION;
    float HSM_BZL_COLOR_VALUE;
    float HSM_BZL_NOISE;
    float HSM_BZL_BRIGHTNESS;
    float HSM_BZL_HIGHLIGHT;
    float HSM_BZL_AMBIENT_LIGHTING_MULTIPLIER;
    float HSM_BZL_AMBIENT2_LIGHTING_MULTIPLIER;
    float HSM_FRM_USE_INDEPENDENT_COLOR;
    float HSM_FRM_COLOR_HUE;
    float HSM_FRM_COLOR_SATURATION;
    float HSM_FRM_COLOR_VALUE;
    float HSM_FRM_NOISE;
    float HSM_FRM_OUTER_CURVATURE_SCALE;
    float HSM_FRM_THICKNESS;
    float HSM_FRM_THICKNESS_SCALE_X;
    float HSM_FRM_OUTER_POS_Y;
    float HSM_FRM_INNER_EDGE_THICKNESS;
    float HSM_FRM_OUTER_EDGE_THICKNESS;
    float HSM_FRM_OUTER_EDGE_SHADING;
    float HSM_FRM_OUTER_CORNER_RADIUS;
    float HSM_BZL_OUTER_POSITION_Y;
    float HSM_FRM_SHADOW_OPACITY;
    float HSM_FRM_SHADOW_WIDTH;
    float HSM_REFLECT_CORNER_FADE;
    float HSM_REFLECT_CORNER_INNER_SPREAD;
    float HSM_REFLECT_CORNER_OUTER_SPREAD;
    float HSM_REFLECT_CORNER_ROTATION_OFFSET_TOP;
    float HSM_REFLECT_CORNER_ROTATION_OFFSET_BOTTOM;
    float HSM_REFLECT_CORNER_SPREAD_FALLOFF;
    float HSM_REFLECT_CORNER_FADE_DISTANCE;
    float HSM_REFLECT_GLOBAL_AMOUNT;
    float HSM_REFLECT_GLOBAL_GAMMA_ADJUST;
    float HSM_REFLECT_BEZEL_INNER_EDGE_AMOUNT;
    float HSM_REFLECT_BEZEL_INNER_EDGE_FULLSCREEN_GLOW;
    float HSM_REFLECT_FRAME_INNER_EDGE_AMOUNT;
    float HSM_REFLECT_FRAME_INNER_EDGE_SHARPNESS;
    float HSM_REFLECT_DIRECT_AMOUNT;
    float HSM_REFLECT_DIFFUSED_AMOUNT;
    float HSM_REFLECT_FULLSCREEN_GLOW;
    float HSM_REFLECT_FULLSCREEN_GLOW_GAMMA;
    float HSM_REFLECT_FADE_AMOUNT;
    float HSM_REFLECT_RADIAL_FADE_WIDTH;
    float HSM_REFLECT_RADIAL_FADE_HEIGHT;
    float HSM_REFLECT_LATERAL_OUTER_FADE_POSITION;
    float HSM_REFLECT_LATERAL_OUTER_FADE_DISTANCE;
    float HSM_REFLECT_VIGNETTE_AMOUNT;
    float HSM_REFLECT_VIGNETTE_SIZE;
    float HSM_REFLECT_NOISE_AMOUNT;
    float HSM_REFLECT_NOISE_SAMPLES;
    float HSM_REFLECT_NOISE_SAMPLE_DISTANCE;
    float HSM_REFLECT_BLUR_NUM_SAMPLES;
    float HSM_REFLECT_BLUR_FALLOFF_DISTANCE;
    float HSM_REFLECT_BLUR_MIN;
    float HSM_REFLECT_BLUR_MAX;
    float HSM_REFLECT_MASK_IMG_AMOUNT;
    float HSM_REFLECT_IS_LAST_PASS;
    float HSM_GLASS_BORDER_ON;
    float HSM_POTATO_SHOW_BG_OVER_SCREEN;
    float HSM_STANDARD_DECAL_SCALE_WITH_FRAME;
    float HSM_STANDARD_TOP_SCALE_WITH_FRAME;
    float HSM_BG_LAYER_ORDER;
    float HSM_VIEWPORT_VIGNETTE_LAYER_ORDER;
    float HSM_CRT_LAYER_ORDER;
    float HSM_DEVICE_LAYER_ORDER;
    float HSM_CAB_GLASS_LAYER_ORDER;
    float HSM_DECAL_LAYER_ORDER;
    float HSM_LED_LAYER_ORDER;
    float HSM_TOP_LAYER_ORDER;
    float HSM_CUTOUT_ASPECT_MODE;
    float HSM_CUTOUT_EXPLICIT_ASPECT;
    float HSM_CUTOUT_SCALE_MODE;
    float HSM_CUTOUT_SCALE_FULL_WITH_ZOOM;
    float HSM_CUTOUT_KEEP_ASPECT;
    float HSM_CUTOUT_SCALE;
    float HSM_CUTOUT_SCALE_X;
    float HSM_CUTOUT_CORNER_RADIUS;
    float HSM_CUTOUT_POS_X;
    float HSM_CUTOUT_POS_Y;
    float HSM_BG_OPACITY;
    float HSM_BG_HUE;
    float HSM_BG_COLORIZE_ON;
    float HSM_BG_SATURATION;
    float HSM_BG_BRIGHTNESS;
    float HSM_BG_GAMMA;
    float HSM_BG_AMBIENT_LIGHTING_MULTIPLIER;
    float HSM_BG_AMBIENT2_LIGHTING_MULTIPLIER;
    float HSM_BG_APPLY_AMBIENT_IN_ADD_MODE;
    float HSM_BG_BLEND_MODE;
    float HSM_BG_SOURCE_MATTE_TYPE;
    float HSM_BG_MASK_MODE;
    float HSM_BG_CUTOUT_MODE;
    float HSM_BG_DUALSCREEN_VIS_MODE;
    float HSM_BG_SCALE_MODE;
    float HSM_BG_SCALE_FULL_WITH_ZOOM;
    float HSM_BG_FILL_MODE;
    float HSM_BG_SCALE_KEEP_ASPECT;
    float HSM_BG_SCALE;
    float HSM_BG_SCALE_X;
    float HSM_BG_POS_X;
    float HSM_BG_POS_Y;
    float HSM_BG_MIRROR_WRAP;
    float HSM_BG_MIPMAPPING_BLEND_BIAS;
    float HSM_VIEWPORT_VIGNETTE_OPACITY;
    float HSM_VIEWPORT_VIGNETTE_MASK_MODE;
    float HSM_VIEWPORT_VIGNETTE_CUTOUT_MODE;
    float HSM_VIEWPORT_VIGNETTE_SCALE_MODE;
    float HSM_VIEWPORT_VIGNETTE_SCALE;
    float HSM_VIEWPORT_VIGNETTE_SCALE_X;
    float HSM_VIEWPORT_VIGNETTE_POS_X;
    float HSM_VIEWPORT_VIGNETTE_POS_Y;
    float HSM_LED_OPACITY;
    float HSM_LED_HUE;
    float HSM_LED_COLORIZE_ON;
    float HSM_LED_SATURATION;
    float HSM_LED_BRIGHTNESS;
    float HSM_LED_GAMMA;
    float HSM_LED_AMBIENT_LIGHTING_MULTIPLIER;
    float HSM_LED_AMBIENT2_LIGHTING_MULTIPLIER;
    float HSM_LED_APPLY_AMBIENT_IN_ADD_MODE;
    float HSM_LED_BLEND_MODE;
    float HSM_LED_SOURCE_MATTE_TYPE;
    float HSM_LED_MASK_MODE;
    float HSM_LED_CUTOUT_MODE;
    float HSM_LED_DUALSCREEN_VIS_MODE;
    float HSM_LED_SCALE_MODE;
    float HSM_LED_SCALE_FULL_WITH_ZOOM;
    float HSM_LED_SCALE_KEEP_ASPECT;
    float HSM_LED_FILL_MODE;
    float HSM_LED_SCALE;
    float HSM_LED_SCALE_X;
    float HSM_LED_POS_X;
    float HSM_LED_POS_Y;
    float HSM_LED_MIPMAPPING_BLEND_BIAS;
    float HSM_DEVICE_OPACITY;
    float HSM_DEVICE_HUE;
    float HSM_DEVICE_COLORIZE_ON;
    float HSM_DEVICE_SATURATION;
    float HSM_DEVICE_BRIGHTNESS;
    float HSM_DEVICE_GAMMA;
    float HSM_DEVICE_AMBIENT_LIGHTING_MULTIPLIER;
    float HSM_DEVICE_AMBIENT2_LIGHTING_MULTIPLIER;
    float HSM_DEVICE_APPLY_AMBIENT_IN_ADD_MODE;
    float HSM_DEVICE_BLEND_MODE;
    float HSM_DEVICE_SOURCE_MATTE_TYPE;
    float HSM_DEVICE_MASK_MODE;
    float HSM_DEVICE_CUTOUT_MODE;
    float HSM_DEVICE_DUALSCREEN_VIS_MODE;
    float HSM_DEVICE_SCALE_MODE;
    float HSM_DEVICE_SCALE_FULL_WITH_ZOOM;
    float HSM_DEVICE_SCALE_KEEP_ASPECT;
    float HSM_DEVICE_FILL_MODE;
    float HSM_DEVICE_SCALE;
    float HSM_DEVICE_SCALE_X;
    float HSM_DEVICE_POS_X;
    float HSM_DEVICE_POS_Y;
    float HSM_DEVICE_COPY_INHERITED_COORD;
    float HSM_REFLECT_MASK_SCALE_MODE;
    float HSM_DEVICE_MIPMAPPING_BLEND_BIAS;
    float HSM_FRM_OPACITY;
    float HSM_FRM_BLEND_MODE;
    float HSM_FRM_TEXTURE_OPACITY;
    float HSM_FRM_TEXTURE_BLEND_MODE;
    float HSM_DECAL_OPACITY;
    float HSM_DECAL_HUE;
    float HSM_DECAL_COLORIZE_ON;
    float HSM_DECAL_SATURATION;
    float HSM_DECAL_BRIGHTNESS;
    float HSM_DECAL_GAMMA;
    float HSM_DECAL_AMBIENT_LIGHTING_MULTIPLIER;
    float HSM_DECAL_AMBIENT2_LIGHTING_MULTIPLIER;
    float HSM_DECAL_APPLY_AMBIENT_IN_ADD_MODE;
    float HSM_DECAL_BLEND_MODE;
    float HSM_DECAL_SOURCE_MATTE_TYPE;
    float HSM_DECAL_MASK_MODE;
    float HSM_DECAL_CUTOUT_MODE;
    float HSM_DECAL_DUALSCREEN_VIS_MODE;
    float HSM_DECAL_SCALE_MODE;
    float HSM_DECAL_SCALE_FULL_WITH_ZOOM;
    float HSM_DECAL_SCALE_KEEP_ASPECT;
    float HSM_DECAL_FILL_MODE;
    float HSM_DECAL_SCALE;
    float HSM_DECAL_SCALE_X;
    float HSM_DECAL_POS_X;
    float HSM_DECAL_POS_Y;
    float HSM_DECAL_MIPMAPPING_BLEND_BIAS;
    float HSM_CAB_GLASS_OPACITY;
    float HSM_CAB_GLASS_HUE;
    float HSM_CAB_GLASS_COLORIZE_ON;
    float HSM_CAB_GLASS_SATURATION;
    float HSM_CAB_GLASS_BRIGHTNESS;
    float HSM_CAB_GLASS_GAMMA;
    float HSM_CAB_GLASS_AMBIENT_LIGHTING_MULTIPLIER;
    float HSM_CAB_GLASS_AMBIENT2_LIGHTING_MULTIPLIER;
    float HSM_CAB_GLASS_APPLY_AMBIENT_IN_ADD_MODE;
    float HSM_CAB_GLASS_BLEND_MODE;
    float HSM_CAB_GLASS_SOURCE_MATTE_TYPE;
    float HSM_CAB_GLASS_MASK_MODE;
    float HSM_CAB_GLASS_CUTOUT_MODE;
    float HSM_CAB_GLASS_DUALSCREEN_VIS_MODE;
    float HSM_CAB_GLASS_SCALE_MODE;
    float HSM_CAB_GLASS_SCALE_FULL_WITH_ZOOM;
    float HSM_CAB_GLASS_SCALE_KEEP_ASPECT;
    float HSM_CAB_GLASS_FILL_MODE;
    float HSM_CAB_GLASS_SCALE;
    float HSM_CAB_GLASS_SCALE_X;
    float HSM_CAB_GLASS_POS_X;
    float HSM_CAB_GLASS_POS_Y;
    float HSM_CAB_GLASS_MIPMAPPING_BLEND_BIAS;
    float HSM_TOP_OPACITY;
    float HSM_TOP_HUE;
    float HSM_TOP_COLORIZE_ON;
    float HSM_TOP_SATURATION;
    float HSM_TOP_BRIGHTNESS;
    float HSM_TOP_GAMMA;
    float HSM_TOP_AMBIENT_LIGHTING_MULTIPLIER;
    float HSM_TOP_AMBIENT2_LIGHTING_MULTIPLIER;
    float HSM_TOP_APPLY_AMBIENT_IN_ADD_MODE;
    float HSM_TOP_BLEND_MODE;
    float HSM_TOP_SOURCE_MATTE_TYPE;
    float HSM_TOP_MASK_MODE;
    float HSM_TOP_CUTOUT_MODE;
    float HSM_TOP_DUALSCREEN_VIS_MODE;
    float HSM_TOP_SCALE_MODE;
    float HSM_TOP_SCALE_FULL_WITH_ZOOM;
    float HSM_TOP_SCALE_KEEP_ASPECT;
    float HSM_TOP_FILL_MODE;
    float HSM_TOP_SCALE;
    float HSM_TOP_SCALE_X;
    float HSM_TOP_POS_X;
    float HSM_TOP_POS_Y;
    float HSM_TOP_MIRROR_WRAP;
    float HSM_TOP_MIPMAPPING_BLEND_BIAS;
    float HSM_RENDER_SIMPLE_MODE;
    float HSM_RENDER_SIMPLE_MASK_TYPE;
    float HSM_LAYERING_DEBUG_MASK_MODE;
    float HSM_INTRO_LOGO_BLEND_MODE;
    float HSM_INTRO_LOGO_FLIP_VERTICAL;
    float HSM_INTRO_NOISE_BLEND_MODE;
    float HSM_INTRO_NOISE_HOLD;
    float HSM_INTRO_NOISE_FADE_OUT;
    float HSM_INTRO_SOLID_BLACK_HOLD;
    float HSM_INTRO_SOLID_BLACK_FADE_OUT;
    float HSM_INTRO_SOLID_COLOR_BLEND_MODE;
    float HSM_INTRO_LOGO_OVER_SOLID_COLOR;
    float HSM_INTRO_LOGO_PLACEMENT;
    float HSM_INTRO_LOGO_HEIGHT;
    float HSM_INTRO_LOGO_POS_X;
    float HSM_INTRO_LOGO_POS_Y;
    float HSM_INTRO_WHEN_TO_SHOW;
    float HSM_INTRO_SPEED;
    float HSM_INTRO_LOGO_WAIT;
    float HSM_INTRO_LOGO_FADE_IN;
    float HSM_INTRO_LOGO_HOLD;
    float HSM_INTRO_LOGO_FADE_OUT;
    float HSM_INTRO_SOLID_COLOR_HUE;
    float HSM_INTRO_SOLID_COLOR_SAT;
    float HSM_INTRO_SOLID_COLOR_VALUE;
    float HSM_INTRO_SOLID_COLOR_HOLD;
    float HSM_INTRO_SOLID_COLOR_FADE_OUT;
    float GAMMA_INPUT;
    float gamma_out;
    float post_br;
    float post_br_affect_black_level;
    float glow;
    float bloom;
    float mask_bloom;
    float bloom_dist;
    float halation;
    float TATE;
    float IOS;
    float OS;
    float BLOOM;
    float overscanX;
    float overscanY;
    float intres;
    float prescalex;
    float c_shape;
    float sborder;
    float csize;
    float bsize1;
    float warpX;
    float warpY;
    float gamma_c;
    float brightboost;
    float brightboost1;
    float blendMode;
    float gsl;
    float scanline1;
    float scanline2;
    float beam_min;
    float beam_max;
    float beam_size;
    float vertmask;
    float scans;
    float scan_falloff;
    float spike;
    float ring;
    float scangamma;
    float rolling_scan;
    float h_sharp;
    float s_sharp;
    float smart_ei;
    float ei_limit;
    float sth;
    float barspeed;
    float barintensity;
    float bardir;
    float shadowMask;
    float maskstr;
    float mcut;
    float masksize;
    float maskDark;
    float maskLight;
    float mask_gamma;
    float slotmask;
    float slotmask1;
    float slotwidth;
    float double_slot;
    float slotms;
    float mclip;
    float mshift;
    float mask_layout;
    float GDV_DECONVERGENCE_ON;
    float decons;
    float GDV_NOISE_ON;
    float addnoised;
    float noisetype;
    float noiseresd;
    float deconrr;
    float deconrg;
    float deconrb;
    float deconrry;
    float deconrgy;
    float deconrby;
    float deconsmooth;
    float dctypex;
    float dctypey;
    float g_grade_on;
    float wp_temperature;
    float g_satr;
    float g_satg;
    float g_satb;
    float AS;
    float asat;
    float hcrt_h_size;
    float hcrt_v_size;
    float hcrt_h_cent;
    float hcrt_v_cent;
    float hcrt_pin_phase;
    float hcrt_pin_amp;
} global;

struct Push
{
    float g_gamma_in;
    float g_gamma_out;
    float g_signal_type;
    float g_crtgamut;
    float g_space_out;
    float g_hue_degrees;
    float g_I_SHIFT;
    float g_Q_SHIFT;
    float g_I_MUL;
    float g_Q_MUL;
    float g_lum_fix;
    float g_sat;
    float g_vibr;
    float g_lum;
    float g_cntrst;
    float g_mid;
    float g_lift;
    float blr;
    float blg;
    float blb;
    float wlr;
    float wlg;
    float wlb;
    float rg;
    float rb;
    float gr;
    float gb;
    float br;
    float bg;
};

uniform Push params;

layout(binding = 3) uniform sampler2D Source;
layout(binding = 1) uniform sampler2D InfoCachePass;
layout(binding = 2) uniform sampler2D InfoCachePassFeedback;

layout(location = 0) in vec2 vTexCoord;
layout(location = 0) out vec4 FragColor;
float NEGATIVE_CROP_EXPAND_MULTIPLIER;
float MAX_NEGATIVE_CROP;
float DEFAULT_SCREEN_ASPECT;
float DEFAULT_BEZEL_ASPECT;
vec2 DEFAULT_SCREEN_SCALE;
vec2 DEFAULT_BEZEL_SCALE;
int INFOCACHE_MAX_INDEX;
float BLEND_MODE_OFF;
float BLEND_MODE_NORMAL;
float BLEND_MODE_ADD;
float BLEND_MODE_MULTIPLY;
float SOURCE_MATTE_PREMULTIPLIED;
float SOURCE_MATTE_WHITE;
float SOURCE_MATTE_NONE;
float IMAGE_ASPECT_MODE_INHERIT_ASPECT_SCALE;
float IMAGE_ASPECT_MODE_KEEP_ASPECT;
float FILL_MODE_STRETCH;
float FILL_MODE_SPLIT_FILL_HORIZONTAL;
float FILL_MODE_SPLIT_FILL_VERTICAL;
bool CACHE_INFO_PARAM_SUM_CHANGED;
float CURRENT_FRAME_FROM_CACHE_INFO;
float TUBE_DIFFUSE_MASK;
float TUBE_MASK;
float BEZEL_MASK;
float INSIDE_BEZEL_MASK;
float OUTSIDE_TUBE_MASK_FOR_IMAGE;
float FRAME_MASK;
float FRAME_MASK_FOR_IMAGE;
float OUTSIDE_BEZEL_MASK;
float OUTSIDE_FRAME_MASK_FOR_IMAGE;
float OUTSIDE_FRAME_MASK;
float CUTOUT_MASK;
float SCREEN_INDEX;
float SCREEN_ASPECT;
vec2 SCREEN_SCALE;
vec2 SCREEN_POS_OFFSET;
vec2 SCREEN_SCALE_2ND_SCREEN;
vec2 SCREEN_POS_OFFSET_2ND_SCREEN;
vec2 VIEWPORT_SCALE;
vec2 VIEWPORT_POS;
vec2 TUBE_SCALE;
vec2 TUBE_DIFFUSE_SCALE;
float TUBE_DIFFUSE_ASPECT;
vec2 FRAME_SCALE;
vec2 BEZEL_OUTSIDE_SCALE;
vec2 BACKGROUND_SCALE;
vec2 LED_SCALE;
vec2 DEVICE_SCALE;
vec2 DECAL_SCALE;
vec2 CAB_GLASS_SCALE;
vec2 TOP_IMAGE_SCALE;
float AVERAGE_LUMA;
float USE_VERTICAL_SCANLINES;
vec2 CORE_SIZE;
vec2 ROTATED_CORE_ORIGINAL_SIZE;
vec2 ROTATED_CORE_PREPPED_SIZE;
vec2 ROTATED_DEREZED_SIZE;
vec2 CROPPED_ROTATED_SIZE_WITH_RES_MULT;
vec2 CROPPED_ROTATED_SIZE_WITH_RES_MULT_FEEDBACK;
vec2 CROPPED_ROTATED_SIZE;
vec2 SAMPLE_AREA_START_PIXEL_COORD;
vec2 VIEWPORT_UNSCALED_COORD;
vec2 SCREEN_COORD;
vec2 TUBE_COORD;
vec2 TUBE_DIFFUSE_COORD;
vec2 BEZEL_OUTSIDE_COORD;
vec2 BACKGROUND_COORD;
vec2 DEVICE_COORD;
vec2 LED_COORD;
vec2 DECAL_COORD;
vec2 CAB_GLASS_COORD;
vec2 TOP_IMAGE_COORD;
vec2 SCREEN_CURVED_COORD;
vec2 TUBE_CURVED_COORD;
vec2 TUBE_DIFFUSE_CURVED_COORD;
vec2 BEZEL_OUTSIDE_CURVED_COORD;
vec2 FRAME_OUTSIDE_CURVED_COORD;
vec2 BACKGROUND_CURVED_COORD;
vec2 LED_CURVED_COORD;
vec2 DEVICE_CURVED_COORD;
vec2 DECAL_CURVED_COORD;
vec2 CAB_GLASS_CURVED_COORD;
vec2 TOP_IMAGE_CURVED_COORD;
float HSM_RESOLUTION_DEBUG_ON;
float HSM_CACHE_GRAPHICS_ON;
float HSM_CACHE_UPDATE_INDICATOR_MODE;
float HSM_GLOBAL_GRAPHICS_BRIGHTNESS;
float HSM_STATIC_LAYERS_GAMMA;
float HSM_AMBIENT_LIGHTING_OPACITY;
float HSM_AMBIENT2_LIGHTING_OPACITY;
float HSM_AMBIENT_LIGHTING_SWAP_IMAGES;
float HSM_VIEWPORT_ZOOM;
float HSM_VIEWPORT_ZOOM_MASK;
float HSM_VIEWPORT_POSITION_X;
float HSM_VIEWPORT_POSITION_Y;
float HSM_FLIP_VIEWPORT_VERTICAL;
float HSM_FLIP_VIEWPORT_HORIZONTAL;
float HSM_FLIP_CORE_VERTICAL;
float HSM_FLIP_CORE_HORIZONTAL;
float HSM_ROTATE_CORE_IMAGE;
float HSM_ASPECT_RATIO_ORIENTATION;
float HSM_ASPECT_RATIO_MODE;
float HSM_ASPECT_RATIO_EXPLICIT;
float HSM_VERTICAL_PRESET;
float HSM_INT_SCALE_MAX_HEIGHT;
float HSM_NON_INTEGER_SCALE;
float HSM_USE_PHYSICAL_SIZE_FOR_NON_INTEGER;
float HSM_PHYSICAL_MONITOR_ASPECT_RATIO;
float HSM_PHYSICAL_MONITOR_DIAGONAL_SIZE;
float HSM_PHYSICAL_SIM_TUBE_DIAGONAL_SIZE;
float HSM_USE_IMAGE_FOR_PLACEMENT;
float HSM_PLACEMENT_IMAGE_USE_HORIZONTAL;
float HSM_PLACEMENT_IMAGE_MODE;
float HSM_NON_INTEGER_SCALE_OFFSET;
float HSM_USE_SNAP_TO_CLOSEST_INT_SCALE;
float HSM_SNAP_TO_CLOSEST_INT_SCALE_TOLERANCE;
float HSM_SCREEN_POSITION_X;
float HSM_SCREEN_POSITION_Y;
float HSM_CROP_MODE;
float HSM_CROP_PERCENT_ZOOM;
float HSM_CROP_PERCENT_TOP;
float HSM_CROP_PERCENT_BOTTOM;
float HSM_CROP_PERCENT_LEFT;
float HSM_CROP_PERCENT_RIGHT;
float HSM_CROP_BLACK_THRESHOLD;
float HSM_SCANLINE_DIRECTION;
float HSM_CORE_RES_SAMPLING_MULT_SCANLINE_DIR;
float HSM_DOWNSAMPLE_BLUR_SCANLINE_DIR;
float HSM_CORE_RES_SAMPLING_MULT_OPPOSITE_DIR;
float HSM_DOWNSAMPLE_BLUR_OPPOSITE_DIR;
float HSM_CORE_RES_SAMPLING_SHIFT_OPPOSITE_DIR;
float HSM_USE_GEOM;
float HSM_CURVATURE_MODE;
float HSM_CURVATURE_3D_RADIUS;
float HSM_CURVATURE_3D_VIEW_DIST;
float HSM_CURVATURE_3D_TILT_ANGLE_X;
float HSM_CURVATURE_3D_TILT_ANGLE_Y;
float HSM_CRT_CURVATURE_SCALE;
float HSM_AB_COMPARE_SHOW_MODE;
float HSM_AB_COMPARE_AREA;
float HSM_AB_COMPARE_SPLIT_POSITION;
float HSM_AB_COMPARE_FREEZE_CRT_TUBE;
float HSM_AB_COMPARE_FREEZE_GRAPHICS;
float HSM_SCREEN_VIGNETTE_DUALSCREEN_VIS_MODE;
float HSM_MONOCHROME_DUALSCREEN_VIS_MODE;
float HSM_TUBE_DIFFUSE_MODE;
float HSM_TUBE_DIFFUSE_OPACITY;
float HSM_TUBE_DIFFUSE_IMAGE_DUALSCREEN_VIS_MODE;
float HSM_TUBE_DIFFUSE_IMAGE_COLORIZE_ON;
float HSM_TUBE_DIFFUSE_IMAGE_HUE;
float HSM_TUBE_DIFFUSE_IMAGE_SATURATION;
float HSM_TUBE_DIFFUSE_IMAGE_BRIGHTNESS;
float HSM_TUBE_DIFFUSE_IMAGE_GAMMA;
float HSM_TUBE_DIFFUSE_IMAGE_AMBIENT_LIGHTING;
float HSM_TUBE_DIFFUSE_IMAGE_AMBIENT2_LIGHTING;
float HSM_TUBE_DIFFUSE_IMAGE_SCALE;
float HSM_TUBE_DIFFUSE_IMAGE_SCALE_X;
float HSM_TUBE_SHADOW_IMAGE_ON;
float HSM_TUBE_SHADOW_IMAGE_OPACITY;
float HSM_TUBE_SHADOW_IMAGE_POS_X;
float HSM_TUBE_SHADOW_IMAGE_POS_Y;
float HSM_TUBE_SHADOW_IMAGE_SCALE_X;
float HSM_TUBE_SHADOW_IMAGE_SCALE_Y;
float HSM_TUBE_SHADOW_CURVATURE_SCALE;
float HSM_TUBE_COLORED_GEL_IMAGE_ON;
float HSM_TUBE_COLORED_GEL_IMAGE_SCALE;
float HSM_TUBE_COLORED_GEL_IMAGE_FLIP_HORIZONTAL;
float HSM_TUBE_COLORED_GEL_IMAGE_FLIP_VERTICAL;
float HSM_TUBE_COLORED_GEL_IMAGE_DUALSCREEN_VIS_MODE;
float HSM_TUBE_COLORED_GEL_IMAGE_MULTIPLY_AMOUNT;
float HSM_TUBE_COLORED_GEL_IMAGE_ADDITIVE_AMOUNT;
float HSM_TUBE_COLORED_GEL_IMAGE_NORMAL_AMOUNT;
float HSM_TUBE_COLORED_GEL_IMAGE_TRANSPARENCY_THRESHOLD;
float HSM_TUBE_COLORED_GEL_IMAGE_NORMAL_BRIGHTNESS;
float HSM_TUBE_COLORED_GEL_IMAGE_NORMAL_VIGNETTE;
float HSM_TUBE_COLORED_GEL_IMAGE_FAKE_SCANLINE_AMOUNT;
float HSM_TUBE_COLORED_GEL_IMAGE_AMBIENT_LIGHTING;
float HSM_TUBE_COLORED_GEL_IMAGE_AMBIENT2_LIGHTING;
float HSM_SHOW_CRT_ON_TOP_OF_COLORED_GEL;
float HSM_TUBE_STATIC_REFLECTION_IMAGE_ON;
float HSM_TUBE_STATIC_REFLECTION_IMAGE_DUALSCREEN_VIS_MODE;
float HSM_TUBE_STATIC_REFLECTION_IMAGE_OPACITY;
float HSM_TUBE_STATIC_REFLECTION_IMAGE_AMBIENT_LIGHTING;
float HSM_TUBE_STATIC_REFLECTION_IMAGE_AMBIENT2_LIGHTING;
float HSM_TUBE_STATIC_REFLECTION_IMAGE_SCALE;
float HSM_TUBE_STATIC_REFLECTION_IMAGE_SHADOW_OPACITY;
float HSM_DUALSCREEN_MODE;
float HSM_DUALSCREEN_CORE_IMAGE_SPLIT_MODE;
float HSM_DUALSCREEN_CORE_IMAGE_SWAP_SCREENS;
float HSM_DUALSCREEN_CORE_IMAGE_SPLIT_OFFSET;
float HSM_DUALSCREEN_VIEWPORT_SPLIT_LOCATION;
float HSM_DUALSCREEN_SHIFT_POSITION_WITH_SCALE;
float HSM_DUALSCREEN_POSITION_OFFSET_BETWEEN_SCREENS;
float HSM_2ND_SCREEN_ASPECT_RATIO_MODE;
float HSM_2ND_SCREEN_INDEPENDENT_SCALE;
float HSM_2ND_SCREEN_SCALE_OFFSET;
float HSM_2ND_SCREEN_POS_X;
float HSM_2ND_SCREEN_POS_Y;
float HSM_2ND_SCREEN_CROP_PERCENT_ZOOM;
float HSM_2ND_SCREEN_CROP_PERCENT_TOP;
float HSM_2ND_SCREEN_CROP_PERCENT_BOTTOM;
float HSM_2ND_SCREEN_CROP_PERCENT_LEFT;
float HSM_2ND_SCREEN_CROP_PERCENT_RIGHT;
float HSM_SCREEN_REFLECTION_SCALE;
float HSM_SCREEN_REFLECTION_POS_X;
float HSM_SCREEN_REFLECTION_POS_Y;
float HSM_AMBIENT_LIGHTING_HUE;
float HSM_AMBIENT_LIGHTING_SATURATION;
float HSM_AMBIENT_LIGHTING_VALUE;
float HSM_AMBIENT_LIGHTING_CONTRAST;
float HSM_AMBIENT_LIGHTING_SCALE_KEEP_ASPECT;
float HSM_AMBIENT_LIGHTING_SCALE_WITH_ZOOM;
float HSM_AMBIENT_LIGHTING_SCALE;
float HSM_AMBIENT_LIGHTING_SCALE_X;
float HSM_AMBIENT_LIGHTING_ROTATE;
float HSM_AMBIENT_LIGHTING_MIRROR_HORZ;
float HSM_AMBIENT_LIGHTING_POSITION_X;
float HSM_AMBIENT_LIGHTING_POSITION_Y;
float HSM_AMBIENT_LIGHTING_DITHERING_SAMPLES;
float HSM_AMBIENT2_LIGHTING_HUE;
float HSM_AMBIENT2_LIGHTING_SATURATION;
float HSM_AMBIENT2_LIGHTING_VALUE;
float HSM_AMBIENT2_LIGHTING_CONTRAST;
float HSM_AMBIENT2_LIGHTING_SCALE_KEEP_ASPECT;
float HSM_AMBIENT2_LIGHTING_SCALE_WITH_ZOOM;
float HSM_AMBIENT2_LIGHTING_SCALE;
float HSM_AMBIENT2_LIGHTING_SCALE_X;
float HSM_AMBIENT2_LIGHTING_ROTATE;
float HSM_AMBIENT2_LIGHTING_MIRROR_HORZ;
float HSM_AMBIENT2_LIGHTING_POSITION_X;
float HSM_AMBIENT2_LIGHTING_POSITION_Y;
float HSM_BZL_OPACITY;
float HSM_BZL_BLEND_MODE;
float HSM_BZL_WIDTH;
float HSM_BZL_HEIGHT;
float HSM_BZL_INNER_CORNER_RADIUS_SCALE;
float CURVATURE_MODE_OFF;
float CURVATURE_MODE_2D;
float CURVATURE_MODE_2D_CYLINDER;
float CURVATURE_MODE_3D_1;
float CURVATURE_MODE_3D_2;
float CURVATURE_MODE_3D_CYLINDER;

vec3 r601_YUV(vec3 RGB)
{
    return RGB * mat3(vec3(0.2989999949932098388671875, 0.58700001239776611328125, 0.114000000059604644775390625), vec3(-0.147406995296478271484375, -0.2893910109996795654296875, 0.4367980062961578369140625), vec3(0.614777028560638427734375, -0.51479899883270263671875, -0.0999779999256134033203125));
}

vec3 RGB_YIQ(vec3 col)
{
    return col * mat3(vec3(0.2989999949932098388671875, 0.58700001239776611328125, 0.114000000059604644775390625), vec3(0.595899999141693115234375, -0.2745999991893768310546875, -0.3212999999523162841796875), vec3(0.21150000393390655517578125, -0.522700011730194091796875, 0.3111999928951263427734375));
}

vec3 RGB_FCC(vec3 col)
{
    return col * mat3(vec3(0.2999969422817230224609375, 0.590001583099365234375, 0.110001496970653533935546875), vec3(0.599002420902252197265625, -0.277301251888275146484375, -0.3217011392116546630859375), vec3(0.2130016982555389404296875, -0.525101184844970703125, 0.312099516391754150390625));
}

vec3 PCtoTV(inout vec3 col, float luma_swing, inout float Umax, inout float Vmax, float max_swing, bool rgb_in)
{
    col *= 255.0;
    float _1706;
    if (max_swing == 1.0)
    {
        _1706 = Umax * 224.0;
    }
    else
    {
        _1706 = Umax * 239.0;
    }
    Umax = _1706;
    float _1719;
    if (max_swing == 1.0)
    {
        _1719 = Vmax * 224.0;
    }
    else
    {
        _1719 = Vmax * 239.0;
    }
    Vmax = _1719;
    float _1730;
    if (luma_swing == 1.0)
    {
        _1730 = ((col.x * 219.0) / 255.0) + 16.0;
    }
    else
    {
        _1730 = col.x;
    }
    col.x = _1730;
    float _1747;
    if (rgb_in == true)
    {
        _1747 = ((col.y * 219.0) / 255.0) + 16.0;
    }
    else
    {
        _1747 = (((col.y - 128.0) * (Umax * 2.0)) / 255.0) + Umax;
    }
    col.y = _1747;
    float _1770;
    if (rgb_in == true)
    {
        _1770 = ((col.z * 219.0) / 255.0) + 16.0;
    }
    else
    {
        _1770 = (((col.z - 128.0) * (Vmax * 2.0)) / 255.0) + Vmax;
    }
    col.z = _1770;
    return col / vec3(255.0);
}

vec3 TVtoPC(inout vec3 col, float luma_swing, inout float Umax, inout float Vmax, float max_swing, bool rgb_in)
{
    col *= 255.0;
    float _1799;
    if (max_swing == 1.0)
    {
        _1799 = Umax * 224.0;
    }
    else
    {
        _1799 = Umax * 239.0;
    }
    Umax = _1799;
    float _1810;
    if (max_swing == 1.0)
    {
        _1810 = Vmax * 224.0;
    }
    else
    {
        _1810 = Vmax * 239.0;
    }
    Vmax = _1810;
    float _1822;
    if (luma_swing == 1.0)
    {
        _1822 = ((col.x - 16.0) / 219.0) * 255.0;
    }
    else
    {
        _1822 = col.x;
    }
    float colx = _1822;
    float _1837;
    if (rgb_in == true)
    {
        _1837 = ((col.y - 16.0) / 219.0) * 255.0;
    }
    else
    {
        _1837 = (((col.y - Umax) / (Umax * 2.0)) * 255.0) + 128.0;
    }
    float coly = _1837;
    float _1859;
    if (rgb_in == true)
    {
        _1859 = ((col.z - 16.0) / 219.0) * 255.0;
    }
    else
    {
        _1859 = (((col.z - Vmax) / (Vmax * 2.0)) * 255.0) + 128.0;
    }
    float colz = _1859;
    return vec3(colx, coly, colz) / vec3(255.0);
}

vec3 YUV_r601(vec3 RGB)
{
    return RGB * mat3(vec3(1.0, 0.0, 1.14025080204010009765625), vec3(1.0, -0.3939306735992431640625, -0.580809175968170166015625), vec3(1.0, 2.02839756011962890625, -2.9356581876527343410998582839966e-07));
}

vec3 YIQ_RGB(vec3 col)
{
    return col * mat3(vec3(1.0, 0.95599997043609619140625, 0.619000017642974853515625), vec3(1.0, -0.272000014781951904296875, -0.647000014781951904296875), vec3(1.0, -1.10599994659423828125, 1.70299994945526123046875));
}

vec3 FCC_RGB(vec3 col)
{
    return col * mat3(vec3(1.0, 0.946882188320159912109375, 0.623556554317474365234375), vec3(1.0, -0.2747876346111297607421875, -0.635691106319427490234375), vec3(1.0, -1.1085450649261474609375, 1.70900690555572509765625));
}

vec3 r601_YCC(vec3 RGB)
{
    return RGB * mat3(vec3(0.2989999949932098388671875, 0.58700001239776611328125, 0.114000000059604644775390625), vec3(-0.1687358915805816650390625, -0.3312641084194183349609375, 0.5), vec3(0.5, -0.4186875820159912109375, -0.081312410533428192138671875));
}

vec3 YCC_r601(vec3 YUV)
{
    return YUV * mat3(vec3(1.0, 0.0, 1.401999950408935546875), vec3(1.0, -0.344136297702789306640625, -0.714136302471160888671875), vec3(1.0, 1.77199995517730712890625, 0.0));
}

float moncurve_f(inout float color, float gamma, float offs)
{
    color = clamp(color, 0.0, 1.0);
    float fs = ((gamma - 1.0) / offs) * pow((offs * gamma) / ((gamma - 1.0) * (1.0 + offs)), gamma);
    float xb = offs / (gamma - 1.0);
    float _1384;
    if (color > xb)
    {
        _1384 = pow((color + offs) / (1.0 + offs), gamma);
    }
    else
    {
        _1384 = color * fs;
    }
    color = _1384;
    return color;
}

vec3 moncurve_f_f3(inout vec3 color, float gamma, float offs)
{
    float param = color.x;
    float param_1 = gamma;
    float param_2 = offs;
    float _1410 = moncurve_f(param, param_1, param_2);
    color.x = _1410;
    float param_3 = color.y;
    float param_4 = gamma;
    float param_5 = offs;
    float _1419 = moncurve_f(param_3, param_4, param_5);
    color.y = _1419;
    float param_6 = color.z;
    float param_7 = gamma;
    float param_8 = offs;
    float _1428 = moncurve_f(param_6, param_7, param_8);
    color.z = _1428;
    return color;
}

vec3 wp_adjust(float temperature, vec3 color)
{
    float temp3 = 1000.0 / temperature;
    float temp6 = 1000000.0 / pow(temperature, 2.0);
    float temp9 = 1000000000.0 / pow(temperature, 3.0);
    vec3 wp = vec3(1.0);
    float _1269;
    if (temperature <= 7000.0)
    {
        _1269 = ((0.24406300485134124755859375 + (0.099109999835491180419921875 * temp3)) + (2.9677999019622802734375 * temp6)) - (4.606999874114990234375 * temp9);
    }
    else
    {
        _1269 = ((0.23703999817371368408203125 + (0.2474800050258636474609375 * temp3)) + (1.90180003643035888671875 * temp6)) - (2.00640010833740234375 * temp9);
    }
    wp.x = _1269;
    wp.y = (((-3.0) * pow(wp.x, 2.0)) + (2.86999988555908203125 * wp.x)) - 0.2750000059604644775390625;
    wp.z = (1.0 - wp.x) - wp.y;
    vec3 fw_trans = (vec3(wp.x / wp.y, 1.0, wp.z / wp.y) * mat3(vec3(0.732800006866455078125, 0.4296000003814697265625, -0.1624000072479248046875), vec3(-0.703599989414215087890625, 1.6974999904632568359375, 0.006099999882280826568603515625), vec3(0.0030000000260770320892333984375, -0.013600000180304050445556640625, 0.98339998722076416015625))) / vec3(0.94924962520599365234375, 1.03540575504302978515625, 1.06009232997894287109375);
    return color * fw_trans;
}

vec3 XYZ_to_RGB(vec3 XYZ, float CSPC)
{
    vec3 _1009;
    if (CSPC == 3.0)
    {
        _1009 = mat3(vec3(2.0415899753570556640625, -0.969240009784698486328125, 0.01343999989330768585205078125), vec3(-0.565010011196136474609375, 1.87597000598907470703125, -0.11835999786853790283203125), vec3(-0.3447299897670745849609375, 0.041560001671314239501953125, 1.01516997814178466796875)) * XYZ;
    }
    else
    {
        vec3 _1031;
        if (CSPC == 2.0)
        {
            _1031 = mat3(vec3(1.716609477996826171875, -0.666682720184326171875, 0.01764220558106899261474609375), vec3(-0.3556621372699737548828125, 1.616477489471435546875, -0.042776308953762054443359375), vec3(-0.2533601224422454833984375, 0.015768505632877349853515625, 0.9422285556793212890625)) * XYZ;
        }
        else
        {
            vec3 _1052;
            if (CSPC == 1.0)
            {
                _1052 = mat3(vec3(2.4933965206146240234375, -0.82948720455169677734375, 0.0358506850898265838623046875), vec3(-0.93134605884552001953125, 1.7626602649688720703125, -0.07618270814418792724609375), vec3(-0.40269458293914794921875, 0.02362464182078838348388671875, 0.957014024257659912109375)) * XYZ;
            }
            else
            {
                _1052 = mat3(vec3(3.2408125400543212890625, -0.96924304962158203125, 0.0556383989751338958740234375), vec3(-1.53730857372283935546875, 1.8759663105010986328125, -0.20400743186473846435546875), vec3(-0.498586595058441162109375, 0.0415550507605075836181640625, 1.057129383087158203125)) * XYZ;
            }
            _1031 = _1052;
        }
        _1009 = _1031;
    }
    return _1009;
}

float moncurve_r(inout float color, float gamma, float offs)
{
    color = clamp(color, 0.0, 1.0);
    float yb = pow((offs * gamma) / ((gamma - 1.0) * (1.0 + offs)), gamma);
    float rs = pow((gamma - 1.0) / offs, gamma - 1.0) * pow((1.0 + offs) / gamma, gamma);
    float _1465;
    if (color > yb)
    {
        _1465 = ((1.0 + offs) * pow(color, 1.0 / gamma)) - offs;
    }
    else
    {
        _1465 = color * rs;
    }
    color = _1465;
    return color;
}

vec3 moncurve_r_f3(inout vec3 color, float gamma, float offs)
{
    float param = color.x;
    float param_1 = gamma;
    float param_2 = offs;
    float _1492 = moncurve_r(param, param_1, param_2);
    color.x = _1492;
    float param_3 = color.y;
    float param_4 = gamma;
    float param_5 = offs;
    float _1501 = moncurve_r(param_3, param_4, param_5);
    color.y = _1501;
    float param_6 = color.z;
    float param_7 = gamma;
    float param_8 = offs;
    float _1510 = moncurve_r(param_6, param_7, param_8);
    color.z = _1510;
    return color;
}

vec3 RGB_to_XYZ(vec3 RGB, float CSPC)
{
    vec3 _1093;
    if (CSPC == 3.0)
    {
        _1093 = mat3(vec3(0.576669991016387939453125, 0.2973400056362152099609375, 0.02703000046312808990478515625), vec3(0.18556000292301177978515625, 0.62735998630523681640625, 0.070689998567104339599609375), vec3(0.18822999298572540283203125, 0.075290001928806304931640625, 0.991339981555938720703125)) * RGB;
    }
    else
    {
        vec3 _1114;
        if (CSPC == 2.0)
        {
            _1114 = mat3(vec3(0.63697350025177001953125, 0.2484013736248016357421875, 0.0), vec3(0.1529456079006195068359375, 0.67799961566925048828125, 0.04253686964511871337890625), vec3(0.117858089506626129150390625, 0.039131723344326019287109375, 1.06084382534027099609375)) * RGB;
        }
        else
        {
            vec3 _1134;
            if (CSPC == 1.0)
            {
                _1134 = mat3(vec3(0.48659050464630126953125, 0.22898375988006591796875, 0.0), vec3(0.265668213367462158203125, 0.69173991680145263671875, 0.0451134741306304931640625), vec3(0.19819043576717376708984375, 0.079276166856288909912109375, 1.0438029766082763671875)) * RGB;
            }
            else
            {
                _1134 = mat3(vec3(0.412410795688629150390625, 0.21264933049678802490234375, 0.0193317569792270660400390625), vec3(0.3575845658779144287109375, 0.715169131755828857421875, 0.119194857776165008544921875), vec3(0.18045382201671600341796875, 0.072181522846221923828125, 0.950390160083770751953125)) * RGB;
            }
            _1114 = _1134;
        }
        _1093 = _1114;
    }
    return _1093;
}

vec3 XYZtoYxy(vec3 XYZ)
{
    float XYZrgb = (XYZ.x + XYZ.y) + XYZ.z;
    float _1184;
    if (XYZrgb <= 0.0)
    {
        _1184 = 0.3804999887943267822265625;
    }
    else
    {
        _1184 = XYZ.x / XYZrgb;
    }
    float Yxyg = _1184;
    float _1197;
    if (XYZrgb <= 0.0)
    {
        _1197 = 0.3768999874591827392578125;
    }
    else
    {
        _1197 = XYZ.y / XYZrgb;
    }
    float Yxyb = _1197;
    return vec3(XYZ.y, Yxyg, Yxyb);
}

float contrast_sigmoid_inv(inout float color, inout float cont, float pivot)
{
    cont = pow(cont - 1.0, 3.0);
    float knee = 1.0 / (1.0 + exp(cont * pivot));
    float shldr = 1.0 / (1.0 + exp(cont * (pivot - 1.0)));
    color = pivot - (log((1.0 / ((color * (shldr - knee)) + knee)) - 1.0) / cont);
    return color;
}

float contrast_sigmoid(inout float color, inout float cont, float pivot)
{
    cont = pow(cont + 1.0, 3.0);
    float knee = 1.0 / (1.0 + exp(cont * pivot));
    float shldr = 1.0 / (1.0 + exp(cont * (pivot - 1.0)));
    color = ((1.0 / (1.0 + exp(cont * (pivot - color)))) - knee) / (shldr - knee);
    return color;
}

vec3 YxytoXYZ(vec3 Yxy)
{
    float Xs = Yxy.x * (Yxy.y / Yxy.z);
    float Xsz = (Yxy.x <= 0.0) ? 0.0 : 1.0;
    vec3 XYZ = vec3(Xsz, Xsz, Xsz) * vec3(Xs, Yxy.x, ((Xs / Yxy.y) - Xs) - Yxy.x);
    return XYZ;
}

vec2 HSM_GetViewportCoordWithFlip(vec2 viewport_coord)
{
    vec2 out_coord = viewport_coord;
    if (HSM_FLIP_VIEWPORT_VERTICAL == (-1.0))
    {
        out_coord.y = 1.0 - out_coord.y;
    }
    if (HSM_FLIP_VIEWPORT_HORIZONTAL == (-1.0))
    {
        out_coord.x = 1.0 - out_coord.x;
    }
    return out_coord;
}

vec2 HSM_GetViewportCoordWithZoomAndPan(vec2 viewport_coord)
{
    vec2 param = viewport_coord;
    vec2 out_coord = HSM_GetViewportCoordWithFlip(param);
    out_coord = ((out_coord - vec2(0.5)) / vec2(HSM_VIEWPORT_ZOOM)) + vec2(0.5);
    out_coord.x += HSM_VIEWPORT_POSITION_X;
    out_coord.y -= HSM_VIEWPORT_POSITION_Y;
    return out_coord;
}

float HSM_GetScreenIndex(vec2 viewport_coord)
{
    float out_index = 1.0;
    float output_aspect = global.FinalViewportSize.x / global.FinalViewportSize.y;
    if (HSM_DUALSCREEN_MODE == 0.0)
    {
        out_index = 1.0;
    }
    if (HSM_DUALSCREEN_MODE == 1.0)
    {
        out_index = float((viewport_coord.y < (0.5 + (HSM_DUALSCREEN_VIEWPORT_SPLIT_LOCATION / output_aspect))) ? 1 : 2);
    }
    if (HSM_DUALSCREEN_MODE == 2.0)
    {
        out_index = float((viewport_coord.x < (0.5 + (HSM_DUALSCREEN_VIEWPORT_SPLIT_LOCATION / output_aspect))) ? 1 : 2);
    }
    return out_index;
}

vec2 HSM_GetRotatedNegativeCropAddedSize()
{
    return (global.NegativeCropAddedPassSize.yx * HSM_ROTATE_CORE_IMAGE) + (global.NegativeCropAddedPassSize.xy * (1.0 - HSM_ROTATE_CORE_IMAGE));
}

vec2 HSM_GetRotatedCoreOriginalSize()
{
    return (global.OriginalSize.yx * HSM_ROTATE_CORE_IMAGE) + (global.OriginalSize.xy * (1.0 - HSM_ROTATE_CORE_IMAGE));
}

vec4 HSM_GetCacheSampleRange(float column_index, float row_index)
{
    float num_rows = 8.0;
    float num_columns = 8.0;
    float range_width = 1.0 / num_columns;
    float range_height = 1.0 / num_rows;
    float zero_based_row_index = row_index - 1.0;
    float zero_based_column_index = column_index - 1.0;
    vec4 out_sample_range = vec4(0.0);
    out_sample_range.x = zero_based_column_index * range_width;
    out_sample_range.y = zero_based_row_index * range_height;
    out_sample_range.z = out_sample_range.x + range_width;
    out_sample_range.w = out_sample_range.y + range_height;
    return out_sample_range;
}

vec2 HSM_GetCacheSampleCoord(float column_index, float row_index)
{
    float num_rows = 8.0;
    float num_columns = 8.0;
    float range_width = 1.0 / num_columns;
    float range_height = 1.0 / num_rows;
    float param = column_index;
    float param_1 = row_index;
    vec4 sample_range = HSM_GetCacheSampleRange(param, param_1);
    return vec2(sample_range.x + (range_width / 2.0), sample_range.y + (range_height / 2.0));
}

float HSM_GetUseVerticalScanlines(float screen_aspect)
{
    float auto_use_vert_scanlines = float(int(screen_aspect < 1.0));
    float scanline_direction = float((HSM_SCANLINE_DIRECTION < 2.0) ? 0 : 1);
    if (HSM_SCANLINE_DIRECTION < 1.0)
    {
        if (HSM_DUALSCREEN_MODE < 1.0)
        {
            scanline_direction = auto_use_vert_scanlines;
        }
    }
    return scanline_direction;
}

vec2 HSM_GetCoordWithPositionOffset(vec2 in_coord, vec2 position_offset)
{
    return in_coord - position_offset;
}

vec2 HSM_GetInverseScaledCoord(vec2 in_coord, vec2 in_scale)
{
    vec2 middle = vec2(0.499989986419677734375);
    vec2 diff = in_coord - middle;
    vec2 screen_inverse_scale = vec2(1.0) / in_scale;
    vec2 scaled_coord = middle + (diff * screen_inverse_scale);
    return scaled_coord;
}

vec2 HSM_GetVTexCoordWithArgs(vec2 in_coord, vec2 in_scale, vec2 position_offset)
{
    vec2 param = in_coord;
    vec2 param_1 = position_offset;
    vec2 param_2 = HSM_GetCoordWithPositionOffset(param, param_1);
    vec2 param_3 = in_scale;
    return HSM_GetInverseScaledCoord(param_2, param_3);
}

vec4 HSM_UpdateGlobalScreenValuesFromCache(sampler2D in_cache_pass, sampler2D in_cache_feedback_pass, vec2 vTexCoord_1)
{
    float output_aspect = global.FinalViewportSize.x / global.FinalViewportSize.y;
    vec2 param = vTexCoord_1;
    vec2 flipped_viewport_coord = HSM_GetViewportCoordWithZoomAndPan(param);
    vec2 param_1 = flipped_viewport_coord;
    SCREEN_INDEX = HSM_GetScreenIndex(param_1);
    CORE_SIZE = global.CorePassSize.xy;
    ROTATED_CORE_PREPPED_SIZE = HSM_GetRotatedNegativeCropAddedSize();
    ROTATED_CORE_ORIGINAL_SIZE = HSM_GetRotatedCoreOriginalSize();
    vec2 sample_coord = vec2(0.0);
    vec4 texture_sample = vec4(0.0);
    float param_2 = 1.0;
    float param_3 = 1.0;
    sample_coord = HSM_GetCacheSampleCoord(param_2, param_3);
    texture_sample = texture(in_cache_pass, sample_coord);
    AVERAGE_LUMA = texture_sample.w;
    float res_mult_size_sum = 0.0;
    float res_mult_size_sum_feedback = 0.0;
    float res_mult_size2_sum = 0.0;
    float res_mult_size2_sum_feedback = 0.0;
    if (SCREEN_INDEX == 1.0)
    {
        float param_4 = 2.0;
        float param_5 = 1.0;
        sample_coord = HSM_GetCacheSampleCoord(param_4, param_5);
        texture_sample = texture(in_cache_pass, sample_coord);
        SCREEN_ASPECT = texture_sample.x;
        SCREEN_SCALE = texture_sample.zw;
        float param_6 = 3.0;
        float param_7 = 1.0;
        sample_coord = HSM_GetCacheSampleCoord(param_6, param_7);
        texture_sample = texture(in_cache_pass, sample_coord);
        TUBE_SCALE = texture_sample.xy;
        SCREEN_POS_OFFSET = texture_sample.zw;
        float param_8 = 3.0;
        float param_9 = 4.0;
        sample_coord = HSM_GetCacheSampleCoord(param_8, param_9);
        texture_sample = texture(in_cache_pass, sample_coord);
        TUBE_DIFFUSE_SCALE = texture_sample.xy;
        TUBE_DIFFUSE_ASPECT = (TUBE_DIFFUSE_SCALE.x / TUBE_DIFFUSE_SCALE.y) * output_aspect;
        float param_10 = 4.0;
        float param_11 = 1.0;
        sample_coord = HSM_GetCacheSampleCoord(param_10, param_11);
        texture_sample = texture(in_cache_pass, sample_coord);
        CROPPED_ROTATED_SIZE_WITH_RES_MULT = texture_sample.xy;
        res_mult_size_sum = CROPPED_ROTATED_SIZE_WITH_RES_MULT.x + CROPPED_ROTATED_SIZE_WITH_RES_MULT.y;
        texture_sample = texture(in_cache_feedback_pass, sample_coord);
        CROPPED_ROTATED_SIZE_WITH_RES_MULT_FEEDBACK = texture_sample.xy;
        res_mult_size_sum_feedback = CROPPED_ROTATED_SIZE_WITH_RES_MULT_FEEDBACK.x + CROPPED_ROTATED_SIZE_WITH_RES_MULT_FEEDBACK.y;
        float param_12 = 1.0;
        float param_13 = 2.0;
        sample_coord = HSM_GetCacheSampleCoord(param_12, param_13);
        texture_sample = texture(in_cache_pass, sample_coord);
        CROPPED_ROTATED_SIZE = texture_sample.xy;
        SAMPLE_AREA_START_PIXEL_COORD = texture_sample.zw;
    }
    if (SCREEN_INDEX == 2.0)
    {
        float param_14 = 2.0;
        float param_15 = 2.0;
        sample_coord = HSM_GetCacheSampleCoord(param_14, param_15);
        texture_sample = texture(in_cache_pass, sample_coord);
        SCREEN_ASPECT = texture_sample.x;
        SCREEN_SCALE = texture_sample.yz;
        float param_16 = 3.0;
        float param_17 = 2.0;
        sample_coord = HSM_GetCacheSampleCoord(param_16, param_17);
        texture_sample = texture(in_cache_pass, sample_coord);
        TUBE_SCALE = texture_sample.xy;
        SCREEN_POS_OFFSET = texture_sample.zw;
        float param_18 = 3.0;
        float param_19 = 4.0;
        sample_coord = HSM_GetCacheSampleCoord(param_18, param_19);
        texture_sample = texture(in_cache_pass, sample_coord);
        TUBE_DIFFUSE_SCALE = texture_sample.zw;
        TUBE_DIFFUSE_ASPECT = (TUBE_DIFFUSE_SCALE.x / TUBE_DIFFUSE_SCALE.y) * output_aspect;
        float param_20 = 4.0;
        float param_21 = 2.0;
        sample_coord = HSM_GetCacheSampleCoord(param_20, param_21);
        texture_sample = texture(in_cache_pass, sample_coord);
        CROPPED_ROTATED_SIZE_WITH_RES_MULT = texture_sample.xy;
        res_mult_size2_sum = CROPPED_ROTATED_SIZE_WITH_RES_MULT.x + CROPPED_ROTATED_SIZE_WITH_RES_MULT.y;
        texture_sample = texture(in_cache_feedback_pass, sample_coord);
        CROPPED_ROTATED_SIZE_WITH_RES_MULT_FEEDBACK = texture_sample.xy;
        res_mult_size2_sum_feedback = CROPPED_ROTATED_SIZE_WITH_RES_MULT_FEEDBACK.x + CROPPED_ROTATED_SIZE_WITH_RES_MULT_FEEDBACK.y;
        float param_22 = 1.0;
        float param_23 = 3.0;
        sample_coord = HSM_GetCacheSampleCoord(param_22, param_23);
        texture_sample = texture(in_cache_pass, sample_coord);
        CROPPED_ROTATED_SIZE = texture_sample.xy;
        SAMPLE_AREA_START_PIXEL_COORD = texture_sample.zw;
    }
    float param_24 = 2.0;
    float param_25 = 3.0;
    sample_coord = HSM_GetCacheSampleCoord(param_24, param_25);
    texture_sample = texture(in_cache_pass, sample_coord);
    CORE_SIZE = texture_sample.xy;
    float param_26 = 3.0;
    float param_27 = 3.0;
    sample_coord = HSM_GetCacheSampleCoord(param_26, param_27);
    texture_sample = texture(in_cache_pass, sample_coord);
    VIEWPORT_SCALE = texture_sample.xy;
    VIEWPORT_POS = texture_sample.zw;
    float param_28 = 4.0;
    float param_29 = 3.0;
    sample_coord = HSM_GetCacheSampleCoord(param_28, param_29);
    texture_sample = texture(in_cache_pass, sample_coord);
    SCREEN_SCALE_2ND_SCREEN = texture_sample.xy;
    SCREEN_POS_OFFSET_2ND_SCREEN = texture_sample.zw;
    float param_30 = 1.0;
    float param_31 = 4.0;
    sample_coord = HSM_GetCacheSampleCoord(param_30, param_31);
    texture_sample = texture(in_cache_pass, sample_coord);
    float parameter_sum = texture_sample.x;
    CURRENT_FRAME_FROM_CACHE_INFO = texture_sample.y;
    ROTATED_DEREZED_SIZE = texture_sample.zw;
    texture_sample = texture(in_cache_feedback_pass, sample_coord);
    float parameter_sum_feedback = texture_sample.x;
    float param_32 = 2.0;
    float param_33 = 4.0;
    sample_coord = HSM_GetCacheSampleCoord(param_32, param_33);
    texture_sample = texture(in_cache_pass, sample_coord);
    NEGATIVE_CROP_EXPAND_MULTIPLIER = texture_sample.x;
    MAX_NEGATIVE_CROP = texture_sample.y;
    float param_34 = SCREEN_ASPECT;
    USE_VERTICAL_SCANLINES = HSM_GetUseVerticalScanlines(param_34);
    vec2 param_35 = flipped_viewport_coord;
    vec2 param_36 = SCREEN_SCALE;
    vec2 param_37 = SCREEN_POS_OFFSET;
    SCREEN_COORD = HSM_GetVTexCoordWithArgs(param_35, param_36, param_37);
    vec2 param_38 = flipped_viewport_coord;
    vec2 param_39 = TUBE_DIFFUSE_SCALE;
    vec2 param_40 = SCREEN_POS_OFFSET;
    TUBE_DIFFUSE_COORD = HSM_GetVTexCoordWithArgs(param_38, param_39, param_40);
    float param_sum_epsilon = 1.0000000116860974230803549289703e-07;
    CACHE_INFO_PARAM_SUM_CHANGED = false;
    CACHE_INFO_PARAM_SUM_CHANGED = ((res_mult_size_sum != res_mult_size_sum_feedback) || (res_mult_size2_sum != res_mult_size2_sum_feedback)) ? true : CACHE_INFO_PARAM_SUM_CHANGED;
    CACHE_INFO_PARAM_SUM_CHANGED = (abs(parameter_sum - parameter_sum_feedback) > param_sum_epsilon) ? true : CACHE_INFO_PARAM_SUM_CHANGED;
    return vec4(0.0);
}

vec2 HSM_GetNegativeCropAddedSize()
{
    return global.NegativeCropAddedPassSize.xy;
}

float rolled_gain(inout float color, float gain)
{
    float gx = abs(gain) + 0.001000000047497451305389404296875;
    float _1593;
    if (gain > 0.0)
    {
        _1593 = 0.5 / (gx / 2.0);
    }
    else
    {
        _1593 = 0.5 / gx;
    }
    float anch = _1593;
    float _1605;
    if (gain > 0.0)
    {
        _1605 = color * ((color - anch) / (1.0 - anch));
    }
    else
    {
        _1605 = (color * ((1.0 - anch) / (color - anch))) * (1.0 - gain);
    }
    color = _1605;
    return color;
}

vec4 rolled_gain_v4(inout vec4 color, float gain)
{
    float param = color.x;
    float param_1 = gain;
    float _1637 = rolled_gain(param, param_1);
    color.x = _1637;
    float param_2 = color.y;
    float param_3 = gain;
    float _1644 = rolled_gain(param_2, param_3);
    color.y = _1644;
    float param_4 = color.z;
    float param_5 = gain;
    float _1651 = rolled_gain(param_4, param_5);
    color.z = _1651;
    return vec4(color.xyz, 1.0);
}

vec3 mixfix(vec3 a, vec3 b, float c)
{
    vec3 _1688;
    if (a.z < 1.0)
    {
        _1688 = mix(a, b, vec3(c));
    }
    else
    {
        _1688 = a;
    }
    return _1688;
}

float SatMask(float color_r, float color_g, float color_b)
{
    float max_rgb = max(color_r, max(color_g, color_b));
    float min_rgb = min(color_r, min(color_g, color_b));
    float msk = clamp((max_rgb - min_rgb) / (max_rgb + min_rgb), 0.0, 1.0);
    return msk;
}

void main()
{
    NEGATIVE_CROP_EXPAND_MULTIPLIER = 0.5;
    MAX_NEGATIVE_CROP = 0.5;
    DEFAULT_SCREEN_ASPECT = 1.3329918384552001953125;
    DEFAULT_BEZEL_ASPECT = 1.32272231578826904296875;
    DEFAULT_SCREEN_SCALE = vec2(0.0);
    DEFAULT_BEZEL_SCALE = vec2(0.0);
    INFOCACHE_MAX_INDEX = 4;
    BLEND_MODE_OFF = 0.0;
    BLEND_MODE_NORMAL = 1.0;
    BLEND_MODE_ADD = 2.0;
    BLEND_MODE_MULTIPLY = 3.0;
    SOURCE_MATTE_PREMULTIPLIED = 0.0;
    SOURCE_MATTE_WHITE = 1.0;
    SOURCE_MATTE_NONE = 2.0;
    IMAGE_ASPECT_MODE_INHERIT_ASPECT_SCALE = 0.0;
    IMAGE_ASPECT_MODE_KEEP_ASPECT = 1.0;
    FILL_MODE_STRETCH = 0.0;
    FILL_MODE_SPLIT_FILL_HORIZONTAL = 1.0;
    FILL_MODE_SPLIT_FILL_VERTICAL = 2.0;
    CACHE_INFO_PARAM_SUM_CHANGED = false;
    CURRENT_FRAME_FROM_CACHE_INFO = 0.0;
    TUBE_DIFFUSE_MASK = 0.0;
    TUBE_MASK = 0.0;
    BEZEL_MASK = 0.0;
    INSIDE_BEZEL_MASK = 0.0;
    OUTSIDE_TUBE_MASK_FOR_IMAGE = 0.0;
    FRAME_MASK = 0.0;
    FRAME_MASK_FOR_IMAGE = 0.0;
    OUTSIDE_BEZEL_MASK = 0.0;
    OUTSIDE_FRAME_MASK_FOR_IMAGE = 0.0;
    OUTSIDE_FRAME_MASK = 0.0;
    CUTOUT_MASK = 0.0;
    SCREEN_INDEX = 1.0;
    SCREEN_ASPECT = 1.0;
    SCREEN_SCALE = vec2(1.0);
    SCREEN_POS_OFFSET = vec2(0.1500000059604644775390625);
    SCREEN_SCALE_2ND_SCREEN = vec2(1.0);
    SCREEN_POS_OFFSET_2ND_SCREEN = vec2(0.1500000059604644775390625);
    VIEWPORT_SCALE = vec2(1.0);
    VIEWPORT_POS = vec2(1.0);
    TUBE_SCALE = vec2(1.0);
    TUBE_DIFFUSE_SCALE = vec2(1.0);
    TUBE_DIFFUSE_ASPECT = 1.0;
    FRAME_SCALE = vec2(1.0);
    BEZEL_OUTSIDE_SCALE = vec2(0.5);
    BACKGROUND_SCALE = vec2(0.5);
    LED_SCALE = vec2(0.5);
    DEVICE_SCALE = vec2(0.5);
    DECAL_SCALE = vec2(0.5);
    CAB_GLASS_SCALE = vec2(0.5);
    TOP_IMAGE_SCALE = vec2(0.5);
    AVERAGE_LUMA = 0.0;
    USE_VERTICAL_SCANLINES = 0.0;
    CORE_SIZE = vec2(1.0);
    ROTATED_CORE_ORIGINAL_SIZE = vec2(1.0);
    ROTATED_CORE_PREPPED_SIZE = vec2(1.0);
    ROTATED_DEREZED_SIZE = vec2(1.0);
    CROPPED_ROTATED_SIZE_WITH_RES_MULT = vec2(1.0);
    CROPPED_ROTATED_SIZE_WITH_RES_MULT_FEEDBACK = vec2(1.0);
    CROPPED_ROTATED_SIZE = vec2(1.0);
    SAMPLE_AREA_START_PIXEL_COORD = vec2(1.0);
    VIEWPORT_UNSCALED_COORD = vec2(0.5);
    SCREEN_COORD = vec2(0.5);
    TUBE_COORD = vec2(0.5);
    TUBE_DIFFUSE_COORD = vec2(0.5);
    BEZEL_OUTSIDE_COORD = vec2(0.5);
    BACKGROUND_COORD = vec2(0.5);
    DEVICE_COORD = vec2(0.5);
    LED_COORD = vec2(0.5);
    DECAL_COORD = vec2(0.5);
    CAB_GLASS_COORD = vec2(0.5);
    TOP_IMAGE_COORD = vec2(0.5);
    SCREEN_CURVED_COORD = vec2(0.5);
    TUBE_CURVED_COORD = vec2(0.5);
    TUBE_DIFFUSE_CURVED_COORD = vec2(0.5);
    BEZEL_OUTSIDE_CURVED_COORD = vec2(0.5);
    FRAME_OUTSIDE_CURVED_COORD = vec2(0.5);
    BACKGROUND_CURVED_COORD = vec2(0.5);
    LED_CURVED_COORD = vec2(0.5);
    DEVICE_CURVED_COORD = vec2(0.5);
    DECAL_CURVED_COORD = vec2(0.5);
    CAB_GLASS_CURVED_COORD = vec2(0.5);
    TOP_IMAGE_CURVED_COORD = vec2(0.5);
    HSM_RESOLUTION_DEBUG_ON = 0.0;
    HSM_CACHE_GRAPHICS_ON = 1.0;
    HSM_CACHE_UPDATE_INDICATOR_MODE = 2.0;
    HSM_GLOBAL_GRAPHICS_BRIGHTNESS = 1.0;
    HSM_STATIC_LAYERS_GAMMA = 1.0;
    HSM_AMBIENT_LIGHTING_OPACITY = 0.0;
    HSM_AMBIENT2_LIGHTING_OPACITY = 0.0;
    HSM_AMBIENT_LIGHTING_SWAP_IMAGES = 0.0;
    HSM_VIEWPORT_ZOOM = 1.0;
    HSM_VIEWPORT_ZOOM_MASK = 0.0;
    HSM_VIEWPORT_POSITION_X = -0.0;
    HSM_VIEWPORT_POSITION_Y = -0.0;
    HSM_FLIP_VIEWPORT_VERTICAL = 1.0;
    HSM_FLIP_VIEWPORT_HORIZONTAL = 1.0;
    HSM_FLIP_CORE_VERTICAL = 1.0;
    HSM_FLIP_CORE_HORIZONTAL = 1.0;
    HSM_ROTATE_CORE_IMAGE = 0.0;
    HSM_ASPECT_RATIO_ORIENTATION = 0.0;
    HSM_ASPECT_RATIO_MODE = 0.0;
    HSM_ASPECT_RATIO_EXPLICIT = 1.33329999446868896484375;
    HSM_VERTICAL_PRESET = 0.0;
    HSM_INT_SCALE_MAX_HEIGHT = 0.88999998569488525390625;
    HSM_NON_INTEGER_SCALE = 0.829699993133544921875;
    HSM_USE_PHYSICAL_SIZE_FOR_NON_INTEGER = 0.0;
    HSM_PHYSICAL_MONITOR_ASPECT_RATIO = 1.769999980926513671875;
    HSM_PHYSICAL_MONITOR_DIAGONAL_SIZE = 27.0;
    HSM_PHYSICAL_SIM_TUBE_DIAGONAL_SIZE = 18.1000003814697265625;
    HSM_USE_IMAGE_FOR_PLACEMENT = 0.0;
    HSM_PLACEMENT_IMAGE_USE_HORIZONTAL = 0.0;
    HSM_PLACEMENT_IMAGE_MODE = 0.0;
    HSM_NON_INTEGER_SCALE_OFFSET = 1.0;
    HSM_USE_SNAP_TO_CLOSEST_INT_SCALE = 0.0;
    HSM_SNAP_TO_CLOSEST_INT_SCALE_TOLERANCE = (HSM_USE_SNAP_TO_CLOSEST_INT_SCALE > 0.5) ? 0.20000000298023223876953125 : 0.0;
    HSM_SCREEN_POSITION_X = 0.0;
    HSM_SCREEN_POSITION_Y = -0.0;
    HSM_CROP_MODE = 2.0;
    HSM_CROP_PERCENT_ZOOM = 0.0;
    HSM_CROP_PERCENT_TOP = 0.0;
    HSM_CROP_PERCENT_BOTTOM = 0.0;
    HSM_CROP_PERCENT_LEFT = 0.0;
    HSM_CROP_PERCENT_RIGHT = 0.0;
    HSM_CROP_BLACK_THRESHOLD = 0.0;
    HSM_SCANLINE_DIRECTION = 0.0;
    HSM_CORE_RES_SAMPLING_MULT_SCANLINE_DIR = 1.0;
    HSM_DOWNSAMPLE_BLUR_SCANLINE_DIR = 0.0;
    HSM_CORE_RES_SAMPLING_MULT_OPPOSITE_DIR = 1.0;
    HSM_DOWNSAMPLE_BLUR_OPPOSITE_DIR = 0.0;
    HSM_CORE_RES_SAMPLING_SHIFT_OPPOSITE_DIR = 0.0;
    HSM_USE_GEOM = 0.0;
    HSM_CURVATURE_MODE = 1.0;
    HSM_CURVATURE_3D_RADIUS = 2.0;
    HSM_CURVATURE_3D_VIEW_DIST = 1.5;
    HSM_CURVATURE_3D_TILT_ANGLE_X = 0.0;
    HSM_CURVATURE_3D_TILT_ANGLE_Y = 0.0;
    HSM_CRT_CURVATURE_SCALE = 1.0;
    HSM_AB_COMPARE_SHOW_MODE = 0.0;
    HSM_AB_COMPARE_AREA = 0.0;
    HSM_AB_COMPARE_SPLIT_POSITION = 0.5;
    HSM_AB_COMPARE_FREEZE_CRT_TUBE = 0.0;
    HSM_AB_COMPARE_FREEZE_GRAPHICS = 0.0;
    HSM_SCREEN_VIGNETTE_DUALSCREEN_VIS_MODE = 0.0;
    HSM_MONOCHROME_DUALSCREEN_VIS_MODE = 0.0;
    HSM_TUBE_DIFFUSE_MODE = 0.0;
    HSM_TUBE_DIFFUSE_OPACITY = 1.0;
    HSM_TUBE_DIFFUSE_IMAGE_DUALSCREEN_VIS_MODE = 0.0;
    HSM_TUBE_DIFFUSE_IMAGE_COLORIZE_ON = 0.0;
    HSM_TUBE_DIFFUSE_IMAGE_HUE = 0.0;
    HSM_TUBE_DIFFUSE_IMAGE_SATURATION = 1.0;
    HSM_TUBE_DIFFUSE_IMAGE_BRIGHTNESS = 0.20000000298023223876953125;
    HSM_TUBE_DIFFUSE_IMAGE_GAMMA = 1.0;
    HSM_TUBE_DIFFUSE_IMAGE_AMBIENT_LIGHTING = 1.0;
    HSM_TUBE_DIFFUSE_IMAGE_AMBIENT2_LIGHTING = 0.0;
    HSM_TUBE_DIFFUSE_IMAGE_SCALE = 1.2000000476837158203125;
    HSM_TUBE_DIFFUSE_IMAGE_SCALE_X = 1.0;
    HSM_TUBE_SHADOW_IMAGE_ON = 1.0;
    HSM_TUBE_SHADOW_IMAGE_OPACITY = 0.60000002384185791015625;
    HSM_TUBE_SHADOW_IMAGE_POS_X = 0.0;
    HSM_TUBE_SHADOW_IMAGE_POS_Y = 0.0900000035762786865234375;
    HSM_TUBE_SHADOW_IMAGE_SCALE_X = 1.2200000286102294921875;
    HSM_TUBE_SHADOW_IMAGE_SCALE_Y = 1.2999999523162841796875;
    HSM_TUBE_SHADOW_CURVATURE_SCALE = 3.0;
    HSM_TUBE_COLORED_GEL_IMAGE_ON = 0.0;
    HSM_TUBE_COLORED_GEL_IMAGE_SCALE = 1.0;
    HSM_TUBE_COLORED_GEL_IMAGE_FLIP_HORIZONTAL = 1.0;
    HSM_TUBE_COLORED_GEL_IMAGE_FLIP_VERTICAL = 1.0;
    HSM_TUBE_COLORED_GEL_IMAGE_DUALSCREEN_VIS_MODE = 0.0;
    HSM_TUBE_COLORED_GEL_IMAGE_MULTIPLY_AMOUNT = 0.89999997615814208984375;
    HSM_TUBE_COLORED_GEL_IMAGE_ADDITIVE_AMOUNT = 0.0;
    HSM_TUBE_COLORED_GEL_IMAGE_NORMAL_AMOUNT = 0.1500000059604644775390625;
    HSM_TUBE_COLORED_GEL_IMAGE_TRANSPARENCY_THRESHOLD = 0.23000000417232513427734375;
    HSM_TUBE_COLORED_GEL_IMAGE_NORMAL_BRIGHTNESS = 1.0;
    HSM_TUBE_COLORED_GEL_IMAGE_NORMAL_VIGNETTE = 0.0;
    HSM_TUBE_COLORED_GEL_IMAGE_FAKE_SCANLINE_AMOUNT = 0.0;
    HSM_TUBE_COLORED_GEL_IMAGE_AMBIENT_LIGHTING = 1.0;
    HSM_TUBE_COLORED_GEL_IMAGE_AMBIENT2_LIGHTING = 0.0;
    HSM_SHOW_CRT_ON_TOP_OF_COLORED_GEL = 0.0;
    HSM_TUBE_STATIC_REFLECTION_IMAGE_ON = 0.0;
    HSM_TUBE_STATIC_REFLECTION_IMAGE_DUALSCREEN_VIS_MODE = 0.0;
    HSM_TUBE_STATIC_REFLECTION_IMAGE_OPACITY = 0.100000001490116119384765625;
    HSM_TUBE_STATIC_REFLECTION_IMAGE_AMBIENT_LIGHTING = 1.0;
    HSM_TUBE_STATIC_REFLECTION_IMAGE_AMBIENT2_LIGHTING = 0.0;
    HSM_TUBE_STATIC_REFLECTION_IMAGE_SCALE = 1.10000002384185791015625;
    HSM_TUBE_STATIC_REFLECTION_IMAGE_SHADOW_OPACITY = 0.4000000059604644775390625;
    HSM_DUALSCREEN_MODE = 0.0;
    HSM_DUALSCREEN_CORE_IMAGE_SPLIT_MODE = 1.0;
    HSM_DUALSCREEN_CORE_IMAGE_SWAP_SCREENS = 0.0;
    HSM_DUALSCREEN_CORE_IMAGE_SPLIT_OFFSET = 0.0;
    HSM_DUALSCREEN_VIEWPORT_SPLIT_LOCATION = 0.0;
    HSM_DUALSCREEN_SHIFT_POSITION_WITH_SCALE = 1.0;
    HSM_DUALSCREEN_POSITION_OFFSET_BETWEEN_SCREENS = 0.0;
    HSM_2ND_SCREEN_ASPECT_RATIO_MODE = 0.0;
    HSM_2ND_SCREEN_INDEPENDENT_SCALE = 0.0;
    HSM_2ND_SCREEN_SCALE_OFFSET = 1.0;
    HSM_2ND_SCREEN_POS_X = 0.0;
    HSM_2ND_SCREEN_POS_Y = 0.0;
    HSM_2ND_SCREEN_CROP_PERCENT_ZOOM = 0.0;
    HSM_2ND_SCREEN_CROP_PERCENT_TOP = 0.0;
    HSM_2ND_SCREEN_CROP_PERCENT_BOTTOM = 0.0;
    HSM_2ND_SCREEN_CROP_PERCENT_LEFT = 0.0;
    HSM_2ND_SCREEN_CROP_PERCENT_RIGHT = 0.0;
    HSM_SCREEN_REFLECTION_SCALE = 1.0;
    HSM_SCREEN_REFLECTION_POS_X = 0.0;
    HSM_SCREEN_REFLECTION_POS_Y = 0.0;
    HSM_AMBIENT_LIGHTING_HUE = 0.0;
    HSM_AMBIENT_LIGHTING_SATURATION = 1.0;
    HSM_AMBIENT_LIGHTING_VALUE = 1.0;
    HSM_AMBIENT_LIGHTING_CONTRAST = 1.0;
    HSM_AMBIENT_LIGHTING_SCALE_KEEP_ASPECT = 0.0;
    HSM_AMBIENT_LIGHTING_SCALE_WITH_ZOOM = 1.0;
    HSM_AMBIENT_LIGHTING_SCALE = 1.0;
    HSM_AMBIENT_LIGHTING_SCALE_X = 1.0;
    HSM_AMBIENT_LIGHTING_ROTATE = 0.0;
    HSM_AMBIENT_LIGHTING_MIRROR_HORZ = 0.0;
    HSM_AMBIENT_LIGHTING_POSITION_X = 0.0;
    HSM_AMBIENT_LIGHTING_POSITION_Y = -0.0;
    HSM_AMBIENT_LIGHTING_DITHERING_SAMPLES = 0.0;
    HSM_AMBIENT2_LIGHTING_HUE = 0.0;
    HSM_AMBIENT2_LIGHTING_SATURATION = 1.0;
    HSM_AMBIENT2_LIGHTING_VALUE = 2.0;
    HSM_AMBIENT2_LIGHTING_CONTRAST = 1.0;
    HSM_AMBIENT2_LIGHTING_SCALE_KEEP_ASPECT = 1.0;
    HSM_AMBIENT2_LIGHTING_SCALE_WITH_ZOOM = 1.0;
    HSM_AMBIENT2_LIGHTING_SCALE = 1.0;
    HSM_AMBIENT2_LIGHTING_SCALE_X = 1.0;
    HSM_AMBIENT2_LIGHTING_ROTATE = 0.0;
    HSM_AMBIENT2_LIGHTING_MIRROR_HORZ = 0.0;
    HSM_AMBIENT2_LIGHTING_POSITION_X = 0.0;
    HSM_AMBIENT2_LIGHTING_POSITION_Y = -0.0;
    HSM_BZL_OPACITY = 1.0;
    HSM_BZL_BLEND_MODE = 1.0;
    HSM_BZL_WIDTH = 0.107799999415874481201171875;
    HSM_BZL_HEIGHT = 0.0873199999332427978515625;
    HSM_BZL_INNER_CORNER_RADIUS_SCALE = 0.800000011920928955078125;
    CURVATURE_MODE_OFF = 0.0;
    CURVATURE_MODE_2D = 1.0;
    CURVATURE_MODE_2D_CYLINDER = 2.0;
    CURVATURE_MODE_3D_1 = 3.0;
    CURVATURE_MODE_3D_2 = 4.0;
    CURVATURE_MODE_3D_CYLINDER = 5.0;
    float lum_exp = 1.0;
    vec4 src_rgba = texture(Source, vTexCoord);
    vec3 src = src_rgba.xyz * lum_exp;
    if (false)
    {
        FragColor = src_rgba;
        return;
    }
    vec3 _2017;
    if (false)
    {
        vec3 param = src;
        _2017 = r601_YUV(param);
    }
    else
    {
        vec3 _2024;
        if (true)
        {
            vec3 param_1 = src;
            _2024 = RGB_YIQ(param_1);
        }
        else
        {
            vec3 _2031;
            if (false)
            {
                vec3 param_2 = src;
                _2031 = RGB_FCC(param_2);
            }
            else
            {
                vec3 _2038;
                if (false)
                {
                    vec3 param_3 = src;
                    _2038 = RGB_FCC(param_3);
                }
                else
                {
                    vec3 param_4 = src;
                    _2038 = RGB_YIQ(param_4);
                }
                _2031 = _2038;
            }
            _2024 = _2031;
        }
        _2017 = _2024;
    }
    vec3 col = _2017;
    vec2 UVmax = vec2(0.595899999141693115234375, 0.522700011730194091796875);
    col = clamp(col, vec3(0.0, -UVmax.x, -UVmax.y), vec3(1.0, UVmax.x, UVmax.y));
    vec3 _2069;
    if (false)
    {
        _2069 = col;
    }
    else
    {
        vec3 _2074;
        if (true)
        {
            _2074 = col;
        }
        else
        {
            vec3 _2079;
            if (false)
            {
                vec3 param_5 = col;
                float param_6 = 1.0;
                float param_7 = UVmax.x;
                float param_8 = UVmax.y;
                float param_9 = 1.0;
                bool param_10 = false;
                vec3 _2093 = PCtoTV(param_5, param_6, param_7, param_8, param_9, param_10);
                _2079 = _2093;
            }
            else
            {
                vec3 _2095;
                if (false)
                {
                    vec3 param_11 = col;
                    float param_12 = 1.0;
                    float param_13 = UVmax.x;
                    float param_14 = UVmax.y;
                    float param_15 = 1.0;
                    bool param_16 = false;
                    vec3 _2109 = PCtoTV(param_11, param_12, param_13, param_14, param_15, param_16);
                    _2095 = _2109;
                }
                else
                {
                    vec3 param_17 = col;
                    float param_18 = 1.0;
                    float param_19 = UVmax.x;
                    float param_20 = UVmax.y;
                    float param_21 = 1.0;
                    bool param_22 = false;
                    vec3 _2122 = PCtoTV(param_17, param_18, param_19, param_20, param_21, param_22);
                    _2095 = _2122;
                }
                _2079 = _2095;
            }
            _2074 = _2079;
        }
        _2069 = _2074;
    }
    col = _2069;
    float hue_radians = 0.0;
    float hue = atan(col.z, col.y) + hue_radians;
    float chroma = sqrt((col.z * col.z) + (col.y * col.y));
    col = vec3(col.x, chroma * cos(hue), chroma * sin(hue));
    col.y = (mod((col.y + 1.0) + 0.0, 2.0) - 1.0) * 1.0;
    col.z = (mod((col.z + 1.0) + 0.0, 2.0) - 1.0) * 1.0;
    vec3 _2176;
    if (false)
    {
        _2176 = col;
    }
    else
    {
        vec3 _2181;
        if (true)
        {
            _2181 = col;
        }
        else
        {
            vec3 _2186;
            if (false)
            {
                vec3 param_23 = col;
                float param_24 = 1.0;
                float param_25 = UVmax.x;
                float param_26 = UVmax.y;
                float param_27 = 1.0;
                bool param_28 = false;
                vec3 _2200 = TVtoPC(param_23, param_24, param_25, param_26, param_27, param_28);
                _2186 = _2200;
            }
            else
            {
                vec3 _2202;
                if (false)
                {
                    vec3 param_29 = col;
                    float param_30 = 1.0;
                    float param_31 = UVmax.x;
                    float param_32 = UVmax.y;
                    float param_33 = 1.0;
                    bool param_34 = false;
                    vec3 _2216 = TVtoPC(param_29, param_30, param_31, param_32, param_33, param_34);
                    _2202 = _2216;
                }
                else
                {
                    vec3 param_35 = col;
                    float param_36 = 1.0;
                    float param_37 = UVmax.x;
                    float param_38 = UVmax.y;
                    float param_39 = 1.0;
                    bool param_40 = false;
                    vec3 _2229 = TVtoPC(param_35, param_36, param_37, param_38, param_39, param_40);
                    _2202 = _2229;
                }
                _2186 = _2202;
            }
            _2181 = _2186;
        }
        _2176 = _2181;
    }
    col = _2176;
    vec3 _2234;
    if (false)
    {
        vec3 param_41 = col;
        _2234 = YUV_r601(param_41);
    }
    else
    {
        vec3 _2241;
        if (true)
        {
            vec3 param_42 = col;
            _2241 = YIQ_RGB(param_42);
        }
        else
        {
            vec3 _2248;
            if (false)
            {
                vec3 param_43 = col;
                _2248 = FCC_RGB(param_43);
            }
            else
            {
                vec3 _2255;
                if (false)
                {
                    vec3 param_44 = col;
                    _2255 = FCC_RGB(param_44);
                }
                else
                {
                    vec3 param_45 = col;
                    _2255 = YIQ_RGB(param_45);
                }
                _2248 = _2255;
            }
            _2241 = _2248;
        }
        _2234 = _2241;
    }
    col = _2234;
    vec3 param_46 = clamp(col, vec3(0.0), vec3(1.0));
    col = r601_YCC(param_46);
    vec3 _2275;
    if (false)
    {
        _2275 = src;
    }
    else
    {
        vec3 param_47 = clamp(col, vec3(0.0, -0.885999977588653564453125, -0.699999988079071044921875), vec3(1.0, 0.885999977588653564453125, 0.699999988079071044921875));
        _2275 = YCC_r601(param_47);
    }
    col = _2275;
    vec3 param_48 = col;
    float param_49 = 2.2219998836517333984375;
    float param_50 = 0.098999999463558197021484375;
    vec3 _2297 = moncurve_f_f3(param_48, param_49, param_50);
    col = _2297;
    mat3 m_in;
    if (false)
    {
        m_in = mat3(vec3(0.60699284076690673828125, 0.2989666163921356201171875, 0.0), vec3(0.173448503017425537109375, 0.58642113208770751953125, 0.066075615584850311279296875), vec3(0.20057128369808197021484375, 0.114612154662609100341796875, 1.11746847629547119140625));
    }
    else
    {
        if (false)
        {
            m_in = mat3(vec3(0.55842006206512451171875, 0.285805523395538330078125, 0.0351760648190975189208984375), vec3(0.2061356604099273681640625, 0.63714659214019775390625, 0.093698024749755859375), vec3(0.185893595218658447265625, 0.077048003673553466796875, 0.96004259586334228515625));
        }
        else
        {
            if (false)
            {
                m_in = mat3(vec3(0.33989441394805908203125, 0.18490256369113922119140625, 0.019034087657928466796875), vec3(0.3349787294864654541015625, 0.711829841136932373046875, 0.14954407513141632080078125), vec3(0.22866378724575042724609375, 0.1032675206661224365234375, 1.1433188915252685546875));
            }
            else
            {
                if (false)
                {
                    m_in = mat3(vec3(0.3935419619083404541015625, 0.21238772571086883544921875, 0.01874009333550930023193359375), vec3(0.3652588427066802978515625, 0.70106136798858642578125, 0.111934162676334381103515625), vec3(0.1916484832763671875, 0.086550928652286529541015625, 0.9582424163818359375));
                }
                else
                {
                    if (false)
                    {
                        m_in = mat3(vec3(0.466563642024993896484375, 0.2566100060939788818359375, 0.0058320458047091960906982421875), vec3(0.303923308849334716796875, 0.668200194835662841796875, 0.105618737637996673583984375), vec3(0.17996217310428619384765625, 0.075189672410488128662109375, 0.97746574878692626953125));
                    }
                    else
                    {
                        if (true)
                        {
                            m_in = mat3(vec3(0.396037876605987548828125, 0.22429330646991729736328125, 0.0205068178474903106689453125), vec3(0.3120144903659820556640625, 0.67417418956756591796875, 0.12814880907535552978515625), vec3(0.2449673116207122802734375, 0.101532511413097381591796875, 1.26512730121612548828125));
                        }
                        else
                        {
                            if (false)
                            {
                                m_in = mat3(vec3(0.4319432675838470458984375, 0.22272075712680816650390625, 0.02024734020233154296875), vec3(0.3412348926067352294921875, 0.70600330829620361328125, 0.129433929920196533203125), vec3(0.17818950116634368896484375, 0.0712758004665374755859375, 0.938464701175689697265625));
                            }
                        }
                    }
                }
            }
        }
    }
    vec3 gamut = m_in * col;
    vec3 _2415;
    if (false)
    {
        float param_51 = 6600.0;
        vec3 param_52 = gamut;
        _2415 = wp_adjust(param_51, param_52);
    }
    else
    {
        vec3 _2424;
        if (false)
        {
            float param_53 = 6500.0;
            vec3 param_54 = gamut;
            _2424 = wp_adjust(param_53, param_54);
        }
        else
        {
            vec3 _2433;
            if (false)
            {
                float param_55 = 5404.0;
                vec3 param_56 = gamut;
                _2433 = wp_adjust(param_55, param_56);
            }
            else
            {
                vec3 _2442;
                if (false)
                {
                    float param_57 = 6500.0;
                    vec3 param_58 = gamut;
                    _2442 = wp_adjust(param_57, param_58);
                }
                else
                {
                    vec3 _2450;
                    if (false)
                    {
                        float param_59 = 6500.0;
                        vec3 param_60 = gamut;
                        _2450 = wp_adjust(param_59, param_60);
                    }
                    else
                    {
                        vec3 _2458;
                        if (true)
                        {
                            float param_61 = 5604.0;
                            vec3 param_62 = gamut;
                            _2458 = wp_adjust(param_61, param_62);
                        }
                        else
                        {
                            vec3 _2467;
                            if (false)
                            {
                                float param_63 = 6500.0;
                                vec3 param_64 = gamut;
                                _2467 = wp_adjust(param_63, param_64);
                            }
                            else
                            {
                                float param_65 = 6500.0;
                                vec3 param_66 = gamut;
                                _2467 = wp_adjust(param_65, param_66);
                            }
                            _2458 = _2467;
                        }
                        _2450 = _2458;
                    }
                    _2442 = _2450;
                }
                _2433 = _2442;
            }
            _2424 = _2433;
        }
        _2415 = _2424;
    }
    vec3 wp = _2415;
    vec3 param_67 = wp;
    float param_68 = 0.0;
    vec3 adj = clamp(XYZ_to_RGB(param_67, param_68), vec3(0.0), vec3(1.0));
    vec3 param_69 = false ? col : adj;
    float param_70 = 1.97491359710693359375;
    float param_71 = 0.098999999463558197021484375;
    vec3 _2501 = moncurve_r_f3(param_69, param_70, param_71);
    adj = _2501;
    vec3 vcolor = adj;
    vec3 _2504;
    if (false)
    {
        _2504 = clamp(pow(vcolor, vec3(2.19921875)), vec3(0.0), vec3(1.0));
    }
    else
    {
        vec3 _2515;
        if (false)
        {
            vec3 param_72 = vcolor;
            float param_73 = 2.2222220897674560546875;
            float param_74 = 0.0992999970912933349609375;
            vec3 _2524 = moncurve_f_f3(param_72, param_73, param_74);
            _2515 = _2524;
        }
        else
        {
            vec3 _2526;
            if (false)
            {
                _2526 = clamp(pow(vcolor, vec3(2.599999904632568359375)), vec3(0.0), vec3(1.0));
            }
            else
            {
                vec3 _2537;
                if (true)
                {
                    vec3 param_75 = vcolor;
                    float param_76 = 2.400000095367431640625;
                    float param_77 = 0.054999999701976776123046875;
                    vec3 _2546 = moncurve_f_f3(param_75, param_76, param_77);
                    _2537 = _2546;
                }
                else
                {
                    _2537 = clamp(pow(pow(vcolor, vec3(0.9811000823974609375)), vec3(2.400000095367431640625)), vec3(0.0), vec3(1.0));
                }
                _2526 = _2537;
            }
            _2515 = _2526;
        }
        _2504 = _2515;
    }
    vcolor = _2504;
    vec3 param_78 = vcolor;
    float param_79 = 0.0;
    vcolor = RGB_to_XYZ(param_78, param_79);
    vec3 param_80 = vcolor;
    vec3 Yxy = XYZtoYxy(param_80);
    float param_81 = Yxy.x;
    float param_82 = 2.400000095367431640625;
    float param_83 = 0.054999999701976776123046875;
    float _2575 = moncurve_r(param_81, param_82, param_83);
    float toGamma = clamp(_2575, 0.0, 1.0);
    float _2580;
    if (Yxy.x > 0.5)
    {
        float param_84 = toGamma;
        float param_85 = 2.2999999523162841796875;
        float param_86 = 0.5;
        float _2588 = contrast_sigmoid_inv(param_84, param_85, param_86);
        _2580 = _2588;
    }
    else
    {
        _2580 = toGamma;
    }
    toGamma = _2580;
    float _2593;
    if (false)
    {
        float param_87 = toGamma;
        float param_88 = 0.0;
        float param_89 = 0.5;
        float _2600 = contrast_sigmoid(param_87, param_88, param_89);
        _2593 = _2600;
    }
    else
    {
        float param_90 = toGamma;
        float param_91 = 0.0;
        float param_92 = 0.5;
        float _2606 = contrast_sigmoid_inv(param_90, param_91, param_92);
        _2593 = _2606;
    }
    float sigmoid = _2593;
    float param_93 = sigmoid;
    float param_94 = 2.400000095367431640625;
    float param_95 = 0.054999999701976776123046875;
    float _2613 = moncurve_f(param_93, param_94, param_95);
    vec3 contrast = vec3(_2613, Yxy.y, Yxy.z);
    vec3 param_96 = contrast;
    vec3 param_97 = YxytoXYZ(param_96);
    float param_98 = 0.0;
    vec3 XYZsrgb = clamp(XYZ_to_RGB(param_97, param_98), vec3(0.0), vec3(1.0));
    vec3 _2629;
    if (true)
    {
        vec3 param_99 = vcolor;
        float param_100 = 0.0;
        _2629 = XYZ_to_RGB(param_99, param_100);
    }
    else
    {
        _2629 = XYZsrgb;
    }
    contrast = _2629;
    vec2 param_101 = vTexCoord;
    vec2 viewportCoordTransformed = HSM_GetViewportCoordWithZoomAndPan(param_101);
    vec2 param_102 = vTexCoord;
    vec4 _2647 = HSM_UpdateGlobalScreenValuesFromCache(InfoCachePass, InfoCachePassFeedback, param_102);
    vec2 derezed_size = HSM_GetNegativeCropAddedSize();
    vec2 cur_pixel_pos = vTexCoord * derezed_size;
    vec2 _2657;
    if (HSM_ROTATE_CORE_IMAGE > 0.5)
    {
        _2657 = vec2(CROPPED_ROTATED_SIZE.y, CROPPED_ROTATED_SIZE.x);
    }
    else
    {
        _2657 = CROPPED_ROTATED_SIZE;
    }
    vec2 cropped_size = _2657;
    vec2 _2671;
    if (HSM_ROTATE_CORE_IMAGE > 0.5)
    {
        _2671 = vec2(ROTATED_CORE_PREPPED_SIZE.y, ROTATED_CORE_PREPPED_SIZE.x);
    }
    else
    {
        _2671 = ROTATED_CORE_PREPPED_SIZE;
    }
    vec2 raw_size = _2671;
    vec2 _2685;
    if (HSM_ROTATE_CORE_IMAGE > 0.5)
    {
        _2685 = vec2(SAMPLE_AREA_START_PIXEL_COORD.y, SAMPLE_AREA_START_PIXEL_COORD.x);
    }
    else
    {
        _2685 = SAMPLE_AREA_START_PIXEL_COORD;
    }
    vec2 sample_start_area = _2685;
    vec2 pos_in_cropped_coords = (cur_pixel_pos - sample_start_area) / cropped_size;
    pos_in_cropped_coords = ((pos_in_cropped_coords - vec2(0.5)) * (1.0 - (2.0 * MAX_NEGATIVE_CROP))) + vec2(0.5);
    vec2 vpos = pos_in_cropped_coords;
    float adjusted_lift = 0.0;
    contrast += ((vec3(1.0) - contrast) * (adjusted_lift / 20.0));
    vec4 screen = vec4(max(contrast, vec3(0.0)), 1.0);
    float sat = 1.0;
    mat4 color = mat4(vec4(1.0, 0.0, 0.0, 0.0), vec4(0.0, 1.0, 0.0, 0.0), vec4(0.0, 0.0, 1.0, 0.0), vec4(0.0));
    vec3 coeff = vec3(0.21264933049678802490234375, 0.715169131755828857421875, 0.072181522846221923828125);
    mat3 adjust = mat3(vec3(((1.0 - sat) * coeff.x) + sat, (1.0 - sat) * coeff.x, (1.0 - sat) * coeff.x), vec3((1.0 - sat) * coeff.y, ((1.0 - sat) * coeff.y) + sat, (1.0 - sat) * coeff.y), vec3((1.0 - sat) * coeff.z, (1.0 - sat) * coeff.z, ((1.0 - sat) * coeff.z) + sat));
    vec4 param_103 = screen;
    float param_104 = 0.0;
    vec4 _2799 = rolled_gain_v4(param_103, param_104);
    screen = clamp(_2799, vec4(0.0), vec4(1.0));
    screen = color * screen;
    vec3 param_105 = screen.xyz;
    float param_106 = 0.0;
    vec3 src_h = RGB_to_XYZ(param_105, param_106) * mat3(vec3(0.40020000934600830078125, 0.70759999752044677734375, -0.080799996852874755859375), vec3(-0.2263000011444091796875, 1.16530001163482666015625, 0.04569999873638153076171875), vec3(0.0, 0.0, 0.918200016021728515625));
    float _2827;
    if (src_h.x >= 0.0)
    {
        _2827 = pow(src_h.x, 0.430000007152557373046875);
    }
    else
    {
        _2827 = -pow(-src_h.x, 0.430000007152557373046875);
    }
    src_h.x = _2827;
    float _2845;
    if (src_h.y >= 0.0)
    {
        _2845 = pow(src_h.y, 0.430000007152557373046875);
    }
    else
    {
        _2845 = -pow(-src_h.y, 0.430000007152557373046875);
    }
    src_h.y = _2845;
    float _2862;
    if (src_h.z >= 0.0)
    {
        _2862 = pow(src_h.z, 0.430000007152557373046875);
    }
    else
    {
        _2862 = -pow(-src_h.z, 0.430000007152557373046875);
    }
    src_h.z = _2862;
    src_h *= mat3(vec3(0.4000000059604644775390625, 0.4000000059604644775390625, 0.20000000298023223876953125), vec3(4.4549999237060546875, -4.8509998321533203125, 0.3959999978542327880859375), vec3(0.805599987506866455078125, 0.3571999967098236083984375, -1.16279995441436767578125));
    float hue_at = atan(src_h.z, src_h.y);
    chroma = sqrt((src_h.z * src_h.z) + (src_h.y * src_h.y));
    float hue_radians_r = -0.69813168048858642578125;
    float hue_r = (chroma * cos(hue_at + hue_radians_r)) * 2.0;
    float hue_radians_g = 4.0142574310302734375;
    float hue_g = (chroma * cos(hue_at + hue_radians_g)) * 2.0;
    float hue_radians_b = 1.74532926082611083984375;
    float hue_b = (chroma * cos(hue_at + hue_radians_b)) * 2.0;
    float msk = dot(clamp(vec3(hue_r, hue_g, hue_b), vec3(0.0), vec3(1.0)), vec3(-0.0));
    vec3 param_107 = screen.xyz;
    vec3 param_108 = vec3(dot(coeff, screen.xyz));
    float param_109 = msk;
    src_h = mixfix(param_107, param_108, param_109);
    float _2959;
    if (false)
    {
        float param_110 = src_h.x;
        float param_111 = src_h.y;
        float param_112 = src_h.z;
        _2959 = 1.0 - (abs(SatMask(param_110, param_111, param_112) - 1.0) * 0.0);
    }
    else
    {
        float param_113 = src_h.x;
        float param_114 = src_h.y;
        float param_115 = src_h.z;
        _2959 = 1.0 - (SatMask(param_113, param_114, param_115) * 0.0);
    }
    float sat_msk = _2959;
    vec3 param_116 = src_h;
    vec3 param_117 = clamp(adjust * src_h, vec3(0.0), vec3(1.0));
    float param_118 = clamp(sat_msk, 0.0, 1.0);
    src_h = mixfix(param_116, param_117, param_118);
    vec3 _3004;
    if (false)
    {
        _3004 = clamp(pow(src_h, vec3(0.4547069370746612548828125)), vec3(0.0), vec3(1.0));
    }
    else
    {
        vec3 _3015;
        if (false)
        {
            vec3 param_119 = src_h;
            float param_120 = 2.2222220897674560546875;
            float param_121 = 0.0992999970912933349609375;
            vec3 _3022 = moncurve_r_f3(param_119, param_120, param_121);
            _3015 = _3022;
        }
        else
        {
            vec3 _3024;
            if (false)
            {
                _3024 = clamp(pow(src_h, vec3(0.3846153914928436279296875)), vec3(0.0), vec3(1.0));
            }
            else
            {
                vec3 _3035;
                if (true)
                {
                    vec3 param_122 = src_h;
                    float param_123 = 2.400000095367431640625;
                    float param_124 = 0.054999999701976776123046875;
                    vec3 _3042 = moncurve_r_f3(param_122, param_123, param_124);
                    _3035 = _3042;
                }
                else
                {
                    _3035 = clamp(pow(pow(src_h, vec3(1.0192639827728271484375)), vec3(0.4166666567325592041015625)), vec3(0.0), vec3(1.0));
                }
                _3024 = _3035;
            }
            _3015 = _3024;
        }
        _3004 = _3015;
    }
    vec3 TRC = _3004;
    FragColor = vec4(TRC, src_rgba.w);
}

