#version 430

layout(binding = 0, std140) uniform UBO
{
    mat4 MVP;
    vec4 SourceSize;
    vec4 OriginalSize;
    vec4 CorePassSize;
    vec4 CorePassFeedbackSize;
    vec4 OutputSize;
    vec4 FinalViewportSize;
    vec4 NegativeCropAddedPassSize;
    vec4 DerezedPassSize;
    int FrameDirection;
    uint FrameCount;
    float HSM_RESOLUTION_DEBUG_ON;
    float HSM_CACHE_GRAPHICS_ON;
    float HSM_CACHE_UPDATE_INDICATOR_MODE;
    float HSM_GLOBAL_GRAPHICS_BRIGHTNESS;
    float HSM_STATIC_LAYERS_GAMMA;
    float HSM_AMBIENT_LIGHTING_OPACITY;
    float HSM_AMBIENT2_LIGHTING_OPACITY;
    float HSM_AMBIENT_LIGHTING_SWAP_IMAGES;
    float HSM_AMBIENT_LIGHTING_HUE;
    float HSM_AMBIENT_LIGHTING_SATURATION;
    float HSM_AMBIENT_LIGHTING_VALUE;
    float HSM_AMBIENT_LIGHTING_CONTRAST;
    float HSM_AMBIENT_LIGHTING_SCALE_KEEP_ASPECT;
    float HSM_AMBIENT_LIGHTING_SCALE_WITH_ZOOM;
    float HSM_AMBIENT_LIGHTING_SCALE;
    float HSM_AMBIENT_LIGHTING_SCALE_X;
    float HSM_AMBIENT_LIGHTING_ROTATE;
    float HSM_AMBIENT_LIGHTING_MIRROR_HORZ;
    float HSM_AMBIENT_LIGHTING_POSITION_X;
    float HSM_AMBIENT_LIGHTING_POSITION_Y;
    float HSM_AMBIENT_LIGHTING_DITHERING_SAMPLES;
    float HSM_AMBIENT2_LIGHTING_HUE;
    float HSM_AMBIENT2_LIGHTING_SATURATION;
    float HSM_AMBIENT2_LIGHTING_VALUE;
    float HSM_AMBIENT2_LIGHTING_CONTRAST;
    float HSM_AMBIENT2_LIGHTING_SCALE_KEEP_ASPECT;
    float HSM_AMBIENT2_LIGHTING_SCALE_WITH_ZOOM;
    float HSM_AMBIENT2_LIGHTING_SCALE;
    float HSM_AMBIENT2_LIGHTING_SCALE_X;
    float HSM_AMBIENT2_LIGHTING_ROTATE;
    float HSM_AMBIENT2_LIGHTING_MIRROR_HORZ;
    float HSM_AMBIENT2_LIGHTING_POSITION_X;
    float HSM_AMBIENT2_LIGHTING_POSITION_Y;
    float HSM_VIEWPORT_ZOOM;
    float HSM_VIEWPORT_POSITION_X;
    float HSM_VIEWPORT_POSITION_Y;
    float HSM_VIEWPORT_ZOOM_MASK;
    float HSM_FLIP_VIEWPORT_VERTICAL;
    float HSM_FLIP_VIEWPORT_HORIZONTAL;
    float HSM_FLIP_CORE_VERTICAL;
    float HSM_FLIP_CORE_HORIZONTAL;
    float HSM_ROTATE_CORE_IMAGE;
    float HSM_ASPECT_RATIO_ORIENTATION;
    float HSM_ASPECT_RATIO_MODE;
    float HSM_ASPECT_RATIO_EXPLICIT;
    float HSM_INT_SCALE_MODE;
    float HSM_INT_SCALE_MULTIPLE_OFFSET;
    float HSM_INT_SCALE_MULTIPLE_OFFSET_LONG;
    float HSM_INT_SCALE_MAX_HEIGHT;
    float HSM_VERTICAL_PRESET;
    float HSM_NON_INTEGER_SCALE;
    float HSM_USE_PHYSICAL_SIZE_FOR_NON_INTEGER;
    float HSM_PHYSICAL_MONITOR_ASPECT_RATIO;
    float HSM_PHYSICAL_MONITOR_DIAGONAL_SIZE;
    float HSM_PHYSICAL_SIM_TUBE_DIAGONAL_SIZE;
    float HSM_USE_IMAGE_FOR_PLACEMENT;
    float HSM_PLACEMENT_IMAGE_USE_HORIZONTAL;
    float HSM_PLACEMENT_IMAGE_MODE;
    float HSM_NON_INTEGER_SCALE_OFFSET;
    float HSM_USE_SNAP_TO_CLOSEST_INT_SCALE;
    float HSM_SNAP_TO_CLOSEST_INT_SCALE_TOLERANCE;
    float HSM_SCREEN_POSITION_X;
    float HSM_SCREEN_POSITION_Y;
    float HSM_CROP_MODE;
    float HSM_CROP_PERCENT_ZOOM;
    float HSM_CROP_PERCENT_TOP;
    float HSM_CROP_PERCENT_BOTTOM;
    float HSM_CROP_PERCENT_LEFT;
    float HSM_CROP_PERCENT_RIGHT;
    float HSM_CROP_BLACK_THRESHOLD;
    float HSM_SCANLINE_DIRECTION;
    float HSM_CORE_RES_SAMPLING_MULT_SCANLINE_DIR;
    float HSM_DOWNSAMPLE_BLUR_SCANLINE_DIR;
    float HSM_CORE_RES_SAMPLING_MULT_OPPOSITE_DIR;
    float HSM_DOWNSAMPLE_BLUR_OPPOSITE_DIR;
    float HSM_CORE_RES_SAMPLING_SHIFT_OPPOSITE_DIR;
    float HSM_INTERLACE_TRIGGER_RES;
    float HSM_INTERLACE_MODE;
    float HSM_INTERLACE_EFFECT_SMOOTHNESS_INTERS;
    float HSM_INTERLACE_SCANLINE_EFFECT;
    float iscans;
    float HSM_FAKE_SCANLINE_MODE;
    float HSM_FAKE_SCANLINE_OPACITY;
    float HSM_FAKE_SCANLINE_RES_MODE;
    float HSM_FAKE_SCANLINE_RES;
    float HSM_FAKE_SCANLINE_INT_SCALE;
    float HSM_FAKE_SCANLINE_ROLL;
    float HSM_FAKE_SCANLINE_CURVATURE;
    float HSM_FAKE_SCANLINE_BRIGHTNESS_CUTOFF;
    float HSM_DUALSCREEN_MODE;
    float HSM_DUALSCREEN_CORE_IMAGE_SPLIT_MODE;
    float HSM_DUALSCREEN_CORE_IMAGE_SWAP_SCREENS;
    float HSM_DUALSCREEN_CORE_IMAGE_SPLIT_OFFSET;
    float HSM_DUALSCREEN_VIEWPORT_SPLIT_LOCATION;
    float HSM_DUALSCREEN_SHIFT_POSITION_WITH_SCALE;
    float HSM_DUALSCREEN_POSITION_OFFSET_BETWEEN_SCREENS;
    float HSM_2ND_SCREEN_ASPECT_RATIO_MODE;
    float HSM_2ND_SCREEN_INDEPENDENT_SCALE;
    float HSM_2ND_SCREEN_SCALE_OFFSET;
    float HSM_2ND_SCREEN_POS_X;
    float HSM_2ND_SCREEN_POS_Y;
    float HSM_2ND_SCREEN_CROP_PERCENT_ZOOM;
    float HSM_2ND_SCREEN_CROP_PERCENT_TOP;
    float HSM_2ND_SCREEN_CROP_PERCENT_BOTTOM;
    float HSM_2ND_SCREEN_CROP_PERCENT_LEFT;
    float HSM_2ND_SCREEN_CROP_PERCENT_RIGHT;
    float HSM_CURVATURE_MODE;
    float HSM_CURVATURE_2D_SCALE_LONG_AXIS;
    float HSM_CURVATURE_2D_SCALE_SHORT_AXIS;
    float HSM_CURVATURE_3D_RADIUS;
    float HSM_CURVATURE_3D_VIEW_DIST;
    float HSM_CURVATURE_3D_TILT_ANGLE_X;
    float HSM_CURVATURE_3D_TILT_ANGLE_Y;
    float HSM_CRT_CURVATURE_SCALE;
    float HSM_ANTI_FLICKER_ON;
    float HSM_ANTI_FLICKER_THRESHOLD;
    float HSM_AB_COMPARE_SHOW_MODE;
    float HSM_AB_COMPARE_AREA;
    float HSM_AB_COMPARE_FREEZE_CRT_TUBE;
    float HSM_AB_COMPARE_FREEZE_GRAPHICS;
    float HSM_AB_COMPARE_SPLIT_AREA;
    float HSM_AB_COMPARE_SPLIT_POSITION;
    float HSM_CRT_BLEND_MODE;
    float HSM_CRT_BLEND_AMOUNT;
    float HSM_CRT_SCREEN_BLEND_MODE;
    float HSM_SCREEN_VIGNETTE_ON;
    float HSM_SCREEN_VIGNETTE_DUALSCREEN_VIS_MODE;
    float HSM_SCREEN_VIGNETTE_STRENGTH;
    float HSM_SCREEN_VIGNETTE_POWER;
    float HSM_SCREEN_VIGNETTE_IN_REFLECTION;
    float HSM_MONOCHROME_MODE;
    float HSM_MONOCHROME_BRIGHTNESS;
    float HSM_MONOCHROME_GAMMA;
    float HSM_MONOCHROME_HUE_OFFSET;
    float HSM_MONOCHROME_SATURATION;
    float HSM_MONOCHROME_DUALSCREEN_VIS_MODE;
    float HSM_SCREEN_REFLECTION_SCALE;
    float HSM_SCREEN_REFLECTION_POS_X;
    float HSM_SCREEN_REFLECTION_POS_Y;
    float HSM_TUBE_DIFFUSE_MODE;
    float HSM_TUBE_DIFFUSE_IMAGE_DUALSCREEN_VIS_MODE;
    float HSM_TUBE_DIFFUSE_OPACITY;
    float HSM_TUBE_DIFFUSE_IMAGE_HUE;
    float HSM_TUBE_DIFFUSE_IMAGE_COLORIZE_ON;
    float HSM_TUBE_DIFFUSE_IMAGE_SATURATION;
    float HSM_TUBE_DIFFUSE_IMAGE_BRIGHTNESS;
    float HSM_TUBE_DIFFUSE_IMAGE_GAMMA;
    float HSM_TUBE_DIFFUSE_IMAGE_AMBIENT_LIGHTING;
    float HSM_TUBE_DIFFUSE_IMAGE_AMBIENT2_LIGHTING;
    float HSM_TUBE_DIFFUSE_IMAGE_SCALE;
    float HSM_TUBE_DIFFUSE_IMAGE_SCALE_X;
    float HSM_TUBE_EMPTY_THICKNESS;
    float HSM_TUBE_EMPTY_THICKNESS_X_SCALE;
    float HSM_TUBE_DIFFUSE_FORCE_ASPECT;
    float HSM_TUBE_EXPLICIT_ASPECT;
    float HSM_SCREEN_CORNER_RADIUS_SCALE;
    float HSM_TUBE_COLORED_GEL_IMAGE_ON;
    float HSM_TUBE_COLORED_GEL_IMAGE_DUALSCREEN_VIS_MODE;
    float HSM_TUBE_COLORED_GEL_IMAGE_MULTIPLY_AMOUNT;
    float HSM_TUBE_COLORED_GEL_IMAGE_NORMAL_AMOUNT;
    float HSM_TUBE_COLORED_GEL_IMAGE_NORMAL_BRIGHTNESS;
    float HSM_TUBE_COLORED_GEL_IMAGE_NORMAL_VIGNETTE;
    float HSM_TUBE_COLORED_GEL_IMAGE_TRANSPARENCY_THRESHOLD;
    float HSM_TUBE_COLORED_GEL_IMAGE_ADDITIVE_AMOUNT;
    float HSM_SHOW_CRT_ON_TOP_OF_COLORED_GEL;
    float HSM_TUBE_SHADOW_IMAGE_ON;
    float HSM_TUBE_SHADOW_IMAGE_OPACITY;
    float HSM_TUBE_SHADOW_IMAGE_SCALE_X;
    float HSM_TUBE_SHADOW_IMAGE_SCALE_Y;
    float HSM_TUBE_SHADOW_IMAGE_POS_X;
    float HSM_TUBE_SHADOW_IMAGE_POS_Y;
    float HSM_TUBE_SHADOW_CURVATURE_SCALE;
    float HSM_TUBE_COLORED_GEL_IMAGE_AMBIENT_LIGHTING;
    float HSM_TUBE_COLORED_GEL_IMAGE_AMBIENT2_LIGHTING;
    float HSM_TUBE_COLORED_GEL_IMAGE_FAKE_SCANLINE_AMOUNT;
    float HSM_TUBE_COLORED_GEL_IMAGE_SCALE;
    float HSM_TUBE_COLORED_GEL_IMAGE_FLIP_HORIZONTAL;
    float HSM_TUBE_COLORED_GEL_IMAGE_FLIP_VERTICAL;
    float HSM_TUBE_STATIC_REFLECTION_IMAGE_ON;
    float HSM_TUBE_STATIC_REFLECTION_IMAGE_DUALSCREEN_VIS_MODE;
    float HSM_TUBE_STATIC_REFLECTION_IMAGE_OPACITY;
    float HSM_TUBE_STATIC_REFLECTION_IMAGE_AMBIENT_LIGHTING;
    float HSM_TUBE_STATIC_REFLECTION_IMAGE_AMBIENT2_LIGHTING;
    float HSM_TUBE_STATIC_REFLECTION_IMAGE_SCALE;
    float HSM_TUBE_STATIC_REFLECTION_IMAGE_SHADOW_OPACITY;
    float HSM_TUBE_STATIC_REFLECTION_IMAGE_DITHERING_SAMPLES;
    float HSM_GLOBAL_CORNER_RADIUS;
    float HSM_TUBE_BLACK_EDGE_CORNER_RADIUS_SCALE;
    float HSM_TUBE_BLACK_EDGE_SHARPNESS;
    float HSM_TUBE_BLACK_EDGE_CURVATURE_SCALE;
    float HSM_TUBE_BLACK_EDGE_THICKNESS;
    float HSM_TUBE_BLACK_EDGE_THICKNESS_X_SCALE;
    float HSM_BZL_USE_INDEPENDENT_SCALE;
    float HSM_BZL_INDEPENDENT_SCALE;
    float HSM_BZL_USE_INDEPENDENT_CURVATURE;
    float HSM_BZL_INDEPENDENT_CURVATURE_SCALE_LONG_AXIS;
    float HSM_BZL_INDEPENDENT_CURVATURE_SCALE_SHORT_AXIS;
    float HSM_BZL_OPACITY;
    float HSM_BZL_BLEND_MODE;
    float HSM_BZL_WIDTH;
    float HSM_BZL_HEIGHT;
    float HSM_BZL_SCALE_OFFSET;
    float HSM_BZL_INNER_CURVATURE_SCALE;
    float HSM_BZL_INNER_CORNER_RADIUS_SCALE;
    float HSM_BZL_OUTER_CURVATURE_SCALE;
    float HSM_BZL_INNER_EDGE_THICKNESS;
    float HSM_BZL_INNER_EDGE_SHARPNESS;
    float HSM_BZL_OUTER_CORNER_RADIUS_SCALE;
    float HSM_BZL_INNER_EDGE_SHADOW;
    float HSM_BZL_COLOR_HUE;
    float HSM_BZL_COLOR_SATURATION;
    float HSM_BZL_COLOR_VALUE;
    float HSM_BZL_NOISE;
    float HSM_BZL_BRIGHTNESS;
    float HSM_BZL_HIGHLIGHT;
    float HSM_BZL_AMBIENT_LIGHTING_MULTIPLIER;
    float HSM_BZL_AMBIENT2_LIGHTING_MULTIPLIER;
    float HSM_FRM_USE_INDEPENDENT_COLOR;
    float HSM_FRM_COLOR_HUE;
    float HSM_FRM_COLOR_SATURATION;
    float HSM_FRM_COLOR_VALUE;
    float HSM_FRM_NOISE;
    float HSM_FRM_OUTER_CURVATURE_SCALE;
    float HSM_FRM_THICKNESS;
    float HSM_FRM_THICKNESS_SCALE_X;
    float HSM_FRM_OUTER_POS_Y;
    float HSM_FRM_INNER_EDGE_THICKNESS;
    float HSM_FRM_OUTER_EDGE_THICKNESS;
    float HSM_FRM_OUTER_EDGE_SHADING;
    float HSM_FRM_OUTER_CORNER_RADIUS;
    float HSM_BZL_OUTER_POSITION_Y;
    float HSM_FRM_SHADOW_OPACITY;
    float HSM_FRM_SHADOW_WIDTH;
    float HSM_REFLECT_CORNER_FADE;
    float HSM_REFLECT_CORNER_INNER_SPREAD;
    float HSM_REFLECT_CORNER_OUTER_SPREAD;
    float HSM_REFLECT_CORNER_ROTATION_OFFSET_TOP;
    float HSM_REFLECT_CORNER_ROTATION_OFFSET_BOTTOM;
    float HSM_REFLECT_CORNER_SPREAD_FALLOFF;
    float HSM_REFLECT_CORNER_FADE_DISTANCE;
    float HSM_REFLECT_GLOBAL_AMOUNT;
    float HSM_REFLECT_GLOBAL_GAMMA_ADJUST;
    float HSM_REFLECT_BEZEL_INNER_EDGE_AMOUNT;
    float HSM_REFLECT_BEZEL_INNER_EDGE_FULLSCREEN_GLOW;
    float HSM_REFLECT_FRAME_INNER_EDGE_AMOUNT;
    float HSM_REFLECT_FRAME_INNER_EDGE_SHARPNESS;
    float HSM_REFLECT_DIRECT_AMOUNT;
    float HSM_REFLECT_DIFFUSED_AMOUNT;
    float HSM_REFLECT_FULLSCREEN_GLOW;
    float HSM_REFLECT_FULLSCREEN_GLOW_GAMMA;
    float HSM_REFLECT_FADE_AMOUNT;
    float HSM_REFLECT_RADIAL_FADE_WIDTH;
    float HSM_REFLECT_RADIAL_FADE_HEIGHT;
    float HSM_REFLECT_LATERAL_OUTER_FADE_POSITION;
    float HSM_REFLECT_LATERAL_OUTER_FADE_DISTANCE;
    float HSM_REFLECT_VIGNETTE_AMOUNT;
    float HSM_REFLECT_VIGNETTE_SIZE;
    float HSM_REFLECT_NOISE_AMOUNT;
    float HSM_REFLECT_NOISE_SAMPLES;
    float HSM_REFLECT_NOISE_SAMPLE_DISTANCE;
    float HSM_REFLECT_BLUR_NUM_SAMPLES;
    float HSM_REFLECT_BLUR_FALLOFF_DISTANCE;
    float HSM_REFLECT_BLUR_MIN;
    float HSM_REFLECT_BLUR_MAX;
    float HSM_REFLECT_MASK_IMG_AMOUNT;
    float HSM_REFLECT_IS_LAST_PASS;
    float HSM_GLASS_BORDER_ON;
    float HSM_POTATO_SHOW_BG_OVER_SCREEN;
    float HSM_STANDARD_DECAL_SCALE_WITH_FRAME;
    float HSM_STANDARD_TOP_SCALE_WITH_FRAME;
    float HSM_BG_LAYER_ORDER;
    float HSM_VIEWPORT_VIGNETTE_LAYER_ORDER;
    float HSM_CRT_LAYER_ORDER;
    float HSM_DEVICE_LAYER_ORDER;
    float HSM_CAB_GLASS_LAYER_ORDER;
    float HSM_DECAL_LAYER_ORDER;
    float HSM_LED_LAYER_ORDER;
    float HSM_TOP_LAYER_ORDER;
    float HSM_CUTOUT_ASPECT_MODE;
    float HSM_CUTOUT_EXPLICIT_ASPECT;
    float HSM_CUTOUT_SCALE_MODE;
    float HSM_CUTOUT_SCALE_FULL_WITH_ZOOM;
    float HSM_CUTOUT_KEEP_ASPECT;
    float HSM_CUTOUT_SCALE;
    float HSM_CUTOUT_SCALE_X;
    float HSM_CUTOUT_CORNER_RADIUS;
    float HSM_CUTOUT_POS_X;
    float HSM_CUTOUT_POS_Y;
    float HSM_BG_OPACITY;
    float HSM_BG_HUE;
    float HSM_BG_COLORIZE_ON;
    float HSM_BG_SATURATION;
    float HSM_BG_BRIGHTNESS;
    float HSM_BG_GAMMA;
    float HSM_BG_AMBIENT_LIGHTING_MULTIPLIER;
    float HSM_BG_AMBIENT2_LIGHTING_MULTIPLIER;
    float HSM_BG_APPLY_AMBIENT_IN_ADD_MODE;
    float HSM_BG_BLEND_MODE;
    float HSM_BG_SOURCE_MATTE_TYPE;
    float HSM_BG_MASK_MODE;
    float HSM_BG_CUTOUT_MODE;
    float HSM_BG_DUALSCREEN_VIS_MODE;
    float HSM_BG_SCALE_MODE;
    float HSM_BG_SCALE_FULL_WITH_ZOOM;
    float HSM_BG_FILL_MODE;
    float HSM_BG_SCALE_KEEP_ASPECT;
    float HSM_BG_SCALE;
    float HSM_BG_SCALE_X;
    float HSM_BG_POS_X;
    float HSM_BG_POS_Y;
    float HSM_BG_MIRROR_WRAP;
    float HSM_BG_MIPMAPPING_BLEND_BIAS;
    float HSM_VIEWPORT_VIGNETTE_OPACITY;
    float HSM_VIEWPORT_VIGNETTE_MASK_MODE;
    float HSM_VIEWPORT_VIGNETTE_CUTOUT_MODE;
    float HSM_VIEWPORT_VIGNETTE_SCALE_MODE;
    float HSM_VIEWPORT_VIGNETTE_SCALE;
    float HSM_VIEWPORT_VIGNETTE_SCALE_X;
    float HSM_VIEWPORT_VIGNETTE_POS_X;
    float HSM_VIEWPORT_VIGNETTE_POS_Y;
    float HSM_LED_OPACITY;
    float HSM_LED_HUE;
    float HSM_LED_COLORIZE_ON;
    float HSM_LED_SATURATION;
    float HSM_LED_BRIGHTNESS;
    float HSM_LED_GAMMA;
    float HSM_LED_AMBIENT_LIGHTING_MULTIPLIER;
    float HSM_LED_AMBIENT2_LIGHTING_MULTIPLIER;
    float HSM_LED_APPLY_AMBIENT_IN_ADD_MODE;
    float HSM_LED_BLEND_MODE;
    float HSM_LED_SOURCE_MATTE_TYPE;
    float HSM_LED_MASK_MODE;
    float HSM_LED_CUTOUT_MODE;
    float HSM_LED_DUALSCREEN_VIS_MODE;
    float HSM_LED_SCALE_MODE;
    float HSM_LED_SCALE_FULL_WITH_ZOOM;
    float HSM_LED_SCALE_KEEP_ASPECT;
    float HSM_LED_FILL_MODE;
    float HSM_LED_SCALE;
    float HSM_LED_SCALE_X;
    float HSM_LED_POS_X;
    float HSM_LED_POS_Y;
    float HSM_LED_MIPMAPPING_BLEND_BIAS;
    float HSM_DEVICE_OPACITY;
    float HSM_DEVICE_HUE;
    float HSM_DEVICE_COLORIZE_ON;
    float HSM_DEVICE_SATURATION;
    float HSM_DEVICE_BRIGHTNESS;
    float HSM_DEVICE_GAMMA;
    float HSM_DEVICE_AMBIENT_LIGHTING_MULTIPLIER;
    float HSM_DEVICE_AMBIENT2_LIGHTING_MULTIPLIER;
    float HSM_DEVICE_APPLY_AMBIENT_IN_ADD_MODE;
    float HSM_DEVICE_BLEND_MODE;
    float HSM_DEVICE_SOURCE_MATTE_TYPE;
    float HSM_DEVICE_MASK_MODE;
    float HSM_DEVICE_CUTOUT_MODE;
    float HSM_DEVICE_DUALSCREEN_VIS_MODE;
    float HSM_DEVICE_SCALE_MODE;
    float HSM_DEVICE_SCALE_FULL_WITH_ZOOM;
    float HSM_DEVICE_SCALE_KEEP_ASPECT;
    float HSM_DEVICE_FILL_MODE;
    float HSM_DEVICE_SCALE;
    float HSM_DEVICE_SCALE_X;
    float HSM_DEVICE_POS_X;
    float HSM_DEVICE_POS_Y;
    float HSM_DEVICE_COPY_INHERITED_COORD;
    float HSM_REFLECT_MASK_SCALE_MODE;
    float HSM_DEVICE_MIPMAPPING_BLEND_BIAS;
    float HSM_FRM_OPACITY;
    float HSM_FRM_BLEND_MODE;
    float HSM_FRM_TEXTURE_OPACITY;
    float HSM_FRM_TEXTURE_BLEND_MODE;
    float HSM_DECAL_OPACITY;
    float HSM_DECAL_HUE;
    float HSM_DECAL_COLORIZE_ON;
    float HSM_DECAL_SATURATION;
    float HSM_DECAL_BRIGHTNESS;
    float HSM_DECAL_GAMMA;
    float HSM_DECAL_AMBIENT_LIGHTING_MULTIPLIER;
    float HSM_DECAL_AMBIENT2_LIGHTING_MULTIPLIER;
    float HSM_DECAL_APPLY_AMBIENT_IN_ADD_MODE;
    float HSM_DECAL_BLEND_MODE;
    float HSM_DECAL_SOURCE_MATTE_TYPE;
    float HSM_DECAL_MASK_MODE;
    float HSM_DECAL_CUTOUT_MODE;
    float HSM_DECAL_DUALSCREEN_VIS_MODE;
    float HSM_DECAL_SCALE_MODE;
    float HSM_DECAL_SCALE_FULL_WITH_ZOOM;
    float HSM_DECAL_SCALE_KEEP_ASPECT;
    float HSM_DECAL_FILL_MODE;
    float HSM_DECAL_SCALE;
    float HSM_DECAL_SCALE_X;
    float HSM_DECAL_POS_X;
    float HSM_DECAL_POS_Y;
    float HSM_DECAL_MIPMAPPING_BLEND_BIAS;
    float HSM_CAB_GLASS_OPACITY;
    float HSM_CAB_GLASS_HUE;
    float HSM_CAB_GLASS_COLORIZE_ON;
    float HSM_CAB_GLASS_SATURATION;
    float HSM_CAB_GLASS_BRIGHTNESS;
    float HSM_CAB_GLASS_GAMMA;
    float HSM_CAB_GLASS_AMBIENT_LIGHTING_MULTIPLIER;
    float HSM_CAB_GLASS_AMBIENT2_LIGHTING_MULTIPLIER;
    float HSM_CAB_GLASS_APPLY_AMBIENT_IN_ADD_MODE;
    float HSM_CAB_GLASS_BLEND_MODE;
    float HSM_CAB_GLASS_SOURCE_MATTE_TYPE;
    float HSM_CAB_GLASS_MASK_MODE;
    float HSM_CAB_GLASS_CUTOUT_MODE;
    float HSM_CAB_GLASS_DUALSCREEN_VIS_MODE;
    float HSM_CAB_GLASS_SCALE_MODE;
    float HSM_CAB_GLASS_SCALE_FULL_WITH_ZOOM;
    float HSM_CAB_GLASS_SCALE_KEEP_ASPECT;
    float HSM_CAB_GLASS_FILL_MODE;
    float HSM_CAB_GLASS_SCALE;
    float HSM_CAB_GLASS_SCALE_X;
    float HSM_CAB_GLASS_POS_X;
    float HSM_CAB_GLASS_POS_Y;
    float HSM_CAB_GLASS_MIPMAPPING_BLEND_BIAS;
    float HSM_TOP_OPACITY;
    float HSM_TOP_HUE;
    float HSM_TOP_COLORIZE_ON;
    float HSM_TOP_SATURATION;
    float HSM_TOP_BRIGHTNESS;
    float HSM_TOP_GAMMA;
    float HSM_TOP_AMBIENT_LIGHTING_MULTIPLIER;
    float HSM_TOP_AMBIENT2_LIGHTING_MULTIPLIER;
    float HSM_TOP_APPLY_AMBIENT_IN_ADD_MODE;
    float HSM_TOP_BLEND_MODE;
    float HSM_TOP_SOURCE_MATTE_TYPE;
    float HSM_TOP_MASK_MODE;
    float HSM_TOP_CUTOUT_MODE;
    float HSM_TOP_DUALSCREEN_VIS_MODE;
    float HSM_TOP_SCALE_MODE;
    float HSM_TOP_SCALE_FULL_WITH_ZOOM;
    float HSM_TOP_SCALE_KEEP_ASPECT;
    float HSM_TOP_FILL_MODE;
    float HSM_TOP_SCALE;
    float HSM_TOP_SCALE_X;
    float HSM_TOP_POS_X;
    float HSM_TOP_POS_Y;
    float HSM_TOP_MIRROR_WRAP;
    float HSM_TOP_MIPMAPPING_BLEND_BIAS;
    float HSM_RENDER_SIMPLE_MODE;
    float HSM_RENDER_SIMPLE_MASK_TYPE;
    float HSM_LAYERING_DEBUG_MASK_MODE;
    float HSM_INTRO_LOGO_BLEND_MODE;
    float HSM_INTRO_LOGO_FLIP_VERTICAL;
    float HSM_INTRO_NOISE_BLEND_MODE;
    float HSM_INTRO_NOISE_HOLD;
    float HSM_INTRO_NOISE_FADE_OUT;
    float HSM_INTRO_SOLID_BLACK_HOLD;
    float HSM_INTRO_SOLID_BLACK_FADE_OUT;
    float HSM_INTRO_SOLID_COLOR_BLEND_MODE;
    float HSM_INTRO_LOGO_OVER_SOLID_COLOR;
    float HSM_INTRO_LOGO_PLACEMENT;
    float HSM_INTRO_LOGO_HEIGHT;
    float HSM_INTRO_LOGO_POS_X;
    float HSM_INTRO_LOGO_POS_Y;
    float HSM_INTRO_WHEN_TO_SHOW;
    float HSM_INTRO_SPEED;
    float HSM_INTRO_LOGO_WAIT;
    float HSM_INTRO_LOGO_FADE_IN;
    float HSM_INTRO_LOGO_HOLD;
    float HSM_INTRO_LOGO_FADE_OUT;
    float HSM_INTRO_SOLID_COLOR_HUE;
    float HSM_INTRO_SOLID_COLOR_SAT;
    float HSM_INTRO_SOLID_COLOR_VALUE;
    float HSM_INTRO_SOLID_COLOR_HOLD;
    float HSM_INTRO_SOLID_COLOR_FADE_OUT;
    float GAMMA_INPUT;
    float gamma_out;
    float post_br;
    float post_br_affect_black_level;
    float glow;
    float bloom;
    float mask_bloom;
    float bloom_dist;
    float halation;
    float TATE;
    float IOS;
    float OS;
    float BLOOM;
    float overscanX;
    float overscanY;
    float intres;
    float prescalex;
    float c_shape;
    float sborder;
    float csize;
    float bsize1;
    float warpX;
    float warpY;
    float gamma_c;
    float brightboost;
    float brightboost1;
    float blendMode;
    float gsl;
    float scanline1;
    float scanline2;
    float beam_min;
    float beam_max;
    float beam_size;
    float vertmask;
    float scans;
    float scan_falloff;
    float spike;
    float ring;
    float scangamma;
    float rolling_scan;
    float h_sharp;
    float s_sharp;
    float smart_ei;
    float ei_limit;
    float sth;
    float barspeed;
    float barintensity;
    float bardir;
    float shadowMask;
    float maskstr;
    float mcut;
    float masksize;
    float maskDark;
    float maskLight;
    float mask_gamma;
    float slotmask;
    float slotmask1;
    float slotwidth;
    float double_slot;
    float slotms;
    float mclip;
    float mshift;
    float mask_layout;
    float GDV_DECONVERGENCE_ON;
    float decons;
    float GDV_NOISE_ON;
    float addnoised;
    float noisetype;
    float noiseresd;
    float deconrr;
    float deconrg;
    float deconrb;
    float deconrry;
    float deconrgy;
    float deconrby;
    float deconsmooth;
    float dctypex;
    float dctypey;
    float g_grade_on;
    float wp_temperature;
    float g_satr;
    float g_satg;
    float g_satb;
    float AS;
    float asat;
    float hcrt_h_size;
    float hcrt_v_size;
    float hcrt_h_cent;
    float hcrt_v_cent;
    float hcrt_pin_phase;
    float hcrt_pin_amp;
} global;

layout(binding = 7) uniform sampler2D Source;
layout(binding = 5) uniform sampler2D BloomPass;
layout(binding = 8) uniform sampler2D InfoCachePass;
layout(binding = 9) uniform sampler2D InfoCachePassFeedback;
layout(binding = 3) uniform sampler2D AvgLumPass;
layout(binding = 2) uniform sampler2D LinearizePass;
layout(binding = 4) uniform sampler2D GlowPass;

layout(location = 0) in vec2 vTexCoord;
layout(location = 0) out vec4 FragColor;
float NEGATIVE_CROP_EXPAND_MULTIPLIER;
float MAX_NEGATIVE_CROP;
float DEFAULT_SCREEN_ASPECT;
float DEFAULT_BEZEL_ASPECT;
vec2 DEFAULT_SCREEN_SCALE;
vec2 DEFAULT_BEZEL_SCALE;
int INFOCACHE_MAX_INDEX;
float BLEND_MODE_OFF;
float BLEND_MODE_NORMAL;
float BLEND_MODE_ADD;
float BLEND_MODE_MULTIPLY;
float SOURCE_MATTE_PREMULTIPLIED;
float SOURCE_MATTE_WHITE;
float SOURCE_MATTE_NONE;
float IMAGE_ASPECT_MODE_INHERIT_ASPECT_SCALE;
float IMAGE_ASPECT_MODE_KEEP_ASPECT;
float FILL_MODE_STRETCH;
float FILL_MODE_SPLIT_FILL_HORIZONTAL;
float FILL_MODE_SPLIT_FILL_VERTICAL;
bool CACHE_INFO_PARAM_SUM_CHANGED;
float CURRENT_FRAME_FROM_CACHE_INFO;
float TUBE_DIFFUSE_MASK;
float TUBE_MASK;
float BEZEL_MASK;
float INSIDE_BEZEL_MASK;
float OUTSIDE_TUBE_MASK_FOR_IMAGE;
float FRAME_MASK;
float FRAME_MASK_FOR_IMAGE;
float OUTSIDE_BEZEL_MASK;
float OUTSIDE_FRAME_MASK_FOR_IMAGE;
float OUTSIDE_FRAME_MASK;
float CUTOUT_MASK;
float SCREEN_INDEX;
float SCREEN_ASPECT;
vec2 SCREEN_SCALE;
vec2 SCREEN_POS_OFFSET;
vec2 SCREEN_SCALE_2ND_SCREEN;
vec2 SCREEN_POS_OFFSET_2ND_SCREEN;
vec2 VIEWPORT_SCALE;
vec2 VIEWPORT_POS;
vec2 TUBE_SCALE;
vec2 TUBE_DIFFUSE_SCALE;
float TUBE_DIFFUSE_ASPECT;
vec2 FRAME_SCALE;
vec2 BEZEL_OUTSIDE_SCALE;
vec2 BACKGROUND_SCALE;
vec2 LED_SCALE;
vec2 DEVICE_SCALE;
vec2 DECAL_SCALE;
vec2 CAB_GLASS_SCALE;
vec2 TOP_IMAGE_SCALE;
float AVERAGE_LUMA;
float USE_VERTICAL_SCANLINES;
vec2 CORE_SIZE;
vec2 ROTATED_CORE_ORIGINAL_SIZE;
vec2 ROTATED_CORE_PREPPED_SIZE;
vec2 ROTATED_DEREZED_SIZE;
vec2 CROPPED_ROTATED_SIZE_WITH_RES_MULT;
vec2 CROPPED_ROTATED_SIZE_WITH_RES_MULT_FEEDBACK;
vec2 CROPPED_ROTATED_SIZE;
vec2 SAMPLE_AREA_START_PIXEL_COORD;
vec2 VIEWPORT_UNSCALED_COORD;
vec2 SCREEN_COORD;
vec2 TUBE_COORD;
vec2 TUBE_DIFFUSE_COORD;
vec2 BEZEL_OUTSIDE_COORD;
vec2 BACKGROUND_COORD;
vec2 DEVICE_COORD;
vec2 LED_COORD;
vec2 DECAL_COORD;
vec2 CAB_GLASS_COORD;
vec2 TOP_IMAGE_COORD;
vec2 SCREEN_CURVED_COORD;
vec2 TUBE_CURVED_COORD;
vec2 TUBE_DIFFUSE_CURVED_COORD;
vec2 BEZEL_OUTSIDE_CURVED_COORD;
vec2 FRAME_OUTSIDE_CURVED_COORD;
vec2 BACKGROUND_CURVED_COORD;
vec2 LED_CURVED_COORD;
vec2 DEVICE_CURVED_COORD;
vec2 DECAL_CURVED_COORD;
vec2 CAB_GLASS_CURVED_COORD;
vec2 TOP_IMAGE_CURVED_COORD;
float HSM_RESOLUTION_DEBUG_ON;
float HSM_CACHE_GRAPHICS_ON;
float HSM_CACHE_UPDATE_INDICATOR_MODE;
float HSM_GLOBAL_GRAPHICS_BRIGHTNESS;
float HSM_STATIC_LAYERS_GAMMA;
float HSM_AMBIENT_LIGHTING_OPACITY;
float HSM_AMBIENT2_LIGHTING_OPACITY;
float HSM_AMBIENT_LIGHTING_SWAP_IMAGES;
float HSM_VIEWPORT_ZOOM;
float HSM_VIEWPORT_ZOOM_MASK;
float HSM_VIEWPORT_POSITION_X;
float HSM_VIEWPORT_POSITION_Y;
float HSM_FLIP_VIEWPORT_VERTICAL;
float HSM_FLIP_VIEWPORT_HORIZONTAL;
float HSM_FLIP_CORE_VERTICAL;
float HSM_FLIP_CORE_HORIZONTAL;
float HSM_ROTATE_CORE_IMAGE;
float HSM_ASPECT_RATIO_ORIENTATION;
float HSM_ASPECT_RATIO_MODE;
float HSM_ASPECT_RATIO_EXPLICIT;
float HSM_VERTICAL_PRESET;
float HSM_INT_SCALE_MAX_HEIGHT;
float HSM_NON_INTEGER_SCALE;
float HSM_USE_PHYSICAL_SIZE_FOR_NON_INTEGER;
float HSM_PHYSICAL_MONITOR_ASPECT_RATIO;
float HSM_PHYSICAL_MONITOR_DIAGONAL_SIZE;
float HSM_PHYSICAL_SIM_TUBE_DIAGONAL_SIZE;
float HSM_USE_IMAGE_FOR_PLACEMENT;
float HSM_PLACEMENT_IMAGE_USE_HORIZONTAL;
float HSM_PLACEMENT_IMAGE_MODE;
float HSM_NON_INTEGER_SCALE_OFFSET;
float HSM_USE_SNAP_TO_CLOSEST_INT_SCALE;
float HSM_SNAP_TO_CLOSEST_INT_SCALE_TOLERANCE;
float HSM_SCREEN_POSITION_X;
float HSM_SCREEN_POSITION_Y;
float HSM_CROP_MODE;
float HSM_CROP_PERCENT_ZOOM;
float HSM_CROP_PERCENT_TOP;
float HSM_CROP_PERCENT_BOTTOM;
float HSM_CROP_PERCENT_LEFT;
float HSM_CROP_PERCENT_RIGHT;
float HSM_CROP_BLACK_THRESHOLD;
float HSM_SCANLINE_DIRECTION;
float HSM_CORE_RES_SAMPLING_MULT_SCANLINE_DIR;
float HSM_DOWNSAMPLE_BLUR_SCANLINE_DIR;
float HSM_CORE_RES_SAMPLING_MULT_OPPOSITE_DIR;
float HSM_DOWNSAMPLE_BLUR_OPPOSITE_DIR;
float HSM_CORE_RES_SAMPLING_SHIFT_OPPOSITE_DIR;
float HSM_USE_GEOM;
float HSM_CURVATURE_MODE;
float HSM_CURVATURE_3D_RADIUS;
float HSM_CURVATURE_3D_VIEW_DIST;
float HSM_CURVATURE_3D_TILT_ANGLE_X;
float HSM_CURVATURE_3D_TILT_ANGLE_Y;
float HSM_CRT_CURVATURE_SCALE;
float HSM_AB_COMPARE_SHOW_MODE;
float HSM_AB_COMPARE_AREA;
float HSM_AB_COMPARE_SPLIT_POSITION;
float HSM_AB_COMPARE_FREEZE_CRT_TUBE;
float HSM_AB_COMPARE_FREEZE_GRAPHICS;
float HSM_SCREEN_VIGNETTE_DUALSCREEN_VIS_MODE;
float HSM_MONOCHROME_DUALSCREEN_VIS_MODE;
float HSM_TUBE_DIFFUSE_MODE;
float HSM_TUBE_DIFFUSE_OPACITY;
float HSM_TUBE_DIFFUSE_IMAGE_DUALSCREEN_VIS_MODE;
float HSM_TUBE_DIFFUSE_IMAGE_COLORIZE_ON;
float HSM_TUBE_DIFFUSE_IMAGE_HUE;
float HSM_TUBE_DIFFUSE_IMAGE_SATURATION;
float HSM_TUBE_DIFFUSE_IMAGE_BRIGHTNESS;
float HSM_TUBE_DIFFUSE_IMAGE_GAMMA;
float HSM_TUBE_DIFFUSE_IMAGE_AMBIENT_LIGHTING;
float HSM_TUBE_DIFFUSE_IMAGE_AMBIENT2_LIGHTING;
float HSM_TUBE_DIFFUSE_IMAGE_SCALE;
float HSM_TUBE_DIFFUSE_IMAGE_SCALE_X;
float HSM_TUBE_SHADOW_IMAGE_ON;
float HSM_TUBE_SHADOW_IMAGE_OPACITY;
float HSM_TUBE_SHADOW_IMAGE_POS_X;
float HSM_TUBE_SHADOW_IMAGE_POS_Y;
float HSM_TUBE_SHADOW_IMAGE_SCALE_X;
float HSM_TUBE_SHADOW_IMAGE_SCALE_Y;
float HSM_TUBE_SHADOW_CURVATURE_SCALE;
float HSM_TUBE_COLORED_GEL_IMAGE_ON;
float HSM_TUBE_COLORED_GEL_IMAGE_SCALE;
float HSM_TUBE_COLORED_GEL_IMAGE_FLIP_HORIZONTAL;
float HSM_TUBE_COLORED_GEL_IMAGE_FLIP_VERTICAL;
float HSM_TUBE_COLORED_GEL_IMAGE_DUALSCREEN_VIS_MODE;
float HSM_TUBE_COLORED_GEL_IMAGE_MULTIPLY_AMOUNT;
float HSM_TUBE_COLORED_GEL_IMAGE_ADDITIVE_AMOUNT;
float HSM_TUBE_COLORED_GEL_IMAGE_NORMAL_AMOUNT;
float HSM_TUBE_COLORED_GEL_IMAGE_TRANSPARENCY_THRESHOLD;
float HSM_TUBE_COLORED_GEL_IMAGE_NORMAL_BRIGHTNESS;
float HSM_TUBE_COLORED_GEL_IMAGE_NORMAL_VIGNETTE;
float HSM_TUBE_COLORED_GEL_IMAGE_FAKE_SCANLINE_AMOUNT;
float HSM_TUBE_COLORED_GEL_IMAGE_AMBIENT_LIGHTING;
float HSM_TUBE_COLORED_GEL_IMAGE_AMBIENT2_LIGHTING;
float HSM_SHOW_CRT_ON_TOP_OF_COLORED_GEL;
float HSM_TUBE_STATIC_REFLECTION_IMAGE_ON;
float HSM_TUBE_STATIC_REFLECTION_IMAGE_DUALSCREEN_VIS_MODE;
float HSM_TUBE_STATIC_REFLECTION_IMAGE_OPACITY;
float HSM_TUBE_STATIC_REFLECTION_IMAGE_AMBIENT_LIGHTING;
float HSM_TUBE_STATIC_REFLECTION_IMAGE_AMBIENT2_LIGHTING;
float HSM_TUBE_STATIC_REFLECTION_IMAGE_SCALE;
float HSM_TUBE_STATIC_REFLECTION_IMAGE_SHADOW_OPACITY;
float HSM_DUALSCREEN_MODE;
float HSM_DUALSCREEN_CORE_IMAGE_SPLIT_MODE;
float HSM_DUALSCREEN_CORE_IMAGE_SWAP_SCREENS;
float HSM_DUALSCREEN_CORE_IMAGE_SPLIT_OFFSET;
float HSM_DUALSCREEN_VIEWPORT_SPLIT_LOCATION;
float HSM_DUALSCREEN_SHIFT_POSITION_WITH_SCALE;
float HSM_DUALSCREEN_POSITION_OFFSET_BETWEEN_SCREENS;
float HSM_2ND_SCREEN_ASPECT_RATIO_MODE;
float HSM_2ND_SCREEN_INDEPENDENT_SCALE;
float HSM_2ND_SCREEN_SCALE_OFFSET;
float HSM_2ND_SCREEN_POS_X;
float HSM_2ND_SCREEN_POS_Y;
float HSM_2ND_SCREEN_CROP_PERCENT_ZOOM;
float HSM_2ND_SCREEN_CROP_PERCENT_TOP;
float HSM_2ND_SCREEN_CROP_PERCENT_BOTTOM;
float HSM_2ND_SCREEN_CROP_PERCENT_LEFT;
float HSM_2ND_SCREEN_CROP_PERCENT_RIGHT;
float HSM_SCREEN_REFLECTION_SCALE;
float HSM_SCREEN_REFLECTION_POS_X;
float HSM_SCREEN_REFLECTION_POS_Y;
float HSM_AMBIENT_LIGHTING_HUE;
float HSM_AMBIENT_LIGHTING_SATURATION;
float HSM_AMBIENT_LIGHTING_VALUE;
float HSM_AMBIENT_LIGHTING_CONTRAST;
float HSM_AMBIENT_LIGHTING_SCALE_KEEP_ASPECT;
float HSM_AMBIENT_LIGHTING_SCALE_WITH_ZOOM;
float HSM_AMBIENT_LIGHTING_SCALE;
float HSM_AMBIENT_LIGHTING_SCALE_X;
float HSM_AMBIENT_LIGHTING_ROTATE;
float HSM_AMBIENT_LIGHTING_MIRROR_HORZ;
float HSM_AMBIENT_LIGHTING_POSITION_X;
float HSM_AMBIENT_LIGHTING_POSITION_Y;
float HSM_AMBIENT_LIGHTING_DITHERING_SAMPLES;
float HSM_AMBIENT2_LIGHTING_HUE;
float HSM_AMBIENT2_LIGHTING_SATURATION;
float HSM_AMBIENT2_LIGHTING_VALUE;
float HSM_AMBIENT2_LIGHTING_CONTRAST;
float HSM_AMBIENT2_LIGHTING_SCALE_KEEP_ASPECT;
float HSM_AMBIENT2_LIGHTING_SCALE_WITH_ZOOM;
float HSM_AMBIENT2_LIGHTING_SCALE;
float HSM_AMBIENT2_LIGHTING_SCALE_X;
float HSM_AMBIENT2_LIGHTING_ROTATE;
float HSM_AMBIENT2_LIGHTING_MIRROR_HORZ;
float HSM_AMBIENT2_LIGHTING_POSITION_X;
float HSM_AMBIENT2_LIGHTING_POSITION_Y;
float HSM_BZL_OPACITY;
float HSM_BZL_BLEND_MODE;
float HSM_BZL_WIDTH;
float HSM_BZL_HEIGHT;
float HSM_BZL_INNER_CORNER_RADIUS_SCALE;
float CURVATURE_MODE_OFF;
float CURVATURE_MODE_2D;
float CURVATURE_MODE_2D_CYLINDER;
float CURVATURE_MODE_3D_1;
float CURVATURE_MODE_3D_2;
float CURVATURE_MODE_3D_CYLINDER;
float HSM_BZL_INNER_EDGE_THICKNESS;
float HSM_BZL_INNER_EDGE_SHARPNESS;
float HSM_BZL_OUTER_POSITION_Y;
float HSM_BZL_OUTER_CURVATURE_SCALE;
float HSM_BZL_OUTER_CORNER_RADIUS_SCALE;
float HSM_BZL_BRIGHTNESS;
float HSM_BZL_HIGHLIGHT;
float HSM_BZL_NOISE;
float HSM_BZL_INNER_EDGE_SHADOW;
float HSM_BZL_COLOR_HUE;
float HSM_BZL_COLOR_SATURATION;
float HSM_BZL_COLOR_VALUE;
float HSM_BZL_AMBIENT_LIGHTING_MULTIPLIER;
float HSM_BZL_AMBIENT2_LIGHTING_MULTIPLIER;
float HSM_FRM_USE_INDEPENDENT_COLOR;
float HSM_FRM_COLOR_HUE;
float HSM_FRM_COLOR_SATURATION;
float HSM_FRM_COLOR_VALUE;
float HSM_FRM_OPACITY;
float HSM_FRM_BLEND_MODE;
float HSM_FRM_TEXTURE_OPACITY;
float HSM_FRM_TEXTURE_BLEND_MODE;
float HSM_FRM_NOISE;
float HSM_FRM_INNER_EDGE_THICKNESS;
float HSM_FRM_THICKNESS;
float HSM_FRM_THICKNESS_SCALE_X;
float HSM_FRM_OUTER_POS_Y;
float HSM_FRM_OUTER_CURVATURE_SCALE;
float HSM_FRM_OUTER_CORNER_RADIUS;
float HSM_FRM_OUTER_EDGE_THICKNESS;
float HSM_FRM_OUTER_EDGE_SHADING;
float HSM_FRM_SHADOW_OPACITY;
float HSM_FRM_SHADOW_WIDTH;
float HSM_REFLECT_CORNER_FADE;
float HSM_REFLECT_CORNER_FADE_DISTANCE;
float HSM_REFLECT_CORNER_INNER_SPREAD;
float HSM_REFLECT_CORNER_OUTER_SPREAD;
float HSM_REFLECT_CORNER_ROTATION_OFFSET_TOP;
float HSM_REFLECT_CORNER_ROTATION_OFFSET_BOTTOM;
float HSM_REFLECT_CORNER_SPREAD_FALLOFF;
float MAX_LAYER_ORDER;

vec2 HSM_GetViewportCoordWithFlip(vec2 viewport_coord)
{
    vec2 out_coord = viewport_coord;
    if (HSM_FLIP_VIEWPORT_VERTICAL == (-1.0))
    {
        out_coord.y = 1.0 - out_coord.y;
    }
    if (HSM_FLIP_VIEWPORT_HORIZONTAL == (-1.0))
    {
        out_coord.x = 1.0 - out_coord.x;
    }
    return out_coord;
}

vec2 HSM_GetViewportCoordWithZoomAndPan(vec2 viewport_coord)
{
    vec2 param = viewport_coord;
    vec2 out_coord = HSM_GetViewportCoordWithFlip(param);
    out_coord = ((out_coord - vec2(0.5)) / vec2(HSM_VIEWPORT_ZOOM)) + vec2(0.5);
    out_coord.x += HSM_VIEWPORT_POSITION_X;
    out_coord.y -= HSM_VIEWPORT_POSITION_Y;
    return out_coord;
}

float HSM_GetScreenIndex(vec2 viewport_coord)
{
    float out_index = 1.0;
    float output_aspect = global.FinalViewportSize.x / global.FinalViewportSize.y;
    if (HSM_DUALSCREEN_MODE == 0.0)
    {
        out_index = 1.0;
    }
    if (HSM_DUALSCREEN_MODE == 1.0)
    {
        out_index = float((viewport_coord.y < (0.5 + (HSM_DUALSCREEN_VIEWPORT_SPLIT_LOCATION / output_aspect))) ? 1 : 2);
    }
    if (HSM_DUALSCREEN_MODE == 2.0)
    {
        out_index = float((viewport_coord.x < (0.5 + (HSM_DUALSCREEN_VIEWPORT_SPLIT_LOCATION / output_aspect))) ? 1 : 2);
    }
    return out_index;
}

vec2 HSM_GetRotatedNegativeCropAddedSize()
{
    return (global.NegativeCropAddedPassSize.yx * HSM_ROTATE_CORE_IMAGE) + (global.NegativeCropAddedPassSize.xy * (1.0 - HSM_ROTATE_CORE_IMAGE));
}

vec2 HSM_GetRotatedCoreOriginalSize()
{
    return (global.OriginalSize.yx * HSM_ROTATE_CORE_IMAGE) + (global.OriginalSize.xy * (1.0 - HSM_ROTATE_CORE_IMAGE));
}

vec4 HSM_GetCacheSampleRange(float column_index, float row_index)
{
    float num_rows = 8.0;
    float num_columns = 8.0;
    float range_width = 1.0 / num_columns;
    float range_height = 1.0 / num_rows;
    float zero_based_row_index = row_index - 1.0;
    float zero_based_column_index = column_index - 1.0;
    vec4 out_sample_range = vec4(0.0);
    out_sample_range.x = zero_based_column_index * range_width;
    out_sample_range.y = zero_based_row_index * range_height;
    out_sample_range.z = out_sample_range.x + range_width;
    out_sample_range.w = out_sample_range.y + range_height;
    return out_sample_range;
}

vec2 HSM_GetCacheSampleCoord(float column_index, float row_index)
{
    float num_rows = 8.0;
    float num_columns = 8.0;
    float range_width = 1.0 / num_columns;
    float range_height = 1.0 / num_rows;
    float param = column_index;
    float param_1 = row_index;
    vec4 sample_range = HSM_GetCacheSampleRange(param, param_1);
    return vec2(sample_range.x + (range_width / 2.0), sample_range.y + (range_height / 2.0));
}

float HSM_GetUseVerticalScanlines(float screen_aspect)
{
    float auto_use_vert_scanlines = float(int(screen_aspect < 1.0));
    float scanline_direction = float((HSM_SCANLINE_DIRECTION < 2.0) ? 0 : 1);
    if (HSM_SCANLINE_DIRECTION < 1.0)
    {
        if (HSM_DUALSCREEN_MODE < 1.0)
        {
            scanline_direction = auto_use_vert_scanlines;
        }
    }
    return scanline_direction;
}

vec2 HSM_GetCoordWithPositionOffset(vec2 in_coord, vec2 position_offset)
{
    return in_coord - position_offset;
}

vec2 HSM_GetInverseScaledCoord(vec2 in_coord, vec2 in_scale)
{
    vec2 middle = vec2(0.499989986419677734375);
    vec2 diff = in_coord - middle;
    vec2 screen_inverse_scale = vec2(1.0) / in_scale;
    vec2 scaled_coord = middle + (diff * screen_inverse_scale);
    return scaled_coord;
}

vec2 HSM_GetVTexCoordWithArgs(vec2 in_coord, vec2 in_scale, vec2 position_offset)
{
    vec2 param = in_coord;
    vec2 param_1 = position_offset;
    vec2 param_2 = HSM_GetCoordWithPositionOffset(param, param_1);
    vec2 param_3 = in_scale;
    return HSM_GetInverseScaledCoord(param_2, param_3);
}

vec4 HSM_UpdateGlobalScreenValuesFromCache(sampler2D in_cache_pass, sampler2D in_cache_feedback_pass, vec2 vTexCoord_1)
{
    float output_aspect = global.FinalViewportSize.x / global.FinalViewportSize.y;
    vec2 param = vTexCoord_1;
    vec2 flipped_viewport_coord = HSM_GetViewportCoordWithZoomAndPan(param);
    vec2 param_1 = flipped_viewport_coord;
    SCREEN_INDEX = HSM_GetScreenIndex(param_1);
    CORE_SIZE = global.CorePassSize.xy;
    ROTATED_CORE_PREPPED_SIZE = HSM_GetRotatedNegativeCropAddedSize();
    ROTATED_CORE_ORIGINAL_SIZE = HSM_GetRotatedCoreOriginalSize();
    vec2 sample_coord = vec2(0.0);
    vec4 texture_sample = vec4(0.0);
    float param_2 = 1.0;
    float param_3 = 1.0;
    sample_coord = HSM_GetCacheSampleCoord(param_2, param_3);
    texture_sample = texture(in_cache_pass, sample_coord);
    AVERAGE_LUMA = texture_sample.w;
    float res_mult_size_sum = 0.0;
    float res_mult_size_sum_feedback = 0.0;
    float res_mult_size2_sum = 0.0;
    float res_mult_size2_sum_feedback = 0.0;
    if (SCREEN_INDEX == 1.0)
    {
        float param_4 = 2.0;
        float param_5 = 1.0;
        sample_coord = HSM_GetCacheSampleCoord(param_4, param_5);
        texture_sample = texture(in_cache_pass, sample_coord);
        SCREEN_ASPECT = texture_sample.x;
        SCREEN_SCALE = texture_sample.zw;
        float param_6 = 3.0;
        float param_7 = 1.0;
        sample_coord = HSM_GetCacheSampleCoord(param_6, param_7);
        texture_sample = texture(in_cache_pass, sample_coord);
        TUBE_SCALE = texture_sample.xy;
        SCREEN_POS_OFFSET = texture_sample.zw;
        float param_8 = 3.0;
        float param_9 = 4.0;
        sample_coord = HSM_GetCacheSampleCoord(param_8, param_9);
        texture_sample = texture(in_cache_pass, sample_coord);
        TUBE_DIFFUSE_SCALE = texture_sample.xy;
        TUBE_DIFFUSE_ASPECT = (TUBE_DIFFUSE_SCALE.x / TUBE_DIFFUSE_SCALE.y) * output_aspect;
        float param_10 = 4.0;
        float param_11 = 1.0;
        sample_coord = HSM_GetCacheSampleCoord(param_10, param_11);
        texture_sample = texture(in_cache_pass, sample_coord);
        CROPPED_ROTATED_SIZE_WITH_RES_MULT = texture_sample.xy;
        res_mult_size_sum = CROPPED_ROTATED_SIZE_WITH_RES_MULT.x + CROPPED_ROTATED_SIZE_WITH_RES_MULT.y;
        texture_sample = texture(in_cache_feedback_pass, sample_coord);
        CROPPED_ROTATED_SIZE_WITH_RES_MULT_FEEDBACK = texture_sample.xy;
        res_mult_size_sum_feedback = CROPPED_ROTATED_SIZE_WITH_RES_MULT_FEEDBACK.x + CROPPED_ROTATED_SIZE_WITH_RES_MULT_FEEDBACK.y;
        float param_12 = 1.0;
        float param_13 = 2.0;
        sample_coord = HSM_GetCacheSampleCoord(param_12, param_13);
        texture_sample = texture(in_cache_pass, sample_coord);
        CROPPED_ROTATED_SIZE = texture_sample.xy;
        SAMPLE_AREA_START_PIXEL_COORD = texture_sample.zw;
    }
    if (SCREEN_INDEX == 2.0)
    {
        float param_14 = 2.0;
        float param_15 = 2.0;
        sample_coord = HSM_GetCacheSampleCoord(param_14, param_15);
        texture_sample = texture(in_cache_pass, sample_coord);
        SCREEN_ASPECT = texture_sample.x;
        SCREEN_SCALE = texture_sample.yz;
        float param_16 = 3.0;
        float param_17 = 2.0;
        sample_coord = HSM_GetCacheSampleCoord(param_16, param_17);
        texture_sample = texture(in_cache_pass, sample_coord);
        TUBE_SCALE = texture_sample.xy;
        SCREEN_POS_OFFSET = texture_sample.zw;
        float param_18 = 3.0;
        float param_19 = 4.0;
        sample_coord = HSM_GetCacheSampleCoord(param_18, param_19);
        texture_sample = texture(in_cache_pass, sample_coord);
        TUBE_DIFFUSE_SCALE = texture_sample.zw;
        TUBE_DIFFUSE_ASPECT = (TUBE_DIFFUSE_SCALE.x / TUBE_DIFFUSE_SCALE.y) * output_aspect;
        float param_20 = 4.0;
        float param_21 = 2.0;
        sample_coord = HSM_GetCacheSampleCoord(param_20, param_21);
        texture_sample = texture(in_cache_pass, sample_coord);
        CROPPED_ROTATED_SIZE_WITH_RES_MULT = texture_sample.xy;
        res_mult_size2_sum = CROPPED_ROTATED_SIZE_WITH_RES_MULT.x + CROPPED_ROTATED_SIZE_WITH_RES_MULT.y;
        texture_sample = texture(in_cache_feedback_pass, sample_coord);
        CROPPED_ROTATED_SIZE_WITH_RES_MULT_FEEDBACK = texture_sample.xy;
        res_mult_size2_sum_feedback = CROPPED_ROTATED_SIZE_WITH_RES_MULT_FEEDBACK.x + CROPPED_ROTATED_SIZE_WITH_RES_MULT_FEEDBACK.y;
        float param_22 = 1.0;
        float param_23 = 3.0;
        sample_coord = HSM_GetCacheSampleCoord(param_22, param_23);
        texture_sample = texture(in_cache_pass, sample_coord);
        CROPPED_ROTATED_SIZE = texture_sample.xy;
        SAMPLE_AREA_START_PIXEL_COORD = texture_sample.zw;
    }
    float param_24 = 2.0;
    float param_25 = 3.0;
    sample_coord = HSM_GetCacheSampleCoord(param_24, param_25);
    texture_sample = texture(in_cache_pass, sample_coord);
    CORE_SIZE = texture_sample.xy;
    float param_26 = 3.0;
    float param_27 = 3.0;
    sample_coord = HSM_GetCacheSampleCoord(param_26, param_27);
    texture_sample = texture(in_cache_pass, sample_coord);
    VIEWPORT_SCALE = texture_sample.xy;
    VIEWPORT_POS = texture_sample.zw;
    float param_28 = 4.0;
    float param_29 = 3.0;
    sample_coord = HSM_GetCacheSampleCoord(param_28, param_29);
    texture_sample = texture(in_cache_pass, sample_coord);
    SCREEN_SCALE_2ND_SCREEN = texture_sample.xy;
    SCREEN_POS_OFFSET_2ND_SCREEN = texture_sample.zw;
    float param_30 = 1.0;
    float param_31 = 4.0;
    sample_coord = HSM_GetCacheSampleCoord(param_30, param_31);
    texture_sample = texture(in_cache_pass, sample_coord);
    float parameter_sum = texture_sample.x;
    CURRENT_FRAME_FROM_CACHE_INFO = texture_sample.y;
    ROTATED_DEREZED_SIZE = texture_sample.zw;
    texture_sample = texture(in_cache_feedback_pass, sample_coord);
    float parameter_sum_feedback = texture_sample.x;
    float param_32 = 2.0;
    float param_33 = 4.0;
    sample_coord = HSM_GetCacheSampleCoord(param_32, param_33);
    texture_sample = texture(in_cache_pass, sample_coord);
    NEGATIVE_CROP_EXPAND_MULTIPLIER = texture_sample.x;
    MAX_NEGATIVE_CROP = texture_sample.y;
    float param_34 = SCREEN_ASPECT;
    USE_VERTICAL_SCANLINES = HSM_GetUseVerticalScanlines(param_34);
    vec2 param_35 = flipped_viewport_coord;
    vec2 param_36 = SCREEN_SCALE;
    vec2 param_37 = SCREEN_POS_OFFSET;
    SCREEN_COORD = HSM_GetVTexCoordWithArgs(param_35, param_36, param_37);
    vec2 param_38 = flipped_viewport_coord;
    vec2 param_39 = TUBE_DIFFUSE_SCALE;
    vec2 param_40 = SCREEN_POS_OFFSET;
    TUBE_DIFFUSE_COORD = HSM_GetVTexCoordWithArgs(param_38, param_39, param_40);
    float param_sum_epsilon = 1.0000000116860974230803549289703e-07;
    CACHE_INFO_PARAM_SUM_CHANGED = false;
    CACHE_INFO_PARAM_SUM_CHANGED = ((res_mult_size_sum != res_mult_size_sum_feedback) || (res_mult_size2_sum != res_mult_size2_sum_feedback)) ? true : CACHE_INFO_PARAM_SUM_CHANGED;
    CACHE_INFO_PARAM_SUM_CHANGED = (abs(parameter_sum - parameter_sum_feedback) > param_sum_epsilon) ? true : CACHE_INFO_PARAM_SUM_CHANGED;
    return vec4(0.0);
}

vec2 HSM_GetOuterBezelScale(vec2 tube_diffuse_scale, float screen_aspect)
{
    vec2 bezel_outer_scale_offset = vec2((HSM_BZL_WIDTH / screen_aspect) + 1.0, HSM_BZL_HEIGHT + 1.0);
    return bezel_outer_scale_offset;
}

float intersect(vec2 in_coord, vec2 sinangle, vec2 cosangle, float in_radius, float in_distance)
{
    float A = dot(in_coord, in_coord) + (in_distance * in_distance);
    float B = 2.0 * ((in_radius * (dot(in_coord, sinangle) - ((in_distance * cosangle.x) * cosangle.y))) - (in_distance * in_distance));
    float C = (in_distance * in_distance) + ((((2.0 * in_radius) * in_distance) * cosangle.x) * cosangle.y);
    return ((-B) - sqrt((B * B) - ((4.0 * A) * C))) / (2.0 * A);
}

vec2 bkwtrans(vec2 in_coord, vec2 sinangle, vec2 cosangle, float in_radius, float in_distance)
{
    vec2 param = in_coord;
    vec2 param_1 = sinangle;
    vec2 param_2 = cosangle;
    float param_3 = in_radius;
    float param_4 = in_distance;
    float c = intersect(param, param_1, param_2, param_3, param_4);
    vec2 pt = vec2(c) * in_coord;
    pt -= (vec2(-in_radius) * sinangle);
    pt /= vec2(in_radius);
    vec2 tang = sinangle / cosangle;
    vec2 poc = pt / cosangle;
    float A = dot(tang, tang) + 1.0;
    float B = (-2.0) * dot(poc, tang);
    float C = dot(poc, poc) - 1.0;
    float a = ((-B) + sqrt((B * B) - ((4.0 * A) * C))) / (2.0 * A);
    vec2 uv = (pt - (sinangle * a)) / cosangle;
    float r = max(abs(in_radius * acos(a)), 9.9999997473787516355514526367188e-06);
    return (uv * r) / vec2(sin(r / in_radius));
}

vec2 fwtrans(inout vec2 uv, vec2 sinangle, vec2 cosangle, float in_radius, float in_distance)
{
    float r = max(abs(sqrt(dot(uv, uv))), 9.9999997473787516355514526367188e-06);
    uv *= (sin(r / in_radius) / r);
    float x = 1.0 - cos(r / in_radius);
    float D = ((in_distance / in_radius) + ((x * cosangle.x) * cosangle.y)) + dot(uv, sinangle);
    return (((uv * cosangle) - (sinangle * x)) * in_distance) / vec2(D);
}

vec3 maxscale(vec2 sinangle, vec2 cosangle, float in_radius, float in_distance, float in_aspect)
{
    vec2 aspect_vec2 = vec2(1.0, 1.0 / in_aspect);
    vec2 param = (sinangle * (-in_radius)) / vec2(1.0 + (((in_radius / in_distance) * cosangle.x) * cosangle.y));
    vec2 param_1 = sinangle;
    vec2 param_2 = cosangle;
    float param_3 = in_radius;
    float param_4 = in_distance;
    vec2 c = bkwtrans(param, param_1, param_2, param_3, param_4);
    vec2 a = vec2(0.5) * aspect_vec2;
    vec2 param_5 = vec2(-a.x, c.y);
    vec2 param_6 = sinangle;
    vec2 param_7 = cosangle;
    float param_8 = in_radius;
    float param_9 = in_distance;
    vec2 _2666 = fwtrans(param_5, param_6, param_7, param_8, param_9);
    vec2 param_10 = vec2(c.x, -a.y);
    vec2 param_11 = sinangle;
    vec2 param_12 = cosangle;
    float param_13 = in_radius;
    float param_14 = in_distance;
    vec2 _2683 = fwtrans(param_10, param_11, param_12, param_13, param_14);
    vec2 lo = vec2(_2666.x, _2683.y) / aspect_vec2;
    vec2 param_15 = vec2(a.x, c.y);
    vec2 param_16 = sinangle;
    vec2 param_17 = cosangle;
    float param_18 = in_radius;
    float param_19 = in_distance;
    vec2 _2703 = fwtrans(param_15, param_16, param_17, param_18, param_19);
    vec2 param_20 = vec2(c.x, a.y);
    vec2 param_21 = sinangle;
    vec2 param_22 = cosangle;
    float param_23 = in_radius;
    float param_24 = in_distance;
    vec2 _2719 = fwtrans(param_20, param_21, param_22, param_23, param_24);
    vec2 hi = vec2(_2703.x, _2719.y) / aspect_vec2;
    return vec3(((hi + lo) * aspect_vec2) * 0.5, max(hi.x - lo.x, hi.y - lo.y));
}

vec2 transform(inout vec2 coord, vec3 stretch, vec2 sinangle, vec2 cosangle, float in_radius, float in_distance, vec2 aspect)
{
    coord = (((coord - vec2(0.5)) * aspect) * stretch.z) + stretch.xy;
    vec2 param = coord;
    vec2 param_1 = sinangle;
    vec2 param_2 = cosangle;
    float param_3 = in_radius;
    float param_4 = in_distance;
    return (bkwtrans(param, param_1, param_2, param_3, param_4) / aspect) + vec2(0.5);
}

vec2 HSM_GetGeomCurvedCoord(vec2 in_coord, float tilt_x, float tilt_y, float in_radius, inout float in_distance, float in_aspect)
{
    in_distance *= 1.39999997615814208984375;
    vec2 ang = vec2(tilt_x, tilt_y);
    vec2 v_sinangle = sin(ang);
    vec2 v_cosangle = cos(ang);
    vec2 param = v_sinangle;
    vec2 param_1 = v_cosangle;
    float param_2 = in_radius;
    float param_3 = in_distance;
    float param_4 = in_aspect;
    vec3 v_stretch = maxscale(param, param_1, param_2, param_3, param_4);
    vec2 aspect_vec2 = vec2(1.0, 1.0 / in_aspect);
    vec2 param_5 = in_coord;
    vec3 param_6 = v_stretch;
    vec2 param_7 = v_sinangle;
    vec2 param_8 = v_cosangle;
    float param_9 = in_radius;
    float param_10 = in_distance;
    vec2 param_11 = aspect_vec2;
    vec2 _2816 = transform(param_5, param_6, param_7, param_8, param_9, param_10, param_11);
    vec2 curved_coord = _2816;
    return curved_coord;
}

vec2 HSM_GetGeomCurvedCoordRetainWidth(vec2 in_coord, float tilt_x, float tilt_y, float in_radius, float in_distance, float in_aspect)
{
    vec2 param = in_coord;
    float param_1 = tilt_x;
    float param_2 = tilt_y;
    float param_3 = in_radius;
    float param_4 = in_distance;
    float param_5 = in_aspect;
    vec2 _2833 = HSM_GetGeomCurvedCoord(param, param_1, param_2, param_3, param_4, param_5);
    vec2 ctr_curved_coord = _2833 - vec2(0.5);
    vec2 param_6 = vec2(1.0, 0.5);
    float param_7 = tilt_x;
    float param_8 = tilt_y;
    float param_9 = in_radius;
    float param_10 = in_distance;
    float param_11 = in_aspect;
    vec2 _2848 = HSM_GetGeomCurvedCoord(param_6, param_7, param_8, param_9, param_10, param_11);
    vec2 right_edge_curved_ctr_coord = _2848 - vec2(0.5);
    ctr_curved_coord.x = (ctr_curved_coord.x * 0.5) / right_edge_curved_ctr_coord.x;
    return ctr_curved_coord + vec2(0.5);
}

vec2 HSM_GetCurvatureScales(float screen_aspect)
{
    vec2 curvature_scales = (screen_aspect < 1.0) ? vec2(1.0) : vec2(1.0);
    curvature_scales = (clamp(curvature_scales, vec2(1.0), vec2(5.0)) - vec2(1.0)) + vec2(1.0);
    return curvature_scales;
}

vec2 hrg_get_aspect_vector(float geom_aspect_ratio)
{
    float geom_max_aspect_ratio = 1.0;
    float geom_clamped_aspect_ratio = min(geom_aspect_ratio, geom_max_aspect_ratio);
    vec2 output_aspect = normalize(vec2(geom_clamped_aspect_ratio, 1.0));
    return output_aspect;
}

vec3 hrg_sphere_uv_to_xyz(vec2 video_uv, vec2 output_aspect, float in_geom_radius)
{
    vec2 square_uv = video_uv * output_aspect;
    vec2 square_uv_unit = normalize(square_uv);
    float arc_len = square_uv.y / square_uv_unit.y;
    float angle_from_image_center = arc_len / in_geom_radius;
    float xy_dist_from_sphere_center = sin(angle_from_image_center) * in_geom_radius;
    vec2 xy_pos = square_uv_unit * xy_dist_from_sphere_center;
    float z_pos = cos(angle_from_image_center) * in_geom_radius;
    vec3 intersection_pos_local = vec3(xy_pos.x, -xy_pos.y, z_pos);
    return intersection_pos_local;
}

vec3 hrg_sphere_alt_uv_to_xyz(vec2 video_uv, vec2 output_aspect, float in_geom_radius)
{
    vec2 square_uv = video_uv * output_aspect;
    vec2 arc_len = square_uv;
    vec2 angle_from_image_center = arc_len / vec2(in_geom_radius);
    vec2 xy_pos = sin(angle_from_image_center) * in_geom_radius;
    float z_pos = sqrt((in_geom_radius * in_geom_radius) - dot(xy_pos, xy_pos));
    return vec3(xy_pos.x, -xy_pos.y, z_pos);
}

vec3 hrg_cylinder_uv_to_xyz(vec2 video_uv, vec2 output_aspect, float in_geom_radius)
{
    vec2 square_uv = video_uv * output_aspect;
    float arc_len = square_uv.x;
    float angle_from_image_center = arc_len / in_geom_radius;
    float x_pos = sin(angle_from_image_center) * in_geom_radius;
    float z_pos = cos(angle_from_image_center) * in_geom_radius;
    vec3 intersection_pos_local = vec3(x_pos, -square_uv.y, z_pos);
    return intersection_pos_local;
}

vec3 hrg_uv_to_xyz(vec2 uv, vec2 output_aspect, float in_geom_mode, float in_geom_radius)
{
    vec3 _1066;
    if (in_geom_mode < 1.5)
    {
        vec2 param = uv;
        vec2 param_1 = output_aspect;
        float param_2 = in_geom_radius;
        _1066 = hrg_sphere_uv_to_xyz(param, param_1, param_2);
    }
    else
    {
        vec3 _1079;
        if (in_geom_mode < 2.5)
        {
            vec2 param_3 = uv;
            vec2 param_4 = output_aspect;
            float param_5 = in_geom_radius;
            _1079 = hrg_sphere_alt_uv_to_xyz(param_3, param_4, param_5);
        }
        else
        {
            vec2 param_6 = uv;
            vec2 param_7 = output_aspect;
            float param_8 = in_geom_radius;
            _1079 = hrg_cylinder_uv_to_xyz(param_6, param_7, param_8);
        }
        _1066 = _1079;
    }
    return _1066;
}

vec3 hrg_get_ideal_global_eye_pos_for_points(inout vec3 eye_pos, vec2 output_aspect, vec3 global_coords[9], int num_points, float in_geom_radius, float in_geom_view_dist)
{
    int max_centering_iters = 1;
    vec3 eyespace_coords[9];
    float _1314;
    float _1327;
    float _1340;
    float _1353;
    for (int iter = 0; iter < max_centering_iters; iter++)
    {
        for (int i = 0; i < num_points; i++)
        {
            eyespace_coords[i] = global_coords[i] - eye_pos;
        }
        float abs_radius = abs(in_geom_radius);
        vec2 offset_dr_min = vec2(10.0 * abs_radius, 10.0 * abs_radius);
        vec2 offset_ul_max = vec2((-10.0) * abs_radius, (-10.0) * abs_radius);
        for (int i_1 = 0; i_1 < num_points; i_1++)
        {
            vec2 flipy = vec2(1.0, -1.0);
            vec3 eyespace_xyz = eyespace_coords[i_1];
            vec2 offset_dr = eyespace_xyz.xy - ((vec2(-0.5) * (output_aspect * (-eyespace_xyz.z))) / (flipy * in_geom_view_dist));
            vec2 offset_ul = eyespace_xyz.xy - ((vec2(0.5) * (output_aspect * (-eyespace_xyz.z))) / (flipy * in_geom_view_dist));
            offset_dr_min = min(offset_dr_min, offset_dr);
            offset_ul_max = max(offset_ul_max, offset_ul);
        }
        vec2 center_offset = (offset_ul_max + offset_dr_min) * 0.5;
        vec3 _1247 = eye_pos;
        vec2 _1249 = _1247.xy + center_offset;
        eye_pos.x = _1249.x;
        eye_pos.y = _1249.y;
        for (int i_2 = 0; i_2 < num_points; i_2++)
        {
            eyespace_coords[i_2] = global_coords[i_2] - eye_pos;
        }
        float offset_z_max = ((-10.0) * in_geom_radius) * in_geom_view_dist;
        for (int i_3 = 0; i_3 < num_points; i_3++)
        {
            vec3 eyespace_xyz_flipy = eyespace_coords[i_3] * vec3(1.0, -1.0, 1.0);
            vec4 offset_zzzz = eyespace_xyz_flipy.zzzz + ((eyespace_xyz_flipy.xyxy * in_geom_view_dist) / (vec4(-0.5, -0.5, 0.5, 0.5) * vec4(output_aspect, output_aspect)));
            if (eyespace_xyz_flipy.x < 0.0)
            {
                _1314 = max(offset_z_max, offset_zzzz.x);
            }
            else
            {
                _1314 = offset_z_max;
            }
            offset_z_max = _1314;
            if (eyespace_xyz_flipy.y < 0.0)
            {
                _1327 = max(offset_z_max, offset_zzzz.y);
            }
            else
            {
                _1327 = offset_z_max;
            }
            offset_z_max = _1327;
            if (eyespace_xyz_flipy.x > 0.0)
            {
                _1340 = max(offset_z_max, offset_zzzz.z);
            }
            else
            {
                _1340 = offset_z_max;
            }
            offset_z_max = _1340;
            if (eyespace_xyz_flipy.y > 0.0)
            {
                _1353 = max(offset_z_max, offset_zzzz.w);
            }
            else
            {
                _1353 = offset_z_max;
            }
            offset_z_max = _1353;
            offset_z_max = max(offset_z_max, eyespace_xyz_flipy.z);
        }
        eye_pos.z += offset_z_max;
    }
    return eye_pos;
}

vec3 hrg_get_ideal_global_eye_pos(mat3 local_to_global, vec2 output_aspect, float in_geom_mode, float in_geom_radius, float in_geom_view_dist)
{
    vec3 high_view = vec3(0.0, output_aspect.y, -in_geom_view_dist);
    vec3 low_view = high_view * vec3(1.0, -1.0, 1.0);
    float len_sq = dot(high_view, high_view);
    float fov = abs(acos(dot(high_view, low_view) / len_sq));
    float eye_z_spherical = in_geom_radius / sin(fov * 0.5);
    vec3 _1410;
    if (in_geom_mode < 2.5)
    {
        _1410 = vec3(0.0, 0.0, eye_z_spherical);
    }
    else
    {
        _1410 = vec3(0.0, 0.0, max(in_geom_view_dist, eye_z_spherical));
    }
    vec3 eye_pos = _1410;
    int num_points = 9;
    vec2 param = vec2(0.0);
    vec2 param_1 = output_aspect;
    float param_2 = in_geom_mode;
    float param_3 = in_geom_radius;
    vec3 global_coords[9];
    global_coords[0] = hrg_uv_to_xyz(param, param_1, param_2, param_3) * local_to_global;
    vec2 param_4 = vec2(0.0, -0.5);
    vec2 param_5 = output_aspect;
    float param_6 = in_geom_mode;
    float param_7 = in_geom_radius;
    global_coords[1] = hrg_uv_to_xyz(param_4, param_5, param_6, param_7) * local_to_global;
    vec2 param_8 = vec2(0.0, 0.5);
    vec2 param_9 = output_aspect;
    float param_10 = in_geom_mode;
    float param_11 = in_geom_radius;
    global_coords[2] = hrg_uv_to_xyz(param_8, param_9, param_10, param_11) * local_to_global;
    vec2 param_12 = vec2(-0.5, 0.0);
    vec2 param_13 = output_aspect;
    float param_14 = in_geom_mode;
    float param_15 = in_geom_radius;
    global_coords[3] = hrg_uv_to_xyz(param_12, param_13, param_14, param_15) * local_to_global;
    vec2 param_16 = vec2(0.5, 0.0);
    vec2 param_17 = output_aspect;
    float param_18 = in_geom_mode;
    float param_19 = in_geom_radius;
    global_coords[4] = hrg_uv_to_xyz(param_16, param_17, param_18, param_19) * local_to_global;
    vec2 param_20 = vec2(-0.5);
    vec2 param_21 = output_aspect;
    float param_22 = in_geom_mode;
    float param_23 = in_geom_radius;
    global_coords[5] = hrg_uv_to_xyz(param_20, param_21, param_22, param_23) * local_to_global;
    vec2 param_24 = vec2(0.5, -0.5);
    vec2 param_25 = output_aspect;
    float param_26 = in_geom_mode;
    float param_27 = in_geom_radius;
    global_coords[6] = hrg_uv_to_xyz(param_24, param_25, param_26, param_27) * local_to_global;
    vec2 param_28 = vec2(-0.5, 0.5);
    vec2 param_29 = output_aspect;
    float param_30 = in_geom_mode;
    float param_31 = in_geom_radius;
    global_coords[7] = hrg_uv_to_xyz(param_28, param_29, param_30, param_31) * local_to_global;
    vec2 param_32 = vec2(0.5);
    vec2 param_33 = output_aspect;
    float param_34 = in_geom_mode;
    float param_35 = in_geom_radius;
    global_coords[8] = hrg_uv_to_xyz(param_32, param_33, param_34, param_35) * local_to_global;
    float num_negative_z_coords = 0.0;
    for (int i = 0; i < num_points; i++)
    {
        num_negative_z_coords += float(global_coords[0].z < 0.0);
    }
    vec3 _1555;
    if (num_negative_z_coords > 0.5)
    {
        _1555 = eye_pos;
    }
    else
    {
        vec3 param_36 = eye_pos;
        vec2 param_37 = output_aspect;
        vec3 param_38[9] = global_coords;
        int param_39 = num_points;
        float param_40 = in_geom_radius;
        float param_41 = in_geom_view_dist;
        vec3 _1572 = hrg_get_ideal_global_eye_pos_for_points(param_36, param_37, param_38, param_39, param_40, param_41);
        _1555 = _1572;
    }
    return _1555;
}

vec2 hrg_quadratic_solve(float a, float b_over_2, float c)
{
    float discriminant = (b_over_2 * b_over_2) - (a * c);
    float solution0 = c / ((-b_over_2) + sqrt(discriminant));
    return vec2(solution0, discriminant);
}

vec2 hrg_intersect_sphere(vec3 view_vec, vec3 eye_pos_vec, float in_geom_radius)
{
    float a = dot(view_vec, view_vec);
    float b_over_2 = dot(view_vec, eye_pos_vec);
    float c = dot(eye_pos_vec, eye_pos_vec) - (in_geom_radius * in_geom_radius);
    float param = a;
    float param_1 = b_over_2;
    float param_2 = c;
    return hrg_quadratic_solve(param, param_1, param_2);
}

vec2 hrg_intersect_cylinder(vec3 view_vec, vec3 eye_pos_vec, float in_geom_radius)
{
    vec3 cylinder_top_vec = vec3(0.0, in_geom_radius, 0.0);
    vec3 cylinder_axis_vec = vec3(0.0, 1.0, 0.0);
    vec3 top_to_eye_vec = eye_pos_vec - cylinder_top_vec;
    vec3 axis_x_view = cross(cylinder_axis_vec, view_vec);
    vec3 axis_x_top_to_eye = cross(cylinder_axis_vec, top_to_eye_vec);
    float a = dot(axis_x_view, axis_x_view);
    float b_over_2 = dot(axis_x_top_to_eye, axis_x_view);
    float c = dot(axis_x_top_to_eye, axis_x_top_to_eye) - (in_geom_radius * in_geom_radius);
    float param = a;
    float param_1 = b_over_2;
    float param_2 = c;
    return hrg_quadratic_solve(param, param_1, param_2);
}

vec2 hrg_intersect(vec3 view_vec_local, vec3 eye_pos_local, float in_geom_mode, float in_geom_radius)
{
    vec2 _1006;
    if (in_geom_mode < 2.5)
    {
        vec3 param = view_vec_local;
        vec3 param_1 = eye_pos_local;
        float param_2 = in_geom_radius;
        _1006 = hrg_intersect_sphere(param, param_1, param_2);
    }
    else
    {
        vec3 param_3 = view_vec_local;
        vec3 param_4 = eye_pos_local;
        float param_5 = in_geom_radius;
        _1006 = hrg_intersect_cylinder(param_3, param_4, param_5);
    }
    return _1006;
}

vec2 hrg_sphere_xyz_to_uv(vec3 intersection_pos_local, vec2 output_aspect, float in_geom_radius)
{
    vec3 image_center_pos_local = vec3(0.0, 0.0, in_geom_radius);
    float cp_len = length(cross(intersection_pos_local, image_center_pos_local));
    float dp = dot(intersection_pos_local, image_center_pos_local);
    float angle_from_image_center = atan(cp_len, dp);
    float arc_len = angle_from_image_center * in_geom_radius;
    vec2 square_uv_unit = normalize(vec2(intersection_pos_local.x, -intersection_pos_local.y));
    vec2 square_uv = square_uv_unit * arc_len;
    vec2 video_uv = square_uv / output_aspect;
    return video_uv;
}

vec2 hrg_sphere_alt_xyz_to_uv(vec3 intersection_pos_local, vec2 output_aspect, float in_geom_radius)
{
    vec2 angle_from_image_center = atan(vec2(intersection_pos_local.x, -intersection_pos_local.y), intersection_pos_local.zz);
    vec2 signed_arc_len = angle_from_image_center * in_geom_radius;
    vec2 video_uv = signed_arc_len / output_aspect;
    return video_uv;
}

vec2 hrg_cylinder_xyz_to_uv(vec3 intersection_pos_local, vec2 output_aspect, float in_geom_radius)
{
    float angle_from_image_center = atan(intersection_pos_local.x, intersection_pos_local.z);
    float signed_arc_len = angle_from_image_center * in_geom_radius;
    vec2 square_uv = vec2(signed_arc_len, -intersection_pos_local.y);
    vec2 video_uv = square_uv / output_aspect;
    return video_uv;
}

vec2 hrg_xyz_to_uv(vec3 intersection_pos_local, vec2 output_aspect, float in_geom_mode, float in_geom_radius)
{
    vec2 _1029;
    if (in_geom_mode < 1.5)
    {
        vec3 param = intersection_pos_local;
        vec2 param_1 = output_aspect;
        float param_2 = in_geom_radius;
        _1029 = hrg_sphere_xyz_to_uv(param, param_1, param_2);
    }
    else
    {
        vec2 _1042;
        if (in_geom_mode < 2.5)
        {
            vec3 param_3 = intersection_pos_local;
            vec2 param_4 = output_aspect;
            float param_5 = in_geom_radius;
            _1042 = hrg_sphere_alt_xyz_to_uv(param_3, param_4, param_5);
        }
        else
        {
            vec3 param_6 = intersection_pos_local;
            vec2 param_7 = output_aspect;
            float param_8 = in_geom_radius;
            _1042 = hrg_cylinder_xyz_to_uv(param_6, param_7, param_8);
        }
        _1029 = _1042;
    }
    return _1029;
}

vec2 hrg_view_vec_to_uv(vec3 view_vec_local, vec3 eye_pos_local, vec2 output_aspect, float in_geom_mode, float in_geom_radius, out vec3 intersection_pos)
{
    vec3 param = view_vec_local;
    vec3 param_1 = eye_pos_local;
    float param_2 = in_geom_mode;
    float param_3 = in_geom_radius;
    vec2 intersect_dist_and_discriminant = hrg_intersect(param, param_1, param_2, param_3);
    vec3 intersection_pos_local = eye_pos_local + (view_vec_local * intersect_dist_and_discriminant.x);
    intersection_pos = intersection_pos_local;
    vec2 _1123;
    if (intersect_dist_and_discriminant.y > 0.004999999888241291046142578125)
    {
        vec3 param_4 = intersection_pos_local;
        vec2 param_5 = output_aspect;
        float param_6 = in_geom_mode;
        float param_7 = in_geom_radius;
        _1123 = hrg_xyz_to_uv(param_4, param_5, param_6, param_7);
    }
    else
    {
        _1123 = vec2(1.0);
    }
    return _1123;
}

mat3 hrg_get_pixel_to_object_matrix(mat3 global_to_local, vec3 eye_pos_local, vec3 view_vec_global, vec3 intersection_pos_local, vec3 normal, vec2 output_pixel_size)
{
    vec3 pos = intersection_pos_local;
    vec3 eye_pos = eye_pos_local;
    vec3 view_vec_right_global = view_vec_global + vec3(output_pixel_size.x, 0.0, 0.0);
    vec3 view_vec_down_global = view_vec_global + vec3(0.0, -output_pixel_size.y, 0.0);
    vec3 view_vec_right_local = view_vec_right_global * global_to_local;
    vec3 view_vec_down_local = view_vec_down_global * global_to_local;
    vec3 intersection_vec_dot_normal = vec3(dot(pos - eye_pos, normal));
    vec3 right_pos = eye_pos + ((intersection_vec_dot_normal / vec3(dot(view_vec_right_local, normal))) * view_vec_right_local);
    vec3 down_pos = eye_pos + ((intersection_vec_dot_normal / vec3(dot(view_vec_down_local, normal))) * view_vec_down_local);
    vec3 object_right_vec = right_pos - pos;
    vec3 object_down_vec = down_pos - pos;
    mat3 pixel_to_object = mat3(vec3(object_right_vec.x, object_down_vec.x, 0.0), vec3(object_right_vec.y, object_down_vec.y, 0.0), vec3(object_right_vec.z, object_down_vec.z, 0.0));
    return pixel_to_object;
}

mat3 hrg_get_object_to_tangent_matrix(vec3 intersection_pos_local, vec3 normal, vec2 output_aspect, float in_geom_mode)
{
    vec3 pos = intersection_pos_local;
    vec3 x_vec = vec3(1.0, 0.0, 0.0);
    vec3 y_vec = vec3(0.0, 1.0, 0.0);
    vec3 cotangent_unscaled;
    vec3 cobitangent_unscaled;
    if (in_geom_mode < 1.5)
    {
        cotangent_unscaled = normalize(cross(y_vec, pos)) * output_aspect.y;
        cobitangent_unscaled = normalize(cross(x_vec, pos)) * output_aspect.x;
    }
    else
    {
        if (in_geom_mode < 2.5)
        {
            vec3 tangent = normalize(cross(y_vec, vec3(pos.x, 0.0, pos.z))) * output_aspect.x;
            vec3 bitangent = normalize(cross(x_vec, vec3(0.0, pos.yz))) * output_aspect.y;
            cotangent_unscaled = cross(normal, bitangent);
            cobitangent_unscaled = cross(tangent, normal);
        }
        else
        {
            cotangent_unscaled = cross(y_vec, normal) * output_aspect.y;
            cobitangent_unscaled = vec3(0.0, -output_aspect.x, 0.0);
        }
    }
    vec3 computed_normal = cross(cobitangent_unscaled, cotangent_unscaled);
    float inv_determinant = inversesqrt(dot(computed_normal, computed_normal));
    vec3 cotangent = cotangent_unscaled * inv_determinant;
    vec3 cobitangent = cobitangent_unscaled * inv_determinant;
    mat3 object_to_tangent = mat3(vec3(cotangent), vec3(cobitangent), vec3(normal));
    return object_to_tangent;
}

vec2 hrg_get_curved_video_uv_coords_and_tangent_matrix(vec2 flat_video_uv, vec3 eye_pos_local, vec2 output_pixel_size, vec2 output_aspect, float in_geom_mode, float in_geom_radius, float in_geom_view_dist, mat3 global_to_local, out mat2 pixel_to_tangent_video_uv)
{
    vec2 view_uv = (flat_video_uv - vec2(0.5)) * output_aspect;
    vec3 view_vec_global = vec3(view_uv.x, -view_uv.y, -in_geom_view_dist);
    vec3 view_vec_local = view_vec_global * global_to_local;
    vec3 param = view_vec_local;
    vec3 param_1 = eye_pos_local;
    vec2 param_2 = output_aspect;
    float param_3 = in_geom_mode;
    float param_4 = in_geom_radius;
    vec3 param_5;
    vec2 _1797 = hrg_view_vec_to_uv(param, param_1, param_2, param_3, param_4, param_5);
    vec3 pos = param_5;
    vec2 centered_uv = _1797;
    vec2 video_uv = centered_uv + vec2(0.5);
    bool geom_force_correct_tangent_matrix = true;
    if (geom_force_correct_tangent_matrix)
    {
        vec3 _1810;
        if (in_geom_mode < 2.5)
        {
            _1810 = pos;
        }
        else
        {
            _1810 = vec3(pos.x, 0.0, pos.z);
        }
        vec3 normal_base = _1810;
        vec3 normal = normalize(normal_base);
        mat3 param_6 = global_to_local;
        vec3 param_7 = eye_pos_local;
        vec3 param_8 = view_vec_global;
        vec3 param_9 = pos;
        vec3 param_10 = normal;
        vec2 param_11 = output_pixel_size;
        mat3 pixel_to_object = hrg_get_pixel_to_object_matrix(param_6, param_7, param_8, param_9, param_10, param_11);
        vec3 param_12 = pos;
        vec3 param_13 = normal;
        vec2 param_14 = output_aspect;
        float param_15 = in_geom_mode;
        mat3 object_to_tangent = hrg_get_object_to_tangent_matrix(param_12, param_13, param_14, param_15);
        mat3 pixel_to_tangent3x3 = pixel_to_object * object_to_tangent;
        pixel_to_tangent_video_uv = mat2(vec2(pixel_to_tangent3x3[0].x, pixel_to_tangent3x3[0].y), vec2(pixel_to_tangent3x3[1].x, pixel_to_tangent3x3[1].y));
    }
    else
    {
        pixel_to_tangent_video_uv = mat2(vec2(output_pixel_size.x, 0.0), vec2(0.0, output_pixel_size.y));
    }
    return video_uv;
}

vec2 HRG_GetGeomCurvedCoord(vec2 in_coord, float in_geom_mode, float in_geom_radius, float in_geom_view_dist, float in_geom_tilt_angle_x, float in_geom_tilt_angle_y, float in_screen_aspect, float pin_inner_edge, vec2 in_source_size, vec2 in_output_size, out mat2 pixel_to_video_uv)
{
    vec2 output_pixel_size = vec2(1.0) / in_output_size;
    float geom_radius_scaled = in_geom_radius;
    float param = in_screen_aspect;
    vec2 output_aspect = hrg_get_aspect_vector(param);
    vec2 geom_tilt_angle = vec2(in_geom_tilt_angle_x, in_geom_tilt_angle_y);
    vec2 sin_tilt = sin(geom_tilt_angle);
    vec2 cos_tilt = cos(geom_tilt_angle);
    mat3 rot_x_matrix = mat3(vec3(1.0, 0.0, 0.0), vec3(0.0, cos_tilt.y, -sin_tilt.y), vec3(0.0, sin_tilt.y, cos_tilt.y));
    mat3 rot_y_matrix = mat3(vec3(cos_tilt.x, 0.0, sin_tilt.x), vec3(0.0, 1.0, 0.0), vec3(-sin_tilt.x, 0.0, cos_tilt.x));
    mat3 local_to_global = rot_x_matrix * rot_y_matrix;
    mat3 global_to_local = transpose(local_to_global);
    mat3 param_1 = local_to_global;
    vec2 param_2 = output_aspect;
    float param_3 = in_geom_mode;
    float param_4 = geom_radius_scaled;
    float param_5 = in_geom_view_dist;
    vec3 eye_pos_global = hrg_get_ideal_global_eye_pos(param_1, param_2, param_3, param_4, param_5);
    vec3 eye_pos_local = eye_pos_global * global_to_local;
    vec2 curved_coord;
    if (in_geom_mode > 0.5)
    {
        vec2 param_6 = in_coord;
        vec3 param_7 = eye_pos_local;
        vec2 param_8 = output_pixel_size;
        vec2 param_9 = output_aspect;
        float param_10 = in_geom_mode;
        float param_11 = geom_radius_scaled;
        float param_12 = in_geom_view_dist;
        mat3 param_13 = global_to_local;
        mat2 param_14;
        vec2 _1978 = hrg_get_curved_video_uv_coords_and_tangent_matrix(param_6, param_7, param_8, param_9, param_10, param_11, param_12, param_13, param_14);
        pixel_to_video_uv = param_14;
        vec2 ctr_curved_coord = _1978 - vec2(0.5);
        if ((in_geom_tilt_angle_x == 0.0) && (in_geom_tilt_angle_y == 0.0))
        {
            vec2 param_15 = vec2(1.0, 0.5);
            vec3 param_16 = eye_pos_local;
            vec2 param_17 = output_pixel_size;
            vec2 param_18 = output_aspect;
            float param_19 = in_geom_mode;
            float param_20 = geom_radius_scaled;
            float param_21 = in_geom_view_dist;
            mat3 param_22 = global_to_local;
            mat2 param_23;
            vec2 _2007 = hrg_get_curved_video_uv_coords_and_tangent_matrix(param_15, param_16, param_17, param_18, param_19, param_20, param_21, param_22, param_23);
            pixel_to_video_uv = param_23;
            vec2 right_edge_curved_ctr_coord = _2007 - vec2(0.5);
            vec2 param_24 = vec2(0.5, 1.0);
            vec3 param_25 = eye_pos_local;
            vec2 param_26 = output_pixel_size;
            vec2 param_27 = output_aspect;
            float param_28 = in_geom_mode;
            float param_29 = geom_radius_scaled;
            float param_30 = in_geom_view_dist;
            mat3 param_31 = global_to_local;
            mat2 param_32;
            vec2 _2029 = hrg_get_curved_video_uv_coords_and_tangent_matrix(param_24, param_25, param_26, param_27, param_28, param_29, param_30, param_31, param_32);
            pixel_to_video_uv = param_32;
            vec2 bottom_edge_curved_ctr_coord = _2029 - vec2(0.5);
            ctr_curved_coord.x = (ctr_curved_coord.x * 0.5) / right_edge_curved_ctr_coord.x;
            ctr_curved_coord.y = (ctr_curved_coord.y * 0.5) / bottom_edge_curved_ctr_coord.y;
        }
        if (pin_inner_edge == 1.0)
        {
            if (in_geom_tilt_angle_y != 0.0)
            {
                vec2 param_33 = vec2(0.5, 0.0);
                vec3 param_34 = eye_pos_local;
                vec2 param_35 = output_pixel_size;
                vec2 param_36 = output_aspect;
                float param_37 = in_geom_mode;
                float param_38 = geom_radius_scaled;
                float param_39 = in_geom_view_dist;
                mat3 param_40 = global_to_local;
                mat2 param_41;
                vec2 _2072 = hrg_get_curved_video_uv_coords_and_tangent_matrix(param_33, param_34, param_35, param_36, param_37, param_38, param_39, param_40, param_41);
                pixel_to_video_uv = param_41;
                vec2 top_edge_curved_ctr_coord = _2072;
                ctr_curved_coord.y -= top_edge_curved_ctr_coord.y;
            }
            if (in_geom_tilt_angle_x != 0.0)
            {
                vec2 param_42 = vec2(0.0, 0.5);
                vec3 param_43 = eye_pos_local;
                vec2 param_44 = output_pixel_size;
                vec2 param_45 = output_aspect;
                float param_46 = in_geom_mode;
                float param_47 = geom_radius_scaled;
                float param_48 = in_geom_view_dist;
                mat3 param_49 = global_to_local;
                mat2 param_50;
                vec2 _2101 = hrg_get_curved_video_uv_coords_and_tangent_matrix(param_42, param_43, param_44, param_45, param_46, param_47, param_48, param_49, param_50);
                pixel_to_video_uv = param_50;
                vec2 left_edge_curved_ctr_coord = _2101;
                ctr_curved_coord.x -= left_edge_curved_ctr_coord.x;
            }
        }
        curved_coord = ctr_curved_coord + vec2(0.5);
    }
    else
    {
        curved_coord = in_coord;
        pixel_to_video_uv = mat2(vec2(output_pixel_size.x, 0.0), vec2(0.0, output_pixel_size.y));
    }
    return curved_coord;
}

vec2 HSM_GetCurvatureValues(float screen_aspect)
{
    vec2 curvature_values = (screen_aspect < 1.0) ? vec2(0.039999999105930328369140625, 0.02999999932944774627685546875) : vec2(0.02999999932944774627685546875, 0.039999999105930328369140625);
    return curvature_values;
}

vec2 HSM_GetCrtPiCurvedCoord(inout vec2 in_coord, inout vec2 in_curvature)
{
    in_curvature *= 5.0;
    vec2 barrelScale = vec2(1.0) - (in_curvature * 0.23000000417232513427734375);
    in_coord -= vec2(0.5);
    float _2880;
    if (HSM_CURVATURE_MODE == 2.0)
    {
        _2880 = 0.0;
    }
    else
    {
        _2880 = in_coord.y * in_coord.y;
    }
    float rsq = (in_coord.x * in_coord.x) + _2880;
    in_coord += (in_coord * (in_curvature * rsq));
    in_coord *= barrelScale;
    in_coord += vec2(0.5);
    return in_coord;
}

vec2 HSM_Get2DCurvedCoord(vec2 in_coord, vec2 curvature_values)
{
    vec2 ctr_curved_coord = vec2(0.0);
    vec2 param = in_coord;
    vec2 param_1 = curvature_values;
    vec2 _2911 = HSM_GetCrtPiCurvedCoord(param, param_1);
    ctr_curved_coord = _2911 - vec2(0.5);
    vec2 param_2 = vec2(1.0, 0.5);
    vec2 param_3 = curvature_values;
    vec2 _2918 = HSM_GetCrtPiCurvedCoord(param_2, param_3);
    vec2 right_edge_curved_ctr_coord = _2918 - vec2(0.5);
    ctr_curved_coord.x = (ctr_curved_coord.x * 0.5) / right_edge_curved_ctr_coord.x;
    vec2 param_4 = vec2(0.5, 1.0);
    vec2 param_5 = curvature_values;
    vec2 _2932 = HSM_GetCrtPiCurvedCoord(param_4, param_5);
    vec2 bottom_edge_curved_ctr_coord = _2932 - vec2(0.5);
    ctr_curved_coord.y = (ctr_curved_coord.y * 0.5) / bottom_edge_curved_ctr_coord.y;
    return ctr_curved_coord + vec2(0.5);
}

vec2 HSM_GetCurvedCoord(vec2 in_coord, float curvature_multiplier, float screen_aspect)
{
    if (HSM_CURVATURE_MODE == CURVATURE_MODE_OFF)
    {
        return in_coord;
    }
    float epsilon = 0.00200000009499490261077880859375;
    vec2 original_size = HSM_GetRotatedNegativeCropAddedSize();
    vec2 adjusted_coord = in_coord;
    float tilt_angle_y = HSM_CURVATURE_3D_TILT_ANGLE_Y;
    float tilt_angle_x = HSM_CURVATURE_3D_TILT_ANGLE_X;
    float pin_inner_edge = 0.0;
    vec2 curved_coord = vec2(0.0);
    if (HSM_CURVATURE_MODE > CURVATURE_MODE_2D_CYLINDER)
    {
        if (HSM_USE_GEOM > 0.5)
        {
            vec2 param = in_coord;
            float param_1 = HSM_CURVATURE_3D_TILT_ANGLE_X;
            float param_2 = HSM_CURVATURE_3D_TILT_ANGLE_Y;
            float param_3 = HSM_CURVATURE_3D_RADIUS;
            float param_4 = HSM_CURVATURE_3D_VIEW_DIST;
            float param_5 = screen_aspect;
            curved_coord = HSM_GetGeomCurvedCoordRetainWidth(param, param_1, param_2, param_3, param_4, param_5);
        }
        else
        {
            float geom_radius_with_mult = HSM_CURVATURE_3D_RADIUS;
            if (HSM_CURVATURE_MODE == CURVATURE_MODE_3D_1)
            {
                geom_radius_with_mult -= 0.4000000059604644775390625;
            }
            if (HSM_CURVATURE_MODE == CURVATURE_MODE_3D_CYLINDER)
            {
                geom_radius_with_mult -= 1.0;
            }
            geom_radius_with_mult *= (1.0 / (curvature_multiplier + epsilon));
            float param_6 = screen_aspect;
            vec2 extra_curvature_mult = HSM_GetCurvatureScales(param_6);
            float geom_mode = HSM_CURVATURE_MODE - 2.0;
            vec2 param_7 = adjusted_coord;
            float param_8 = geom_mode;
            float param_9 = geom_radius_with_mult;
            float param_10 = HSM_CURVATURE_3D_VIEW_DIST;
            float param_11 = tilt_angle_x;
            float param_12 = tilt_angle_y;
            float param_13 = screen_aspect;
            float param_14 = pin_inner_edge;
            vec2 param_15 = global.SourceSize.xy;
            vec2 param_16 = global.OutputSize.xy;
            mat2 param_17;
            vec2 _3044 = HRG_GetGeomCurvedCoord(param_7, param_8, param_9, param_10, param_11, param_12, param_13, param_14, param_15, param_16, param_17);
            mat2 pixel_to_video_uv = param_17;
            curved_coord = _3044;
        }
    }
    else
    {
        float param_18 = screen_aspect;
        vec2 curvature_values = HSM_GetCurvatureValues(param_18) * curvature_multiplier;
        vec2 param_19 = adjusted_coord;
        vec2 param_20 = curvature_values;
        curved_coord = HSM_Get2DCurvedCoord(param_19, param_20);
    }
    return curved_coord;
}

vec2 HSM_GetTubeCurvedCoord(vec2 screen_coord, float curvature_scale, vec2 screen_scale, vec2 tube_scale, float screen_aspect, float apply_black_edge_offset)
{
    vec2 black_edge_scale_offset = tube_scale / screen_scale;
    vec2 tube_curved_coord = vec2(0.5);
    if (false)
    {
        vec2 curvature_values = (screen_aspect < 1.0) ? vec2(0.039999999105930328369140625, 0.02999999932944774627685546875) : vec2(0.02999999932944774627685546875, 0.039999999105930328369140625);
        curvature_values *= ((curvature_scale * 100.0) / 100.0);
        vec2 param = screen_coord;
        vec2 param_1 = curvature_values;
        tube_curved_coord = HSM_Get2DCurvedCoord(param, param_1);
    }
    else
    {
        vec2 param_2 = screen_coord;
        float param_3 = (curvature_scale * 100.0) / 100.0;
        float param_4 = screen_aspect;
        tube_curved_coord = HSM_GetCurvedCoord(param_2, param_3, param_4);
    }
    if (apply_black_edge_offset == 1.0)
    {
        vec2 param_5 = tube_curved_coord;
        vec2 param_6 = black_edge_scale_offset;
        tube_curved_coord = HSM_GetInverseScaledCoord(param_5, param_6);
    }
    return tube_curved_coord;
}

vec2 GetDefaultScreenScale()
{
    float output_aspect = global.FinalViewportSize.x / global.FinalViewportSize.y;
    vec2 out_placement_scale = vec2(1.1058499813079833984375, 0.82959997653961181640625);
    out_placement_scale.x /= output_aspect;
    return out_placement_scale;
}

vec2 GetDefaultBezelScale()
{
    float output_aspect = global.FinalViewportSize.x / global.FinalViewportSize.y;
    vec2 out_placement_scale = vec2(1.20500004291534423828125, 0.9110000133514404296875);
    out_placement_scale.x /= output_aspect;
    return out_placement_scale;
}

float HSM_GetBezelCoords(vec2 tube_diffuse_coord, vec2 tube_diffuse_scale, vec2 tube_scale, float screen_aspect, bool curve_coords_on, out vec2 bezel_outside_scale, inout vec2 bezel_outside_coord, inout vec2 bezel_outside_curved_coord, inout vec2 frame_outside_coord)
{
    float output_aspect = global.OutputSize.x / global.OutputSize.y;
    vec2 bezel_outer_pos_offset = vec2(0.0, HSM_BZL_OUTER_POSITION_Y);
    vec2 param = tube_diffuse_scale;
    float param_1 = screen_aspect;
    vec2 bezel_outer_scale_offset = HSM_GetOuterBezelScale(param, param_1);
    bezel_outside_coord = tube_diffuse_coord + bezel_outer_pos_offset;
    bezel_outside_curved_coord = bezel_outside_coord;
    if (curve_coords_on)
    {
        bool _3609 = HSM_CURVATURE_MODE > 0.0;
        bool _3617;
        if (_3609)
        {
            _3617 = (HSM_CURVATURE_3D_TILT_ANGLE_X != 0.0) || (HSM_CURVATURE_3D_TILT_ANGLE_Y != 0.0);
        }
        else
        {
            _3617 = _3609;
        }
        if (_3617)
        {
            vec2 param_2 = bezel_outside_curved_coord;
            float param_3 = 0.0;
            float param_4 = (bezel_outer_scale_offset.x * output_aspect) / bezel_outer_scale_offset.y;
            bezel_outside_curved_coord = HSM_GetCurvedCoord(param_2, param_3, param_4);
        }
    }
    vec2 black_edge_scale_offset = tube_scale / tube_diffuse_scale;
    bezel_outside_scale = (tube_diffuse_scale * black_edge_scale_offset) * bezel_outer_scale_offset;
    vec2 param_5 = bezel_outside_curved_coord;
    vec2 param_6 = black_edge_scale_offset * bezel_outer_scale_offset;
    bezel_outside_coord = HSM_GetInverseScaledCoord(param_5, param_6) + vec2(0.0, HSM_BZL_OUTER_POSITION_Y);
    vec2 param_7 = bezel_outside_curved_coord;
    vec2 param_8 = black_edge_scale_offset * bezel_outer_scale_offset;
    bezel_outside_curved_coord = HSM_GetInverseScaledCoord(param_7, param_8) + vec2(0.0, HSM_BZL_OUTER_POSITION_Y);
    frame_outside_coord = (((bezel_outside_curved_coord + vec2(0.0, HSM_FRM_OUTER_POS_Y)) - vec2(0.5)) / vec2(((HSM_FRM_THICKNESS * HSM_FRM_THICKNESS_SCALE_X) / ((tube_diffuse_scale.x / tube_diffuse_scale.y) * output_aspect)) + 1.0, HSM_FRM_THICKNESS + 1.0)) + vec2(0.5);
    if (HSM_BZL_OUTER_CURVATURE_SCALE > 0.0)
    {
        if (curve_coords_on)
        {
            vec2 param_9 = bezel_outside_curved_coord;
            float param_10 = HSM_BZL_OUTER_CURVATURE_SCALE;
            vec2 param_11 = tube_diffuse_scale;
            vec2 param_12 = tube_scale;
            float param_13 = ((bezel_outer_scale_offset.x * global.OutputSize.x) / global.OutputSize.y) / bezel_outer_scale_offset.y;
            float param_14 = 0.0;
            bezel_outside_curved_coord = HSM_GetTubeCurvedCoord(param_9, param_10, param_11, param_12, param_13, param_14);
        }
        if (curve_coords_on)
        {
            if (HSM_FRM_OUTER_CURVATURE_SCALE > 0.0)
            {
                vec2 param_15 = frame_outside_coord;
                float param_16 = HSM_BZL_OUTER_CURVATURE_SCALE * HSM_FRM_OUTER_CURVATURE_SCALE;
                vec2 param_17 = tube_diffuse_scale;
                vec2 param_18 = tube_scale;
                float param_19 = ((bezel_outer_scale_offset.x * global.OutputSize.x) / global.OutputSize.y) / bezel_outer_scale_offset.y;
                float param_20 = 0.0;
                frame_outside_coord = HSM_GetTubeCurvedCoord(param_15, param_16, param_17, param_18, param_19, param_20);
            }
        }
    }
    DEFAULT_SCREEN_SCALE = GetDefaultScreenScale();
    DEFAULT_BEZEL_SCALE = GetDefaultBezelScale();
    return 0.0;
}

vec2 HSM_GetMirrorWrappedCoord(inout vec2 in_coord)
{
    vec2 ctr_coord = in_coord - vec2(0.5);
    bool _3068 = abs(ctr_coord.x) > 0.5;
    bool _3076;
    if (!_3068)
    {
        _3076 = abs(ctr_coord.y) > 0.5;
    }
    else
    {
        _3076 = _3068;
    }
    if (_3076)
    {
        in_coord = ((ctr_coord / vec2(HSM_SCREEN_REFLECTION_SCALE)) + vec2(0.5)) + vec2(HSM_SCREEN_REFLECTION_POS_X, HSM_SCREEN_REFLECTION_POS_Y);
    }
    in_coord = mod(in_coord, vec2(2.0));
    vec2 ctr_mirror_coord = in_coord - vec2(0.5);
    float mirror_x = clamp(clamp(abs(ctr_mirror_coord.x) - 0.5, 0.0, 1.0) * 100000.0, 0.0, 1.0);
    float mirror_y = clamp(clamp(abs(ctr_mirror_coord.y) - 0.5, 0.0, 1.0) * 100000.0, 0.0, 1.0);
    ctr_mirror_coord.x -= (((mirror_x * 2.0) * sign(ctr_mirror_coord.x)) * (abs(ctr_mirror_coord.x) - 0.5));
    ctr_mirror_coord.y -= (((mirror_y * 2.0) * sign(ctr_mirror_coord.y)) * (abs(ctr_mirror_coord.y) - 0.5));
    return ctr_mirror_coord + vec2(0.5);
}

vec2 HSM_RotateCoordinate(vec2 in_coord, float rotation_on)
{
    vec2 ctr_coord = in_coord - vec2(0.5);
    ctr_coord = (ctr_coord * (1.0 - rotation_on)) + (vec2(-ctr_coord.y, ctr_coord.x) * rotation_on);
    return ctr_coord + vec2(0.5);
}

vec4 HSM_GetTexSampleFromSampleStartAndSize(sampler2D in_sampler, inout vec2 in_screen_coord, vec2 sample_start_pixel_coord, vec2 window_size)
{
    vec2 core_prepped_size = HSM_GetRotatedNegativeCropAddedSize();
    if (HSM_DUALSCREEN_MODE > 0.0)
    {
        if (HSM_FLIP_CORE_VERTICAL == (-1.0))
        {
            in_screen_coord.y = 1.0 - in_screen_coord.y;
        }
    }
    vec2 px_coord = SAMPLE_AREA_START_PIXEL_COORD + (in_screen_coord * window_size);
    vec2 sample_coord = px_coord / core_prepped_size;
    vec2 param = sample_coord;
    float param_1 = HSM_ROTATE_CORE_IMAGE;
    sample_coord = HSM_RotateCoordinate(param, param_1);
    vec4 out_color = texture(in_sampler, sample_coord);
    return out_color;
}

vec4 HSM_GetCroppedTexSample(sampler2D in_sampler, inout vec2 in_screen_coord)
{
    vec2 core_prepped_size = HSM_GetRotatedNegativeCropAddedSize();
    float param = SCREEN_ASPECT;
    if (HSM_GetUseVerticalScanlines(param) > 0.5)
    {
        in_screen_coord.x += (HSM_CORE_RES_SAMPLING_SHIFT_OPPOSITE_DIR / CROPPED_ROTATED_SIZE_WITH_RES_MULT.x);
    }
    else
    {
        in_screen_coord.y += (HSM_CORE_RES_SAMPLING_SHIFT_OPPOSITE_DIR / CROPPED_ROTATED_SIZE_WITH_RES_MULT.y);
    }
    vec2 param_1 = in_screen_coord;
    vec2 param_2 = SAMPLE_AREA_START_PIXEL_COORD;
    vec2 param_3 = CROPPED_ROTATED_SIZE;
    vec4 _3535 = HSM_GetTexSampleFromSampleStartAndSize(in_sampler, param_1, param_2, param_3);
    vec4 out_color = _3535;
    return out_color;
}

void fetch_pixel(inout vec3 c, inout vec3 b, vec2 coord, vec2 bcoord)
{
    float stepx = global.OutputSize.z;
    float stepy = global.OutputSize.w;
    float ds = 1.0;
    vec2 dx = vec2(stepx, 0.0);
    vec2 dy = vec2(0.0, stepy);
    float posx = (2.0 * coord.x) - 1.0;
    float posy = (2.0 * coord.y) - 1.0;
    if (false)
    {
        posx = sign(posx) * pow(abs(posx), 1.0499999523162841796875);
        dx *= posx;
    }
    if (false)
    {
        posy = sign(posy) * pow(abs(posy), 1.0499999523162841796875);
        dy *= posy;
    }
    vec2 rc = (dx * 1.0) + (dy * 1.0);
    vec2 gc = (dx * 0.0) + (dy * 0.0);
    vec2 bc = (dx * (-1.0)) + (dy * (-1.0));
    float r1 = texture(Source, coord + rc).x;
    float g1 = texture(Source, coord + gc).y;
    float b1 = texture(Source, coord + bc).z;
    vec3 d = vec3(r1, g1, b1);
    c = clamp(mix(c, d, vec3(ds)), vec3(0.0), vec3(1.0));
    vec2 param = bcoord + rc;
    vec4 _4620 = HSM_GetCroppedTexSample(BloomPass, param);
    r1 = _4620.x;
    vec2 param_1 = bcoord + gc;
    vec4 _4626 = HSM_GetCroppedTexSample(BloomPass, param_1);
    g1 = _4626.y;
    vec2 param_2 = bcoord + bc;
    vec4 _4632 = HSM_GetCroppedTexSample(BloomPass, param_2);
    b1 = _4632.z;
    d = vec3(r1, g1, b1);
    b = clamp(mix(b, d, vec3(ds)), vec3(0.0), vec3(1.0));
}

float SlotMask(inout vec2 pos, float m)
{
    if (true)
    {
        return 1.0;
    }
    else
    {
        float final_mask_size = 1.0;
        if (false)
        {
            final_mask_size = float((((global.FinalViewportSize.x + global.FinalViewportSize.y) / 3.0) > 1900.0) ? 2 : 1);
        }
        final_mask_size = max(1.0, floor((((1.0 - HSM_VIEWPORT_ZOOM_MASK) + (HSM_VIEWPORT_ZOOM_MASK * VIEWPORT_SCALE.y)) * final_mask_size) + 0.20000000298023223876953125));
        pos = floor(pos / vec2(final_mask_size));
        float mlen = 4.0;
        float px = fract(pos.x / mlen);
        float py = floor((fract(pos.y / 2.0) * 2.0) * 1.0);
        float slot_dark = mix(1.0, 1.0, m);
        float slot = 1.0;
        if ((py == 0.0) && (px < 0.5))
        {
            slot = slot_dark;
        }
        else
        {
            if ((py == 1.0) && (px >= 0.5))
            {
                slot = slot_dark;
            }
        }
        return slot;
    }
}

vec3 Mask(inout vec2 pos, float mx)
{
    float final_mask_size = 1.0;
    if (false)
    {
        final_mask_size = float((global.FinalViewportSize.y > 2000.0) ? 2 : 1);
    }
    final_mask_size = max(1.0, floor((((1.0 - HSM_VIEWPORT_ZOOM_MASK) + (HSM_VIEWPORT_ZOOM_MASK * VIEWPORT_SCALE.y)) * final_mask_size) + 0.20000000298023223876953125));
    vec2 pos0 = pos;
    pos.y = floor(pos.y / final_mask_size);
    float next_line = float(fract(pos.y * 0.5) > 0.25);
    float _3786;
    if (true)
    {
        _3786 = pos0.x + (next_line * 0.0);
    }
    else
    {
        _3786 = pos0.x + (pos.y * 0.0);
    }
    pos0.x = _3786;
    pos = floor(pos0 / vec2(final_mask_size));
    vec3 mask = vec3(0.5);
    vec3 one = vec3(1.0);
    float dark_compensate = mix(max(clamp(mix(1.10000002384185791015625, 0.300000011920928955078125, mx), 0.0, 1.0) - 0.4000000059604644775390625, 0.0) + 1.0, 1.0, mx);
    float mc = 0.699999988079071044921875;
    if (false)
    {
        mask = vec3(1.0);
    }
    else
    {
        if (true)
        {
            pos.x = fract(pos.x * 0.5);
            if (pos.x < 0.4900000095367431640625)
            {
                mask.x = 1.0;
                mask.y = mc;
                mask.z = 1.0;
            }
            else
            {
                mask.x = mc;
                mask.y = 1.0;
                mask.z = mc;
            }
        }
        else
        {
            if (false)
            {
                float line = 1.5;
                float odd = 0.0;
                if (fract(pos.x / 6.0) < 0.4900000095367431640625)
                {
                    odd = 1.0;
                }
                if (fract((pos.y + odd) / 2.0) < 0.4900000095367431640625)
                {
                    line = 0.5;
                }
                pos.x = fract(pos.x / 3.0);
                if (pos.x < 0.300000011920928955078125)
                {
                    mask.x = 1.5;
                }
                else
                {
                    if (pos.x < 0.60000002384185791015625)
                    {
                        mask.y = 1.5;
                    }
                    else
                    {
                        mask.z = 1.5;
                    }
                }
                mask *= line;
            }
            else
            {
                if (false)
                {
                    pos.x = fract(pos.x / 3.0);
                    if (pos.x < 0.300000011920928955078125)
                    {
                        mask.x = 1.5;
                    }
                    else
                    {
                        if (pos.x < 0.60000002384185791015625)
                        {
                            mask.y = 1.5;
                        }
                        else
                        {
                            mask.z = 1.5;
                        }
                    }
                }
                else
                {
                    if (false)
                    {
                        pos.x += (pos.y * 3.0);
                        pos.x = fract(pos.x / 6.0);
                        if (pos.x < 0.300000011920928955078125)
                        {
                            mask.x = 1.5;
                        }
                        else
                        {
                            if (pos.x < 0.60000002384185791015625)
                            {
                                mask.y = 1.5;
                            }
                            else
                            {
                                mask.z = 1.5;
                            }
                        }
                    }
                    else
                    {
                        if (false)
                        {
                            pos = floor(pos * vec2(1.0, 0.5));
                            pos.x += (pos.y * 3.0);
                            pos.x = fract(pos.x / 6.0);
                            if (pos.x < 0.300000011920928955078125)
                            {
                                mask.x = 1.5;
                            }
                            else
                            {
                                if (pos.x < 0.60000002384185791015625)
                                {
                                    mask.y = 1.5;
                                }
                                else
                                {
                                    mask.z = 1.5;
                                }
                            }
                        }
                        else
                        {
                            if (false)
                            {
                                mask = vec3(0.0);
                                pos.x = fract(pos.x / 2.0);
                                if (pos.x < 0.4900000095367431640625)
                                {
                                    mask.x = 1.0;
                                    mask.z = 1.0;
                                }
                                else
                                {
                                    mask.y = 1.0;
                                }
                                mask = clamp(mix(mix(one, mask, vec3(1.10000002384185791015625)), mix(one, mask, vec3(0.300000011920928955078125)), vec3(mx)), vec3(0.0), vec3(1.0)) * dark_compensate;
                            }
                            else
                            {
                                if (false)
                                {
                                    mask = vec3(0.0);
                                    pos.x = fract(pos.x / 3.0);
                                    if (pos.x < 0.300000011920928955078125)
                                    {
                                        mask.x = 1.0;
                                    }
                                    else
                                    {
                                        if (pos.x < 0.60000002384185791015625)
                                        {
                                            mask.y = 1.0;
                                        }
                                        else
                                        {
                                            mask.z = 1.0;
                                        }
                                    }
                                    mask = clamp(mix(mix(one, mask, vec3(1.10000002384185791015625)), mix(one, mask, vec3(0.300000011920928955078125)), vec3(mx)), vec3(0.0), vec3(1.0)) * dark_compensate;
                                }
                                else
                                {
                                    if (false)
                                    {
                                        mask = vec3(0.0);
                                        pos.x = fract(pos.x / 2.0);
                                        if (pos.x < 0.4900000095367431640625)
                                        {
                                            mask = vec3(0.0);
                                        }
                                        else
                                        {
                                            mask = vec3(1.0);
                                        }
                                        mask = clamp(mix(mix(one, mask, vec3(1.10000002384185791015625)), mix(one, mask, vec3(0.300000011920928955078125)), vec3(mx)), vec3(0.0), vec3(1.0)) * dark_compensate;
                                    }
                                    else
                                    {
                                        if (false)
                                        {
                                            mask = vec3(0.0);
                                            pos.x = fract(pos.x / 3.0);
                                            if (pos.x < 0.300000011920928955078125)
                                            {
                                                mask = vec3(0.0);
                                            }
                                            else
                                            {
                                                if (pos.x < 0.60000002384185791015625)
                                                {
                                                    mask = vec3(1.0);
                                                }
                                                else
                                                {
                                                    mask = vec3(1.0);
                                                }
                                            }
                                            mask = clamp(mix(mix(one, mask, vec3(1.10000002384185791015625)), mix(one, mask, vec3(0.300000011920928955078125)), vec3(mx)), vec3(0.0), vec3(1.0)) * dark_compensate;
                                        }
                                        else
                                        {
                                            if (false)
                                            {
                                                mask = vec3(0.0);
                                                pos.x = fract(pos.x / 3.0);
                                                if (pos.x < 0.300000011920928955078125)
                                                {
                                                    mask = vec3(0.0);
                                                }
                                                else
                                                {
                                                    if (pos.x < 0.60000002384185791015625)
                                                    {
                                                        mask.x = 1.0;
                                                        mask.z = 1.0;
                                                    }
                                                    else
                                                    {
                                                        mask.y = 1.0;
                                                    }
                                                }
                                                mask = clamp(mix(mix(one, mask, vec3(1.10000002384185791015625)), mix(one, mask, vec3(0.300000011920928955078125)), vec3(mx)), vec3(0.0), vec3(1.0)) * dark_compensate;
                                            }
                                            else
                                            {
                                                if (false)
                                                {
                                                    mask = vec3(0.0);
                                                    pos.x = fract(pos.x * 0.25);
                                                    if (pos.x < 0.20000000298023223876953125)
                                                    {
                                                        mask = vec3(0.0);
                                                    }
                                                    else
                                                    {
                                                        if (pos.x < 0.4000000059604644775390625)
                                                        {
                                                            mask.x = 1.0;
                                                        }
                                                        else
                                                        {
                                                            if (pos.x < 0.699999988079071044921875)
                                                            {
                                                                mask.y = 1.0;
                                                            }
                                                            else
                                                            {
                                                                mask.z = 1.0;
                                                            }
                                                        }
                                                    }
                                                    mask = clamp(mix(mix(one, mask, vec3(1.10000002384185791015625)), mix(one, mask, vec3(0.300000011920928955078125)), vec3(mx)), vec3(0.0), vec3(1.0)) * dark_compensate;
                                                }
                                                else
                                                {
                                                    if (false)
                                                    {
                                                        mask = vec3(0.0);
                                                        pos.x = fract(pos.x * 0.25);
                                                        if (pos.x < 0.20000000298023223876953125)
                                                        {
                                                            mask.x = 1.0;
                                                        }
                                                        else
                                                        {
                                                            if (pos.x < 0.4000000059604644775390625)
                                                            {
                                                                mask.x = 1.0;
                                                                mask.y = 1.0;
                                                            }
                                                            else
                                                            {
                                                                if (pos.x < 0.699999988079071044921875)
                                                                {
                                                                    mask.y = 1.0;
                                                                    mask.z = 1.0;
                                                                }
                                                                else
                                                                {
                                                                    mask.z = 1.0;
                                                                }
                                                            }
                                                        }
                                                        mask = clamp(mix(mix(one, mask, vec3(1.10000002384185791015625)), mix(one, mask, vec3(0.300000011920928955078125)), vec3(mx)), vec3(0.0), vec3(1.0)) * dark_compensate;
                                                    }
                                                    else
                                                    {
                                                        mask = vec3(0.0);
                                                        pos.x = floor(mod(pos.x, 7.0));
                                                        if (pos.x < 1.0)
                                                        {
                                                            mask = vec3(0.0);
                                                        }
                                                        else
                                                        {
                                                            if (pos.x < 3.0)
                                                            {
                                                                mask.x = 1.0;
                                                            }
                                                            else
                                                            {
                                                                if (pos.x < 5.0)
                                                                {
                                                                    mask.y = 1.0;
                                                                }
                                                                else
                                                                {
                                                                    mask.z = 1.0;
                                                                }
                                                            }
                                                        }
                                                        mask = clamp(mix(mix(one, mask, vec3(1.10000002384185791015625)), mix(one, mask, vec3(0.300000011920928955078125)), vec3(mx)), vec3(0.0), vec3(1.0)) * dark_compensate;
                                                    }
                                                }
                                            }
                                        }
                                    }
                                }
                            }
                        }
                    }
                }
            }
        }
    }
    return mask;
}

vec3 plant(vec3 tar, float r)
{
    float t = max(max(tar.x, tar.y), tar.z) + 9.9999997473787516355514526367188e-06;
    return (tar * r) / vec3(t);
}

vec3 declip(inout vec3 c, float b)
{
    float m = max(max(c.x, c.y), c.z);
    if (m > b)
    {
        c = (c * b) / vec3(m);
    }
    return c;
}

vec3 _noise(inout vec3 v)
{
    if (false)
    {
        v.z = -0.20000000298023223876953125;
    }
    else
    {
        v.z = mod(v.z, 6001.0) / 1753.0;
    }
    v = (fract(v) + fract(v * 10000.0)) + fract(v * 9.9999997473787516355514526367188e-05);
    v += vec3(0.123450003564357757568359375, 0.6789000034332275390625, 0.3141590058803558349609375);
    v = fract((v * dot(v, v)) * 123.45600128173828125);
    v = fract((v * dot(v, v)) * 123.45600128173828125);
    v = fract((v * dot(v, v)) * 123.45600128173828125);
    v = fract((v * dot(v, v)) * 123.45600128173828125);
    return v;
}

float humbar(inout float pos)
{
    if (true)
    {
        return 1.0;
    }
    else
    {
        float _4380;
        if (true)
        {
            _4380 = pos;
        }
        else
        {
            _4380 = 1.0 - pos;
        }
        pos = _4380;
        pos = fract(pos + (mod(float(global.FrameCount), 50.0) / 49.0));
        float _4400;
        if (false)
        {
            _4400 = pos;
        }
        else
        {
            _4400 = 1.0 - pos;
        }
        pos = _4400;
        return 1.0 + (0.0 * pos);
    }
}

void main()
{
    NEGATIVE_CROP_EXPAND_MULTIPLIER = 0.5;
    MAX_NEGATIVE_CROP = 0.5;
    DEFAULT_SCREEN_ASPECT = 1.3329918384552001953125;
    DEFAULT_BEZEL_ASPECT = 1.32272231578826904296875;
    DEFAULT_SCREEN_SCALE = vec2(0.0);
    DEFAULT_BEZEL_SCALE = vec2(0.0);
    INFOCACHE_MAX_INDEX = 4;
    BLEND_MODE_OFF = 0.0;
    BLEND_MODE_NORMAL = 1.0;
    BLEND_MODE_ADD = 2.0;
    BLEND_MODE_MULTIPLY = 3.0;
    SOURCE_MATTE_PREMULTIPLIED = 0.0;
    SOURCE_MATTE_WHITE = 1.0;
    SOURCE_MATTE_NONE = 2.0;
    IMAGE_ASPECT_MODE_INHERIT_ASPECT_SCALE = 0.0;
    IMAGE_ASPECT_MODE_KEEP_ASPECT = 1.0;
    FILL_MODE_STRETCH = 0.0;
    FILL_MODE_SPLIT_FILL_HORIZONTAL = 1.0;
    FILL_MODE_SPLIT_FILL_VERTICAL = 2.0;
    CACHE_INFO_PARAM_SUM_CHANGED = false;
    CURRENT_FRAME_FROM_CACHE_INFO = 0.0;
    TUBE_DIFFUSE_MASK = 0.0;
    TUBE_MASK = 0.0;
    BEZEL_MASK = 0.0;
    INSIDE_BEZEL_MASK = 0.0;
    OUTSIDE_TUBE_MASK_FOR_IMAGE = 0.0;
    FRAME_MASK = 0.0;
    FRAME_MASK_FOR_IMAGE = 0.0;
    OUTSIDE_BEZEL_MASK = 0.0;
    OUTSIDE_FRAME_MASK_FOR_IMAGE = 0.0;
    OUTSIDE_FRAME_MASK = 0.0;
    CUTOUT_MASK = 0.0;
    SCREEN_INDEX = 1.0;
    SCREEN_ASPECT = 1.0;
    SCREEN_SCALE = vec2(1.0);
    SCREEN_POS_OFFSET = vec2(0.1500000059604644775390625);
    SCREEN_SCALE_2ND_SCREEN = vec2(1.0);
    SCREEN_POS_OFFSET_2ND_SCREEN = vec2(0.1500000059604644775390625);
    VIEWPORT_SCALE = vec2(1.0);
    VIEWPORT_POS = vec2(1.0);
    TUBE_SCALE = vec2(1.0);
    TUBE_DIFFUSE_SCALE = vec2(1.0);
    TUBE_DIFFUSE_ASPECT = 1.0;
    FRAME_SCALE = vec2(1.0);
    BEZEL_OUTSIDE_SCALE = vec2(0.5);
    BACKGROUND_SCALE = vec2(0.5);
    LED_SCALE = vec2(0.5);
    DEVICE_SCALE = vec2(0.5);
    DECAL_SCALE = vec2(0.5);
    CAB_GLASS_SCALE = vec2(0.5);
    TOP_IMAGE_SCALE = vec2(0.5);
    AVERAGE_LUMA = 0.0;
    USE_VERTICAL_SCANLINES = 0.0;
    CORE_SIZE = vec2(1.0);
    ROTATED_CORE_ORIGINAL_SIZE = vec2(1.0);
    ROTATED_CORE_PREPPED_SIZE = vec2(1.0);
    ROTATED_DEREZED_SIZE = vec2(1.0);
    CROPPED_ROTATED_SIZE_WITH_RES_MULT = vec2(1.0);
    CROPPED_ROTATED_SIZE_WITH_RES_MULT_FEEDBACK = vec2(1.0);
    CROPPED_ROTATED_SIZE = vec2(1.0);
    SAMPLE_AREA_START_PIXEL_COORD = vec2(1.0);
    VIEWPORT_UNSCALED_COORD = vec2(0.5);
    SCREEN_COORD = vec2(0.5);
    TUBE_COORD = vec2(0.5);
    TUBE_DIFFUSE_COORD = vec2(0.5);
    BEZEL_OUTSIDE_COORD = vec2(0.5);
    BACKGROUND_COORD = vec2(0.5);
    DEVICE_COORD = vec2(0.5);
    LED_COORD = vec2(0.5);
    DECAL_COORD = vec2(0.5);
    CAB_GLASS_COORD = vec2(0.5);
    TOP_IMAGE_COORD = vec2(0.5);
    SCREEN_CURVED_COORD = vec2(0.5);
    TUBE_CURVED_COORD = vec2(0.5);
    TUBE_DIFFUSE_CURVED_COORD = vec2(0.5);
    BEZEL_OUTSIDE_CURVED_COORD = vec2(0.5);
    FRAME_OUTSIDE_CURVED_COORD = vec2(0.5);
    BACKGROUND_CURVED_COORD = vec2(0.5);
    LED_CURVED_COORD = vec2(0.5);
    DEVICE_CURVED_COORD = vec2(0.5);
    DECAL_CURVED_COORD = vec2(0.5);
    CAB_GLASS_CURVED_COORD = vec2(0.5);
    TOP_IMAGE_CURVED_COORD = vec2(0.5);
    HSM_RESOLUTION_DEBUG_ON = 0.0;
    HSM_CACHE_GRAPHICS_ON = 1.0;
    HSM_CACHE_UPDATE_INDICATOR_MODE = 2.0;
    HSM_GLOBAL_GRAPHICS_BRIGHTNESS = 1.0;
    HSM_STATIC_LAYERS_GAMMA = 1.0;
    HSM_AMBIENT_LIGHTING_OPACITY = 0.0;
    HSM_AMBIENT2_LIGHTING_OPACITY = 0.0;
    HSM_AMBIENT_LIGHTING_SWAP_IMAGES = 0.0;
    HSM_VIEWPORT_ZOOM = 1.0;
    HSM_VIEWPORT_ZOOM_MASK = 0.0;
    HSM_VIEWPORT_POSITION_X = -0.0;
    HSM_VIEWPORT_POSITION_Y = -0.0;
    HSM_FLIP_VIEWPORT_VERTICAL = 1.0;
    HSM_FLIP_VIEWPORT_HORIZONTAL = 1.0;
    HSM_FLIP_CORE_VERTICAL = 1.0;
    HSM_FLIP_CORE_HORIZONTAL = 1.0;
    HSM_ROTATE_CORE_IMAGE = 0.0;
    HSM_ASPECT_RATIO_ORIENTATION = 0.0;
    HSM_ASPECT_RATIO_MODE = 0.0;
    HSM_ASPECT_RATIO_EXPLICIT = 1.33329999446868896484375;
    HSM_VERTICAL_PRESET = 0.0;
    HSM_INT_SCALE_MAX_HEIGHT = 0.88999998569488525390625;
    HSM_NON_INTEGER_SCALE = 0.829699993133544921875;
    HSM_USE_PHYSICAL_SIZE_FOR_NON_INTEGER = 0.0;
    HSM_PHYSICAL_MONITOR_ASPECT_RATIO = 1.769999980926513671875;
    HSM_PHYSICAL_MONITOR_DIAGONAL_SIZE = 27.0;
    HSM_PHYSICAL_SIM_TUBE_DIAGONAL_SIZE = 18.1000003814697265625;
    HSM_USE_IMAGE_FOR_PLACEMENT = 0.0;
    HSM_PLACEMENT_IMAGE_USE_HORIZONTAL = 0.0;
    HSM_PLACEMENT_IMAGE_MODE = 0.0;
    HSM_NON_INTEGER_SCALE_OFFSET = 1.0;
    HSM_USE_SNAP_TO_CLOSEST_INT_SCALE = 0.0;
    HSM_SNAP_TO_CLOSEST_INT_SCALE_TOLERANCE = (HSM_USE_SNAP_TO_CLOSEST_INT_SCALE > 0.5) ? 0.20000000298023223876953125 : 0.0;
    HSM_SCREEN_POSITION_X = 0.0;
    HSM_SCREEN_POSITION_Y = -0.0;
    HSM_CROP_MODE = 2.0;
    HSM_CROP_PERCENT_ZOOM = 0.0;
    HSM_CROP_PERCENT_TOP = 0.0;
    HSM_CROP_PERCENT_BOTTOM = 0.0;
    HSM_CROP_PERCENT_LEFT = 0.0;
    HSM_CROP_PERCENT_RIGHT = 0.0;
    HSM_CROP_BLACK_THRESHOLD = 0.0;
    HSM_SCANLINE_DIRECTION = 0.0;
    HSM_CORE_RES_SAMPLING_MULT_SCANLINE_DIR = 1.0;
    HSM_DOWNSAMPLE_BLUR_SCANLINE_DIR = 0.0;
    HSM_CORE_RES_SAMPLING_MULT_OPPOSITE_DIR = 1.0;
    HSM_DOWNSAMPLE_BLUR_OPPOSITE_DIR = 0.0;
    HSM_CORE_RES_SAMPLING_SHIFT_OPPOSITE_DIR = 0.0;
    HSM_USE_GEOM = 0.0;
    HSM_CURVATURE_MODE = 1.0;
    HSM_CURVATURE_3D_RADIUS = 2.0;
    HSM_CURVATURE_3D_VIEW_DIST = 1.5;
    HSM_CURVATURE_3D_TILT_ANGLE_X = 0.0;
    HSM_CURVATURE_3D_TILT_ANGLE_Y = 0.0;
    HSM_CRT_CURVATURE_SCALE = 1.0;
    HSM_AB_COMPARE_SHOW_MODE = 0.0;
    HSM_AB_COMPARE_AREA = 0.0;
    HSM_AB_COMPARE_SPLIT_POSITION = 0.5;
    HSM_AB_COMPARE_FREEZE_CRT_TUBE = 0.0;
    HSM_AB_COMPARE_FREEZE_GRAPHICS = 0.0;
    HSM_SCREEN_VIGNETTE_DUALSCREEN_VIS_MODE = 0.0;
    HSM_MONOCHROME_DUALSCREEN_VIS_MODE = 0.0;
    HSM_TUBE_DIFFUSE_MODE = 0.0;
    HSM_TUBE_DIFFUSE_OPACITY = 1.0;
    HSM_TUBE_DIFFUSE_IMAGE_DUALSCREEN_VIS_MODE = 0.0;
    HSM_TUBE_DIFFUSE_IMAGE_COLORIZE_ON = 0.0;
    HSM_TUBE_DIFFUSE_IMAGE_HUE = 0.0;
    HSM_TUBE_DIFFUSE_IMAGE_SATURATION = 1.0;
    HSM_TUBE_DIFFUSE_IMAGE_BRIGHTNESS = 0.20000000298023223876953125;
    HSM_TUBE_DIFFUSE_IMAGE_GAMMA = 1.0;
    HSM_TUBE_DIFFUSE_IMAGE_AMBIENT_LIGHTING = 1.0;
    HSM_TUBE_DIFFUSE_IMAGE_AMBIENT2_LIGHTING = 0.0;
    HSM_TUBE_DIFFUSE_IMAGE_SCALE = 1.2000000476837158203125;
    HSM_TUBE_DIFFUSE_IMAGE_SCALE_X = 1.0;
    HSM_TUBE_SHADOW_IMAGE_ON = 1.0;
    HSM_TUBE_SHADOW_IMAGE_OPACITY = 0.60000002384185791015625;
    HSM_TUBE_SHADOW_IMAGE_POS_X = 0.0;
    HSM_TUBE_SHADOW_IMAGE_POS_Y = 0.0900000035762786865234375;
    HSM_TUBE_SHADOW_IMAGE_SCALE_X = 1.2200000286102294921875;
    HSM_TUBE_SHADOW_IMAGE_SCALE_Y = 1.2999999523162841796875;
    HSM_TUBE_SHADOW_CURVATURE_SCALE = 3.0;
    HSM_TUBE_COLORED_GEL_IMAGE_ON = 0.0;
    HSM_TUBE_COLORED_GEL_IMAGE_SCALE = 1.0;
    HSM_TUBE_COLORED_GEL_IMAGE_FLIP_HORIZONTAL = 1.0;
    HSM_TUBE_COLORED_GEL_IMAGE_FLIP_VERTICAL = 1.0;
    HSM_TUBE_COLORED_GEL_IMAGE_DUALSCREEN_VIS_MODE = 0.0;
    HSM_TUBE_COLORED_GEL_IMAGE_MULTIPLY_AMOUNT = 0.89999997615814208984375;
    HSM_TUBE_COLORED_GEL_IMAGE_ADDITIVE_AMOUNT = 0.0;
    HSM_TUBE_COLORED_GEL_IMAGE_NORMAL_AMOUNT = 0.1500000059604644775390625;
    HSM_TUBE_COLORED_GEL_IMAGE_TRANSPARENCY_THRESHOLD = 0.23000000417232513427734375;
    HSM_TUBE_COLORED_GEL_IMAGE_NORMAL_BRIGHTNESS = 1.0;
    HSM_TUBE_COLORED_GEL_IMAGE_NORMAL_VIGNETTE = 0.0;
    HSM_TUBE_COLORED_GEL_IMAGE_FAKE_SCANLINE_AMOUNT = 0.0;
    HSM_TUBE_COLORED_GEL_IMAGE_AMBIENT_LIGHTING = 1.0;
    HSM_TUBE_COLORED_GEL_IMAGE_AMBIENT2_LIGHTING = 0.0;
    HSM_SHOW_CRT_ON_TOP_OF_COLORED_GEL = 0.0;
    HSM_TUBE_STATIC_REFLECTION_IMAGE_ON = 0.0;
    HSM_TUBE_STATIC_REFLECTION_IMAGE_DUALSCREEN_VIS_MODE = 0.0;
    HSM_TUBE_STATIC_REFLECTION_IMAGE_OPACITY = 0.100000001490116119384765625;
    HSM_TUBE_STATIC_REFLECTION_IMAGE_AMBIENT_LIGHTING = 1.0;
    HSM_TUBE_STATIC_REFLECTION_IMAGE_AMBIENT2_LIGHTING = 0.0;
    HSM_TUBE_STATIC_REFLECTION_IMAGE_SCALE = 1.10000002384185791015625;
    HSM_TUBE_STATIC_REFLECTION_IMAGE_SHADOW_OPACITY = 0.4000000059604644775390625;
    HSM_DUALSCREEN_MODE = 0.0;
    HSM_DUALSCREEN_CORE_IMAGE_SPLIT_MODE = 1.0;
    HSM_DUALSCREEN_CORE_IMAGE_SWAP_SCREENS = 0.0;
    HSM_DUALSCREEN_CORE_IMAGE_SPLIT_OFFSET = 0.0;
    HSM_DUALSCREEN_VIEWPORT_SPLIT_LOCATION = 0.0;
    HSM_DUALSCREEN_SHIFT_POSITION_WITH_SCALE = 1.0;
    HSM_DUALSCREEN_POSITION_OFFSET_BETWEEN_SCREENS = 0.0;
    HSM_2ND_SCREEN_ASPECT_RATIO_MODE = 0.0;
    HSM_2ND_SCREEN_INDEPENDENT_SCALE = 0.0;
    HSM_2ND_SCREEN_SCALE_OFFSET = 1.0;
    HSM_2ND_SCREEN_POS_X = 0.0;
    HSM_2ND_SCREEN_POS_Y = 0.0;
    HSM_2ND_SCREEN_CROP_PERCENT_ZOOM = 0.0;
    HSM_2ND_SCREEN_CROP_PERCENT_TOP = 0.0;
    HSM_2ND_SCREEN_CROP_PERCENT_BOTTOM = 0.0;
    HSM_2ND_SCREEN_CROP_PERCENT_LEFT = 0.0;
    HSM_2ND_SCREEN_CROP_PERCENT_RIGHT = 0.0;
    HSM_SCREEN_REFLECTION_SCALE = 1.0;
    HSM_SCREEN_REFLECTION_POS_X = 0.0;
    HSM_SCREEN_REFLECTION_POS_Y = 0.0;
    HSM_AMBIENT_LIGHTING_HUE = 0.0;
    HSM_AMBIENT_LIGHTING_SATURATION = 1.0;
    HSM_AMBIENT_LIGHTING_VALUE = 1.0;
    HSM_AMBIENT_LIGHTING_CONTRAST = 1.0;
    HSM_AMBIENT_LIGHTING_SCALE_KEEP_ASPECT = 0.0;
    HSM_AMBIENT_LIGHTING_SCALE_WITH_ZOOM = 1.0;
    HSM_AMBIENT_LIGHTING_SCALE = 1.0;
    HSM_AMBIENT_LIGHTING_SCALE_X = 1.0;
    HSM_AMBIENT_LIGHTING_ROTATE = 0.0;
    HSM_AMBIENT_LIGHTING_MIRROR_HORZ = 0.0;
    HSM_AMBIENT_LIGHTING_POSITION_X = 0.0;
    HSM_AMBIENT_LIGHTING_POSITION_Y = -0.0;
    HSM_AMBIENT_LIGHTING_DITHERING_SAMPLES = 0.0;
    HSM_AMBIENT2_LIGHTING_HUE = 0.0;
    HSM_AMBIENT2_LIGHTING_SATURATION = 1.0;
    HSM_AMBIENT2_LIGHTING_VALUE = 2.0;
    HSM_AMBIENT2_LIGHTING_CONTRAST = 1.0;
    HSM_AMBIENT2_LIGHTING_SCALE_KEEP_ASPECT = 1.0;
    HSM_AMBIENT2_LIGHTING_SCALE_WITH_ZOOM = 1.0;
    HSM_AMBIENT2_LIGHTING_SCALE = 1.0;
    HSM_AMBIENT2_LIGHTING_SCALE_X = 1.0;
    HSM_AMBIENT2_LIGHTING_ROTATE = 0.0;
    HSM_AMBIENT2_LIGHTING_MIRROR_HORZ = 0.0;
    HSM_AMBIENT2_LIGHTING_POSITION_X = 0.0;
    HSM_AMBIENT2_LIGHTING_POSITION_Y = -0.0;
    HSM_BZL_OPACITY = 1.0;
    HSM_BZL_BLEND_MODE = 1.0;
    HSM_BZL_WIDTH = 0.107799999415874481201171875;
    HSM_BZL_HEIGHT = 0.0873199999332427978515625;
    HSM_BZL_INNER_CORNER_RADIUS_SCALE = 0.800000011920928955078125;
    CURVATURE_MODE_OFF = 0.0;
    CURVATURE_MODE_2D = 1.0;
    CURVATURE_MODE_2D_CYLINDER = 2.0;
    CURVATURE_MODE_3D_1 = 3.0;
    CURVATURE_MODE_3D_2 = 4.0;
    CURVATURE_MODE_3D_CYLINDER = 5.0;
    HSM_BZL_INNER_EDGE_THICKNESS = 0.0076999999582767486572265625;
    HSM_BZL_INNER_EDGE_SHARPNESS = 0.949999988079071044921875;
    HSM_BZL_OUTER_POSITION_Y = 0.0;
    HSM_BZL_OUTER_CURVATURE_SCALE = 0.0;
    HSM_BZL_OUTER_CORNER_RADIUS_SCALE = 0.540000021457672119140625;
    HSM_BZL_BRIGHTNESS = 0.300000011920928955078125;
    HSM_BZL_HIGHLIGHT = 0.00999999977648258209228515625;
    HSM_BZL_NOISE = 0.300000011920928955078125;
    HSM_BZL_INNER_EDGE_SHADOW = 0.699999988079071044921875;
    HSM_BZL_COLOR_HUE = 0.0;
    HSM_BZL_COLOR_SATURATION = 0.0;
    HSM_BZL_COLOR_VALUE = 0.100000001490116119384765625;
    HSM_BZL_AMBIENT_LIGHTING_MULTIPLIER = 1.0;
    HSM_BZL_AMBIENT2_LIGHTING_MULTIPLIER = 0.0;
    HSM_FRM_USE_INDEPENDENT_COLOR = 0.0;
    HSM_FRM_COLOR_HUE = 0.0;
    HSM_FRM_COLOR_SATURATION = 0.0;
    HSM_FRM_COLOR_VALUE = 0.100000001490116119384765625;
    HSM_FRM_OPACITY = 1.0;
    HSM_FRM_BLEND_MODE = 1.0;
    HSM_FRM_TEXTURE_OPACITY = 0.014999999664723873138427734375;
    HSM_FRM_TEXTURE_BLEND_MODE = 2.0;
    HSM_FRM_NOISE = 0.300000011920928955078125;
    HSM_FRM_INNER_EDGE_THICKNESS = 0.0030000000260770320892333984375;
    HSM_FRM_THICKNESS = 0.070000000298023223876953125;
    HSM_FRM_THICKNESS_SCALE_X = 1.0;
    HSM_FRM_OUTER_POS_Y = 0.0;
    HSM_FRM_OUTER_CURVATURE_SCALE = 0.0;
    HSM_FRM_OUTER_CORNER_RADIUS = 5.0;
    HSM_FRM_OUTER_EDGE_THICKNESS = 0.006000000052154064178466796875;
    HSM_FRM_OUTER_EDGE_SHADING = 0.5;
    HSM_FRM_SHADOW_OPACITY = 1.0;
    HSM_FRM_SHADOW_WIDTH = 0.100000001490116119384765625;
    HSM_REFLECT_CORNER_FADE = 0.100000001490116119384765625;
    HSM_REFLECT_CORNER_FADE_DISTANCE = 1.0;
    HSM_REFLECT_CORNER_INNER_SPREAD = 5.0;
    HSM_REFLECT_CORNER_OUTER_SPREAD = 1.60000002384185791015625;
    HSM_REFLECT_CORNER_ROTATION_OFFSET_TOP = 0.0;
    HSM_REFLECT_CORNER_ROTATION_OFFSET_BOTTOM = 0.0;
    HSM_REFLECT_CORNER_SPREAD_FALLOFF = 100.0;
    MAX_LAYER_ORDER = 12.0;
    vec2 param = vTexCoord;
    vec2 viewportCoordTransformed = HSM_GetViewportCoordWithZoomAndPan(param);
    vec2 param_1 = vTexCoord;
    vec4 _4656 = HSM_UpdateGlobalScreenValuesFromCache(InfoCachePass, InfoCachePassFeedback, param_1);
    vec2 SourceSize = CROPPED_ROTATED_SIZE_WITH_RES_MULT;
    float TATE = USE_VERTICAL_SCANLINES;
    vec2 cache_bounds_coord = SCREEN_COORD;
    vec2 param_2 = TUBE_DIFFUSE_COORD;
    vec2 param_3 = TUBE_DIFFUSE_SCALE;
    vec2 param_4 = TUBE_SCALE;
    float param_5 = SCREEN_ASPECT;
    bool param_6 = false;
    vec2 param_7 = BEZEL_OUTSIDE_SCALE;
    vec2 param_8 = BEZEL_OUTSIDE_COORD;
    vec2 param_9 = BEZEL_OUTSIDE_CURVED_COORD;
    vec2 param_10 = FRAME_OUTSIDE_CURVED_COORD;
    float _4680 = HSM_GetBezelCoords(param_2, param_3, param_4, param_5, param_6, param_7, param_8, param_9, param_10);
    BEZEL_OUTSIDE_SCALE = param_7;
    BEZEL_OUTSIDE_COORD = param_8;
    BEZEL_OUTSIDE_CURVED_COORD = param_9;
    FRAME_OUTSIDE_CURVED_COORD = param_10;
    cache_bounds_coord = ((FRAME_OUTSIDE_CURVED_COORD - vec2(0.5)) * 0.89999997615814208984375) + vec2(0.5);
    bool _4694 = cache_bounds_coord.x < (-0.00999999977648258209228515625);
    bool _4702;
    if (!_4694)
    {
        _4702 = cache_bounds_coord.x > 1.0099999904632568359375;
    }
    else
    {
        _4702 = _4694;
    }
    bool _4709;
    if (!_4702)
    {
        _4709 = cache_bounds_coord.y < (-0.00999999977648258209228515625);
    }
    else
    {
        _4709 = _4702;
    }
    bool _4716;
    if (!_4709)
    {
        _4716 = cache_bounds_coord.y > 1.0099999904632568359375;
    }
    else
    {
        _4716 = _4709;
    }
    if (_4716)
    {
        FragColor = vec4(0.0);
        return;
    }
    float lum = texture(AvgLumPass, vec2(0.5)).w;
    float gamma_in = 1.0 / texture(LinearizePass, vec2(0.25)).w;
    float intera = texture(LinearizePass, vec2(0.75, 0.25)).w;
    bool interb = intera < 0.5;
    bool notate = TATE < 0.5;
    vec2 pos1 = vTexCoord;
    vec2 param_11 = SCREEN_COORD;
    float param_12 = HSM_CRT_CURVATURE_SCALE;
    float param_13 = SCREEN_ASPECT;
    vec2 screen_curved_coord = HSM_GetCurvedCoord(param_11, param_12, param_13);
    vec2 param_14 = screen_curved_coord;
    vec2 _4759 = HSM_GetMirrorWrappedCoord(param_14);
    vec2 pos = _4759;
    vec2 pos0 = pos;
    vec3 color0 = texture(Source, pos1).xyz;
    float c0 = max(max(color0.x, color0.y), color0.z);
    vec3 color = texture(Source, pos1).xyz;
    vec2 param_15 = pos;
    vec4 _4784 = HSM_GetCroppedTexSample(BloomPass, param_15);
    vec3 Bloom = _4784.xyz;
    if (false)
    {
        vec3 param_16 = color;
        vec3 param_17 = Bloom;
        vec2 param_18 = pos1;
        vec2 param_19 = pos;
        fetch_pixel(param_16, param_17, param_18, param_19);
        color = param_16;
        Bloom = param_17;
    }
    float cm = max(max(color.x, color.y), color.z);
    float mx1 = texture(Source, pos1).w;
    float colmx = max(mx1, cm);
    float w3 = min((c0 + 0.0005000000237487256526947021484375) / (pow(colmx, gamma_in / 1.39999997615814208984375) + 0.0005000000237487256526947021484375), 1.0);
    vec2 dx = mix(vec2(0.001000000047497451305389404296875, 0.0), vec2(0.0, 0.001000000047497451305389404296875), vec2(TATE));
    float mx0 = texture(Source, pos1 - dx).w;
    float mx2 = texture(Source, pos1 + dx).w;
    float mx = max(max(mx0, mx1), max(mx2, cm));
    vec3 one = vec3(1.0);
    vec3 orig1 = color;
    vec3 cmask = one;
    vec2 maskcoord = (vTexCoord * global.OutputSize.xy).yx * 1.00000095367431640625;
    if (notate)
    {
        maskcoord = maskcoord.yx;
    }
    vec2 param_20 = maskcoord;
    float param_21 = mx;
    float _4881 = SlotMask(param_20, param_21);
    float smask = _4881;
    vec2 param_22 = maskcoord;
    float param_23 = mx;
    vec3 _4886 = Mask(param_22, param_23);
    cmask *= _4886;
    if (false)
    {
        cmask = cmask.xzy;
    }
    vec3 cmask1 = cmask;
    float smask1 = smask;
    if (false)
    {
        float maxb = max(max(Bloom.x, Bloom.y), Bloom.z);
        maxb = pow(sqrt(maxb * mix(maxb, colmx, 0.75)), 0.2750000059604644775390625);
        vec3 mBloom = (((Bloom * 1.5) + vec3(0.5 * maxb)) * 0.5) * mix(1.0, 2.0 - colmx, 0.5);
        float maskmx = 1.0;
        if (true)
        {
            maskmx = 1.5;
        }
        else
        {
            if (false)
            {
                maskmx = 1.0;
            }
            else
            {
                maskmx = max(max(cmask.x, cmask.y), cmask.z);
            }
        }
        cmask = min(cmask + ((mBloom * maxb) * 0.0), vec3(maskmx));
        smask = min(smask + (((0.89999997615814208984375 * maxb) * max(max(mBloom.x, mBloom.y), mBloom.z)) * 0.0), 1.0);
    }
    color = pow(color, vec3(2.400000095367431640625 / gamma_in));
    color *= cmask;
    color = min(color, vec3(1.0));
    color *= smask;
    color = pow(color, vec3(gamma_in / 2.400000095367431640625));
    cmask = min(cmask * smask, vec3(1.0));
    cmask1 = min(cmask1 * smask1, vec3(1.0));
    float bb = mix(1.39999997615814208984375, 1.10000002384185791015625, colmx);
    if (interb)
    {
        float _5007;
        if (abs(intera - 0.5) < 0.100000001490116119384765625)
        {
            _5007 = pow(0.800000011920928955078125 * bb, 0.64999997615814208984375);
        }
        else
        {
            _5007 = pow(bb, 0.699999988079071044921875);
        }
        bb = _5007;
    }
    color *= bb;
    vec2 param_24 = pos;
    vec4 _5025 = HSM_GetCroppedTexSample(GlowPass, param_24);
    vec3 Glow = _5025.xyz;
    vec2 param_25 = pos;
    vec4 _5030 = HSM_GetCroppedTexSample(LinearizePass, param_25);
    vec3 Ref = _5030.xyz;
    vec2 param_26 = pos;
    vec4 _5035 = HSM_GetCroppedTexSample(BloomPass, param_26);
    float maxb_1 = _5035.w;
    vec3 Bloom1 = Bloom;
    if (false)
    {
        vec3 param_27 = Bloom;
        float param_28 = maxb_1;
        Bloom1 = plant(param_27, param_28);
    }
    Bloom1 = min(Bloom1 * (orig1 + color), max(((vec3(colmx) + orig1) - color) * 0.5, Bloom1 * 0.001000000047497451305389404296875));
    Bloom1 = (Bloom1 + mix(Bloom1, mix(orig1 * colmx, Bloom1, vec3(0.5)), vec3(1.0) - color)) * 0.5;
    Bloom1 *= mix(1.0, 2.0 - colmx, 0.0);
    color += (Bloom1 * 0.0);
    color = min(color, mix(one, cmask1, vec3(0.5)));
    if (!interb)
    {
        vec3 param_29 = color;
        float param_30 = mix(1.0, w3, 0.60000002384185791015625);
        vec3 _5100 = declip(param_29, param_30);
        color = _5100;
    }
    else
    {
        w3 = 1.0;
    }
    if (false)
    {
        Bloom = mix((Bloom + (Bloom * Bloom)) * 0.5, (Bloom * 0.75) * Bloom, vec3(colmx));
        color += (((mix(one, cmask, vec3(0.60000002384185791015625)) * ((2.0 * max((2.0 * mix(maxb_1 * maxb_1, maxb_1, colmx)) - (0.5 * max(max(Ref.x, Ref.y), Ref.z)), 0.25)) * mix(1.0, w3, 0.5 * colmx))) * Bloom) * 0.0);
    }
    Glow = mix(Glow, color * 0.25, vec3(0.699999988079071044921875 * colmx));
    if (true)
    {
        color += ((Glow * 0.5) * 0.07999999821186065673828125);
    }
    else
    {
        cmask *= cmask;
        cmask *= cmask;
        color += ((cmask * (-0.07999999821186065673828125)) * Glow);
    }
    color = pow(color, vec3(0.4166666567325592041015625));
    float rc = (0.60000002384185791015625 * sqrt(max(max(color.x, color.y), color.z))) + 0.4000000059604644775390625;
    if (false)
    {
        vec3 param_31 = vec3(floor((global.OutputSize.xy * vTexCoord) / vec2(2.0)), float(global.FrameCount));
        vec3 _5214 = _noise(param_31);
        vec3 noise0 = _5214;
        if (true)
        {
            color = mix(color, noise0, vec3(0.0500000007450580596923828125 * rc));
        }
        else
        {
            color = min(color * mix(1.0, 1.5 * noise0.x, 0.100000001490116119384765625), vec3(1.0));
        }
    }
    float adjusted_bardir = true ? TATE : (-1.0);
    float param_32 = mix(pos.y, pos.x, adjusted_bardir);
    float _5243 = humbar(param_32);
    color *= _5243;
    FragColor = vec4(color, 1.0);
}

